;-----------------------------------------------------------------------------
; NexGen Nx586 BIOS Hypercode
;-----------------------------------------------------------------------------
; File: CALL.ASM - 
; Date: 2020-09-24
;
; Disassembled by Dipl.-Inf. Herbert Oppmann (herby@memotech.franken.de)
;-----------------------------------------------------------------------------

		include COMMON.INC

	extrn	loc_1AB7:near
	extrn	loc_2AC8:near
	extrn	loc_2B92:near
	extrn	loc_2BA4:near
	extrn	loc_2BB6:near
	extrn	Exception:near
	extrn	ExcpDebugExcp:near

	public	loc_2620
	public	loc_2766


 IF V033S
		db '@(#)call.asm',TAB,'3.3',0
 ELSEIF V033V
		db '@(#)call    ',0
 ELSE
		db '@(#)call.asm',TAB,'3.4',0
 ENDIF
		ALIGN0	32

; Hypermode entry via offset 0A00h
loc_2620:	mov	ebp, esp
		sub	ebp, 3E4h
		push	eax
		push	ebx
		push	ecx
		push	edx
		push	esi
		push	edi
		mov	esp, ebp
		mov	h_excph[ebp], offset loc_29DE
		and	dword ptr h_gatflag[ebp], 40000000h	; bit 30
		; EDX is a progress indicator for the exception handler
		xor	edx, edx
		mov	word ptr h_dbflag[ebp], dx
		bt	dword ptr h_efl[ebp], 8		; EFL.8 = trap flag
		jc	CallTFSet
CallTFBack:	mov	eax, h_gatflag[ebp]
		shl	eax, 1			; bit 30 -> 31
		RDAR	ebx, ?7
		bt	ebx, 27			; set if we should NOT clear IF
		rcr	eax, 1			; into bit 31, 31->30 again
		and	eax, 0C0000000h		; only keep bits 31 and 30
		RDB	ebx, ?7			; "base" address of destination
		and	ebx, 001F0000h		; parameter count from call gate
		or	eax, ebx
		mov	h_gatflag[ebp], eax

		mov	al, 1
		WRSBNK	eax			; select segment register bank 1
						; GS is replaced by IS
		OP_0FE4
		RDB	ebx, ldtr
		MOVSEL	eax, ?7			; destination segment
		bt	eax, 2			; table indicator (TI)
		jc	short loc_2693		; 1=LDT, 0=GDT
		OP_0FE4
		RDB	ebx, gdtr
loc_2693:	and	eax, 0FFF8h		; clear TI and RPL
		mov	cx, gs:[ebx+eax+6]	; base 15:0
		shl	ecx, 16
		mov	cx, gs:[ebx+eax]	; P,DPL,S,TYPE, base 23:16
		mov	h_gate[ebp], ecx
		xor	eax, eax
		WRSBNK	eax			; select segment register bank 0

		RDB	ecx, ?7
		and	ecx, 0FFFCh		; clear RPL
		MOVSEL	cs, ecx
		RDAR	eax, cs
		WRAR	cs, eax
		bts	edx, 31			; progress indicator
		bt	dword ptr h_gatflag[ebp], 30
		jc	loc_2985

		RDAR	eax, cs
		mov	ecx, eax
		shr	eax, 29			; AR.29-30 = DPL
		and	eax, 3
		RDCPL	ebx
		and	ebx, 3
		cmp	eax, ebx		; CPL == DPL?
		jz	loc_2914
		jg	loc_2B92		; #GP(selector)
		DELAYJMP
		bt	ecx, 31			; AR.31 = present
		jnc	loc_29EF		; #NP(new code segment selector)
		bt	ecx, 26			; AR.26 = conforming
		jc	loc_2914
		; CPL != DPL and nonconforming
		mov	eax, cs
		and	eax, 0FFFCh		; clear RPL
		RDAR	ebx, cs
		shr	ebx, 29			; AR.29-30 = DPL
		and	ebx, 3
		or	eax, ebx
		OP_0FE4
		WRSEL	cs, eax			; set new RPL

		; switch stack
		xor	eax, eax
		WRCPL	eax			; set CPL to 0 temporarily
		mov	eax, cs
		and	eax, 3
		mov	bl, 1
		WRSBNK	ebx			; select segment register bank 1
						; FS is replaced by TR
		bts	edx, 29			; progress indicator
		RDAR	ebx, tr
		bt	ebx, 27			; AR.27 = 16/32 bit
		jnc	short loc_274F
		; 32-bit task state segment (TSS)
		mov	bx, fs:8[eax*8]		; SS
		mov	esi, fs:4[eax*8]	; ESP
		jmp	short loc_2761

loc_274F:	; 16-bit task state segment (TSS)
		mov	bx, fs:4[eax*4]		; SS
		movzx	esi, word ptr fs:2[eax*4] ; SP
loc_2761:	OP_0FE4
		WRCPL	eax			; re-set CPL
loc_2766:	mov	ss, bx
		bts	edx, 30			; progress indicator
		btr	edx, 29			; progress indicator
		xor	ebx, ebx
		WRSBNK	ebx			; select segment register bank 0
		RDAR	ebx, ss
		bt	ebx, 22			; AR.22 = big
		jc	short loc_2786
		; 16-bit stack
		mov	ebx, esi
		and	esi, 0FFFFh
loc_2786:	mov	ecx, h_gatflag[ebp]
		mov	eax, ecx
		shr	ecx, 16
		and	ecx, 1Fh
		bt	eax, 31			; 32-bit gate
		jc	short near ptr loc_27DB
		; 16-bit
		MOVSEL	eax, ?6
		mov	ss:[esi-2], ax		; old SS
		mov	eax, h_esp[ebp]
		mov	ss:[esi-4], ax		; old SP
		sub	esi, 4
		or	ecx, ecx
		jz	short near ptr loc_27BD
		@CALL	loc_28BD
loc_27BD:	MOVSEL	eax, ?7
		mov	ss:[esi-2], ax		; old CS
		mov	eax, h_eip3[ebp]
		mov	ss:[esi-4], ax		; old IP
		sub	esi, 4
		movzx	ebx, word ptr h_gate[ebp]
		jmp	short loc_2815

loc_27DB:	; 32-bit gate
		MOVSEL	eax, ?6
		mov	ss:[esi-4], eax		; old SS
		mov	eax, h_esp[ebp]
		mov	ss:[esi-8], eax		; old ESP
		sub	esi, 8
		or	ecx, ecx
		jz	short near ptr loc_27FC
		@CALL	loc_28BB
loc_27FC:	MOVSEL	eax, ?7
loc_27FE:	mov	ss:[esi-4], eax		; old CS
		mov	eax, h_eip3[ebp]
		mov	ss:[esi-8], eax		; old EIP
		sub	esi, 8
		mov	ebx, h_gate[ebp]
loc_2815:	RDAR	eax, cs
		bt	eax, 23			; AR.23 = granularity
		jc	short loc_2825
		; granularity byte
		and	eax, 0FFFFFh		; AR.0-19 = limit
		jmp	short loc_282D

loc_2825:	; granularity 4 KB
		shl	eax, 12			; * 4096
		or	eax, 0FFFh
loc_282D:	; now limit in EAX
		cmp	ebx, eax
		ja	loc_2BB6		; #GP(0)
		RDAR	eax, ss
		bt	eax, 22			; AR.22 = big
		jc	short loc_2847
		mov	word ptr h_esp[ebp], si
		jmp	short loc_284D

loc_2847:	mov	h_esp[ebp], esi
loc_284D:	mov	h_eip3[ebp], ebx

		; check new CS:EIP is accessible
		; save DR7 (and set flag that it was saved)
		mov	edx, dr7
 IF NOT V033S
		bts	word ptr h_dbflag[ebp], 2
		mov	h_dr7[ebp], edx
 ENDIF
		xor	ecx, ecx
		mov	dr7, ecx
		; restore exception handler
		mov	h_excph[ebp], offset Exception
		mov	h_eip2[ebp], ebx
		RDAR	ecx, cs
		mov	eax, ecx
		bts	ecx, 25			; AR.25 = readable
		jnc	short near ptr loc_2885
		test	byte ptr cs:[ebx], 0
		jmp	short loc_2893

loc_2885:	; not readable - temporarily enable R bit
		OP_0FE4
		WRAR	cs, ecx
		test	byte ptr cs:[ebx], 0
		OP_0FE4
		WRAR	cs, eax
loc_2893:	; restore DR7 (and clear flag that it was saved)
		mov	dr7, edx
 IF NOT V033S
		btr	word ptr h_dbflag[ebp], 2
 ENDIF
		; do we need to issue #DB on exit?
		bt	h_dbflag[ebp], 17
		jc	ExcpDebugExcp		; debug exception
		; normal exit
		lea	esp, h_edi[ebp]
		pop	edi
		pop	esi
		pop	edx
		pop	ecx
		pop	ebx
		pop	eax
		pop	ebp
		add	esp, 8
		OP_0FE4
		RETH

; Subroutine: copy stack (32-bit)
; E: ECX = number of dwords to copy
;    ESI = new stack
;    EDX = progress indicator (only bits 31-29 are used, 28-0 are 0)
loc_28BB:	shl	ecx, 1	; *2 = number of words
; <fall through>

; Subroutine: copy stack (16-bit)
; E: ECX = number of words to copy
;    ESI = new stack
;    EDX = progress indicator (only bits 31-29 are used, 28-0 are 0)
loc_28BD:	mov	edi, h_esp[ebp]
		RDAR	eax, ?6		; old SS
		bt	eax, 22		; AR.22 = big
		jc	short loc_28D2
		and	edi, 0FFFFh
loc_28D2:	lea	edi, [edi+ecx*2-2]
		RDCPL	ebx
		and	ebx, 3
		MOVSEL	eax, ?7		; old CS
		and	eax, 3		; RPL of old CS = old CPL
		or	edx, eax	; why??
		or	eax, 1		; bank 1 makes ES to HS??
		OP_0FE4
		WRSBNK	eax
loc_28EB:	WRCPL	edx		; set old CPL
		mov	ax, es:[edi]	; get word from old stack
		lea	edi, [edi-2]
		lea	edi, [edi]	; delay?
		WRCPL	ebx		; set new CPL
		mov	ss:[esi-2], ax
		lea	esi, [esi-2]
		lea	esi, [esi]	; delay?
		loop	near ptr loc_28EB
		OP_0FE4
		WRCPL	ebx
		WRSBNK	ecx		;=0
		@RET

; CPL == DPL or conforming
loc_2914:	mov	h_excph[ebp], offset loc_29EA
		bt	ecx, 31
		jnc	loc_29EF
		mov	esi, h_esp[ebp]
		RDAR	eax, ss
		bt	eax, 22
		jc	short loc_293A
		and	esi, 0FFFFh
loc_293A:	mov	eax, h_gatflag[ebp]
		bt	eax, 31
		jc	short near ptr loc_2967
		MOVSEL	eax, ?6		; old SS
		mov	ss:[esi-2], ax
		mov	eax, h_eip3[ebp]
		mov	ss:[esi-4], ax
		sub	esi, 4
		movzx	ebx, word ptr h_gate[ebp]
		jmp	loc_2815

loc_2967:	MOVSEL	eax, ?6		; old SS
		mov	ss:[esi-4], eax
		mov	eax, h_eip3[ebp]
		mov	ss:[esi-8], eax
		sub	esi, 8
		mov	ebx, h_gate[ebp]
		jmp	loc_2815

; Bit 30 == 1
loc_2985:	mov	h_excph[ebp], offset loc_29EA
		RDAR	eax, cs
		mov	ecx, eax
		shr	eax, 29
		and	eax, 3
		RDCPL	ebx
		and	ebx, 3
		bt	ecx, 26
		jc	short loc_29AC
		cmp	eax, ebx
		jz	short loc_29B5
		jmp	loc_2B92

loc_29AC:	cmp	eax, ebx
		jle	short loc_29B5
		jmp	loc_2B92

loc_29B5:	bt	ecx, 31
		jnc	short loc_29EF
		mov	ebx, h_gate[ebp]
		mov	eax, h_gatflag[ebp]
		bt	eax, 31
		jc	short loc_29D3
		and	ebx, 0FFFFh
loc_29D3:	mov	esi, h_esp[ebp]
		jmp	loc_2815

; special exception handler for CALL
loc_29DE:	mov	esi, esp
		@CALL	loc_2AC8
loc_29EA:	jmp	loc_1AB7	; goto exception handler for RETF

; #NP(new code segment selector)
loc_29EF:	jmp	loc_2BA4

CallTFSet:	; balcony for single-stepping
		or	h_dbflag[ebp], 00020001h
		;		       ^------ generate #DB when exiting
		;			   ^-- set DR6.BS=1
		jmp	CallTFBack	; continue

 IF V033S
		ALIGN	256
 ENDIF
hypseg		ends
		end

;---------------------------------------------------------------- end CALL.ASM