;-----------------------------------------------------------------------------
; NexGen Nx586 BIOS Hypercode
;-----------------------------------------------------------------------------
; File: DECODE.ASM - 
; Date: 2020-09-27
;
; Disassembled by Dipl.-Inf. Herbert Oppmann (herby@memotech.franken.de)
;-----------------------------------------------------------------------------

		include COMMON.INC

	extrn	FORCEBIG:abs

	extrn	ExcpDebugExcp:near
	extrn	loc_2AA7:near
	extrn	DecNXOP:near
	extrn	InstrUnsupp2:near
	extrn	DecICEBP:near
	extrn	DecOUTib:near
	extrn	DecOUTiw:near
	extrn	DecOUTdb:near
	extrn	DecOUTdw:near
	extrn	DecSALC:near
	extrn	DecUMOVb0:near
	extrn	DecUMOVb1:near
	extrn	DecUMOVw0:near
	extrn	DecUMOVw1:near
	extrn	DecHLT:near
 IF NOT (V033S OR V033V)
	extrn	DecMOVSEG:near
 ENDIF
	extrn	DecBSWAPEAX:near
	extrn	DecBSWAPECX:near
	extrn	DecBSWAPEDX:near
	extrn	DecBSWAPEBX:near
	extrn	DecBSWAPESP:near
	extrn	DecBSWAPEBP:near
	extrn	DecBSWAPESI:near
	extrn	DecBSWAPEDI:near
	extrn	DecXADDb:near
	extrn	DecXADDw:near
	extrn	DecCMPXCHGb:near
	extrn	DecCMPXCHGw:near
	extrn	DecFBLD:near
	extrn	DecFBSTP:near
 IF VVL
	extrn	DecMOVfromCR:near
	extrn	DecMOVtoCR:near
 ENDIF
 IF V033S OR V033V
	extrn	loc_6AA8:near
	extrn	loc_6B9A:near
	extrn	loc_708A:near
	extrn	DecFSCALE:near
	extrn	DecFCOS:near
	extrn	DecFSIN:near
	extrn	DecFSINCOS:near
	extrn	DecFPATAN:near
	extrn	DecF2XM1:near
	extrn	DecFYL2XP1:near
	extrn	DecFYL2X:near
	extrn	DecFPTAN:near
	extrn	DecFXTRACT:near
	extrn	DecFSQRT:near
 ENDIF

	public	loc_5320
	public	loc_532E
	public	loc_5B51
	public	loc_5B59
	public	loc_5B93
	public	InstrUnsupp
	public	ForceExec
	public	GetOperand
	public	loc_61DB
 IF VVL
	public	loc_5CE4
 ENDIF

 IF V033S
		db '@(#)decode.asm',TAB,'3.19',0
 ELSEIF V033V OR V034I
		db '@(#)decode  ',0
 ELSE	; PCI+V033W
		db '@(#)decode.asm',TAB,'3.22',0
 ENDIF
		ALIGN0	32

; Main instruction decode table

DecTable:	dw small offset InstrUnsupp	; ADD Eb,Gb
		dw small offset InstrUnsupp	; ADD Ev,Gv
		dw small offset InstrUnsupp	; ADD Gb,Eb
		dw small offset InstrUnsupp	; ADD Gv,Ev
		dw small offset InstrUnsupp	; ADD AL,Ib
		dw small offset InstrUnsupp	; ADD eAX,Iv
		dw small offset InstrUnsupp	; PUSH ES
		dw small offset InstrUnsupp	; POP ES
		dw small offset InstrUnsupp	; OR Eb,Gb
		dw small offset InstrUnsupp	; OR Ev,Gv
		dw small offset InstrUnsupp	; OR Gb,Eb
		dw small offset InstrUnsupp	; OR Gv,Ev
		dw small offset InstrUnsupp	; OR AL,Ib
		dw small offset InstrUnsupp	; OR eAX,Iv
		dw small offset InstrUnsupp	; PUSH CS
		dw small offset Decode0F	; prefix 0Fh
	; 10h
		dw small offset InstrUnsupp	; ADC Eb,Gb
		dw small offset InstrUnsupp	; ADC Ev,Gv
		dw small offset InstrUnsupp	; ADC Gb,Eb
		dw small offset InstrUnsupp	; ADC Gv,Ev
		dw small offset InstrUnsupp	; ADC AL,Ib
		dw small offset InstrUnsupp	; ADC eAX,Iv
		dw small offset InstrUnsupp	; PUSH SS
		dw small offset InstrUnsupp	; POP SS
		dw small offset InstrUnsupp	; SBB Eb,Gb
		dw small offset InstrUnsupp	; SBB Ev,Gv
		dw small offset InstrUnsupp	; SBB Gb,Eb
		dw small offset InstrUnsupp	; SBB Gv,Ev
		dw small offset InstrUnsupp	; SBB AL,Ib
		dw small offset InstrUnsupp	; SBB eAX,Iv
		dw small offset InstrUnsupp	; PUSH DS
		dw small offset InstrUnsupp	; POP DS
	; 20h
		dw small offset InstrUnsupp	; AND Eb,Gb
		dw small offset InstrUnsupp	; AND Ev,Gv
		dw small offset InstrUnsupp	; AND Gb,Eb
		dw small offset InstrUnsupp	; AND Gv,Ev
		dw small offset InstrUnsupp	; AND AL,Ib
		dw small offset InstrUnsupp	; AND eAX,Iv
		dw small offset DecSEGES	; prefix SEGES
		dw small offset InstrUnsupp	; DAA
		dw small offset InstrUnsupp	; SUB Eb,Gb
		dw small offset InstrUnsupp	; SUB Ev,Gv
		dw small offset InstrUnsupp	; SUB Gb,Eb
		dw small offset InstrUnsupp	; SUB Gv,Ev
		dw small offset InstrUnsupp	; SUB AL,Ib
		dw small offset InstrUnsupp	; SUB eAX,Iv
		dw small offset DecSEGCS	; prefix SEGCS
		dw small offset InstrUnsupp	; DAS
	; 30h
		dw small offset InstrUnsupp	; XOR Eb,Gb
		dw small offset InstrUnsupp	; XOR Ev,Gv
		dw small offset InstrUnsupp	; XOR Gb,Eb
		dw small offset InstrUnsupp	; XOR Gv,Ev
		dw small offset InstrUnsupp	; XOR AL,Ib
		dw small offset InstrUnsupp	; XOR eAX,Iv
		dw small offset DecSEGSS	; prefix SEGSS
		dw small offset InstrUnsupp	; AAA
		dw small offset InstrUnsupp	; CMP Eb,Gb
		dw small offset InstrUnsupp	; CMP Ev,Gv
		dw small offset InstrUnsupp	; CMP Gb,Eb
		dw small offset InstrUnsupp	; CMP Gv,Ev
		dw small offset InstrUnsupp	; CMP AL,Ib
		dw small offset InstrUnsupp	; CMP eAX,Iv
		dw small offset DecSEGDS	; prefix SEGDS
		dw small offset InstrUnsupp	; AAS
	; 40h
		dw small offset InstrUnsupp	; INC eAX
		dw small offset InstrUnsupp	; INC eCX
		dw small offset InstrUnsupp	; INC eDX
		dw small offset InstrUnsupp	; INC eBX
		dw small offset InstrUnsupp	; INC eSP
		dw small offset InstrUnsupp	; INC eBP
		dw small offset InstrUnsupp	; INC eSI
		dw small offset InstrUnsupp	; INC eDI
		dw small offset InstrUnsupp	; DEC eAX
		dw small offset InstrUnsupp	; DEC eCX
		dw small offset InstrUnsupp	; DEC eDX
		dw small offset InstrUnsupp	; DEC eBX
		dw small offset InstrUnsupp	; DEC eSP
		dw small offset InstrUnsupp	; DEC eBP
		dw small offset InstrUnsupp	; DEC eSI
		dw small offset InstrUnsupp	; DEC eDI
	; 50h
		dw small offset InstrUnsupp	; PUSH eAX
		dw small offset InstrUnsupp	; PUSH eCX
		dw small offset InstrUnsupp	; PUSH eDX
		dw small offset InstrUnsupp	; PUSH eBX
		dw small offset InstrUnsupp	; PUSH eSP
		dw small offset InstrUnsupp	; PUSH eBP
		dw small offset InstrUnsupp	; PUSH eSI
		dw small offset InstrUnsupp	; PUSH eDI
		dw small offset InstrUnsupp	; POP eAX
		dw small offset InstrUnsupp	; POP eCX
		dw small offset InstrUnsupp	; POP eDX
		dw small offset InstrUnsupp	; POP eBX
 IF VVL
		dw small offset InstrUnsupp	; POP eSP
 ELSE
		dw small offset DecPOPESP	; POP eSP
 ENDIF
		dw small offset InstrUnsupp	; POP eBP
		dw small offset InstrUnsupp	; POP eSI
		dw small offset InstrUnsupp	; POP eDI
	; 60h
		dw small offset InstrUnsupp	; PUSHA(D)
		dw small offset InstrUnsupp	; POPA(D)
		dw small offset InstrUnsupp	; BOUND Gv,Ma
		dw small offset InstrUnsupp	; ARPL Ew,Gw
		dw small offset DecSEGFS	; prefix SEGFS
		dw small offset DecSEGGS	; prefix SEGGS
		dw small offset DecOPSIZE	; prefix operand size
		dw small offset DecADDRSIZE	; prefix address size
		dw small offset InstrUnsupp	; PUSH Iv
		dw small offset InstrUnsupp	; IMUL Gv,Ev,Iv
		dw small offset InstrUnsupp	; PUSH Ib
		dw small offset InstrUnsupp	; IMUL Gv,Ev,Ib
		dw small offset InstrUnsupp	; INSB Yb,DX
		dw small offset InstrUnsupp	; INSW/D Yv,DX
		dw small offset InstrUnsupp	; OUTSB DX,Xb
		dw small offset InstrUnsupp	; OUTSW/D DX,Xv
	; 70h
		dw small offset InstrUnsupp	; JO Jb
		dw small offset InstrUnsupp	; JNO Jb
		dw small offset InstrUnsupp	; JB/JNAE/JC Jb
		dw small offset InstrUnsupp	; JNB/JAE/JNC Jb
		dw small offset InstrUnsupp	; JZ Jb
		dw small offset InstrUnsupp	; JNZ Jb
		dw small offset InstrUnsupp	; JBE Jb
		dw small offset InstrUnsupp	; JNBE Jb
		dw small offset InstrUnsupp	; JS Jb
		dw small offset InstrUnsupp	; JNS Jb
		dw small offset InstrUnsupp	; JP Jb
		dw small offset InstrUnsupp	; JNP Jb
		dw small offset InstrUnsupp	; JL Jb
		dw small offset InstrUnsupp	; JNL Jb
		dw small offset InstrUnsupp	; JLE Jb
		dw small offset InstrUnsupp	; JNLE Jb
	; 80h
		dw small offset InstrUnsupp	; Grp1 Eb,Ib
		dw small offset InstrUnsupp	; Grp1 Ev,Iv
		dw small offset InstrUnsupp	; MOVB AL,immed8 (undoc!)
		dw small offset InstrUnsupp	; Grp1 Eb,Ib
		dw small offset InstrUnsupp	; TEST Eb,Gb
		dw small offset InstrUnsupp	; TEST Ev,Gv
		dw small offset InstrUnsupp	; XCHG Eb,Gb
		dw small offset InstrUnsupp	; XCHG Ev,Gv
		dw small offset InstrUnsupp	; MOV Eb,Gb
		dw small offset InstrUnsupp	; MOV Ev,Gv
		dw small offset InstrUnsupp	; MOV Gb,Eb
		dw small offset InstrUnsupp	; MOV Gv,Ev
		dw small offset InstrUnsupp	; MOV Ew,Sw
		dw small offset InstrUnsupp	; LEA Gv,M
 IF V033S OR V033V
		dw small offset InstrUnsupp	; MOV Sw,Ew
 ELSE
		dw small offset DecMOVSEG	; MOV Sw,Ew
 ENDIF
		dw small offset InstrUnsupp	; POP Ew
	; 90h
		dw small offset InstrUnsupp	; NOP
		dw small offset InstrUnsupp	; XCHG eAX,eCX
		dw small offset InstrUnsupp	; XCHG eAX,eDX
		dw small offset InstrUnsupp	; XCHG eAX,eBX
		dw small offset InstrUnsupp	; XCHG eAX,eSP
		dw small offset InstrUnsupp	; XCHG eAX,eBP
		dw small offset InstrUnsupp	; XCHG eAX,eSI
		dw small offset InstrUnsupp	; XCHG eAX,eDI
		dw small offset InstrUnsupp	; CBW
		dw small offset InstrUnsupp	; CWD/CDQ
		dw small offset InstrUnsupp	; CALL aP
		dw small offset InstrUnsupp	; WAIT
 IF V033S OR V033V OR V034I
		dw small offset InstrUnsupp	; PUSHF Fv
		dw small offset InstrUnsupp	; POPF Fv
 ELSE
		dw small offset DecPUSHF	; PUSHF Fv
		dw small offset DecPOPF		; POPF Fv
 ENDIF
		dw small offset InstrUnsupp	; SAHF
		dw small offset InstrUnsupp	; LAHF
	; A0h
		dw small offset InstrUnsupp	; MOV AL,Ob
		dw small offset InstrUnsupp	; MOV eAX,Ov
		dw small offset InstrUnsupp	; MOV Ob,AL
		dw small offset InstrUnsupp	; MOV Ov,eAX
		dw small offset InstrUnsupp	; MOVSB Xb,Yb
		dw small offset InstrUnsupp	; MOVSW Xv,Yv
		dw small offset InstrUnsupp	; CMPSB Xb,Yb
		dw small offset InstrUnsupp	; CMPSW Xv,Yv
		dw small offset InstrUnsupp	; TEST AL,Ib
		dw small offset InstrUnsupp	; TEST eAX,Iv
		dw small offset InstrUnsupp	; STOSB Yb,AL
		dw small offset InstrUnsupp	; STOSW/D Yv,eAX
		dw small offset InstrUnsupp	; LODSB AL,Xb
		dw small offset InstrUnsupp	; LODSW/D eAX,Xv
		dw small offset InstrUnsupp	; SCASB AL,Yb
		dw small offset InstrUnsupp	; SCASW/D eAX,Yv
	; B0h
		dw small offset InstrUnsupp	; MOV AL,Ib
		dw small offset InstrUnsupp	; MOV CL,Ib
		dw small offset InstrUnsupp	; MOV DL,Ib
		dw small offset InstrUnsupp	; MOV BL,Ib
		dw small offset InstrUnsupp	; MOV AH,Ib
		dw small offset InstrUnsupp	; MOV CH,Ib
		dw small offset InstrUnsupp	; MOV DH,Ib
		dw small offset InstrUnsupp	; MOV BH,Ib
		dw small offset InstrUnsupp	; MOV eAX,Iv
		dw small offset InstrUnsupp	; MOV eCX,Iv
		dw small offset InstrUnsupp	; MOV eDX,Iv
		dw small offset InstrUnsupp	; MOV eBX,Iv
		dw small offset InstrUnsupp	; MOV eSP,Iv
		dw small offset InstrUnsupp	; MOV eBP,Iv
		dw small offset InstrUnsupp	; MOV eSI,Iv
		dw small offset InstrUnsupp	; MOV eDI,Iv
	; C0h
		dw small offset InstrUnsupp	; Grp2a Eb,Ib (shift)
		dw small offset InstrUnsupp	; Grp2a Ev,Ib (shift)
		dw small offset InstrUnsupp	; RET near Iw
		dw small offset InstrUnsupp	; RET near
		dw small offset InstrUnsupp	; LES Gv,Mp
		dw small offset InstrUnsupp	; LDS Gv,Mp
		dw small offset InstrUnsupp	; MOV Eb,Ib
		dw small offset InstrUnsupp	; MOV Ev,Iv
		dw small offset InstrUnsupp	; ENTER Iw,Ib
		dw small offset InstrUnsupp	; LEAVE
		dw small offset InstrUnsupp	; RET far Iw
		dw small offset InstrUnsupp	; RET far
		dw small offset InstrUnsupp	; INT3
		dw small offset InstrUnsupp	; INT Ib
		dw small offset DecINTO		; INTO
		dw small offset InstrUnsupp	; IRET
	; D0h
		dw small offset InstrUnsupp	; Grp2 Eb,1 (shift)
		dw small offset InstrUnsupp	; Grp2 Ev,1 (shift)
		dw small offset InstrUnsupp	; Grp2 Eb,CL (shift)
		dw small offset InstrUnsupp	; Grp2 Ev,CL (shift)
		dw small offset InstrUnsupp	; AMM
		dw small offset InstrUnsupp	; AAD
		dw small offset DecSALC		; SALC (was undocumented until 486)
		dw small offset InstrUnsupp	; XLAT
		dw small offset DecodeD8	; ESC0 (numeric processor)
		dw small offset DecodeD9	; ESC1
		dw small offset DecodeDA	; ESC2
		dw small offset DecodeDB	; ESC3
		dw small offset DecodeDC	; ESC4
		dw small offset DecodeDD	; ESC5
		dw small offset DecodeDE	; ESC6
		dw small offset DecodeDF	; ESC7
	; E0h
		dw small offset InstrUnsupp	; LOOPN Jb
		dw small offset InstrUnsupp	; LOOPE Jb
		dw small offset InstrUnsupp	; LOOP Jb
		dw small offset InstrUnsupp	; JCXZ/JECXZ Jb
		dw small offset InstrUnsupp	; IN AL,Ib
		dw small offset InstrUnsupp	; IN eAX,Ib
		dw small offset DecOUTib	; OUT Ib,Al
		dw small offset DecOUTiw	; OUT Ib,eAX
		dw small offset InstrUnsupp	; CALL Jv
		dw small offset InstrUnsupp	; JMP Jv
		dw small offset InstrUnsupp	; JMP Ap
		dw small offset InstrUnsupp	; JMP Jb
		dw small offset InstrUnsupp	; IN AL,DX
		dw small offset InstrUnsupp	; IN eAX,DX
		dw small offset DecOUTdb	; OUT DX,AL
		dw small offset DecOUTdw	; OUT DX,eAX
	; F0h
		dw small offset DecLOCK		; prefix LOCK
		dw small offset DecICEBP	; ICEBP
		dw small offset DecREPNE	; prefix REPNE
		dw small offset DecREP		; prefix REP/REPE
		dw small offset DecHLT		; HLT
		dw small offset InstrUnsupp	; CMC
		dw small offset InstrUnsupp	; Grp3 Eb (unary)
		dw small offset InstrUnsupp	; Grp3 Ev (unary)
		dw small offset InstrUnsupp	; CLC
		dw small offset InstrUnsupp	; STC
		dw small offset InstrUnsupp	; CLI
 IF V033S
		dw small offset InstrUnsupp	; STI
 ELSE
		dw small offset DecSTI		; STI
 ENDIF
		dw small offset InstrUnsupp	; CLD
		dw small offset InstrUnsupp	; STD
		dw small offset DecGRP4		; Grp4 (INC/DEC)
		dw small offset DecGRP5		; Grp5 (INC/DEC)


; Instruction decode table for instructions starting with 0Fh

DecTable0F:	dw small offset DecGRP6		; Grp6
		dw small offset DecGRP7		; Grp7
		dw small offset InstrUnsupp	; LAR Gv,Ew
		dw small offset InstrUnsupp	; LSL Gv,Ew
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp	; LOADALL ??
		dw small offset InstrUnsupp	; CLTS
		dw small offset InstrUnsupp	; LOADALLD ??
		dw small offset InstrUnsupp2	; INVD (486+)
		dw small offset InstrUnsupp2	; WBINVD (486+)
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp	; UD2 (P6+)
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
	; 10h
		dw small offset DecUMOVb0	; UMOV Eb,Gb
		dw small offset DecUMOVw0	; UMOV Ev,Gv
		dw small offset DecUMOVb1	; UMOV Gb,Eb
		dw small offset DecUMOVw1	; UMOV Gv,Ev
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
	; 20h
 IF VVL
		dw small offset DecMOVfromCR	; MOV Rd,Cd
 ELSE	; PCI
		dw small offset InstrUnsupp	; MOV Rd,Cd
 ENDIF
		dw small offset InstrUnsupp	; MOV Rd,Dd
 IF VVL
		dw small offset DecMOVtoCR	; MOV Cd,Rd
 ELSE	; PCI
		dw small offset InstrUnsupp	; MOV Cd,Rd
 ENDIF
		dw small offset InstrUnsupp	; MOV Dd,Rd
		dw small offset InstrUnsupp	; MOV Rd,Td
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp	; MOV Td,Rd
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
	; 30h
		dw small offset InstrUnsupp	; WRMSR (Pentium+)
		dw small offset InstrUnsupp	; RDTSC (Pentium+)
		dw small offset InstrUnsupp	; RDMSR (Pentium+)
		dw small offset InstrUnsupp	; RDPMC (P6+)
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
	; 40h
		dw small offset InstrUnsupp	; CMOVO (P6+)
		dw small offset InstrUnsupp	; CMOVNO (P6+)
		dw small offset InstrUnsupp	; CMOVB (P6+)
		dw small offset InstrUnsupp	; CMOVNB (P6+)
		dw small offset InstrUnsupp	; CMOVZ (P6+)
		dw small offset InstrUnsupp	; CMOVNZ (P6+)
		dw small offset InstrUnsupp	; CMOVBE (P6+)
		dw small offset InstrUnsupp	; CMOVNBE (P6+)
		dw small offset InstrUnsupp	; CMOVS (P6+)
		dw small offset InstrUnsupp	; CMOVNS (P6+)
		dw small offset InstrUnsupp	; CMOVP (P6+)
		dw small offset InstrUnsupp	; CMOVNP (P6+)
		dw small offset InstrUnsupp	; CMOVL (P6+)
		dw small offset InstrUnsupp	; CMOVNL (P6+)
		dw small offset InstrUnsupp	; CMOVLE (P6+)
		dw small offset InstrUnsupp	; CMOVNLE (P6+)
	; 50h
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset DecNXOP		; NXOP
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
	; 60h
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
	; 70h
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
	; 80h
		dw small offset InstrUnsupp	; JO Jv
		dw small offset InstrUnsupp	; JNO Jv
		dw small offset InstrUnsupp	; JB Jv
		dw small offset InstrUnsupp	; JNB Jv
		dw small offset InstrUnsupp	; JZ Jv
		dw small offset InstrUnsupp	; JNZ Jv
		dw small offset InstrUnsupp	; JBE Jv
		dw small offset InstrUnsupp	; JNBE Jv
		dw small offset InstrUnsupp	; JS Jv
		dw small offset InstrUnsupp	; JNS Jv
		dw small offset InstrUnsupp	; JP Jv
		dw small offset InstrUnsupp	; JNP Jv
		dw small offset InstrUnsupp	; JL Jv
		dw small offset InstrUnsupp	; JNL Jv
		dw small offset InstrUnsupp	; JLE Jv
		dw small offset InstrUnsupp	; JNLE Jv
	; 90h
		dw small offset InstrUnsupp	; SETO Eb
		dw small offset InstrUnsupp	; SETNO Eb
		dw small offset InstrUnsupp	; SETB Eb
		dw small offset InstrUnsupp	; SETNB Eb
		dw small offset InstrUnsupp	; SETZ Eb
		dw small offset InstrUnsupp	; SETNZ Eb
		dw small offset InstrUnsupp	; SETBE Eb
		dw small offset InstrUnsupp	; SETNBE Eb
		dw small offset InstrUnsupp	; SETS Eb
		dw small offset InstrUnsupp	; SETNS Eb
		dw small offset InstrUnsupp	; SETP Eb
		dw small offset InstrUnsupp	; SETNP Eb
		dw small offset InstrUnsupp	; SETL Eb
		dw small offset InstrUnsupp	; SETNL Eb
		dw small offset InstrUnsupp	; SETLE Eb
		dw small offset InstrUnsupp	; SETNLE Eb
	; A0h
		dw small offset InstrUnsupp	; PUSH FS
		dw small offset InstrUnsupp	; POP FS
 IF V033S OR V033V
		dw small offset InstrUnsupp	; CPUID (some 486, Pentium+)
 ELSE
		dw small offset DecCPUID	; CPUID (some 486, Pentium+)
 ENDIF
		dw small offset InstrUnsupp	; BT Ev,Gv
		dw small offset InstrUnsupp	; SHLD Ev,Gv,Ib
		dw small offset InstrUnsupp	; SHLD Ev,Gv,CL
		dw small offset DecCMPXCHGb	; A-step 486: CMPXCHG / 386: XBTS
		dw small offset DecCMPXCHGw	; A-step 486: CMPXCHG / 386: IBTS
		dw small offset InstrUnsupp	; PUSH GS
		dw small offset InstrUnsupp	; POP GS
		dw small offset InstrUnsupp	; RSM (Pentium+, only in SM mode)
		dw small offset InstrUnsupp	; BTS Ev,Gv
		dw small offset InstrUnsupp	; SHRD Ev,Gv,Ib
		dw small offset InstrUnsupp	; SHRD Ev,Gv,CL
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp	; IMUL Gv,Ev
	; B0h
		dw small offset DecCMPXCHGb	; CMPXCHG Eb,Gb (486+)
		dw small offset DecCMPXCHGw	; CMPXCHG Ev,Gv (486+)
		dw small offset InstrUnsupp	; LSS Mp
		dw small offset InstrUnsupp	; BTR Ev,Gv
		dw small offset InstrUnsupp	; LFS Mp
		dw small offset InstrUnsupp	; LGS Mp
		dw small offset InstrUnsupp	; MOVZX Gv,Eb
		dw small offset InstrUnsupp	; MOVZX Gv,Ew
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset DecGRP8		; Grp8 Ev,Ib
		dw small offset InstrUnsupp	; BTC Ev,Gv
		dw small offset InstrUnsupp	; BSF Gv,Ev
		dw small offset InstrUnsupp	; BSR Gv,Ev
		dw small offset InstrUnsupp	; MOVSX Gv,Eb
		dw small offset InstrUnsupp	; MOVSX Gv,Ew
	; C0h
		dw small offset DecXADDb	; XADD Eb,Gb (486+)
		dw small offset DecXADDw	; XADD Ev,Gv (486+)
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp	; Grp9
		dw small offset DecBSWAPEAX	; BSWAP EAX (486+)
		dw small offset DecBSWAPECX	; BSWAP ECX (486+)
		dw small offset DecBSWAPEDX	; BSWAP EDX (486+)
		dw small offset DecBSWAPEBX	; BSWAP EBX (486+)
		dw small offset DecBSWAPESP	; BSWAP ESP (486+)
		dw small offset DecBSWAPEBP	; BSWAP EBP (486+)
		dw small offset DecBSWAPESI	; BSWAP ESI (486+)
		dw small offset DecBSWAPEDI	; BSWAP EDI (486+)
	; D0h
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
	; E0h
		dw small offset InstrUnsupp	; Nx586 hypermode: RETH
		dw small offset InstrUnsupp	; Nx586 hypermode: INTH
		dw small offset InstrUnsupp	; Nx586 hypermode: ??
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp	; Nx586 hypermode: ??
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp	; Nx586 hypermode: Group10
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
	; F0h
		dw small offset InstrUnsupp	; Nx586 hypermode: WRB normal segment
		dw small offset InstrUnsupp	; Nx586 hypermode: WRB other segment
		dw small offset InstrUnsupp	; Nx586 hypermode: RDB normal segment
		dw small offset InstrUnsupp	; Nx586 hypermode: RDB other segment
		dw small offset InstrUnsupp	; Nx586 hypermode: WRAR normal segment
		dw small offset InstrUnsupp	; Nx586 hypermode: WRAR other segment
		dw small offset InstrUnsupp	; Nx586 hypermode: RDAR normal segment
		dw small offset InstrUnsupp	; Nx586 hypermode: RDAR other segment
		dw small offset InstrUnsupp	; Nx586 hypermode: WRSEL normal segment
		dw small offset InstrUnsupp	; Nx586 hypermode: WRSEL other segment
		dw small offset InstrUnsupp	; Nx586 hypermode: LOPCMSK
		dw small offset InstrUnsupp	; Nx586 hypermode: RDSEL other segment
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp

; Opcodes determined by bits 5,4,3 of modR/M byte:
;
; Group| 000   | 001   | 010   | 011   | 100   | 101   | 110   | 111
; -----+-------+-------+-------+-------+-------+-------+-------+-------
;   1  | ADD   | OR    | ADC   | SBB   | AND   | SUB   | XOR   | CMP
; -----+-------+-------+-------+-------+-------+-------+-------+-------
;   2  | ROL   | ROR   | RCL   | RCR   | SHL   | SHR   | SHL   | SAR
; -----+-------+-------+-------+-------+-------+-------+-------+-------
;   3  | TEST  | TEST  | NOT   | NEG   | MUL   | IMUL  | DIV   | IDIV
;      | Ib/Iv | Ib/Iv |       |       | AL/eAX| AL/eAX| AL/eAX| AL/eAX
; -----+-------+-------+-------+-------+-------+-------+-------+-------
;   4  | INC   | DEC   |       |       |       |       |       |
;      | Eb    | Eb    |       |       |       |       |       |
; -----+-------+-------+-------+-------+-------+-------+-------+-------
;   5  | INC   | DEC   | CALL  | CALL  | JMP   | JMP   | PUSH  |
;      | Ev    | Ev    | Ev    | Ep    | Ev    | Ep    | Ev    |
; -----+-------+-------+-------+-------+-------+-------+-------+-------
;   6  | SLDT  | STR   | LLDT  | LTR   | VERR  | VERW  |       |
;      | Ew    | Ew    | Ew    | Ew    | Ew    | Ew    |       |
; -----+-------+-------+-------+-------+-------+-------+-------+-------
;   7  | SGDT  | SIDT  | LGDT  | LIDT  | SMSW  |       | LMSW  | INVLPG
;      | Ms    | Ms    | Ms    | Ms    | Ew    |       | Ew    | (486+)
; -----+-------+-------+-------+-------+-------+-------+-------+-------
;   8  |       |       |       |       | BT    | BTS   | BTR   | BTC
; -----+-------+-------+-------+-------+-------+-------+-------+-------
;   9  |       |CMPXCHG8B|     |       |       |       |       |
;      |       |Mq (Pentium+)| |       |       |       |       |
; -----+-------+-------+-------+-------+-------+-------+-------+-------
; Nx586 hypermode:
; Group| 000   | 001   | 010   | 011   | 100   | 101   | 110   | 111
; -----+-------+-------+-------+-------+-------+-------+-------+-------
;  10  | WRCFG0|       | WRCFG1| WRSBNK| WRCPL | RDCPL | RDMOST|
; -----+-------+-------+-------+-------+-------+-------+-------+-------

loc_5320:	mov	h_opflag[ebp], 0
		bts	h_opflag[ebp], 20	; only calculate effective address
		jmp	short loc_5346

loc_532E:	mov	h_opflag[ebp], 0	; reset opcode flags
		bt	h_efl[ebp], 8		; trap flag?
		jnc	short loc_5346
		or	h_dbflag[ebp], 20001h	; set bit 17 (generate #DB when exiting)
						; and bit 0 (#DB generated by single-stepping)
loc_5346:	mov	dword ptr h_opcode[ebp], 0
		mov	esi, h_eip2[ebp]
		RDAR	eax, cs
		bts	eax, 25			; R readable
		OP_0FE4
		WRAR	cs, eax
		bt	eax, 22			; D/B default operation size
		jnc	short loc_536F
		bts	h_opflag[ebp], 30	; set 32-bit operand size
		bts	h_opflag[ebp], 31	; set 32-bit address size

loc_536F:
 IF V033V OR V033W
		mov	eax, h_gatflag[ebp]
		and	eax, 3Fh
		cmp	eax, 3Ch
		jnz	short loc_57AF
		movzx	eax, byte ptr cs:[esi]	; read opcode byte
		cmp	al, 0DDh
		jnz	short loc_57AA
		mov	byte ptr h_opcode[ebp], al ; current opcode byte
		inc	h_opflag[ebp]		; length of opcode += 1
		inc	esi			; read next opcode
		movzx	ecx, byte ptr cs:[esi]	; byte into ECX
		cmp	cl, 0C0h
		jnc	short loc_57AA
		and	cl, 38h			; ModR/M
		cmp	cl, 20h			; FRSTOR
		jz	loc_5E75
		cmp	cl, 30h			; FSAVE
		jz	loc_5E75
loc_57AA:	jmp	InstrUnsupp
loc_57AF:
 ENDIF
		mov	ebx, offset DecTable
		add	ebx, h_base[ebp]

; dispatch next opcode byte via table
; E: EBX=pointer to decode table
;    ESI=current mortal mode EIP
loc_5377:	movzx	eax, byte ptr cs:[esi]	; read opcode byte
		mov	byte ptr h_opcode[ebp], al ; current opcode byte
		inc	h_opflag[ebp]		; length of opcode += 1
		inc	esi			; read next opcode
		movzx	ecx, byte ptr cs:[esi]	; byte into ECX
		shl	eax, 1
		movzx	eax, word ptr [ebx+eax]
		@JMP	eax


; Instruction starts with 0Fh

Decode0F:	bts	h_opflag[ebp], 23	; 0Fh opcode
		mov	ebx, offset DecTable0F
		add	ebx, h_base[ebp]
		jmp	short loc_5377


; Segment override prefixes

DecSEGES:	mov	h_segpre[ebp], 26h	; remember prefix ES
		mov	al, 1
		jmp	short loc_5412

DecSEGCS:	mov	h_segpre[ebp], 2Eh	; remember prefix CS
		mov	al, 2
		jmp	short loc_5412

DecSEGSS:	mov	h_segpre[ebp], 36h	; remember prefix SS
		mov	al, 3
		jmp	short loc_5412

DecSEGDS:	mov	h_segpre[ebp], 3Eh	; remember prefix DS
		mov	al, 4
		jmp	short loc_5412

DecSEGFS:	mov	h_segpre[ebp], 64h	; remember prefix FS
		mov	al, 5
		jmp	short loc_5412

DecSEGGS:	mov	h_segpre[ebp], 65h	; remember prefix GS
		mov	al, 6
		jmp	short loc_5412


; Operand and address size prefixes

DecOPSIZE:	; already seen this prefix?
		test	byte ptr h_opflag+2[ebp], 4	; = Bit 18 of h_opflag[ebp]
		jnz	short loc_5377		; don't flip twice
		btc	h_opflag[ebp], 30	; flip operand size
		bts	h_opflag[ebp], 18	; remember prefix
		jmp	short loc_5377

DecADDRSIZE:	; already seen this prefix?
		test	byte ptr h_opflag+2[ebp], 8	; = Bit 19 of h_opflag[ebp]
		jnz	short loc_5377		; yes, don't flip twice
		btc	h_opflag[ebp], 31	; flip address size
		bts	h_opflag[ebp], 19	; remember prefix
		jmp	short loc_5377


; LOCK, REP/REPE, REPNE prefixes

DecLOCK:	bts	h_opflag[ebp], 29	; remember LOCK prefix
		jmp	loc_5377

DecREP:		bts	h_opflag[ebp], 28	; remember REP prefix
		jmp	loc_5377

DecREPNE:	bts	h_opflag[ebp], 27	; remember REPNE prefix
		jmp	loc_5377

; from segment override prefix: AL=number (1=ES, .., 6=GS)
loc_5412:	or	byte ptr h_opflag+3[ebp], al ; remember prefix
		jmp	loc_5377		; and continue opcode dispatch


; Opcodes determined by bits 5,4,3 of ModR/M byte

DecGRP4:	mov	ebx, offset DecTableGrp4
		jmp	short loc_543D

DecGRP5:	mov	ebx, offset DecTableGrp5
		jmp	short loc_543D

DecGRP6:	mov	ebx, offset DecTableGrp6
		jmp	short loc_543D

DecGRP7:	mov	ebx, offset DecTableGrp7
		jmp	short loc_543D

DecGRP8:	mov	ebx, offset DecTableGrp8
		jmp	short loc_543D

; Dispatch opcode groups
loc_543D:	add	ebx, h_base[ebp]
		and	ecx, 38h		; ModR/M
		shr	ecx, 2
		movzx	eax, word ptr [ebx+ecx]
		@JMP	eax

; Come here for each escape opcode (0D8h-0DFh) if mod=11
loc_544F:	add	ebx, h_base[ebp]
		and	ecx, 3Fh
		shl	ecx, 1
		movzx	eax, word ptr [ebx+ecx]
		@JMP	eax


DecTableGrp4:	dw small offset InstrUnsupp	; INC Eb
		dw small offset InstrUnsupp	; DEC Eb
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp

DecTableGrp5:	dw small offset InstrUnsupp	; INC Ev
		dw small offset InstrUnsupp	; DEC Ev
		dw small offset InstrUnsupp	; CALL Ev
		dw small offset InstrUnsupp	; CALL Ep
		dw small offset InstrUnsupp	; JMP Ev
		dw small offset InstrUnsupp	; JMP Ep
		dw small offset InstrUnsupp	; PUSH Ev
		dw small offset InstrUnsupp

DecTableGrp6:	dw small offset InstrUnsupp	; SLDT Ew
		dw small offset InstrUnsupp	; STR Ew
		dw small offset InstrUnsupp	; LLDT Ew
		dw small offset InstrUnsupp	; LTR Ew
		dw small offset InstrUnsupp	; VERR Ew
		dw small offset InstrUnsupp	; VERW Ew
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp

DecTableGrp7:	dw small offset InstrUnsupp	; SGDT Ms
		dw small offset InstrUnsupp	; SIDT Ms
		dw small offset InstrUnsupp	; LGDT Ms
		dw small offset InstrUnsupp	; LIDT Ms
		dw small offset InstrUnsupp	; SMSW Ew
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp	; LMSW Ew
		dw small offset InstrUnsupp	; INVLPG

DecTableGrp8:	dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp
		dw small offset InstrUnsupp	; BT
		dw small offset InstrUnsupp	; BTS
		dw small offset InstrUnsupp	; BTR
		dw small offset InstrUnsupp	; BTC


DecodeD8:	cmp	ecx, 0C0h		; mod=11?
		jge	short loc_54C2
		mov	ebx, offset DecTableD8
		jmp	loc_543D

loc_54C2:	mov	ebx, offset DecTableD8C
		jmp	short loc_544F

		ALIGN	16

DecTableD8:	dw small offset loc_5B1C	; FADD single-real
		dw small offset loc_5B1C	; FMUL single-real
		dw small offset loc_5B1C	; FCOM single-real
		dw small offset loc_5B1C	; FCOMP single-real
		dw small offset loc_5B1C	; FSUB single-real
		dw small offset loc_5B1C	; FSUBR single-real
		dw small offset loc_5B1C	; FDIV single-real
		dw small offset loc_5B1C	; FDIVR single-real

DecTableD8C:	dw small offset loc_5B2C	; FADD ST(0),ST(0)
		dw small offset loc_5B2C	; FADD ST(0),ST(1)
		dw small offset loc_5B2C	; FADD ST(0),ST(2)
		dw small offset loc_5B2C	; FADD ST(0),ST(3)
		dw small offset loc_5B2C	; FADD ST(0),ST(4)
		dw small offset loc_5B2C	; FADD ST(0),ST(5)
		dw small offset loc_5B2C	; FADD ST(0),ST(6)
		dw small offset loc_5B2C	; FADD ST(0),ST(7)
		dw small offset loc_5B2C	; FMUL ST(0),ST(0)
		dw small offset loc_5B2C	; FMUL ST(0),ST(1)
		dw small offset loc_5B2C	; FMUL ST(0),ST(2)
		dw small offset loc_5B2C	; FMUL ST(0),ST(3)
		dw small offset loc_5B2C	; FMUL ST(0),ST(4)
		dw small offset loc_5B2C	; FMUL ST(0),ST(5)
		dw small offset loc_5B2C	; FMUL ST(0),ST(6)
		dw small offset loc_5B2C	; FMUL ST(0),ST(7)
	; D0h
		dw small offset loc_5B2C	; FCOM ST(0),ST(0)
		dw small offset loc_5B2C	; FCOM ST(0),ST(1)
		dw small offset loc_5B2C	; FCOM ST(0),ST(2)
		dw small offset loc_5B2C	; FCOM ST(0),ST(3)
		dw small offset loc_5B2C	; FCOM ST(0),ST(4)
		dw small offset loc_5B2C	; FCOM ST(0),ST(5)
		dw small offset loc_5B2C	; FCOM ST(0),ST(6)
		dw small offset loc_5B2C	; FCOM ST(0),ST(7)
		dw small offset loc_5B2C	; FCOMP ST(0),ST(0)
		dw small offset loc_5B2C	; FCOMP ST(0),ST(1)
		dw small offset loc_5B2C	; FCOMP ST(0),ST(2)
		dw small offset loc_5B2C	; FCOMP ST(0),ST(3)
		dw small offset loc_5B2C	; FCOMP ST(0),ST(4)
		dw small offset loc_5B2C	; FCOMP ST(0),ST(5)
		dw small offset loc_5B2C	; FCOMP ST(0),ST(6)
		dw small offset loc_5B2C	; FCOMP ST(0),ST(7)
	; E0h
		dw small offset loc_5B2C	; FSUB ST(0),ST(0)
		dw small offset loc_5B2C	; FSUB ST(0),ST(1)
		dw small offset loc_5B2C	; FSUB ST(0),ST(2)
		dw small offset loc_5B2C	; FSUB ST(0),ST(3)
		dw small offset loc_5B2C	; FSUB ST(0),ST(4)
		dw small offset loc_5B2C	; FSUB ST(0),ST(5)
		dw small offset loc_5B2C	; FSUB ST(0),ST(6)
		dw small offset loc_5B2C	; FSUB ST(0),ST(7)
		dw small offset loc_5B2C	; FSUBR ST(0),ST(0)
		dw small offset loc_5B2C	; FSUBR ST(0),ST(1)
		dw small offset loc_5B2C	; FSUBR ST(0),ST(2)
		dw small offset loc_5B2C	; FSUBR ST(0),ST(3)
		dw small offset loc_5B2C	; FSUBR ST(0),ST(4)
		dw small offset loc_5B2C	; FSUBR ST(0),ST(5)
		dw small offset loc_5B2C	; FSUBR ST(0),ST(6)
		dw small offset loc_5B2C	; FSUBR ST(0),ST(7)
	; F0h
		dw small offset loc_5B2C	; FDIV ST(0),ST(0)
		dw small offset loc_5B2C	; FDIV ST(0),ST(1)
		dw small offset loc_5B2C	; FDIV ST(0),ST(2)
		dw small offset loc_5B2C	; FDIV ST(0),ST(3)
		dw small offset loc_5B2C	; FDIV ST(0),ST(4)
		dw small offset loc_5B2C	; FDIV ST(0),ST(5)
		dw small offset loc_5B2C	; FDIV ST(0),ST(6)
		dw small offset loc_5B2C	; FDIV ST(0),ST(7)
		dw small offset loc_5B2C	; FDIVR ST(0),ST(0)
		dw small offset loc_5B2C	; FDIVR ST(0),ST(1)
		dw small offset loc_5B2C	; FDIVR ST(0),ST(2)
		dw small offset loc_5B2C	; FDIVR ST(0),ST(3)
		dw small offset loc_5B2C	; FDIVR ST(0),ST(4)
		dw small offset loc_5B2C	; FDIVR ST(0),ST(5)
		dw small offset loc_5B2C	; FDIVR ST(0),ST(6)
		dw small offset loc_5B2C	; FDIVR ST(0),ST(7)

DecodeD9:	cmp	ecx, 0C0h		; mod=11?
		jge	short loc_5572
		mov	ebx, offset DecTableD9
		jmp	loc_543D

loc_5572:	mov	ebx, offset DecTableD9C
		jmp	loc_544F

		ALIGN	16

DecTableD9:	dw small offset loc_5B1C	; FLD single-real
		dw small offset loc_5B1C	; Nx586 hypermode: FRDCFG
		dw small offset loc_5B1C	; FST single-real
		dw small offset loc_5B1C	; FSTP single-real
		dw small offset loc_5B1C	; FLDENV 14/28 bytes
		dw small offset loc_5B1C	; FLDCW 2 bytes
		dw small offset loc_5B1C	; FSTENV 14/28 bytes
		dw small offset loc_5B1C	; FSTCW 2 bytes

DecTableD9C:	dw small offset loc_5B2C	; FLD ST(0),ST(0)
		dw small offset loc_5B2C	; FLD ST(0),ST(1)
		dw small offset loc_5B2C	; FLD ST(0),ST(2)
		dw small offset loc_5B2C	; FLD ST(0),ST(3)
		dw small offset loc_5B2C	; FLD ST(0),ST(4)
		dw small offset loc_5B2C	; FLD ST(0),ST(5)
		dw small offset loc_5B2C	; FLD ST(0),ST(6)
		dw small offset loc_5B2C	; FLD ST(0),ST(7)
		dw small offset loc_5B2C	; FXCH ST(0),ST(0)
		dw small offset loc_5B2C	; FXCH ST(0),ST(1)
		dw small offset loc_5B2C	; FXCH ST(0),ST(2)
		dw small offset loc_5B2C	; FXCH ST(0),ST(3)
		dw small offset loc_5B2C	; FXCH ST(0),ST(4)
		dw small offset loc_5B2C	; FXCH ST(0),ST(5)
		dw small offset loc_5B2C	; FXCH ST(0),ST(6)
		dw small offset loc_5B2C	; FXCH ST(0),ST(7)
	; D0h
		dw small offset loc_5B2C	; FNOP
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
	; E0h
		dw small offset loc_5B2C	; FCHS
		dw small offset loc_5B2C	; FABS
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C	; FTST
		dw small offset loc_5B2C	; FXAM
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C	; FLD1
		dw small offset loc_5B2C	; FLDL2T
		dw small offset loc_5B2C	; FLDL2E
		dw small offset loc_5B2C	; FLDPI
		dw small offset loc_5B2C	; FLDLG2
		dw small offset loc_5B2C	; FLDLN2
		dw small offset loc_5B2C	; FLDZ
		dw small offset loc_5B2C	; Nx586 hypermode: ??
	; F0h
 IF V033S
		dw small offset DecF2XM1	; F2XM1
		dw small offset DecFYL2X	; FYL2X
		dw small offset DecFPTAN	; FPTAN
		dw small offset DecFPATAN	; FPATAN
		dw small offset DecFXTRACT	; FXTRACT
 ELSE
		dw small offset loc_5B1C	; F2XM1
		dw small offset loc_5B1C	; FYL2X
		dw small offset loc_5B1C	; FPTAN
		dw small offset loc_5B1C	; FPATAN
		dw small offset loc_5B1C	; FXTRACT
 ENDIF
		dw small offset loc_5B2C	; FPREM1 (387+)
		dw small offset loc_5B2C	; FDECSTP
		dw small offset loc_5B2C	; FINCSTP
		dw small offset loc_5B2C	; FPREM
 IF V033S
		dw small offset DecFYL2XP1	; FYL2XP1
		dw small offset DecFSQRT	; FSQRT
		dw small offset DecFSINCOS	; FSINCOS (387+)
 ELSE
		dw small offset loc_5B1C	; FYL2XP1
		dw small offset loc_5B1C	; FSQRT
		dw small offset loc_5B1C	; FSINCOS (387+)
 ENDIF
		dw small offset loc_5B2C	; FRNDINT
 IF V033S
		dw small offset DecFSCALE	; FSCALE
		dw small offset DecFSIN		; FSIN (387+)
		dw small offset DecFCOS		; FCOS (387+)
 ELSE
		dw small offset loc_5B1C	; FSCALE
		dw small offset loc_5B1C	; FSIN (387+)
		dw small offset loc_5B1C	; FCOS (387+)
 ENDIF

DecodeDA:	cmp	ecx, 0C0h		; mod=11?
		jge	short loc_5622
		mov	ebx, offset DecTableDA
		jmp	loc_543D

loc_5622:	mov	ebx, offset DecTableDAC
		jmp	loc_544F

		ALIGN	16

DecTableDA:	dw small offset loc_5B1C	; FIADD dword-integer
		dw small offset loc_5B1C	; FIMUL dword-integer
		dw small offset loc_5B1C	; FICOM dword-integer
		dw small offset loc_5B1C	; FICOMP dword-integer
		dw small offset loc_5B1C	; FISUB dword-integer
		dw small offset loc_5B1C	; FISUBR dword-integer
		dw small offset loc_5B1C	; FIDIV dword-integer
		dw small offset loc_5B1C	; FIDIVR dword-integer

DecTableDAC:	dw small offset loc_5B2C	; FCMOVB ST(0),ST(0) (P6+)
		dw small offset loc_5B2C	; FCMOVB ST(0),ST(1) (P6+)
		dw small offset loc_5B2C	; FCMOVB ST(0),ST(2) (P6+)
		dw small offset loc_5B2C	; FCMOVB ST(0),ST(3) (P6+)
		dw small offset loc_5B2C	; FCMOVB ST(0),ST(4) (P6+)
		dw small offset loc_5B2C	; FCMOVB ST(0),ST(5) (P6+)
		dw small offset loc_5B2C	; FCMOVB ST(0),ST(6) (P6+)
		dw small offset loc_5B2C	; FCMOVB ST(0),ST(7) (P6+)
		dw small offset loc_5B2C	; FCMOVE ST(0),ST(0) (P6+)
		dw small offset loc_5B2C	; FCMOVE ST(0),ST(1) (P6+)
		dw small offset loc_5B2C	; FCMOVE ST(0),ST(2) (P6+)
		dw small offset loc_5B2C	; FCMOVE ST(0),ST(3) (P6+)
		dw small offset loc_5B2C	; FCMOVE ST(0),ST(4) (P6+)
		dw small offset loc_5B2C	; FCMOVE ST(0),ST(5) (P6+)
		dw small offset loc_5B2C	; FCMOVE ST(0),ST(6) (P6+)
		dw small offset loc_5B2C	; FCMOVE ST(0),ST(7) (P6+)
	; D0h
		dw small offset loc_5B2C	; FCMOVBE ST(0),ST(0) (P6+)
		dw small offset loc_5B2C	; FCMOVBE ST(0),ST(1) (P6+)
		dw small offset loc_5B2C	; FCMOVBE ST(0),ST(2) (P6+)
		dw small offset loc_5B2C	; FCMOVBE ST(0),ST(3) (P6+)
		dw small offset loc_5B2C	; FCMOVBE ST(0),ST(4) (P6+)
		dw small offset loc_5B2C	; FCMOVBE ST(0),ST(5) (P6+)
		dw small offset loc_5B2C	; FCMOVBE ST(0),ST(6) (P6+)
		dw small offset loc_5B2C	; FCMOVBE ST(0),ST(7) (P6+)
		dw small offset loc_5B2C	; FCMOVU ST(0),ST(0) (P6+)
		dw small offset loc_5B2C	; FCMOVU ST(0),ST(1) (P6+)
		dw small offset loc_5B2C	; FCMOVU ST(0),ST(2) (P6+)
		dw small offset loc_5B2C	; FCMOVU ST(0),ST(3) (P6+)
		dw small offset loc_5B2C	; FCMOVU ST(0),ST(4) (P6+)
		dw small offset loc_5B2C	; FCMOVU ST(0),ST(5) (P6+)
		dw small offset loc_5B2C	; FCMOVU ST(0),ST(6) (P6+)
		dw small offset loc_5B2C	; FCMOVU ST(0),ST(7) (P6+)
	; E0h
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C	; FUCOMPP (387+)
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
	; F0h
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C

DecodeDB:	cmp	ecx, 0C0h		; mod=11?
		jge	short loc_56D2
		mov	ebx, offset DecTableDB
		jmp	loc_543D

loc_56D2:	mov	ebx, offset DecTableDBC
		jmp	loc_544F

		ALIGN	16

DecTableDB:	dw small offset loc_5B1C	; FILD dword-integer
		dw small offset loc_5B1C	; FISTTP dword-integer (SSE3)
		dw small offset loc_5B1C	; FIST dword-integer
		dw small offset loc_5B1C	; FISTP dword-integer
		dw small offset loc_5B1C	; Nx586 hypermode: FLDTW
		dw small offset loc_5B1C	; FLD extended-real
		dw small offset loc_5B1C	; Nx586 hypermode: FSTTW
		dw small offset loc_5B1C	; FSTP extended-real

DecTableDBC:	dw small offset loc_5B2C	; FCMOVNB ST(0),ST(0) (P6+)
		dw small offset loc_5B2C	; FCMOVNB ST(0),ST(1) (P6+)
		dw small offset loc_5B2C	; FCMOVNB ST(0),ST(2) (P6+)
		dw small offset loc_5B2C	; FCMOVNB ST(0),ST(3) (P6+)
		dw small offset loc_5B2C	; FCMOVNB ST(0),ST(4) (P6+)
		dw small offset loc_5B2C	; FCMOVNB ST(0),ST(5) (P6+)
		dw small offset loc_5B2C	; FCMOVNB ST(0),ST(6) (P6+)
		dw small offset loc_5B2C	; FCMOVNB ST(0),ST(7) (P6+)
		dw small offset loc_5B2C	; FCMOVNE ST(0),ST(0) (P6+)
		dw small offset loc_5B2C	; FCMOVNE ST(0),ST(1) (P6+)
		dw small offset loc_5B2C	; FCMOVNE ST(0),ST(2) (P6+)
		dw small offset loc_5B2C	; FCMOVNE ST(0),ST(3) (P6+)
		dw small offset loc_5B2C	; FCMOVNE ST(0),ST(4) (P6+)
		dw small offset loc_5B2C	; FCMOVNE ST(0),ST(5) (P6+)
		dw small offset loc_5B2C	; FCMOVNE ST(0),ST(6) (P6+)
		dw small offset loc_5B2C	; FCMOVNE ST(0),ST(7) (P6+)
	; D0h
		dw small offset loc_5B2C	; FCMOVNBE ST(0),ST(0) (P6+)
		dw small offset loc_5B2C	; FCMOVNBE ST(0),ST(1) (P6+)
		dw small offset loc_5B2C	; FCMOVNBE ST(0),ST(2) (P6+)
		dw small offset loc_5B2C	; FCMOVNBE ST(0),ST(3) (P6+)
		dw small offset loc_5B2C	; FCMOVNBE ST(0),ST(4) (P6+)
		dw small offset loc_5B2C	; FCMOVNBE ST(0),ST(5) (P6+)
		dw small offset loc_5B2C	; FCMOVNBE ST(0),ST(6) (P6+)
		dw small offset loc_5B2C	; FCMOVNBE ST(0),ST(7) (P6+)
		dw small offset loc_5B2C	; FCMOVNU ST(0),ST(0) (P6+)
		dw small offset loc_5B2C	; FCMOVNU ST(0),ST(1) (P6+)
		dw small offset loc_5B2C	; FCMOVNU ST(0),ST(2) (P6+)
		dw small offset loc_5B2C	; FCMOVNU ST(0),ST(3) (P6+)
		dw small offset loc_5B2C	; FCMOVNU ST(0),ST(4) (P6+)
		dw small offset loc_5B2C	; FCMOVNU ST(0),ST(5) (P6+)
		dw small offset loc_5B2C	; FCMOVNU ST(0),ST(6) (P6+)
		dw small offset loc_5B2C	; FCMOVNU ST(0),ST(7) (P6+)
	; E0h
		dw small offset loc_5B2C	; FENI (only 87, treated as NOP on later FPUs)
		dw small offset loc_5B2C	; FDISI (only 87, treated as NOP on later FPUs)
		dw small offset loc_5B2C	; FCLEX
		dw small offset loc_5B2C	; FINIT
		dw small offset loc_5B2C	; FSETPM (only 287, treated as NOP on later FPUs)
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C	; FUCOMI ST(0),ST(0) (P6+)
		dw small offset loc_5B2C	; FUCOMI ST(0),ST(1) (P6+)
		dw small offset loc_5B2C	; FUCOMI ST(0),ST(2) (P6+)
		dw small offset loc_5B2C	; FUCOMI ST(0),ST(3) (P6+)
		dw small offset loc_5B2C	; FUCOMI ST(0),ST(4) (P6+)
		dw small offset loc_5B2C	; FUCOMI ST(0),ST(5) (P6+)
		dw small offset loc_5B2C	; FUCOMI ST(0),ST(6) (P6+)
		dw small offset loc_5B2C	; FUCOMI ST(0),ST(7) (P6+)
	; F0h
		dw small offset loc_5B2C	; FCOMI ST(0),ST(0) (P6+)
		dw small offset loc_5B2C	; FCOMI ST(0),ST(1) (P6+)
		dw small offset loc_5B2C	; FCOMI ST(0),ST(2) (P6+)
		dw small offset loc_5B2C	; FCOMI ST(0),ST(3) (P6+)
		dw small offset loc_5B2C	; FCOMI ST(0),ST(4) (P6+)
		dw small offset loc_5B2C	; FCOMI ST(0),ST(5) (P6+)
		dw small offset loc_5B2C	; FCOMI ST(0),ST(6) (P6+)
		dw small offset loc_5B2C	; FCOMI ST(0),ST(7) (P6+)
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C

DecodeDC:	cmp	ecx, 0C0h		; mod=11?
		jge	short loc_5782
		mov	ebx, offset DecTableDC
		jmp	loc_543D

loc_5782:	mov	ebx, offset DecTableDCC
		jmp	loc_544F

		ALIGN	16

DecTableDC:	dw small offset loc_5B1C	; FADD double-real
		dw small offset loc_5B1C	; FMUL double-real
		dw small offset loc_5B1C	; FCOM double-real
		dw small offset loc_5B1C	; FCOMP double-real
		dw small offset loc_5B1C	; FSUB double-real
		dw small offset loc_5B1C	; FSUBR double-real
		dw small offset loc_5B1C	; FDIV double-real
		dw small offset loc_5B1C	; FDIVR double-real

DecTableDCC:	dw small offset loc_5B2C	; FADD ST(0),ST(0)
		dw small offset loc_5B2C	; FADD ST(1),ST(0)
		dw small offset loc_5B2C	; FADD ST(2),ST(0)
		dw small offset loc_5B2C	; FADD ST(3),ST(0)
		dw small offset loc_5B2C	; FADD ST(4),ST(0)
		dw small offset loc_5B2C	; FADD ST(5),ST(0)
		dw small offset loc_5B2C	; FADD ST(6),ST(0)
		dw small offset loc_5B2C	; FADD ST(7),ST(0)
		dw small offset loc_5B2C	; FMUL ST(0),ST(0)
		dw small offset loc_5B2C	; FMUL ST(1),ST(0)
		dw small offset loc_5B2C	; FMUL ST(2),ST(0)
		dw small offset loc_5B2C	; FMUL ST(3),ST(0)
		dw small offset loc_5B2C	; FMUL ST(4),ST(0)
		dw small offset loc_5B2C	; FMUL ST(5),ST(0)
		dw small offset loc_5B2C	; FMUL ST(6),ST(0)
		dw small offset loc_5B2C	; FMUL ST(7),ST(0)
	; D0h
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
	; E0h
		dw small offset loc_5B2C	; FSUBR ST(0),ST(0)
		dw small offset loc_5B2C	; FSUBR ST(1),ST(0)
		dw small offset loc_5B2C	; FSUBR ST(2),ST(0)
		dw small offset loc_5B2C	; FSUBR ST(3),ST(0)
		dw small offset loc_5B2C	; FSUBR ST(4),ST(0)
		dw small offset loc_5B2C	; FSUBR ST(5),ST(0)
		dw small offset loc_5B2C	; FSUBR ST(6),ST(0)
		dw small offset loc_5B2C	; FSUBR ST(7),ST(0)
		dw small offset loc_5B2C	; FSUB ST(0),ST(0)
		dw small offset loc_5B2C	; FSUB ST(1),ST(0)
		dw small offset loc_5B2C	; FSUB ST(2),ST(0)
		dw small offset loc_5B2C	; FSUB ST(3),ST(0)
		dw small offset loc_5B2C	; FSUB ST(4),ST(0)
		dw small offset loc_5B2C	; FSUB ST(5),ST(0)
		dw small offset loc_5B2C	; FSUB ST(6),ST(0)
		dw small offset loc_5B2C	; FSUB ST(7),ST(0)
	; F0h
		dw small offset loc_5B2C	; FDIVR ST(0),ST(0)
		dw small offset loc_5B2C	; FDIVR ST(1),ST(0)
		dw small offset loc_5B2C	; FDIVR ST(2),ST(0)
		dw small offset loc_5B2C	; FDIVR ST(3),ST(0)
		dw small offset loc_5B2C	; FDIVR ST(4),ST(0)
		dw small offset loc_5B2C	; FDIVR ST(5),ST(0)
		dw small offset loc_5B2C	; FDIVR ST(6),ST(0)
		dw small offset loc_5B2C	; FDIVR ST(7),ST(0)
		dw small offset loc_5B2C	; FDIV ST(0),ST(0)
		dw small offset loc_5B2C	; FDIV ST(1),ST(0)
		dw small offset loc_5B2C	; FDIV ST(2),ST(0)
		dw small offset loc_5B2C	; FDIV ST(3),ST(0)
		dw small offset loc_5B2C	; FDIV ST(4),ST(0)
		dw small offset loc_5B2C	; FDIV ST(5),ST(0)
		dw small offset loc_5B2C	; FDIV ST(6),ST(0)
		dw small offset loc_5B2C	; FDIV ST(7),ST(0)

DecodeDD:	cmp	ecx, 0C0h		; mod=11?
		jge	short loc_5832
		mov	ebx, offset DecTableDD
		jmp	loc_543D

loc_5832:	mov	ebx, offset DecTableDDC
		jmp	loc_544F

		ALIGN	16

DecTableDD:	dw small offset loc_5B1C	; FLD double-real
		dw small offset loc_5B1C	; FISTTP integer64 (SSE3), Nx586 hypermode: ??
		dw small offset loc_5B1C	; FST double-real
		dw small offset loc_5B1C	; FSTP double-real
		dw small offset loc_5B1C	; FRSTOR 98/108 bytes
		dw small offset loc_5B1C	; Nx586 hypermode: FLDSW
		dw small offset loc_5B1C	; FSAVE 98/108 bytes
		dw small offset loc_5B1C	; FSTSW 2 bytes

DecTableDDC:	dw small offset loc_5B2C	; FFREE ST(0)
		dw small offset loc_5B2C	; FFREE ST(1)
		dw small offset loc_5B2C	; FFREE ST(2)
		dw small offset loc_5B2C	; FFREE ST(3)
		dw small offset loc_5B2C	; FFREE ST(4)
		dw small offset loc_5B2C	; FFREE ST(5)
		dw small offset loc_5B2C	; FFREE ST(6)
		dw small offset loc_5B2C	; FFREE ST(7)
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
	; D0h
		dw small offset loc_5B2C	; FST ST(0)
		dw small offset loc_5B2C	; FST ST(1)
		dw small offset loc_5B2C	; FST ST(2)
		dw small offset loc_5B2C	; FST ST(3)
		dw small offset loc_5B2C	; FST ST(4)
		dw small offset loc_5B2C	; FST ST(5)
		dw small offset loc_5B2C	; FST ST(6)
		dw small offset loc_5B2C	; FST ST(7)
		dw small offset loc_5B2C	; FSTP ST(0)
		dw small offset loc_5B2C	; FSTP ST(1)
		dw small offset loc_5B2C	; FSTP ST(2)
		dw small offset loc_5B2C	; FSTP ST(3)
		dw small offset loc_5B2C	; FSTP ST(4)
		dw small offset loc_5B2C	; FSTP ST(5)
		dw small offset loc_5B2C	; FSTP ST(6)
		dw small offset loc_5B2C	; FSTP ST(7)
	; E0h
		dw small offset loc_5B2C	; FUCOM ST(0),ST(0) (387+)
		dw small offset loc_5B2C	; FUCOM ST(1),ST(0) (387+)
		dw small offset loc_5B2C	; FUCOM ST(2),ST(0) (387+)
		dw small offset loc_5B2C	; FUCOM ST(3),ST(0) (387+)
		dw small offset loc_5B2C	; FUCOM ST(4),ST(0) (387+)
		dw small offset loc_5B2C	; FUCOM ST(5),ST(0) (387+)
		dw small offset loc_5B2C	; FUCOM ST(6),ST(0) (387+)
		dw small offset loc_5B2C	; FUCOM ST(7),ST(0) (387+)
		dw small offset loc_5B2C	; FUCOMP ST(0),ST(0) (387+)
		dw small offset loc_5B2C	; FUCOMP ST(1),ST(0) (387+)
		dw small offset loc_5B2C	; FUCOMP ST(2),ST(0) (387+)
		dw small offset loc_5B2C	; FUCOMP ST(3),ST(0) (387+)
		dw small offset loc_5B2C	; FUCOMP ST(4),ST(0) (387+)
		dw small offset loc_5B2C	; FUCOMP ST(5),ST(0) (387+)
		dw small offset loc_5B2C	; FUCOMP ST(6),ST(0) (387+)
		dw small offset loc_5B2C	; FUCOMP ST(7),ST(0) (387+)
	; F0h
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C

DecodeDE:	cmp	ecx, 0C0h		; mod=11?
		jge	short loc_58E2
		mov	ebx, offset DecTableDE
		jmp	loc_543D

loc_58E2:	mov	ebx, offset DecTableDEC
		jmp	loc_544F

		ALIGN	16

DecTableDE:	dw small offset loc_5B1C	; FIADD word-integer
		dw small offset loc_5B1C	; FIMUL word-integer
		dw small offset loc_5B1C	; FICOM word-integer
		dw small offset loc_5B1C	; FICOMP word-integer
		dw small offset loc_5B1C	; FISUB word-integer
		dw small offset loc_5B1C	; FISUBR word-integer
		dw small offset loc_5B1C	; FIDIV word-integer
		dw small offset loc_5B1C	; FIDIVR word-integer

DecTableDEC:	dw small offset loc_5B2C	; FADDP ST(0),ST(0)
		dw small offset loc_5B2C	; FADDP ST(1),ST(0)
		dw small offset loc_5B2C	; FADDP ST(2),ST(0)
		dw small offset loc_5B2C	; FADDP ST(3),ST(0)
		dw small offset loc_5B2C	; FADDP ST(4),ST(0)
		dw small offset loc_5B2C	; FADDP ST(5),ST(0)
		dw small offset loc_5B2C	; FADDP ST(6),ST(0)
		dw small offset loc_5B2C	; FADDP ST(7),ST(0)
		dw small offset loc_5B2C	; FMULP ST(0),ST(0)
		dw small offset loc_5B2C	; FMULP ST(1),ST(0)
		dw small offset loc_5B2C	; FMULP ST(2),ST(0)
		dw small offset loc_5B2C	; FMULP ST(3),ST(0)
		dw small offset loc_5B2C	; FMULP ST(4),ST(0)
		dw small offset loc_5B2C	; FMULP ST(5),ST(0)
		dw small offset loc_5B2C	; FMULP ST(6),ST(0)
		dw small offset loc_5B2C	; FMULP ST(7),ST(0)
	; D0h
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C	; FCOMPP
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
	; E0h
		dw small offset loc_5B2C	; FSUBRP ST(0),ST(0)
		dw small offset loc_5B2C	; FSUBRP ST(1),ST(0)
		dw small offset loc_5B2C	; FSUBRP ST(2),ST(0)
		dw small offset loc_5B2C	; FSUBRP ST(3),ST(0)
		dw small offset loc_5B2C	; FSUBRP ST(4),ST(0)
		dw small offset loc_5B2C	; FSUBRP ST(5),ST(0)
		dw small offset loc_5B2C	; FSUBRP ST(6),ST(0)
		dw small offset loc_5B2C	; FSUBRP ST(7),ST(0)
		dw small offset loc_5B2C	; FSUBP ST(0),ST(0)
		dw small offset loc_5B2C	; FSUBP ST(1),ST(0)
		dw small offset loc_5B2C	; FSUBP ST(2),ST(0)
		dw small offset loc_5B2C	; FSUBP ST(3),ST(0)
		dw small offset loc_5B2C	; FSUBP ST(4),ST(0)
		dw small offset loc_5B2C	; FSUBP ST(5),ST(0)
		dw small offset loc_5B2C	; FSUBP ST(6),ST(0)
		dw small offset loc_5B2C	; FSUBP ST(7),ST(0)
	; F0h
		dw small offset loc_5B2C	; FDIVRP ST(0),ST(0)
		dw small offset loc_5B2C	; FDIVRP ST(1),ST(0)
		dw small offset loc_5B2C	; FDIVRP ST(2),ST(0)
		dw small offset loc_5B2C	; FDIVRP ST(3),ST(0)
		dw small offset loc_5B2C	; FDIVRP ST(4),ST(0)
		dw small offset loc_5B2C	; FDIVRP ST(5),ST(0)
		dw small offset loc_5B2C	; FDIVRP ST(6),ST(0)
		dw small offset loc_5B2C	; FDIVRP ST(7),ST(0)
		dw small offset loc_5B2C	; FDIVP ST(0),ST(0)
		dw small offset loc_5B2C	; FDIVP ST(1),ST(0)
		dw small offset loc_5B2C	; FDIVP ST(2),ST(0)
		dw small offset loc_5B2C	; FDIVP ST(3),ST(0)
		dw small offset loc_5B2C	; FDIVP ST(4),ST(0)
		dw small offset loc_5B2C	; FDIVP ST(5),ST(0)
		dw small offset loc_5B2C	; FDIVP ST(6),ST(0)
		dw small offset loc_5B2C	; FDIVP ST(7),ST(0)

DecodeDF:	cmp	ecx, 0C0h		; mod=11?
		jge	short loc_5992
		mov	ebx, offset DecTableDF
		jmp	loc_543D

loc_5992:	mov	ebx, offset DecTableDFC
		jmp	loc_544F

		ALIGN	16

DecTableDF:	dw small offset loc_5B1C	; FILD word-integer
		dw small offset loc_5B1C	; FISTTP word-integer (SSE3), Nx586 hypermode: FWRCFG
		dw small offset loc_5B1C	; FIST word-integer
		dw small offset loc_5B1C	; FISTP word-integer
		dw small offset DecFBLD		; FBLD packed-BCD
		dw small offset loc_5B1C	; FILD qword-integer
		dw small offset DecFBSTP	; FBSTP
		dw small offset loc_5B1C	; FISTP qword-integer

DecTableDFC:	dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
	; D0h
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
	; E0h
		dw small offset loc_5B2C	; FSTSW AX
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C	; FCOMIP ST(0),ST(0) (P6+)
		dw small offset loc_5B2C	; FCOMIP ST(0),ST(1) (P6+)
		dw small offset loc_5B2C	; FCOMIP ST(0),ST(2) (P6+)
		dw small offset loc_5B2C	; FCOMIP ST(0),ST(3) (P6+)
		dw small offset loc_5B2C	; FCOMIP ST(0),ST(4) (P6+)
		dw small offset loc_5B2C	; FCOMIP ST(0),ST(5) (P6+)
		dw small offset loc_5B2C	; FCOMIP ST(0),ST(6) (P6+)
		dw small offset loc_5B2C	; FCOMIP ST(0),ST(7) (P6+)
	; F0h
		dw small offset loc_5B2C	; FUCOMIP ST(0),ST(0) (P6+)
		dw small offset loc_5B2C	; FUCOMIP ST(0),ST(1) (P6+)
		dw small offset loc_5B2C	; FUCOMIP ST(0),ST(2) (P6+)
		dw small offset loc_5B2C	; FUCOMIP ST(0),ST(3) (P6+)
		dw small offset loc_5B2C	; FUCOMIP ST(0),ST(4) (P6+)
		dw small offset loc_5B2C	; FUCOMIP ST(0),ST(5) (P6+)
		dw small offset loc_5B2C	; FUCOMIP ST(0),ST(6) (P6+)
		dw small offset loc_5B2C	; FUCOMIP ST(0),ST(7) (P6+)
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C
		dw small offset loc_5B2C


DecINTO:
 IF V033S
		jmp	short loc_5B3B
 ELSE
		jmp	loc_5B3B
 ENDIF

 IF V033V OR V033W
; FRSTOR and FSAVE go here
; Does a read and write access (without changing the value) to the first
; and last Word (16 bit operand size) or DWord (32 bit operand size) of
; the FPU State information before actual execution.
loc_5E75:
 ENDIF
 IF NOT V033S
		or	byte ptr h_opflag+2[ebp], 10h	; bit 20, only calculate effective address
		@CALL	GetOperand
		xor	eax, eax
		mov	ebx, eax
		mov	al, byte ptr h_opflag+3[ebp]	; segment prefix
		and	al, 7
		shl	al, 1
		add	eax, h_base[ebp]
		test	byte ptr h_opflag+3[ebp], 40h	; bit 30, operand size
		jnz	short loc_5A5E
		; 16 bit
		add	eax, offset loc_5A65
		jmp	eax

loc_5A5E:	; 32 bit
		add	eax, offset loc_5AC5
		jmp	eax

; 16 bit operand size
; 14 byte FPU State Registers + 8 x 10 byte FP Data Registers = 94 byte
; So last Word starts at offset 92
loc_5A65:	jmp	short loc_5A75	; none
		jmp	short loc_5A9C	; ES
		jmp	short loc_5A82	; CS
		jmp	short loc_5A8F	; SS
		jmp	short loc_5A75	; DS
		jmp	short loc_5AA9	; FS
		jmp	short loc_5AB6	; GS
		jmp	$		; fatal

loc_5A75:	segds
		or	word ptr [edx],	0
		segds
		or	word ptr [edx+92], 0
		jmp	short loc_5AC3

loc_5A82:	or	word ptr cs:[edx], 0
		or	word ptr cs:[edx+92], 0
		jmp	short loc_5AC3

loc_5A8F:	or	word ptr ss:[edx], 0
		or	word ptr ss:[edx+92], 0
		jmp	short loc_5AC3

loc_5A9C:	or	word ptr es:[edx], 0
		or	word ptr es:[edx+92], 0
		jmp	short loc_5AC3

loc_5AA9:	or	word ptr fs:[edx], 0
		or	word ptr fs:[edx+92], 0
		jmp	short loc_5AC3

loc_5AB6:	or	word ptr gs:[edx], 0
		or	word ptr gs:[edx+92], 0
		jmp	short loc_5AC3

loc_5AC3:	jmp	short loc_5B17

; 32 bit operand size
; 28 byte FPU State Registers + 8 x 10 byte FP Data Registers = 108 byte
; So last DWord starts at offset 104
loc_5AC5:	jmp	short loc_5AD5	; none
		jmp	short loc_5AF6	; ES
		jmp	short loc_5AE0	; CS
		jmp	short loc_5AEB	; SS
		jmp	short loc_5AD5	; DS
		jmp	short loc_5B01	; FS
		jmp	short loc_5B0C	; GS
		jmp	$		; fatal

loc_5AD5:	segds
		or	dword ptr [edx], 0
		segds
		or	dword ptr [edx+104], 0
		jmp	short loc_5B17

loc_5AE0:	or	dword ptr cs:[edx], 0
		or	dword ptr cs:[edx+104],	0
		jmp	short loc_5B17

loc_5AEB:	or	dword ptr ss:[edx], 0
		or	dword ptr ss:[edx+104],	0
		jmp	short loc_5B17

loc_5AF6:	or	dword ptr es:[edx], 0
		or	dword ptr es:[edx+104],	0
		jmp	short loc_5B17

loc_5B01:	or	dword ptr fs:[edx], 0
		or	dword ptr fs:[edx+104],	0
		jmp	short loc_5B17

loc_5B0C:	or	dword ptr gs:[edx], 0
		or	dword ptr gs:[edx+104],	0
		jmp	short loc_5B17

loc_5B17:	jmp	ForceExec
 ENDIF

loc_5B1C:	or	byte ptr h_opflag+2[ebp], 10h ; bit 20, only calculate effective address
		@CALL	GetOperand
		jmp	short loc_5B3B

loc_5B2C:	mov	ah, byte ptr h_opcode[ebp]
		mov	al, cs:[esi]
		mov	h_opcode[ebp], ax
		inc	h_opflag[ebp]
		jmp	short loc_5B3B

loc_5B3B:	; set next instruction pointer
		movzx	ebx, byte ptr h_opflag[ebp] ; opcode length
		add	ebx, h_eip2[ebp]	; + current IP
		mov	h_eip3[ebp], ebx	; = next IP
		@RET

loc_5B51:	mov	ebx, h_eip3[ebp]
		jmp	short loc_5B69

loc_5B59:	movzx	ebx, byte ptr h_opflag[ebp]
		add	ebx, h_eip2[ebp]
		mov	h_eip3[ebp], ebx
loc_5B69:	mov	h_eip2[ebp], ebx
		mov	eax, dr7
		push	eax
 IF NOT V033S
		bts	word ptr h_dbflag[ebp], 2	; remember DR7 was saved in h_dr7
		mov	h_dr7[ebp], eax
 ENDIF
		xor	eax, eax
		mov	dr7, eax
		mov	al, cs:[ebx]
		pop	eax
		mov	dr7, eax
 IF NOT V033S
		btr	word ptr h_dbflag[ebp], 2
 ENDIF
 IF V033S OR V033V
		cmp	h_uart[ebp], 3F8h
		jz	short loc_59A9
		cmp	h_uart[ebp], 2F8h
		jz	short loc_59A9
		jmp	short loc_5B93	; h_uart == 0

loc_59A9:	; h_uart != 0
		pushf
		pop	eax
		btr	eax, 17		; Virtual 8086 Mode (VM)
		bts	eax, 12		; I/O Privilege Level (IOPL)
		bts	eax, 13		;	"
		push    eax
		popf
		@CALL	loc_6B9A
		cmp     bl, 0
		jz      short loc_5B93
		@CALL	loc_708A
		@CALL	loc_6AA8
 ELSE
		jmp	short loc_5B93	; unnecessary
 ENDIF

loc_5B93:	bt	h_dbflag[ebp], 17	; generate #DB when exiting
		jc	ExcpDebugExcp
		lea	esp, h_edi[ebp]
		pop	edi
		pop	esi
		pop	edx
		pop	ecx
		pop	ebx
		pop	eax
		pop	ebp
		add	esp, 8
		OP_0FE4
		RETH

; Instruction not supported
InstrUnsupp:	mov	eax, h_gatflag[ebp]
		and	eax, 3Fh
		cmp	eax, 3Eh
		jnc	short InstrInvalid
		jmp	short ForceExec

InstrInvalid:	push	EXCP_INVALIDOP+FORCEBIG
		xor	eax, eax
		push	eax
		jmp	loc_2AA7

; restart instruction with masked hypercode exception
; (force direct execution by CPU)
ForceExec:	mov	eax, h_eip2[ebp]
		mov	h_eip3[ebp], eax
		mov	eax, h_cfg0[ebp]
		bts	eax, 31		; mask DECEXCP p-op (suppress hyper-
					; mode exception on next instruction)
		mov	ebx, h_cfg1[ebp]
		bts	ebx, 23
		and	h_dbflag[ebp], 0FFFDFFFEh
		; clear bits 0 (#DB generated by single-stepping)
		; and 17 (generate #DB when exiting)
		DELAYNOP 2
		WRCFG0	eax
		WRCFG1	ebx
		RDAR	eax, cs
		bts	eax, 25			; R = Readable
		OP_0FE4
		WRAR	cs, eax
		jmp	loc_5B51

		ALIGN	16

; MOD+R/M 16-bit
OpTable16:	; MOD=00
		dw small offset Op_BX_SI	; [BX+SI]
		dw small offset Op_BX_DI	; [BX+DI]
		dw small offset Op_BP_SI	; [BP+SI]
		dw small offset Op_BP_DI	; [BP+DI]
		dw small offset Op_SI		; [SI]
		dw small offset Op_DI		; [DI]
		dw small offset Op_d16		; disp16
		dw small offset Op_BX		; [BX]
		; MOD=01
		dw small offset Op_BX_SI_8	; [BX+SI]+disp8
		dw small offset Op_BX_DI_8	; [BX+DI]+disp8
		dw small offset Op_BP_SI_8	; [BP+SI]+disp8
		dw small offset Op_BP_DI_8	; [BP+DI]+disp8
		dw small offset Op_SI_8		; [SI]+disp8
		dw small offset Op_DI_8		; [DI]+disp8
		dw small offset Op_BP_8		; [BP]+disp8
		dw small offset Op_BX_8		; [BX]+disp8
		; MOD=10
		dw small offset Op_BX_SI_16	; [BX+SI]+disp16
		dw small offset Op_BX_DI_16	; [BX+DI]+disp16
		dw small offset Op_BP_SI_16	; [BP+SI]+disp16
		dw small offset Op_BP_DI_16	; [BP+DI]+disp16
		dw small offset Op_SI_16	; [SI]+disp16
		dw small offset Op_DI_16	; [DI]+disp16
		dw small offset Op_BP_16	; [BP]+disp16
		dw small offset Op_BX_16	; [BX]+disp16
		; MOD=11
		dw small offset Op_rEAX		; EAX/AX/AL
		dw small offset Op_rECX		; ECX/CX/CL
		dw small offset Op_rEDX		; EDX/DX/DL
		dw small offset Op_rEBX		; EBX/BX/BL
		dw small offset Op_rESP		; ESP/SP/AH
		dw small offset Op_rEBP		; EBP/BP/CH
		dw small offset Op_rESI		; ESI/SI/DH
		dw small offset Op_rEDI		; EDI/DI/BH

; MOD+R/M-32bit ([--][--] means a SIB byte follows)
OpTable32:	; MOD=00
		dw small offset Op_EAX		; [EAX]
		dw small offset Op_ECX		; [ECX]
		dw small offset Op_EDX		; [EDX]
		dw small offset Op_EBX		; [EBX]
		dw small offset Op_SIB		; [--][--]
		dw small offset Op_d32		; disp32
		dw small offset Op_ESI		; [ESI]
		dw small offset Op_EDI		; [EDI]
		; MOD=01
		dw small offset Op_EAX_8	; disp8[EAX]
		dw small offset Op_ECX_8	; disp8[ECX]
		dw small offset Op_EDX_8	; disp8[EDX]
		dw small offset Op_EBX_8	; disp8[EBX]
		dw small offset Op_SIB		; disp8[--][--]
		dw small offset Op_EBP_8	; disp8[EBP]
		dw small offset Op_ESI_8	; disp8[ESI]
		dw small offset Op_EDI_8	; disp8[EDI]
		; MOD=10
		dw small offset Op_EAX_32	; disp32[EAX]
		dw small offset Op_ECX_32	; disp32[ECX]
		dw small offset Op_EDX_32	; disp32[EDX]
		dw small offset Op_EBX_32	; disp32[EBX]
		dw small offset Op_SIB		; disp32[--][--]
		dw small offset Op_EBP_32	; disp32[EBP]
		dw small offset Op_ESI_32	; disp32[ESI]
		dw small offset Op_EDI_32	; disp32[EDI]
		; MOD=11
		dw small offset Op_rEAX		; EAX/AX/AL
		dw small offset Op_rECX		; ECX/CX/CL
		dw small offset Op_rEDX		; EDX/DX/DL
		dw small offset Op_rEBX		; EBX/BX/BL
		dw small offset Op_rESP		; ESP/SP/AH
		dw small offset Op_rEBP		; EBP/BP/CH
		dw small offset Op_rESI		; ESI/SI/DH
		dw small offset Op_rEDI		; EDI/DI/BH

; SIB byte-32bit
; MOD field + BASE field
OpTableModBase:
		; MOD=00
		dw small offset Op_EAX		; +EAX
		dw small offset Op_ECX		; +ECX
		dw small offset Op_EDX		; +EDX
		dw small offset Op_EBX		; +EBX
		dw small offset Op_ESP		; +ESP
		dw small offset Op_d32		; +disp32
		dw small offset Op_ESI		; +ESI
		dw small offset Op_EDI		; +EDI
		; MOD=01
		dw small offset Op_EAX_8	; +EAX+disp8
		dw small offset Op_ECX_8	; +ECX+disp8
		dw small offset Op_EDX_8	; +EDX+disp8
		dw small offset Op_EBX_8	; +EBX+disp8
		dw small offset Op_ESP_8	; +ESP+disp8
		dw small offset Op_EBP_8	; +EBP+disp8
		dw small offset Op_ESI_8	; +ESI+disp8
		dw small offset Op_EDI_8	; +EDI+disp8
		; MOD=10
		dw small offset Op_EAX_32	; +EAX+disp32
		dw small offset Op_ECX_32	; +ECX+disp32
		dw small offset Op_EDX_32	; +EDX+disp32
		dw small offset Op_EBX_32	; +EBX+disp32
		dw small offset Op_ESP_32	; +ESP+disp32
		dw small offset Op_EBP_32	; +EBP+disp32
		dw small offset Op_ESI_32	; +ESI+disp32
		dw small offset Op_EDI_32	; +EDI+disp32

; INDEX field
OpTableIndex:	dw small offset Op_xEAX		; [EAX*x]
		dw small offset Op_xECX		; [ECX*x]
		dw small offset Op_xEDX		; [EDX*x]
		dw small offset Op_xEBX		; [EBX*x]
		dw small offset Op_xNone	; none
		dw small offset Op_xEBP		; [EBP*x]
		dw small offset Op_xESI		; [ESI*x]
		dw small offset Op_xEDI		; [EDI*x]


; get operand (via ModR/M and SIB byte)
; E: if h_opflag bit 20 is set, do not fetch value from the calculated effective
;    address into h_content
GetOperand:	movzx	eax, byte ptr cs:[esi]	; ModR/M byte
 IF VVL
loc_5CE4:
 ENDIF
		inc	h_opflag[ebp]
		inc	esi
		mov	h_modrm[ebp], eax
		mov	dword ptr h_sib[ebp], 0
		mov	dword ptr h_disp[ebp], 0
		; AL= 7-6 MOD, 5-3 REG/OPCODE, 2-0 R/M
		shl	eax, 2		; MOD field into AH
		shl	al, 3		; shift out REG/OPCODE field
		shr	eax, 4		; = (MOD combined with R/M)*2
		mov	ebx, offset OpTable16
		bt	h_opflag[ebp], 31
		jnc	short loc_5D13
		mov	ebx, offset OpTable32
loc_5D13:	xor	edx, edx
		add	ebx, h_base[ebp]
		movzx	eax, word ptr [ebx+eax]
		@JMP	eax


Op_BX_SI_16:	movsx	eax, word ptr cs:[esi]
		add	h_opflag[ebp], 2
		add	esi, 2
		mov	h_disp[ebp], eax
		jmp	short Op_BX_SI

Op_BX_SI_8:	movsx	eax, byte ptr cs:[esi]
		add	h_opflag[ebp], 1
		add	esi, 1
		mov	h_disp[ebp], eax
Op_BX_SI:	add	dx, word ptr h_ebx[ebp]
		add	dx, word ptr h_esi[ebp]
		add	dx, word ptr h_disp[ebp]
		jmp	loc_61C2

Op_BX_DI_16:	movsx	eax, word ptr cs:[esi]
		add	h_opflag[ebp], 2
		add	esi, 2
		mov	h_disp[ebp], eax
		jmp	short Op_BX_DI


Op_BX_DI_8:	movsx	eax, byte ptr cs:[esi]
		add	h_opflag[ebp], 1
		add	esi, 1
		mov	h_disp[ebp], eax
Op_BX_DI:	add	dx, word ptr h_ebx[ebp]
		add	dx, word ptr h_edi[ebp]
		add	dx, word ptr h_disp[ebp]
		jmp	loc_61C2


Op_BP_SI_16:	movsx	eax, word ptr cs:[esi]
		add	h_opflag[ebp], 2
		add	esi, 2
		mov	h_disp[ebp], eax
		jmp	short Op_BP_SI

Op_BP_SI_8:	movsx	eax, byte ptr cs:[esi]
		add	h_opflag[ebp], 1
		add	esi, 1
		mov	h_disp[ebp], eax
Op_BP_SI:	add	dx, word ptr h_ebp[ebp]
		add	dx, word ptr h_esi[ebp]
		add	dx, word ptr h_disp[ebp]
		test	byte ptr h_opflag+3[ebp], 7	; segment prefix?
		jnz	short loc_5DC5			; yes -> keep
		or	byte ptr h_opflag+3[ebp], 3	; no, force SS
loc_5DC5:	jmp	loc_61C2


Op_BP_DI_16:	movsx	eax, word ptr cs:[esi]
		add	h_opflag[ebp], 2
		add	esi, 2
		mov	h_disp[ebp], eax
		jmp	short Op_BP_DI

Op_BP_DI_8:	movsx	eax, byte ptr cs:[esi]
		add	h_opflag[ebp], 1
		add	esi, 1
		mov	h_disp[ebp], eax
Op_BP_DI:	add	dx, word ptr h_ebp[ebp]
		add	dx, word ptr h_edi[ebp]
		add	dx, word ptr h_disp[ebp]
		test	byte ptr h_opflag+3[ebp], 7	; segment prefix?
		jnz	short loc_5E04			; yes -> keep
		or	byte ptr h_opflag+3[ebp], 3	; no, force SS
loc_5E04:	jmp	loc_61C2


Op_SI_16:	movsx	eax, word ptr cs:[esi]
		add	h_opflag[ebp], 2
		add	esi, 2
		mov	h_disp[ebp], eax
		jmp	short Op_SI

Op_SI_8:	movsx	eax, byte ptr cs:[esi]
		add	h_opflag[ebp], 1
		add	esi, 1
		mov	h_disp[ebp], eax
Op_SI:		add	dx, word ptr h_esi[ebp]
		add	dx, word ptr h_disp[ebp]
		jmp	loc_61C2


Op_DI_16:	movsx	eax, word ptr cs:[esi]
		add	h_opflag[ebp], 2
		add	esi, 2
		mov	h_disp[ebp], eax
		jmp	short Op_DI

Op_DI_8:	movsx	eax, byte ptr cs:[esi]
		add	h_opflag[ebp], 1
		add	esi, 1
		mov	h_disp[ebp], eax
Op_DI:		add	dx, word ptr h_edi[ebp]
		add	dx, word ptr h_disp[ebp]
		jmp	loc_61C2

Op_BP_16:	movsx	eax, word ptr cs:[esi]
		add	h_opflag[ebp], 2
		add	esi, 2
		mov	h_disp[ebp], eax
		add	dx, word ptr h_ebp[ebp]
		add	dx, word ptr h_disp[ebp]
		test	byte ptr h_opflag+3[ebp], 7	; segment prefix?
		jnz	short loc_5E88			; yes -> keep
		or	byte ptr h_opflag+3[ebp], 3	; no, force SS
loc_5E88:	jmp	loc_61C2


Op_BP_8:	movsx	eax, byte ptr cs:[esi]
		add	h_opflag[ebp], 1
		add	esi, 1
		mov	h_disp[ebp], eax
		add	dx, word ptr h_ebp[ebp]
		add	dx, word ptr h_disp[ebp]
		test	byte ptr h_opflag+3[ebp], 7	; segment prefix?
		jnz	short loc_5EB0			; yes -> keep
		or	byte ptr h_opflag+3[ebp], 3	; no, force SS
loc_5EB0:	jmp	loc_61C2


Op_d16:		movsx	eax, word ptr cs:[esi]
		add	h_opflag[ebp], 2
		add	esi, 2
		mov	h_disp[ebp], eax
		add	dx, word ptr h_disp[ebp]
		jmp	loc_61C2


Op_BX_16:	movsx	eax, word ptr cs:[esi]
		add	h_opflag[ebp], 2
		add	esi, 2
		mov	h_disp[ebp], eax
		jmp	short Op_BX

Op_BX_8:	movsx	eax, byte ptr cs:[esi]
		add	h_opflag[ebp], 1
		add	esi, 1
		mov	h_disp[ebp], eax
Op_BX:		add	dx, word ptr h_ebx[ebp]
		add	dx, word ptr h_disp[ebp]
		jmp	loc_61C2


Op_EAX_32:	mov	eax, cs:[esi]
		add	h_opflag[ebp], 4
		add	esi, 4
		mov	h_disp[ebp], eax
		jmp	short Op_EAX

Op_EAX_8:	movsx	eax, byte ptr cs:[esi]
		add	h_opflag[ebp], 1
		add	esi, 1
		mov	h_disp[ebp], eax
Op_EAX:		add	edx, h_eax[ebp]
		add	edx, h_disp[ebp]
		jmp	loc_61C2


Op_ECX_32:	mov	eax, cs:[esi]
		add	h_opflag[ebp], 4
		add	esi, 4
		mov	h_disp[ebp], eax
		jmp	short Op_ECX

Op_ECX_8:	movsx	eax, byte ptr cs:[esi]
		add	h_opflag[ebp], 1
		add	esi, 1
		mov	h_disp[ebp], eax
Op_ECX:		add	edx, h_ecx[ebp]
		add	edx, h_disp[ebp]
		jmp	loc_61C2


Op_EDX_32:	mov	eax, cs:[esi]
		add	h_opflag[ebp], 4
		add	esi, 4
		mov	h_disp[ebp], eax
		jmp	short Op_EDX

Op_EDX_8:	movsx	eax, byte ptr cs:[esi]
		add	h_opflag[ebp], 1
		add	esi, 1
		mov	h_disp[ebp], eax
Op_EDX:		add	edx, h_edx[ebp]
		add	edx, h_disp[ebp]
		jmp	loc_61C2


Op_EBX_32:	mov	eax, cs:[esi]
		add	h_opflag[ebp], 4
		add	esi, 4
		mov	h_disp[ebp], eax
		jmp	short Op_EBX

Op_EBX_8:	movsx	eax, byte ptr cs:[esi]
		add	h_opflag[ebp], 1
		add	esi, 1
		mov	h_disp[ebp], eax
Op_EBX:		add	edx, h_ebx[ebp]
		add	edx, h_disp[ebp]
		jmp	loc_61C2


Op_ESP_32:	mov	eax, cs:[esi]
		add	h_opflag[ebp], 4
		add	esi, 4
		mov	h_disp[ebp], eax
		jmp	short Op_ESP

Op_ESP_8:	movsx	eax, byte ptr cs:[esi]
		add	h_opflag[ebp], 1
		add	esi, 1
		mov	h_disp[ebp], eax
Op_ESP:		add	edx, h_esp[ebp]
		add	edx, h_disp[ebp]
		test	byte ptr h_opflag+3[ebp], 7	; segment prefix?
		jnz	short loc_5FD6			; yes -> keep
		or	byte ptr h_opflag+3[ebp], 3	; no, force SS
loc_5FD6:	jmp	loc_61C2


Op_SIB:		movzx	eax, byte ptr cs:[esi]
		inc	h_opflag[ebp]
		inc	esi
		mov	h_sib[ebp], eax
		; AL= 7-6 SS, 5-3 INDEX, 2-0 BASE
		mov	ecx, eax
		shr	ecx, 6		; SS field into ECX
		and	eax, 38h	; isolate INDEX field
		shr	eax, 2
		mov	ebx, offset OpTableIndex
		add	ebx, h_base[ebp]
		movzx	eax, word ptr [ebx+eax]
		@JMP	eax

Op_xEAX:	mov	eax, h_eax[ebp]
		jmp	short loc_603E

Op_xECX:	mov	eax, h_ecx[ebp]
		jmp	short loc_603E

Op_xEDX:	mov	eax, h_edx[ebp]
		jmp	short loc_603E

Op_xEBX:	mov	eax, h_ebx[ebp]
		jmp	short loc_603E

Op_xNone:	xor	eax, eax
		jmp	short loc_603E

Op_xEBP:	mov	eax, h_ebp[ebp]
		jmp	short loc_603E

Op_xESI:	mov	eax, h_esi[ebp]
		jmp	short loc_603E

Op_xEDI:	mov	eax, h_edi[ebp]
		jmp	short loc_603E

; Index register (content in EAX, shift in CL)
loc_603E:	shl	eax, cl		; SS field
		add	edx, eax
		xor	eax, eax
		mov	al, byte ptr h_sib[ebp]	; SIB byte
		mov	ah, byte ptr h_modrm[ebp] ; ModR/M byte
		shr	ah, 6		; MOD field
		shl	al, 5		; BASE field
		shr	eax, 4
		mov	ebx, offset OpTableModBase
		add	ebx, h_base[ebp]
		movzx	eax, word ptr [ebx+eax]
		@JMP	eax


Op_EBP_32:	mov	eax, cs:[esi]
		add	h_opflag[ebp], 4
		add	esi, 4
		mov	h_disp[ebp], eax
		add	edx, h_ebp[ebp]
		add	edx, h_disp[ebp]
		test	byte ptr h_opflag+3[ebp], 7	; segment prefix?
		jnz	short loc_6084			; yes -> keep
		or	byte ptr h_opflag+3[ebp], 3	; no, force SS
loc_6084:	jmp	loc_61C2

Op_EBP_8:	movsx	eax, byte ptr cs:[esi]
		add	h_opflag[ebp], 1
		add	esi, 1
		mov	h_disp[ebp], eax
		add	edx, h_ebp[ebp]
		add	edx, h_disp[ebp]
		test	byte ptr h_opflag+3[ebp], 7	; segment prefix?
		jnz	short loc_60AA			; yes -> keep
		or	byte ptr h_opflag+3[ebp], 3	; no, force SS
loc_60AA:	jmp	loc_61C2


Op_d32:		mov	eax, cs:[esi]
		add	h_opflag[ebp], 4
		add	esi, 4
		mov	h_disp[ebp], eax
		add	edx, h_disp[ebp]
		jmp	loc_61C2


Op_ESI_32:	mov	eax, cs:[esi]
		add	h_opflag[ebp], 4
		add	esi, 4
		mov	h_disp[ebp], eax
		jmp	short Op_ESI

Op_ESI_8:	movsx	eax, byte ptr cs:[esi]
		add	h_opflag[ebp], 1
		add	esi, 1
		mov	h_disp[ebp], eax
Op_ESI:		add	edx, h_esi[ebp]
		add	edx, h_disp[ebp]
		jmp	loc_61C2


Op_EDI_32:	mov	eax, cs:[esi]
		add	h_opflag[ebp], 4
		add	esi, 4
		mov	h_disp[ebp], eax
		jmp	short Op_EDI

Op_EDI_8:	movsx	eax, byte ptr cs:[esi]
		add	h_opflag[ebp], 1
		add	esi, 1
		mov	h_disp[ebp], eax
Op_EDI:		add	edx, h_edi[ebp]
		add	edx, h_disp[ebp]
		jmp	loc_61C2


Op_rEAX:	mov	eax, h_eax[ebp]
		mov	h_content[ebp], eax
		jmp	loc_61D5

Op_rECX:	mov	eax, h_ecx[ebp]
		mov	h_content[ebp], eax
		jmp	loc_61D5

Op_rEDX:	mov	eax, h_edx[ebp]
		mov	h_content[ebp], eax
		jmp	loc_61D5

Op_rEBX:	mov	eax, h_ebx[ebp]
		mov	h_content[ebp], eax
		jmp	loc_61D5

Op_rESP:	test	byte ptr h_opflag+2[ebp], 20h	; bit 21 (operand is byte)
		jz	short loc_6163
		mov	al, byte ptr h_eax+1[ebp]
		mov	byte ptr h_content[ebp], al
		jmp	short loc_61D5

loc_6163:	mov	eax, h_esp[ebp]
		mov	h_content[ebp], eax
		jmp	short loc_61D5

Op_rEBP:	test	byte ptr h_opflag+2[ebp], 20h	; bit 21 (operand is byte)
		jz	short loc_617F
		mov	al, byte ptr h_ecx+1[ebp]
		mov	byte ptr h_content[ebp], al
		jmp	short loc_61D5

loc_617F:	mov	eax, h_ebp[ebp]
		mov	h_content[ebp], eax
		jmp	short loc_61D5

Op_rESI:	test	byte ptr h_opflag+2[ebp], 20h	; bit 21 (operand is byte)
		jz	short loc_619B
		mov	al, byte ptr h_edx+1[ebp]
		mov	byte ptr h_content[ebp], al
		jmp	short loc_61D5

loc_619B:	mov	eax, h_esi[ebp]
		mov	h_content[ebp], eax
		jmp	short loc_61D5

Op_rEDI:	test	byte ptr h_opflag+2[ebp], 20h	; bit 21 (operand is byte)
		jz	short loc_61B7
		mov	al, byte ptr h_ebx+1[ebp]
		mov	byte ptr h_content[ebp], al
		jmp	short loc_61D5

loc_61B7:	mov	eax, h_edi[ebp]
		mov	h_content[ebp], eax
		jmp	short loc_61D5

; now effective address is in EDX
loc_61C2:	mov	h_disp[ebp], edx
		test	byte ptr h_opflag+2[ebp], 10h	; bit 20 (only calculate effective address)
		jnz	short loc_61D5
		@CALL	loc_61DB	; read content from effective address into h_content
loc_61D5:	@RET


; Read content of effective address
; E: EDX=effective address
; R: value BL/BX/EBX and in h_content
loc_61DB:	xor	eax, eax
		mov	ebx, eax
		mov	al, byte ptr h_opflag+3[ebp]
		and	al, 7		; segment prefix
		shl	al, 1
		add	eax, h_base[ebp]
		test	byte ptr h_opflag+2[ebp], 20h	; bit 21 (operand is byte)
		jnz	short loc_6203
		test	byte ptr h_opflag+3[ebp], 40h	; bit 30 (operand size)
		jnz	short loc_61FC
		; word access
		add	eax, offset loc_623A
		jmp	eax

loc_61FC:	; dword access
		add	eax, offset loc_6270
		jmp	eax

loc_6203:	; byte access
		add	eax, offset loc_620A
		jmp	eax


; byte access table
loc_620A:	jmp	short loc_621A	; none
		jmp	short loc_6229	; ES
		jmp	short loc_621F	; CS
		jmp	short loc_6224	; SS
		jmp	short loc_621A	; DS
		jmp	short loc_622E	; FS
		jmp	short loc_6233	; GS
		jmp	$		; fatal

loc_621A:	segds
		mov	bl, [edx]
		jmp	short loc_6238

loc_621F:	mov	bl, cs:[edx]
		jmp	short loc_6238

loc_6224:	mov	bl, ss:[edx]
		jmp	short loc_6238

loc_6229:	mov	bl, es:[edx]
		jmp	short loc_6238

loc_622E:	mov	bl, fs:[edx]
		jmp	short loc_6238

loc_6233:	mov	bl, gs:[edx]
		jmp	short loc_6238

loc_6238:	jmp	short loc_629E


; word access table
loc_623A:	jmp	short loc_624A	; none
		jmp	short loc_625C	; ES
		jmp	short loc_6250	; CS
		jmp	short loc_6256	; SS
		jmp	short loc_624A	; DS
		jmp	short loc_6262	; FS
		jmp	short loc_6268	; GS
		jmp	$		; fatal

loc_624A:	segds
		mov	bx, [edx]
		jmp	short loc_626E

loc_6250:	mov	bx, cs:[edx]
		jmp	short loc_626E

loc_6256:	mov	bx, ss:[edx]
		jmp	short loc_626E

loc_625C:	mov	bx, es:[edx]
		jmp	short loc_626E

loc_6262:	mov	bx, fs:[edx]
		jmp	short loc_626E

loc_6268:	mov	bx, gs:[edx]
		jmp	short loc_626E

loc_626E:	jmp	short loc_629E


; dword access table
loc_6270:	jmp	short loc_6280	; none
		jmp	short loc_628F	; ES
		jmp	short loc_6285	; CS
		jmp	short loc_628A	; SS
		jmp	short loc_6280	; DS
		jmp	short loc_6294	; FS
		jmp	short loc_6299	; GS
		jmp	$		; fatal

loc_6280:	segds
		mov	ebx, [edx]
		jmp	short loc_629E

loc_6285:	mov	ebx, cs:[edx]
		jmp	short loc_629E

loc_628A:	mov	ebx, ss:[edx]
		jmp	short loc_629E

loc_628F:	mov	ebx, es:[edx]
		jmp	short loc_629E

loc_6294:	mov	ebx, fs:[edx]
		jmp	short loc_629E

loc_6299:	mov	ebx, gs:[edx]
		jmp	short loc_629E

loc_629E:	mov	h_content[ebp], ebx
		@RET


; vvvv-- unused code
; check address against segment limit
; E: selector in h_opflag+3[ebp], EDX=address to check
; R: EBX = segment limit - 9
		xor	eax, eax
		mov	al, byte ptr h_opflag+3[ebp]
		and	al, 7
		shl	al, 1
		add	eax, h_base[ebp]
		add	eax, offset loc_62BA
		jmp	eax

loc_62BA:	jmp	short loc_62CA	; none
		jmp	short loc_62D6	; ES
		jmp	short loc_62CE	; CS
		jmp	short loc_62D2	; SS
		jmp	short loc_62CA	; DS
		jmp	short loc_62DA	; FS
		jmp	short loc_62DE	; GS
		jmp	$		; fatal


loc_62CA:	mov	eax, ds
		jmp	short loc_62E2

loc_62CE:	mov	eax, cs
		jmp	short loc_62E2

loc_62D2:	mov	eax, ss
		jmp	short loc_62E2

loc_62D6:	mov	eax, es
		jmp	short loc_62E2

loc_62DA:	mov	eax, fs
		jmp	short loc_62E2

loc_62DE:	mov	eax, gs
		jmp	short loc_62E2	; superfluous

loc_62E2:	lsl	ebx, eax	; get segment limit
		sub	ebx, 9
		cmp	edx, ebx
		jg	short loc_62F2
		@RET

loc_62F2:	push	EXCP_GENPROT
		xor	eax, eax
		push	eax
		jmp	loc_2AA7
; ^^^^-- unused code


 IF VPCI
DecPOPESP:	mov	esi, h_esp[ebp]
		RDAR	edi, ss
		bt	edi, 22			; B (address size)
		jc	short loc_6331
		; 16 bit address size
		test	byte ptr h_opflag+3[ebp], 40h ; bit 30 (operand size)
		jnz	short loc_6322
		; 16 bit address size, 16 bit operand size
		mov	ax, ss:[si]
		mov	word ptr h_esp[ebp], ax
		jmp	loc_5B59

loc_6322:	; 16 bit address size, 32 bit operand size
		mov	eax, ss:[si]
		mov	h_esp[ebp], eax
		jmp	loc_5B59

loc_6331:	; 32 bit address size
		test	byte ptr h_opflag+3[ebp], 40h ; bit 30 (operand size)
		jnz	short loc_634C
		; 32 bit address size, 16 bit operand size
		mov	ax, ss:[esi]
		add	esi, 2		; this is the tricky part!
		mov	si, ax		; the write to SP is done _after_ ESP was incremented!
		mov	h_esp[ebp], esi
		jmp	loc_5B59

loc_634C:	; 32 bit address size, 32 bit operand size
		mov	eax, ss:[esi]
		mov	h_esp[ebp], eax
		jmp	loc_5B59
 ENDIF

 IF NOT V033S
DecSTI:		; STI set interrupt flag (enable interrupts)
		bt	h_efl[ebp], 9	; IF
		; normal execution if interrupts are already enabled
		jc	ForceExec

		; calculate address of next instruction
		movzx	ebx, byte ptr h_opflag[ebp]	; instruction length
		add	ebx, h_eip2[ebp]		; current IP
		; save DR7, then clear it to prevent breakpoint traps
		mov	eax, dr7
		push	eax
		bts	word ptr h_dbflag[ebp], 2	; DR7 is saved
		mov	h_dr7[ebp], eax
		xor	eax, eax		; clear DR7
		mov	dr7, eax
		; peek into next instruction
		; if ADRSIZE or OPSIZE prefix, read another byte
		; note: this code does not work with multiple prefixes!
		mov	cl, cs:[ebx]
		cmp	cl, 66h
		jz	short loc_6394
		cmp	cl, 67h
		jnz	short loc_6398
loc_6394:	mov	cl, cs:[ebx+1]
loc_6398:	; restore DR7
		pop	eax
		mov	dr7, eax
		btr	word ptr h_dbflag[ebp], 2	; DR7 restored
		cmp	cl, 0FAh	; CLI
		jz	loc_5B59
		cmp	cl, 0FBh	; STI
		jz	loc_5B59
		cmp	cl, 9Dh		; POPF/POPFD
		jz	loc_5B59
		jmp	ForceExec
 ENDIF

 IF NOT (V033S OR V033V)
DecCPUID:	mov	eax, h_eax[ebp]
		or	eax, eax	; level 0?
		jz	short loc_640A	; yes
		cmp	eax, 1		; level 1?
		jnz	loc_5B59	; no, return

		; level 1
		RDMOST	ecx		; get NOT(model + stepping)
		shr	ecx, 24		; move most significant byte into CL
		mov	eax, 0500h	; type =0, family =5
		not	cl
		mov	al, cl		; insert model + stepping
		mov	h_eax[ebp], eax	; return TFMS
		mov	h_edx[ebp], 0	; no FPU
  IF NOT V034I
		mov	eax, h_npx[ebp]
		cmp	al, 81h		; 81h = no FPU present
		jnz	short loc_6405
		mov	h_edx[ebp], 1	; FPU present
loc_6405:
  ENDIF
		jmp	loc_5B59

loc_640A:	; level 0
		mov	eax, 1		; ??
		mov	h_eax[ebp], 1	; max. supported level
		mov	h_ebx[ebp], 'GxeN'
		mov	h_edx[ebp], 'rDne'
		mov	h_ecx[ebp], 'nevi'
		jmp	loc_5B59


  IF NOT V034I
; Intel 486 manual: "Alignment faults are only generated by programs running
; at privilege level 3. The AC bit setting is ignored at privilege levels 0,
; 1 and 2."
; On the Nx586, the real EFL register doesn't seem to have all bits implemented.
; To support AC (bit 18) toggle, hypercode keeps a fully alterable copy at
; h_eflsh[ebp] (the EFL shadow).
DecPUSHF:	mov	esi, h_esp[ebp]
		RDAR	edi, ss
		bt	edi, 22			; B (address size)
		jc	short loc_6480
	; 16 bit address size
		test	byte ptr h_opflag+3[ebp], 40h ; bit 30 (operand size)
		jz	ForceExec		; if 16 bit, we are done because
						; bit 18 not needed
		; do the 32-bit-PUSH "manually"
		mov	eax, h_efl[ebp]
		btr	eax, 18			; EFL[18] = AC alignment check
		bt	h_eflsh[ebp], 18	; insert AC from EFL shadow
		jnc	short loc_646D
		bts	eax, 18
loc_646D:	sub	si, 4
		mov	ss:[si], eax
		mov	h_esp[ebp], esi
		jmp	loc_5B59		; continue after instruction

loc_6480:
	; 32 bit address size
		test	byte ptr h_opflag+3[ebp], 40h ; bit 30 (operand size)
		jz	ForceExec		; if 16 bit, we are done because
						; bit 18 not needed
		; do the 32-bit-PUSH "manually"
		mov	eax, h_efl[ebp]
		btr	eax, 18
		bt	h_eflsh[ebp], 18	; insert AC from EFL shadow
		jnc	short loc_64A2
		bts	eax, 18
loc_64A2:	sub	esi, 4
		mov	ss:[esi], eax
		mov	h_esp[ebp], esi
		jmp	loc_5B59		; continue after instruction


DecPOPF:	mov	esi, h_esp[ebp]
		RDAR	edi, ss
		bt	edi, 22			; B (address size)
		jc	short loc_64D2
	; 16 bit address size
		test	byte ptr h_opflag+3[ebp], 40h	; bit 30 (operand size)
		jz	ForceExec		; if 16 bit, we are done because
						; bit 18 not needed
		; copy AC into EFL shadow
		mov	eax, ss:[si]
		jmp	short loc_64DF

loc_64D2:
	; 32 bit address size
		test	byte ptr h_opflag+3[ebp], 40h	; bit 30 (operand size)
		jz	ForceExec		; if 16 bit, we are done because
						; bit 18 not needed
		; copy AC into EFL shadow
		mov	eax, ss:[esi]
loc_64DF:	bts	h_eflsh[ebp], 18
		bt	eax, 18
		jc	ForceExec
		btr	h_eflsh[ebp], 18
		jmp	ForceExec
  ENDIF
 ENDIF

		ALIGN	256

hypseg		ends
		end

;-------------------------------------------------------------- end DECODE.ASM