;-----------------------------------------------------------------------------
; NexGen Nx586 BIOS Hypercode
;-----------------------------------------------------------------------------
; File: EMUL.ASM - 
; Date: 2020-09-27
;
; Disassembled by Dipl.-Inf. Herbert Oppmann (herby@memotech.franken.de)
;-----------------------------------------------------------------------------

		include COMMON.INC

	extrn	Exception:near
	extrn	loc_2AA7:near
	extrn	InstrUnsupp2:near
	extrn	loc_5B51:near
	extrn	loc_5B59:near
	extrn	ForceExec:near
	extrn	GetOperand:near
	extrn	loc_61DB:near
	extrn	GetOperandAndReg:near
	extrn	WriteRM:near
	extrn	WriteReg:near

	public	DecHLT
	public	DecMOVSEG
	public	DecBSWAPEAX
	public	DecBSWAPECX
	public	DecBSWAPEDX
	public	DecBSWAPEBX
	public	DecBSWAPESP
	public	DecBSWAPEBP
	public	DecBSWAPESI
	public	DecBSWAPEDI
	public	DecXADDb
	public	DecXADDw
	public	DecCMPXCHGb
	public	DecCMPXCHGw


 IF V033S OR V033V
		db '@(#)emul.asm',9,'3.11',0
 ELSE
		db '@(#)emul    ',0
 ENDIF
		ALIGN0	32

	; unused code >>
loc_6920:	push	offset loc_6927+3 ; This is a bug! This is a @CALL gone astray!
		jmp	short loc_696F

loc_6927:	btr	h_opflag[ebp], 30
		@CALL	GetOperandAndReg
		and	cl, 3
		movzx	eax, word ptr h_content[ebp]
		and	al, 3
		cmp	al, cl
		jl	short loc_694D
		btr	h_efl[ebp], 6	; Zero flag (ZF)
		jmp	short loc_696A

loc_694D:	movzx	eax, word ptr h_content[ebp]
		and	eax, 0FFFFFFFCh
		or	al, cl
		mov	ecx, eax
		@CALL	WriteRM
		bts	h_efl[ebp], 6	; Zero flag (ZF)
loc_696A:	jmp	loc_5B59

loc_696F:	mov	eax, cr0
		bt	eax, 0
		jnc	short loc_6988
		bt	h_efl[ebp], 17	; Virtual 8086 mode (VM)
		jc	short loc_6988
		@RET
	; << unused code

loc_6988:	push	EXCP_INVALIDOP
		push	0
		jmp	loc_2AA7

	; unused code >>
		jmp	Exception

		@CALL	GetOperand
		mov	ecx, cr0
		btr	h_opflag[ebp], 30
		@CALL	WriteRM
		jmp	loc_5B59

		@CALL	GetOperandAndReg
		test	byte ptr h_opflag+3[ebp], 40h
		jnz	short loc_69EA
		mov	cx, cs:[esi]
		add	h_opflag[ebp], 2
	; << unused code

loc_69CF:	mov	eax, h_efl[ebp]
		push	eax
		btr	dword ptr [esp], 8	; clear Trap Flag (TF)
		popf
		imul	cx, word ptr h_content[ebp]
		pushf
		pop	h_efl[ebp]
		jmp	short loc_6A09

loc_69EA:	mov	ecx, cs:[esi]
		add	h_opflag[ebp], 4	; length of opcode += 4
loc_69F1:	mov	eax, h_efl[ebp]
		push	eax
		btr	dword ptr [esp], 8	; clear Trap Flag (TF)
		popf
		imul	ecx, h_content[ebp]
		pushf
		pop	h_efl[ebp]
loc_6A09:	and	eax, 100h		; isolate Trap Flag (TF)
		or	h_efl[ebp], eax		; set TF if it was set in EAX
		movzx	ebx, byte ptr h_modrm[ebp]
		and	ebx, 38h		; mask for Reg/Opcode
		shr	ebx, 3			; EBX now contains register number
		@CALL	WriteReg
		jmp	loc_5B59

		@CALL	GetOperandAndReg
		test	byte ptr h_opflag+3[ebp], 40h	; bit 30, 32-bit operand size
		jnz	short loc_6A48
		movsx	cx, byte ptr cs:[esi]
		add	h_opflag[ebp], 1	; length of opcode += 1
		jmp	short loc_69CF

loc_6A48:	movsx	ecx, byte ptr cs:[esi]
		add	h_opflag[ebp], 1	; length of opcode += 1
		jmp	short loc_69F1

DecHLT:		DELAYIO
		jmp	ForceExec

		@CALL	loc_6AAC
		mov	ds, dx
		jmp	short loc_6A9D

		@CALL	loc_6AAC
		mov	es, dx
		jmp	short loc_6A9D

		@CALL	loc_6AAC
		mov	ss, dx
		jmp	short loc_6A9D

		@CALL	loc_6AAC
		mov	fs, dx
		jmp	short loc_6A9D

		@CALL	loc_6AAC
		mov	gs, dx

loc_6A9D:	@CALL	WriteReg
		jmp	loc_5B59

loc_6AAC:	@CALL	GetOperandAndReg
		movzx	eax, byte ptr h_modrm[ebp]
		cmp	eax, 0C0h-1		; Mod >0?
		jg	loc_6988
		test	byte ptr h_opflag+3[ebp], 40h	; bit 30, 32-bit operand size
		jnz	short loc_6AD1
		add	dword ptr h_disp[ebp], 2	; memory displacement += 2
		jmp	short loc_6AD5

loc_6AD1:	add	dword ptr h_disp[ebp], 4	; memory displacement += 4
loc_6AD5:	push	ebx
		mov	ecx, h_content[ebp]
		push	ecx
		mov	eax, h_opflag[ebp]
		push	eax			; save h_opflag
		btr	h_opflag[ebp], 30	; clear 32-bit operand size
		mov	edx, h_disp[ebp]
		@CALL	loc_61DB
		pop	eax
		mov	h_opflag[ebp], eax	; restore h_opflag (especially the 32-bit operand size)
		mov	edx, ebx
		pop	ecx
		pop	ebx
		@RET

		jmp	Exception

		add	byte ptr h_opflag[ebp], 2	; length of opcode += 2
		movzx	edi, word ptr cs:[esi]
		jmp	short near ptr loc_6B16

		xor	edi, edi
		mov	h_excph[ebp], offset loc_6B65
loc_6B16:	RDAR	eax, ss
		bt	eax, 22		; 32 bit stack segment?
		mov	esi, h_esp[ebp]
		jc	short loc_6B28
		movzx	esi, si
loc_6B28:	test	byte ptr h_opflag+3[ebp], 40h ; bit 30, 32-bit operand size
		jnz	short loc_6B39
		movzx	eax, word ptr ss:[esi]
		add	esi, 2
		add	esi, edi
		jmp	short loc_6B41

loc_6B39:	mov	eax, ss:[esi]
		add	esi, 4
		add	esi, edi
loc_6B41:	mov	dl, cs:[eax]
		mov	h_eip3[ebp], eax
		mov	word ptr h_esp[ebp], si
		RDAR	eax, ss
		bt	eax, 22		; 32 bit stack segment?
		jnc	short loc_6B60
		mov	h_esp[ebp], esi
loc_6B60:	jmp	loc_5B51

loc_6B65:	; Exception handler for ??
		jmp	Exception

		test	byte ptr h_opflag+3[ebp], 40h ; bit 30, 32-bit operand size
		jnz	short loc_6BEB
		@CALL	GetOperandAndReg
		mov	al, cs:[esi]
		inc	h_opflag[ebp]
		and	al, 1Fh
		cmp	al, 10h
		jl	short loc_6BEB
		push	eax
		jmp	short loc_6BA6

		test	byte ptr h_opflag+3[ebp], 40h ; bit 30, 32-bit operand size
		jnz	short loc_6BEB
		mov	al, byte ptr h_ecx[ebp]
		and	al, 1Fh
		cmp	al, 10h
		jl	short loc_6BEB
		push	eax
		@CALL	GetOperandAndReg
loc_6BA6:	mov	eax, ecx
		pop	ecx
		and	cl, 0Fh
		test	byte ptr h_opcode[ebp], 8
		jz	short loc_6BB7
		ror	ax, cl
		jmp	short loc_6BBA

loc_6BB7:	rol	ax, cl
loc_6BBA:	setb	bl
		or	ax, ax
		pushf
		pop	edx
		or	dl, bl
		and	edx, 8D5h
		and	h_efl[ebp], 0FFFFF72Ah
		or	h_efl[ebp], edx
		mov	ecx, eax
		@CALL	WriteRM
		jmp	loc_5B59

loc_6BEB:	jmp	ForceExec

		; LOOP, LOOPE == LOOPZ, and LOOPNE == LOOPNZ
		movsx	edi, cl
		inc	h_opflag[ebp]
		mov	ecx, h_ecx[ebp]
		test	byte ptr h_opflag+3[ebp], 80h ; bit 31, 32-bit address size
		jnz	short loc_6C06
		dec	cx		; decrement count
		jmp	short loc_6C07

loc_6C06:	dec	ecx		; decrement count
loc_6C07:	setnz	bl		; BL is set if count != 0
		mov	al, byte ptr h_opcode[ebp]
		cmp	al, 0E2h	; LOOP
		jz	short loc_6C49
		cmp	al, 0E1h	; LOOPE == LOOPZ
		jz	short loc_6C2F

		; LOOPNE == LOOPNZ
		bt	h_efl[ebp], 6	; Zero Flag (ZF)
		setnb	bh
		and	bl, bh
		jnz	short loc_6C58
		mov	h_ecx[ebp], ecx
		jmp	loc_5B59	; don't jump

loc_6C2F:	; LOOPE == LOOPZ
		bt	h_efl[ebp], 6	; Zero Flag (ZF)
		setb	bh
		and	bl, bh
		jnz	short loc_6C58
		mov	h_ecx[ebp], ecx
		jmp	loc_5B59	; don't jump

loc_6C49:	; LOOP
		or	bl, bl
		jnz	short loc_6C58
		mov	h_ecx[ebp], ecx
		jmp	loc_5B59	; don't jump

loc_6C58:	; conditions are met -> jump
		mov	eax, h_eip2[ebp]
		test	byte ptr h_opflag+3[ebp], 40h ; bit 30, 32-bit operand size
		jnz	short loc_6C74
		add	ax, 2
		add	ax, di
		mov	bx, ax
		mov	dl, cs:[bx]
		jmp	short loc_6C7C

loc_6C74:	add	eax, 2
		add	eax, edi
		mov	bl, cs:[eax]
loc_6C7C:	mov	h_eip3[ebp], eax
		mov	h_ecx[ebp], ecx
		jmp	loc_5B51

		; JCXZ / JECXZ
		movsx	edi, cl
		inc	h_opflag[ebp]
		mov	ecx, h_ecx[ebp]
		test	byte ptr h_opflag+3[ebp], 80h ; bit 31, 32-bit address size
		; I think this is a bug - it should check with mask 40h, i.e. operand size
		jnz	short loc_6CA4
		or	cx, cx
		jmp	short loc_6CA6

loc_6CA4:	or	ecx, ecx
loc_6CA6:	jz	short loc_6C58	; jump
		jmp	loc_5B59	; don't jump

DecMOVSEG:
 IF NOT (V033S OR V033V)
		; NxOP 14/5 (only on VL systems) "game assistant"
		; (minor conflict with implementing DOS extenders)
		; controls emulation of MOV reg/mem to/from segreg
		; We come here for MOV segreg, reg/mem
		mov	al, byte ptr h_opflag+3[ebp]
		and	al, 7		; segment override
		cmp	al, 2		; CS
		jz	short loc_6CBB
		jmp	ForceExec	; direct execution, if not CS: prefix

loc_6CBB:
 ENDIF
		@CALL	GetOperand	; get effective address and read content
		movzx	ebx, word ptr h_content[ebp]
 IF NOT (V033S OR V033V)
		RDCPL	eax
		mov	cl, bl
		and	al, 3
		and	cl, 3
		cmp	al, cl
		jz	short loc_6Cxx
loc_6Cxx:
 ENDIF
		@CALL	loc_6CE6
		jmp	loc_5B59

; Subroutine
; Write value to selector according to REG field in modRM
; E: BX = new value
; V: EAX, EBX, ECX
loc_6CE6:	movzx	ecx, byte ptr h_modrm[ebp]
		and	ecx, 38h
		shr	ecx, 3		; reg field
		shl	ecx, 1
		add	ecx, offset loc_6CFD
		@JMP	ecx

loc_6CFD:	; jump table for mov seg,r/m
		jmp	short loc_6D0D	; ES
		jmp	short loc_6D41	; CS -> exception
		jmp	short loc_6D11	; SS
		jmp	short loc_6D2F	; DS
		jmp	short loc_6D33	; FS
		jmp	short loc_6D37	; GS
		jmp	short loc_6D41	; exception
		jmp	short loc_6D41	; exception

loc_6D0D:	mov	es, bx
		jmp	short loc_6D3B

loc_6D11:	; this is MOV SS,CS:xx
		mov	ss, bx
		mov	ebx, h_cfg1[ebp]
		bts	ebx, 23
		DELAYNOP 2
		WRCFG1	ebx
		jmp	short loc_6D3B

loc_6D2F:	mov	ds, bx
		jmp	short loc_6D3B

loc_6D33:	mov	fs, bx
		jmp	short loc_6D3B

loc_6D37:	mov	gs, bx
		jmp	short loc_6D3B

loc_6D3B:	@RET

loc_6D41:	; invalid opcode exception
		push	EXCP_INVALIDOP
		push	0
		jmp	loc_2AA7

; This would be MOV reg/mem, segreg but code is not used anymore
		@CALL	GetOperand
		@CALL	loc_6D80
		movzx	ecx, cx
		movzx	ebx, byte ptr h_modrm[ebp]
		cmp	ebx, 0C0h-1
		jg	short loc_6D71
		and	byte ptr h_opflag+3[ebp], 0BFh
loc_6D71:	@CALL	WriteRM
		jmp	loc_5B59

; Subroutine
; Read value from selector according to REG field in modRM
; E:-
; V: EAX, EBX
; R: ECX is selector value
loc_6D80:	movzx	ecx, byte ptr h_modrm[ebp]
		and	ecx, 38h
		shr	ecx, 3
		shl	ecx, 1
		add	ecx, offset loc_6D97
		@JMP	ecx

loc_6D97:	; jump table for mov r/m,seg
		jmp	short loc_6DA7	; ES
		jmp	short loc_6DAB	; CS
		jmp	short loc_6DAF	; SS
		jmp	short loc_6DB3	; DS
		jmp	short loc_6DB7	; FS
		jmp	short loc_6DBB	; GS
		jmp	short loc_6D41	; exception
		jmp	short loc_6D41	; exception

loc_6DA7:	mov	ecx, es
		jmp	short loc_6DBF

loc_6DAB:	mov	ecx, cs
		jmp	short loc_6DBF

loc_6DAF:	mov	ecx, ss
		jmp	short loc_6DBF

loc_6DB3:	mov	ecx, ds
		jmp	short loc_6DBF

loc_6DB7:	mov	ecx, fs
		jmp	short loc_6DBF

loc_6DBB:	mov	ecx, gs
		jmp	short loc_6DBF

loc_6DBF:	@RET

		jmp	Exception

; BSWAP

DecBSWAPEAX:	lea	edi, h_eax[ebp]
		jmp	short loc_6E08

DecBSWAPEBX:	lea	edi, h_ebx[ebp]
		jmp	short loc_6E08

DecBSWAPECX:	lea	edi, h_ecx[ebp]
		jmp	short loc_6E08

DecBSWAPEDX:	lea	edi, h_edx[ebp]
		jmp	short loc_6E08

DecBSWAPESP:	lea	edi, h_esp[ebp]
		jmp	short loc_6E08

DecBSWAPEBP:	lea	edi, h_ebp[ebp]
		jmp	short loc_6E08

DecBSWAPESI:	lea	edi, h_esi[ebp]
		jmp	short loc_6E08

DecBSWAPEDI:	lea	edi, h_edi[ebp]

loc_6E08:	test	byte ptr h_mode[ebp], BIT 7	; 486 instructions enable
		jnz	short loc_6E16
		jmp	InstrUnsupp2

loc_6E16:	mov	eax, [edi]
		test	byte ptr h_opflag+3[ebp], 40h	; operand size
		jnz	short loc_6E30
		; 16 bit
		ror	eax, 16
		mov	bx, ax
		rol	bx, 8
		rol	eax, 16
		mov	ax, bx
		jmp	short loc_6E3B

loc_6E30:	; 32 bit
		rol	ax, 8
		rol	eax, 16
		rol	ax, 8
loc_6E3B:	mov	[edi], eax
		jmp	loc_5B59


; XADD

DecXADDb:	test	byte ptr h_mode[ebp], BIT 7	; 486 instructions enable
		jnz	short loc_6E50
		jmp	InstrUnsupp2

loc_6E50:	or	byte ptr h_opflag+2[ebp], 20h	; bit 21, operand is byte
		@CALL	GetOperandAndReg
		jmp	short loc_6E8E

DecXADDw:	test	byte ptr h_mode[ebp], BIT 7	; 486 instructions enable
		jnz	short loc_6E6E
		jmp	InstrUnsupp2

loc_6E6E:	@CALL	GetOperandAndReg
		test	byte ptr h_opflag+3[ebp], 40h	; bit 30, operand size
		jnz	short loc_6E87
		; 16 bit
		mov	ax, word ptr h_content[ebp]
		add	cx, ax
		jmp	short loc_6E93

loc_6E87:	; 32 bit
		mov	eax, h_content[ebp]
		add	ecx, eax
		jmp	short loc_6E93

loc_6E8E:	; 8 bit
		mov	al, byte ptr h_content[ebp]
		add	cl, al
loc_6E93:	pushf
		pop	edx
		and	edx, 8D5h	; keep OF, SF, ZF, AF, PF and CF result from add
		and	h_efl[ebp], 0FFFFF72Ah	; clear OF, SF, ZF, AF, PF and CF
		or	h_efl[ebp], edx	; insert the result from add
		movzx	ebx, byte ptr h_modrm[ebp]
		and	ebx, 38h
		shr	ebx, 3
		push	ecx
		mov	ecx, eax
		@CALL	WriteReg
		pop	ecx
		@CALL	WriteRM
		jmp	loc_5B59

; CMPXCHG

DecCMPXCHGb:	test	byte ptr h_mode[ebp], BIT 7	; 486 instructions enable
		jnz	short loc_6EE0
		jmp	InstrUnsupp2

loc_6EE0:	or	byte ptr h_opflag+2[ebp], 20h	; bit 21, operand is byte
		@CALL	GetOperandAndReg
		mov	ebx, h_eax[ebp]
		jmp	short loc_6F3B

DecCMPXCHGw:	test	byte ptr h_mode[ebp], BIT 7	; 486 instructions enable
		jnz	short loc_6F04
		jmp	InstrUnsupp2

loc_6F04:	@CALL	GetOperandAndReg
		mov	ebx, h_eax[ebp]
		test	byte ptr h_opflag+3[ebp], 40h	; bit 30, operand size
		jnz	short loc_6F2C
		; 16 bit
		mov	ax, word ptr h_content[ebp]
		cmp	bx, ax
		jz	short loc_6F4A
		mov	word ptr h_eax[ebp], ax
		jmp	short loc_6F4A

loc_6F2C:	; 32 bit
		mov	eax, h_content[ebp]
		cmp	ebx, eax
		jz	short loc_6F4A
		mov	h_eax[ebp], eax
		jmp	short loc_6F4A

loc_6F3B:	; 8 bit
		mov	al, byte ptr h_content[ebp]
		cmp	bl, al
		jz	short loc_6F4A
		mov	byte ptr h_eax[ebp], al
		jmp	short loc_6F4A

loc_6F4A:	pushf
		pushf
		pop	edx
		and	edx, 8D5h	; keep OF, SF, ZF, AF, PF and CF result from cmp
		and	h_efl[ebp], 0FFFFF72Ah	; clear OF, SF, ZF, AF, PF and CF
		or	h_efl[ebp], edx	; insert the result from cmp
		popf
		jnz	short loc_6F70
		@CALL	WriteRM
loc_6F70:	jmp	loc_5B59

		ALIGN	256

hypseg		ends
		end

;---------------------------------------------------------------- end EMUL.ASM