;-----------------------------------------------------------------------------
; NexGen Nx586 BIOS Hypercode
;-----------------------------------------------------------------------------
; File: F2XM1.ASM - 
; Date: 2020-09-26
;
; Disassembled by Dipl.-Inf. Herbert Oppmann (herby@memotech.franken.de)
;-----------------------------------------------------------------------------
; Only used for VL

		include COMMON.INC

	extrn	loc_8E80:near
	extrn	loc_8F44:near
	extrn	loc_8FB3:near
	extrn	loc_8FD3:near
	extrn	loc_902B:near
	extrn	loc_9097:near
	extrn	loc_90C1:near

	public	DecF2XM1

		db '@(#)f2xm1.asm',TAB,'3.4',0
		ALIGN0	32

loc_9800:	dt 3FF7A55379EDEE8BFBD9h	; 0.00504535

loc_980A:	dt 3FEEA960D545C0794285h	; 1.00957e-005

loc_9814:	dt 3FFADF9F97A0DB510F41h	; 0.0545956

loc_981E:	dt 3FF398C56490234388C3h	; 0.000291388

loc_9828:	dt 3FE8B2CB9996C7A75300h	; 1.66516e-007

HalfLnTwo:	dt 3FFDB17217F7D1CF79ABh	; 0.346574 = 1/2 ln(2)

DecF2XM1:	@CALL	loc_8E80
		fnsave	byte ptr h_fenviron[ebp]
		sub	esp, 94h
		mov	byte ptr [ebp-85h], 0
loc_9856:	mov	byte ptr [ebp-86h], 0
		FNLDSW	h_fsw[ebp]
		FNLDTW	h_ftw[ebp]
		btr	dword ptr h_fsw[ebp], 10; C2 Condition Code
		ffree	st(6)
		ffree	st(7)
		fxam				; set C1 Condition Code to sign of ST(0)
		fstsw	word ptr [esp-4]
		mov	ax, [esp-4]
		test	ah, 2			; bit 9 = C1
		jz	short loc_9886
		; negative
		mov	byte ptr [ebp-85h], 1	; remember sign
		fabs
loc_9886:	sahf				; C0 -> CF, C1 is lost, C2 -> PF, C3 -> ZF
		jbe	short loc_988D		; if NaN, Infinity, Zero, Empty or Denormal
		jnp	short loc_98C8		; if Unsupported
loc_988B:	; Normal finite number
		jmp	short loc_98F0

loc_988D:	; NaN, Infinity, Zero, Empty or Denormal
		jc	short loc_9893		; if NaN, Infinity or Empty
		jp	short loc_98BC		; if Denormal
		; Zero
		jmp	short loc_98D7

loc_9893:	; NaN, Infinity or Empty
		jp	short loc_98AF		; if Infinity
		jz	short loc_98A3		; if Zero
		; NaN
		@CALL	loc_8FD3
		jmp	short loc_98D7

loc_98A3:	; Zero
		@CALL	loc_902B
		jmp	short loc_98D7

loc_98AF:	; Infinity
		test	byte ptr [ebp-85h], 1	; sign
		jz	short loc_98D7		; positive
		fld1
		jmp	short loc_98D7

loc_98BC:	; Denormal
		@CALL	loc_9097
		jmp	short loc_988B

loc_98C8:	@CALL	loc_8FB3
		jmp	loc_9A2C

loc_98D7:	btr	dword ptr h_fsw[ebp], 9	; clear C1
		cmp	byte ptr [ebp-85h], 0	; sign
		jz	loc_9A2C		; positive
		fchs
		jmp	loc_9A2C

loc_98F0:	; Normal finite number
		fninit	
		mov	ecx, h_base[ebp]
		bts	dword ptr h_fsw[ebp], 5	; set Precision Exception (PE)
		fld	tbyte ptr h_fr0[ebp]	; load R0
		fld	st
		fabs	
		fld1	
		fxch	st(1)
		fcom	st(1)
		fstsw	word ptr [esp-4]
		mov	ax, [esp-4]
		sahf	
		ja	short loc_98D7
		fstp	tbyte ptr h_ftemp[ebp]
		fstp	st
		cmp	word ptr h_ftemp[ebp+8], 3FFEh
		jge	short loc_992B
		fld1	
		fstp	tbyte ptr [ebp-90h]
		jmp	short loc_9997

loc_992B:	fld1	
		fstp	tbyte ptr [ebp-90h]
		fld	tbyte ptr h_ftemp[ebp]
		fld1	
		fsub	st, st(1)
		fstp	st(1)
		fstp	st(1)
		fstp	tbyte ptr h_ftemp[ebp]
		fld	tbyte ptr h_ftemp[ebp]
		fldz	
		fcompp	st(1), st
		fstsw	word ptr [esp-4]
		mov	ax, [esp-4]
		sahf	
		jnz	short loc_995E
		mov	byte ptr [ebp-86h], 1
		jmp	short loc_9973

loc_995E:	mov	byte ptr [ebp-86h], 0
		mov	al, [ebp-85h]
		xor	al, 1
		shl	al, 7
		or	h_ftemp[ebp+9], al
loc_9973:	fld	tbyte ptr h_ftemp[ebp]
		fld1	
		fld1	
		fadd	st, st
		test	byte ptr [ebp-85h], 1
		jz	short loc_998F
		fdivp	st(1), st
		fstp	tbyte ptr [ebp-90h]
		jmp	short loc_9997

loc_998F:	fstp	st(1)
		fstp	tbyte ptr [ebp-90h]
loc_9997:	test	byte ptr [ebp-86h], 1
		jnz	short loc_99F6
		fld	st
		fmul	st, st(1)
		fld	tbyte ptr ds:loc_980A[ecx]
		fmul	st, st(1)
		fld	tbyte ptr ds:loc_9800[ecx]
		faddp	st(1), st
		fmul	st, st(1)
		fld	tbyte ptr ds:HalfLnTwo[ecx]
		faddp	st(1), st
		fld	st(2)
		fmulp	st(1), st
		fxch	st(1)
		fld	tbyte ptr ds:loc_9828[ecx]
		fmul	st, st(1)
		fld	tbyte ptr ds:loc_981E[ecx]
		faddp	st(1), st
		fmul	st, st(1)
		fld	tbyte ptr ds:loc_9814[ecx]
		faddp	st(1), st
		fmul	st, st(1)
		fstp	st(1)
		fsub	st, st(1)
		fld1	
		faddp	st(1), st
		fxch	st(1)
		fld1	
		fadd	st, st
		fmulp	st(1), st
		fdiv	st, st(1)
		fstp	st(1)
		fstp	st(1)
loc_99F6:	fld1	
		fld	tbyte ptr [ebp-90h]
		fsub	st, st(1)
		fstp	st(1)
		fxch	st(1)
		fld	tbyte ptr [ebp-90h]
		fmulp	st(1), st
		faddp	st(1), st
		btr	dword ptr h_fsw[ebp], 9	; clear C1
		fxam	
		fstsw	word ptr [esp-4]
		mov	ax, [esp-4]
		sahf				; C0 -> CF, C1 is lost, C2 -> PF, C3 -> ZF
		jnz	short loc_9A2C
		@CALL	loc_90C1
loc_9A2C:	fstp	tbyte ptr h_fr0[ebp]
		@CALL	loc_8F44
; ???
		ALIGN0	16

hypseg		ends
		end

;--------------------------------------------------------------- end F2XM1.ASM