;-----------------------------------------------------------------------------
; NexGen Nx586 BIOS Hypercode
;-----------------------------------------------------------------------------
; File: FBSTP.ASM - 
; Date: 2020-09-26
;
; Disassembled by Dipl.-Inf. Herbert Oppmann (herby@memotech.franken.de)
;-----------------------------------------------------------------------------

		include COMMON.INC

	extrn	Exception:near
	extrn	GetOperand:near
	extrn	loc_61DB:near
	extrn	WriteMem:near
	extrn	loc_8ED1:near
	extrn	loc_8F53:near
	extrn	loc_8FB3:near
	extrn	loc_8FD3:near
	extrn	loc_902B:near

	public	DecFBSTP

		db '@(#)fbstp.asm',TAB,'3.'
 IF V033S OR V033V
		db '5',0
 ELSEIF VVL OR (VPCI GE 'p')
		db '12',0
 ELSE
		db '11',0
 ENDIF
		ALIGN0	32

TenPower18	dt 403ADE0B6B3A763FFFF0h	; 1e+018

dloc_875A	dd 10

; Store BCD Integer and Pop
DecFBSTP:	mov	h_excph[ebp], offset loc_89CF
		or	byte ptr h_opflag+2[ebp], 10h	; set bit 20, only calculate effective address
		@CALL	GetOperand
		mov	eax, cr0
		mov	[ebp-4], eax
		or	al, 1		; set PE = Protected mode enable
		mov	cr0, eax
		pushf
		btr	dword ptr [esp], 17	; clear VM = Virtual 8086 mode
		popf
		fnsave	byte ptr h_fenviron[ebp]
		sub	esp, 0A4h

loc_878E:	mov	eax, h_fsw[ebp]		; FPU Status Word
		mov	[ebp-9Eh], eax
		FNLDTW	h_ftw[ebp]		; FPU Tag Word
		FNLDSW	h_fsw[ebp]
		inc	h_fbstpc[ebp]		; Statistics: Count number of FBSTP instructions
		fxam
		fstsw	word ptr [esp-4]
		mov	ax, [esp-4]
		sahf
		ffree	st(6)
		ffree	st(7)
		jbe	short loc_87E1
		jnp	short loc_87D2

loc_87B8:				; CODE XREF: 8821
		mov	byte ptr [ebp-85h], 0
		test	ah, 2
		jz	short loc_87CB
		mov	byte ptr [ebp-85h], 80h

loc_87CB:				; CODE XREF: 87C2
		fld	st
		fstp	tbyte ptr h_ftemp[ebp]
		jmp	short loc_8823

loc_87D2:	@CALL	loc_8FB3	; CODE XREF: 87B6
		jmp	loc_89BB

loc_87E1:				; CODE XREF: 87B4
		jc	short loc_87F0
		jp	short loc_8821
		fstp	tbyte ptr [ebp-84h]
		jmp	loc_88F5

loc_87F0:				; CODE XREF: 87E1
		jp	short loc_8812
		jz	short loc_8803
 IF V033S OR V033V
		@CALL	loc_8FB3
 ELSE
		@CALL	loc_8FD3
 ENDIF
		jmp	loc_89BB

loc_8803:	@CALL	loc_902B	; CODE XREF: 87F2
		jmp	loc_89BB

loc_8812:	@CALL	loc_8FB3	; CODE XREF: 87F0
		jmp	loc_89BB

loc_8821:				; CODE XREF: 87E3
		jmp	short loc_87B8

loc_8823:
 IF NOT (V033S OR V033V)
		push	dword ptr h_fcw[ebp]
		or	byte ptr [esp],	3Fh
		fldcw	word ptr [esp]
		pop	eax
		frndint
		fstsw	word ptr [esp-4]
		mov	ax, [esp-4]
		and	eax, 220h
  IF VVL OR (VPCI GE 'p')
		mov	[ebp+344h], eax
  ENDIF
		or	h_fsw[ebp], eax
 ENDIF
		mov	ecx, h_base[ebp]
		fld	st
		fabs
		fld	tbyte ptr ds:TenPower18[ecx]	; 1e+018
		fcompp	st(1), st
		fstsw	word ptr [esp-4]
		mov	ax, [esp-4]
		sahf
		jnc	short loc_887D
		btr	dword ptr h_fsw[ebp], 9		; clear C1
 IF NOT (V033S OR V033V)
		btr	dword ptr h_fsw[ebp], 5		; clear PE
 ENDIF
		@CALL	loc_8FB3
		jmp	loc_89BB

loc_887D:
 IF V033S OR V033V
		push	dword ptr h_fcw[ebp]		; FPU Control Word
		or	byte ptr [esp],	3Fh		; set all Exception Masks (PM, UM, OM, ZM, DM, IM)
		fldcw	word ptr [esp]
		pop	eax
		frndint
		fstsw	word ptr [esp-4]
		mov	ax, [esp-4]
		test	al, 2			; Exception Flag DE = Denormalized Operand
		jz	short loc_9E35
		btr	dword ptr h_fsw[ebp], 9		; clear C1
loc_9E35:	and	eax, 220h			
		or	h_fsw[ebp], eax
 ENDIF
		fabs
		fstp	tbyte ptr h_ftemp[ebp]
		fninit
		fild	ds:dloc_875A[ecx]	; = 10
		mov	ebx, 0
		fld	tbyte ptr h_ftemp[ebp]

loc_8892:				; CODE XREF: 88E2
		fprem
		fist	word ptr [ebp-9Ah]
		shl	word ptr [ebp-9Ah], 12
		fld	tbyte ptr h_ftemp[ebp]
		fxch	st(1)
		fsubp	st(1), st
		fdiv	st, st(1)
		fstp	tbyte ptr h_ftemp[ebp]
		fld	tbyte ptr h_ftemp[ebp]
		fprem
		fist	word ptr [ebp-98h]
		sar	dword ptr [ebp-9Ah], 12
		mov	al, [ebp-9Ah]
		mov	[ebp+ebx-84h], al
		fld	tbyte ptr h_ftemp[ebp]
		fxch	st(1)
		fsubp	st(1), st
		fdiv	st, st(1)
		fstp	tbyte ptr h_ftemp[ebp]
		fld	tbyte ptr h_ftemp[ebp]
		cmp	ebx, 8
		jge	short loc_88E4
		inc	ebx
		jmp	short loc_8892

loc_88E4:				; CODE XREF: 88DF
		mov	byte ptr [ebp-7Bh], 0
		fstp	st
		fstp	st
		mov	al, [ebp-85h]
		or	[ebp-7Bh], al

loc_88F5:				; CODE XREF: 87EB	89CA
		mov	eax, [ebp-4]
		mov	cr0, eax
		push	dword ptr h_efl[ebp]
		popf
		btr	h_opflag[ebp], 30
		mov	edx, h_disp[ebp]
		add	edx, 8
		@CALL	loc_61DB
		sub	edx, 8
		@CALL	loc_61DB
		btr	h_opflag[ebp], 21
		bts	h_opflag[ebp], 30
		mov	ecx, [ebp-84h]
		@CALL	WriteMem
		add	dword ptr h_disp[ebp], 4
		mov	ecx, [ebp-80h]
		@CALL	WriteMem
		btr	h_opflag[ebp], 30
		add	dword ptr h_disp[ebp], 4
		movzx	ecx, word ptr [ebp-7Ch]
		@CALL	WriteMem
		mov	eax, cr0
		or	al, 1
		mov	cr0, eax
		pushf
		btr	dword ptr [esp], 17
		popf
		sub	dword ptr h_disp[ebp], 8
		@CALL	loc_8ED1
		fnrstor	byte ptr h_fenviron[ebp]
		fstp	st
 IF NOT (V033S OR V033V)
		bt	dword ptr h_fsw[ebp], 5
		jnc	short loc_89AC
		fstsw	word ptr [esp-4]
		mov	ax, [esp-4]
  IF VVL OR (VPCI GE 'p')
		and	ax, 0FDDFh
		or	eax, [ebp+344h]
  ELSE
		bt	dword ptr h_fcw[ebp], 11	; bit 11-10 of FPU Control Word: RC = Rounding Control
		jc	short loc_89AC
		bt	dword ptr h_fcw[ebp], 10
		jnc	short loc_89AC
		bts	ax, 9			; C1
  ENDIF
		mov	[esp-4], ax
		FNLDSW	[esp-4]
ENDIF

loc_89AC:				; CODE XREF: 898D
		jmp	loc_8F53

 IF (V033S OR V033V)

dloc_89B1	dt 0FFFF8000000000000000h	; -INF
 ELSE
dloc_89B1	dt 0FFFFC000000000000000h	; -QNaN
ENDIF

loc_89BB:				; CODE XREF: 87DC	87FE
					; 0000880D 0000881C	8878
		mov	ecx, h_base[ebp]
		fld	tbyte ptr ds:dloc_89B1[ecx]	; -INF or later -QNaN
		fstp	tbyte ptr [ebp-84h]
		jmp	loc_88F5

; exception handler for FBSTP
loc_89CF:	mov	eax, cr0
		or	al, 1		; set PE = protected mode enable
		mov	cr0, eax
		pushf
		btr	dword ptr [esp], 17	; clear VM = Virtual 8086 mode
		popf
		fnrstor	byte ptr h_fenviron[ebp]
		mov	eax, [ebp-4]
		mov	cr0, eax
		jmp	Exception

		ALIGN0	16

hypseg		ends
		end

;--------------------------------------------------------------- end FBSTP.ASM