;-----------------------------------------------------------------------------
; NexGen Nx586 BIOS Hypercode
;-----------------------------------------------------------------------------
; File: FIXUPNP.ASM - 
; Date: 2020-09-25
;
; Disassembled by Dipl.-Inf. Herbert Oppmann (herby@memotech.franken.de)
;-----------------------------------------------------------------------------

		include COMMON.INC

	extrn	loc_79D5:near

	public	loc_7BE0


		db '@(#)fixupnp.asm',TAB,'3.'
 IF V033S OR V033V
		db '4',0
 ELSEIF V034I
		db '6',0
 ELSEIF V033W OR V034N
		db '7',0
 ELSE
		db '8',0
 ENDIF
		ALIGN0	32

loc_7BE0:				; CODE XREF: 7502
		mov	eax, cr0
		mov	[ebp-4], eax
		or	eax, 1		; set PE = Protected mode enable
		mov	cr0, eax
		pushf
		btr	dword ptr [esp], 17	; clear VM = Virtual 8086 Mode
		popf
		fnsave	byte ptr h_fenviron[ebp]
		fnrstor	byte ptr h_fenviron[ebp]
		fnclex
 IF V033S OR V033V
		mov	ebx, h_fsw[ebp]	; FPU Status Word
		and	ebx, 3800h	; get TOP = Top of stack pointer
		mov	dword ptr [ebp-90h], 0
 ELSE
		mov	dword ptr [ebp-90h], 0
		mov	ebx, h_fsw[ebp]	; FPU Status Word
		mov	eax, ebx
		and	eax, 2C1h	; C1, ES, SF, IE
		cmp	eax, 2C1h
		jnz	short loc_7C1D
		or	dword ptr [ebp-90h], 4

loc_7C1D:				; CODE XREF: 7C14
		and	ebx, 3800h	; get TOP = Top of stack pointer
 ENDIF
		mov	eax, h_fopcodecs[ebp]	; Opcode + CS Selector
		and	eax, 7380000h
		cmp	eax, 1000000h
		jz	loc_7D22
		cmp	eax, 5000000h
		jz	loc_7D22
		mov	eax, h_fopcodecs[ebp]
		and	eax, 7FF0000h
 IF NOT (V033S OR V033V)
		mov	dword ptr [ebp-8Ch], 0
 ENDIF
		cmp	eax, 1F20000h
 IF V033S OR V033V
		mov	dword ptr [ebp-90h], 0FFFFFFFDh
		jz	loc_7D2B
 ELSE
		jnz	short loc_7C77
		mov	eax, h_fsw[ebp]	; FPU Status Word
		bt	eax, 10		; C2
		jnc	loc_7D2B
		mov	dword ptr [ebp-8Ch], 1
		jc	loc_7D2B

loc_7C77:
 ENDIF
		cmp	eax, 1FB0000h
 IF V033S OR V033V
		mov	dword ptr [ebp-90h], 0FFFFFFFDh
 ENDIF
		jz	loc_7D2B
		cmp	eax, 1F40000h
 IF V033S OR V033V
		mov	dword ptr [ebp-90h], 0FFFFFFFDh
 ENDIF
		jz	loc_7D2B
		cmp	eax, 6D90000h
		jz	short loc_7CBB
		cmp	eax, 2E90000h
		jz	short loc_7CBB
		cmp	eax, 1F30000h
		jz	short loc_7CB2
		cmp	eax, 1F10000h
		jz	short loc_7CB2
		cmp	eax, 1F90000h
		jz	short loc_7CB2
		jmp	short loc_7CFD

loc_7CB2:				; CODE XREF: 7CA0	7CA7
					; 00007CAE
 IF V033S OR V033V
		mov	dword ptr [ebp-90h], 0FFFFFFFEh
 ELSE
		or	dword ptr [ebp-90h], 2
 ENDIF
		jmp	short loc_7CFD

loc_7CBB:				; CODE XREF: 7C92	7C99
 IF V033S OR V033V
		mov	dword ptr [ebp-90h], 0FFFFFFFEh
 ELSE
		or	dword ptr [ebp-90h], 2
 ENDIF
		mov	eax, h_fsw[ebp]
		cmp	ebx, 0
		jz	short loc_7CD4
		cmp	ebx, 8000000h
		jz	short loc_7CE0
		jmp	short loc_7CEC

loc_7CD4:				; CODE XREF: 7CC8
		or	eax, 3000h
		mov	ecx, 3000h
		jmp	short loc_7D4E

loc_7CE0:				; CODE XREF: 7CD0
		or	eax, 3800h
		mov	ecx, 3800h
		jmp	short loc_7D4E

loc_7CEC:				; CODE XREF: 7CD2
		sub	ebx, 1000h
		mov	ecx, ebx
		and	eax, 0FFFFC7FFh
		or	eax, ebx
		jmp	short loc_7D4E

loc_7CFD:				; CODE XREF: 7CB0	7CB9
		mov	eax, h_fsw[ebp]	; FPU Status Word
		cmp	ebx, 0
		jnz	short loc_7D11
		or	eax, 3800h	; set TOP = Top of stack pointer to 7
		mov	ecx, 3800h
		jmp	short loc_7D4E

loc_7D11:				; CODE XREF: 7D03
		sub	ebx, 800h	; TOP -= 1
		mov	ecx, ebx

loc_7D19:				; CODE XREF: 7D4C
		and	eax, 0FFFFC7FFh
		or	eax, ebx
		jmp	short loc_7D4E

 IF V034N OR V033W
loc_7D2B:
 ENDIF

loc_7D22:				; CODE XREF: 7C30	7C3B
 IF V033S OR V033V
		mov	dword ptr [ebp-90h], 0FFFFFFFFh
 ELSE
		or	dword ptr [ebp-90h], 1
 ENDIF
 IF VPCI AND NOT V034N
		jmp	short loc_7D32

loc_7D2B:				; CODE XREF: 7C61	7C71
					; 00007C7C 00007C87
		or	dword ptr [ebp-90h], 8
 ENDIF

 IF V033S OR V033V
loc_7D2B:
 ENDIF
loc_7D32:				; CODE XREF: 7D29
		mov	eax, h_fsw[ebp]	; FPU Status Word
		mov	ecx, ebx
		cmp	ebx, 3800h
		jnz	short loc_7D46
		and	eax, 0FFFFC7FFh
		jmp	short loc_7D4E

loc_7D46:				; CODE XREF: 7D3D
		add	ebx, 800h	; TOP += 1
		jmp	short loc_7D19

loc_7D4E:				; CODE XREF: 7CDE	7CEA
					; 00007CFB 00007D0F	7D20
 IF NOT (V033S OR V033V)
		bt	dword ptr [ebp-8Ch], 0
		jnc	short loc_7D64
		btr	eax, 9
		btr	dword ptr [ebp-8Ch], 0
 ENDIF
loc_7D64:				; CODE XREF: 7D56
		mov	h_fsw[ebp], eax
		mov	eax, h_ftw[ebp]	; FPU Tag Word
		cmp	ecx, 0
		jz	short loc_7DBC
		cmp	ecx, 800h
 IF VPCI AND NOT V034N
		jz	loc_7E0C
 ELSE
		jz	short loc_7E0C
 ENDIF
		cmp	ecx, 1000h
		jz	loc_7E5C
		cmp	ecx, 1800h
		jz	loc_7EAE
		cmp	ecx, 2000h
		jz	loc_7F04
		cmp	ecx, 2800h
		jz	loc_7F5A
		cmp	ecx, 3000h
		jz	loc_7FB0
		jmp	loc_7FF4

loc_7DBC:				; CODE XREF: 7D6D
 IF V033S OR V033V
		cmp	dword ptr [ebp-90h], 0FFFFFFFFh
		jz	short loc_7DEB
 ELSE
		bt	dword ptr [ebp-90h], 0
		jc	short loc_7DEB
 ENDIF
 IF VPCI AND NOT V034N
		bt	dword ptr [ebp-90h], 3
  IF V034I
		jc	short loc_7E3B
  ELSE
		jnc	short loc_7DF3
		bt	dword ptr h_gatflag[ebp], 15
		jc	loc_8036
		cmp	dword ptr [ebp-90h], 0Ch
		jz	loc_8036
loc_7DEB:	or	eax, 3
		jmp	loc_8036

  ENDIF
loc_7DF3:
 ENDIF
		and	eax, 0FFFFFFFCh
 IF V033S OR V033V
		cmp	dword ptr [ebp-90h], 0FFFFFFFEh
		jnz	loc_8036
 ELSE
		bt	dword ptr [ebp-90h], 1
		jnc	loc_8036
 ENDIF
		and	eax, 0FFFFFFF3h
		jmp	loc_8036

 IF V033S OR V033V
loc_7DEB:
		or	eax, 3
		jmp	loc_8036
 ENDIF
 IF V033W OR V034I OR V034N
loc_7DEB:
  IF V034I
		cmp	dword ptr [ebp-90h], 12
  ELSE
		cmp	dword ptr [ebp-90h], 5
  ENDIF
		jz	loc_8036
		or	eax, 3
		jmp	loc_8036
 ENDIF

loc_7E0C:				; CODE XREF: 7D75
 IF V033S OR V033V
		cmp	dword ptr [ebp-90h], 0FFFFFFFFh
		jz	short loc_7E3B
 ELSE
		bt	dword ptr [ebp-90h], 0
		jc	short loc_7E3B
 ENDIF
 IF VPCI AND NOT V034N
		bt	dword ptr [ebp-90h], 3
  IF V034I
		jc	short loc_7E8B
  ELSE
		jnc	short loc_7E43
		bt	dword ptr h_gatflag[ebp], 15
		jc	loc_8036
		cmp	dword ptr [ebp-90h], 0Ch
		jz	loc_8036
loc_7E3B:	or	eax, 0Ch
		jmp	loc_8036
  ENDIF
loc_7E43:
 ENDIF
		and	eax, 0FFFFFFF3h
 IF V033S OR V033V
		cmp	dword ptr [ebp-90h], 0FFFFFFFEh
		jnz	loc_8036
 ELSE
		bt	dword ptr [ebp-90h], 1
		jnc	loc_8036
 ENDIF
		and	eax, 0FFFFFFCFh
		jmp	loc_8036

 IF V033S OR V033V
loc_7E3B:	or	eax, 0Ch
		jmp	loc_8036
 ENDIF
 IF V033W OR V034I OR V034N
loc_7E3B:
  IF V034I
		cmp	dword ptr [ebp-90h], 12
  ELSE
		cmp	dword ptr [ebp-90h], 5
  ENDIF
		jz	loc_8036
		or	eax, 0Ch
		jmp	loc_8036
 ENDIF


loc_7E5C:				; CODE XREF: 7D81
 IF V033S OR V033V
		cmp	dword ptr [ebp-90h], 0FFFFFFFFh
		jz	short loc_7E8B
 ELSE
		bt	dword ptr [ebp-90h], 0
		jc	short loc_7E8B
 ENDIF
 IF VPCI AND NOT V034N
		bt	dword ptr [ebp-90h], 3
  IF V034I
		jc	short loc_7EDD
  ELSE
		jnc	short loc_7E93
		bt	dword ptr h_gatflag[ebp], 15
		jc	loc_8036
		cmp	dword ptr [ebp-90h], 0Ch
		jz	loc_8036
loc_7E8B:	or	eax, 30h
		jmp	loc_8036
  ENDIF
loc_7E93:
 ENDIF
		and	eax, 0FFFFFFCFh
 IF V033S OR V033V
		cmp	dword ptr [ebp-90h], 0FFFFFFFEh
		jnz	loc_8036
 ELSE
		bt	dword ptr [ebp-90h], 1
		jnc	loc_8036
 ENDIF
		and	eax, 0FFFFFF3Fh
		jmp	loc_8036

 IF V033S OR V033V
loc_7E8B:	or	eax, 30h
		jmp	loc_8036
 ENDIF
 IF V033W OR V034I OR V034N
loc_7E8B:
  IF V034I
		cmp	dword ptr [ebp-90h], 12
  ELSE
		cmp	dword ptr [ebp-90h], 5
  ENDIF
		jz	loc_8036
		or	eax, 30h
		jmp	loc_8036
 ENDIF


loc_7EAE:				; CODE XREF: 7D8D
 IF V033S OR V033V
		cmp	dword ptr [ebp-90h], 0FFFFFFFFh
		jz	short loc_7EDD
 ELSE
		bt	dword ptr [ebp-90h], 0
		jc	short loc_7EDD
 ENDIF
 IF VPCI AND NOT V034N
		bt	dword ptr [ebp-90h], 3
  IF V034I
		jc	short loc_7F33
  ELSE
		jnc	short loc_7EE7
		bt	dword ptr h_gatflag[ebp], 15
		jc	loc_8036
		cmp	dword ptr [ebp-90h], 0Ch
		jz	loc_8036
loc_7EDD:	or	eax, 0C0h
		jmp	loc_8036
  ENDIF
loc_7EE7:
 ENDIF
		and	eax, 0FFFFFF3Fh
 IF V033S OR V033V
		cmp	dword ptr [ebp-90h], 0FFFFFFFEh
		jnz	loc_8036
 ELSE
		bt	dword ptr [ebp-90h], 1
		jnc	loc_8036
 ENDIF
		and	eax, 0FFFFFCFFh
		jmp	loc_8036

 IF V033S OR V033V
loc_7EDD:	or	eax, 0C0h
		jmp	loc_8036
 ENDIF
 IF V033W OR V034I OR V034N
loc_7EDD:
  IF V034I
		cmp	dword ptr [ebp-90h], 12
  ELSE
		cmp	dword ptr [ebp-90h], 5
  ENDIF
		jz	loc_8036
		or	eax, 0C0h
		jmp	loc_8036
 ENDIF


loc_7F04:				; CODE XREF: 7D99
 IF V033S OR V033V
		cmp	dword ptr [ebp-90h], 0FFFFFFFFh
		jz	short loc_7F33
 ELSE
		bt	dword ptr [ebp-90h], 0
		jc	short loc_7F33
 ENDIF
 IF VPCI AND NOT V034N
		bt	dword ptr [ebp-90h], 3
  IF V034I
		jc	short loc_7F89
  ELSE
		jnc	short loc_7F3D
		bt	dword ptr h_gatflag[ebp], 15
		jc	loc_8036
		cmp	dword ptr [ebp-90h], 0Ch
		jz	loc_8036
loc_7F33:	or	eax, 300h
		jmp	loc_8036
  ENDIF
loc_7F3D:
 ENDIF
		and	eax, 0FFFFFCFFh
 IF V033S OR V033V
		cmp	dword ptr [ebp-90h], 0FFFFFFFEh
		jnz	short loc_8036
 ELSE
		bt	dword ptr [ebp-90h], 1
		jnc	loc_8036
 ENDIF
		and	eax, 0FFFFF3FFh
 IF V033S OR V033V
		jmp	short loc_8036
 ELSE
		jmp	loc_8036
 ENDIF

 IF V033S OR V033V
loc_7F33:	or	eax, 300h
		jmp	short loc_8036
 ENDIF
 IF V033W OR V034I OR V034N
loc_7F33:
  IF V034I
		cmp	dword ptr [ebp-90h], 12
  ELSE
		cmp	dword ptr [ebp-90h], 5
  ENDIF
		jz	loc_8036
		or	eax, 300h
		jmp	loc_8036
 ENDIF


loc_7F5A:				; CODE XREF: 7DA5
 IF V033S OR V033V
		cmp	dword ptr [ebp-90h], 0FFFFFFFFh
		jz	short loc_7F89
 ELSE
		bt	dword ptr [ebp-90h], 0
		jc	short loc_7F89
 ENDIF
 IF VPCI AND NOT V034N
		bt	dword ptr [ebp-90h], 3
  IF V034I
		jc	short loc_7FD7
  ELSE
		jnc	short loc_7F93
		bt	dword ptr h_gatflag[ebp], 15
		jc	loc_8036
		cmp	dword ptr [ebp-90h], 0Ch
		jz	loc_8036
loc_7F89:	or	eax, 0C00h
		jmp	loc_8036
  ENDIF
loc_7F93:
 ENDIF
		and	eax, 0FFFFF3FFh

 IF V033S OR V033V
		cmp	dword ptr [ebp-90h], 0FFFFFFFEh
		jnz	short loc_8036
 ELSEIF VPCI AND NOT V034N
		bt	dword ptr [ebp-90h], 1
		jnc	loc_8036
 ELSE
		bt	dword ptr [ebp-90h], 1
		jnc	short loc_8036
 ENDIF
		and	eax, 0FFFFCFFFh
 IF VPCI AND NOT V034N
		jmp	loc_8036
 ELSE
		jmp	short loc_8036
 ENDIF

 IF V033S OR V033V
loc_7F89:	or	eax, 0C00h
		jmp	short loc_8036
 ELSEIF V033W OR V034I OR V034N
loc_7F89:
   IF V034I
		cmp	dword ptr [ebp-90h], 12
		jz	loc_8036
   ELSE
		cmp	dword ptr [ebp-90h], 5
		jz	short loc_8036
   ENDIF
		or	eax, 0C00h
		jmp	short loc_8036
 ENDIF


loc_7FB0:				; CODE XREF: 7DB1
 IF V033S OR V033V
		cmp	dword ptr [ebp-90h], 0FFFFFFFFh
		jz	short loc_7FD7
 ELSE
		bt	dword ptr [ebp-90h], 0
		jc	short loc_7FD7
 ENDIF
 IF VPCI AND NOT V034N
		bt	dword ptr [ebp-90h], 3
  IF V034I
		jc	short loc_801B
  ELSE
		jnc	short loc_7FDE
		bt	dword ptr h_gatflag[ebp], 15
		jc	short loc_8036
		cmp	dword ptr [ebp-90h], 0Ch
		jz	short loc_8036
loc_7FD7:	or	eax, 3000h
		jmp	short loc_8036
  ENDIF
loc_7FDE:
 ENDIF
		and	eax, 0FFFFCFFFh
 IF V033S OR V033V
		cmp	dword ptr [ebp-90h], 0FFFFFFFEh
		jnz	short loc_8036
 ELSE
		bt	dword ptr [ebp-90h], 1
		jnc	short loc_8036
 ENDIF
		and	eax, 0FFFF3FFFh
		jmp	short loc_8036

 IF V033S OR V033V
loc_7FD7:	or	eax, 3000h
		jmp	short loc_8036
 ENDIF
 IF V033W OR V034I OR V034N
loc_7FD7:
  IF V034I
		cmp	dword ptr [ebp-90h], 12
  ELSE
		cmp	dword ptr [ebp-90h], 5
  ENDIF
		jz	short loc_8036
		or	eax, 3000h
		jmp	short loc_8036
 ENDIF


loc_7FF4:				; CODE XREF: 7DB7
 IF V033S OR V033V
		cmp	dword ptr [ebp-90h], 0FFFFFFFFh
		jz	short loc_801B
 ELSE
		bt	dword ptr [ebp-90h], 0
		jc	short loc_801B
 ENDIF
 IF VPCI AND NOT V034N
		bt	dword ptr [ebp-90h], 3
  IF V034I
		jc	loc_7DEB
  ELSE
		jnc	short loc_8022
		bt	dword ptr h_gatflag[ebp], 15
		jc	short loc_8036
		cmp	dword ptr [ebp-90h], 0Ch
		jz	short loc_8036
loc_801B:	or	eax, 0C000h
		jmp	short loc_8036
  ENDIF
loc_8022:
 ENDIF
		and	eax, 0FFFF3FFFh
 IF V033S OR V033V
		cmp	dword ptr [ebp-90h], 0FFFFFFFEh
		jnz	short loc_8036
 ELSE
		bt	dword ptr [ebp-90h], 1
		jnc	short loc_8036
 ENDIF
		and	eax, 0FFFFFFFCh
		jmp	short loc_8036

 IF V033S OR V033V
loc_801B:	or	eax, 0C000h
		jmp	short loc_8036
 ENDIF
 IF V033W OR V034I OR V034N
loc_801B:
  IF V034I
		cmp	dword ptr [ebp-90h], 12
  ELSE
		cmp	dword ptr [ebp-90h], 5
  ENDIF
		jz	short loc_8036
		or	eax, 0C000h
		jmp	short loc_8036
 ENDIF


loc_8036:				; CODE XREF: 7DD8	7DE5
					; 00007DEE 00007DFE	7E07
		mov	h_ftw[ebp], eax		; FPU Tag Word
		fnldenv	byte ptr h_fenviron[ebp]
		mov	dword ptr [ebp-90h], 0
		mov	byte ptr h_opflag[ebp], 0
		; Toggle bit 0 of F Configuration Register 0 -> 1 -> 0
		mov	eax, h_fcfg[ebp]
		or	eax, 1
		mov	[ebp-90h], eax
 IF NOT (V033S OR V033V)
		DELAYNOP 2
 ENDIF
		FWRCFG	[ebp-90h]
		and	eax, 0FFFFFFFEh
		mov	[ebp-90h], eax
 IF NOT (V033S OR V033V)
		DELAYNOP 2
 ENDIF
		FWRCFG	[ebp-90h]
		jmp	loc_79D5

hypseg		ends
		end

;------------------------------------------------------------- end FIXUPNP.ASM