;-----------------------------------------------------------------------------
; NexGen Nx586 BIOS Hypercode
;-----------------------------------------------------------------------------
; File: FPATAN.ASM - 
; Date: 2020-09-26
;
; Disassembled by Dipl.-Inf. Herbert Oppmann (herby@memotech.franken.de)
;-----------------------------------------------------------------------------
; Only used for VL

		include COMMON.INC

	extrn	loc_8E80:near
	extrn	loc_8F23:near
	extrn	loc_8F53:near
	extrn	loc_8FB3:near
	extrn	loc_8FF4:near
	extrn	loc_9068:near
	extrn	loc_9097:near
	extrn	loc_90C1:near

	public	DecFPATAN

		db '@(#)fpatan.asm',TAB,'3.3',0
		ALIGN0	32

MinusOneThird:	dt 0BFFDAAAAAAAAAAAAA972h	; -0.333333 = -1/3
		ALIGN	16

loc_92A0:	dt 0BFFEA5C2F7B103667FABh	; -0.647506
		ALIGN	16

loc_92B0:	dt 0BFFDD10574A068F935CAh	; -0.408245
		ALIGN	16

loc_92C0:	dt 0BFFBBC22001B7F917D66h	; -0.0918617
		ALIGN	16

loc_92D0:	dt 0BFF7AD388123284F398Dh	; -0.00528628
		ALIGN	16

loc_92E0:	dt 4000A2B8A02B28F2E2DAh	; 2.54252
		ALIGN	16

loc_92F0:	dt 400094964E9438BBCD72h	; 2.32167
		ALIGN	16

loc_9300:	dt 3FFEE98AA9720217AB5Ah	; 0.912272
		ALIGN	16

loc_9310:	dt 3FFC926E087B52D723A7h	; 0.142998
		ALIGN	16

loc_9320:	dt 3FF7C6F248FC810C8958h	; 0.00607136
		ALIGN	16

PiQuarter:	dt 3FFEC90FDAA22168C235h	; 0.785398 = pi/4
		ALIGN	16

PiHalf:		dt 3FFFC90FDAA22168C235h	; 1.5708 = pi/2
		ALIGN	16

PiThreeQuarter:	dt 400096CBE3F9990E91A8h	; 2.35619 = 3/4 x pi

		dt 00000000000000000000h	; 0.0
		ALIGN	16


DecFPATAN:	@CALL	loc_8E80
		fnsave	byte ptr h_fenviron[ebp]
		sub	esp, 0A4h
		mov	byte ptr [ebp-86h], 0
		mov	byte ptr [ebp-85h], 0
		mov	ecx, h_base[ebp]
		FNLDSW	h_fsw[ebp]
		FNLDTW	h_ftw[ebp]
		btr	dword ptr h_fsw[ebp], 0Ah
		ffree	st(6)
		ffree	st(7)
		fxam	
		fstsw	word ptr [esp-4]
		mov	ax, [esp-4]
		test	ah, 2
		jz	short loc_93BB
		mov	byte ptr [ebp-85h], 1
loc_93BB:	sahf	
		jbe	short loc_93C9
		jnp	short loc_93E8
		mov	byte ptr [ebp-86h], 1
		jmp	short loc_93F8

loc_93C9:	jc	short loc_93D6
		jp	short loc_93F1
		mov	byte ptr [ebp-86h], 3
		jmp	short loc_93F8

loc_93D6:	jp	short loc_93F8
		jz	short loc_93E3
		mov	byte ptr [ebp-86h], 4
		jmp	short loc_93F8

loc_93E3:	jmp	loc_947F

loc_93E8:	mov	byte ptr [ebp-86h], 5
		jmp	short loc_93F8

loc_93F1:	mov	byte ptr [ebp-86h], 2
loc_93F8:	fstp	st
		fxam	
		fstsw	word ptr [esp-4]
		mov	ax, [esp-4]
		test	ah, 2
		jz	short loc_9412
		or	byte ptr [ebp-85h], 2
loc_9412:	sahf	
		jbe	short loc_9440
		jnp	loc_94D8
		movzx	esi, byte ptr [ebp-86h]
		mov	eax, h_base[ebp]
		lea	eax, loc_9434[eax+esi*2]
		movzx	eax, word ptr [eax]
		@JMP	eax

loc_9434:	dw small offset loc_94F3
		dw small offset loc_9522
		dw small offset loc_9518
		dw small offset loc_952E
		dw small offset loc_94E7
		dw small offset loc_94D8

loc_9440:	jc	short loc_9469
		jp	short loc_94B3
		movzx	esi, byte ptr [ebp-86h]
		mov	eax, h_base[ebp]
		lea	eax, loc_945D[eax+esi*2]
		movzx	eax, word ptr [eax]
		@JMP	eax

loc_945D:	dw small offset loc_94F3
		dw small offset loc_94F3
		dw small offset loc_94E9
		dw small offset loc_94F3
		dw small offset loc_94E7
		dw small offset loc_94D8

loc_9469:	jp	short loc_948E
		jz	short loc_947F
loc_946D:	fld	tbyte ptr h_fr0[ebp]
		@CALL	loc_8FF4
		jmp	loc_97B3

loc_947F:	@CALL	loc_9068
		jmp	loc_97CA

loc_948E:	movzx	esi, byte ptr [ebp-86h]
		mov	eax, h_base[ebp]
		lea	eax, loc_94A7[eax+esi*2]
		movzx	eax, word ptr [eax]
		@JMP	eax

loc_94A7:	dw small offset loc_9540
		dw small offset loc_952E
		dw small offset loc_9524
		dw small offset loc_952E
		dw small offset loc_94E7
		dw small offset loc_94D8

loc_94B3:	movzx	esi, byte ptr [ebp-86h]
		mov	eax, h_base[ebp]
		lea	eax, loc_94CC[eax+esi*2]
		movzx	eax, word ptr [eax]
		@JMP	eax

loc_94CC:	dw small offset loc_950A
		dw small offset loc_9518
		dw small offset loc_9518
		dw small offset loc_9524
		dw small offset loc_94E7
		dw small offset loc_94D8

loc_94D8:	@CALL	loc_8FB3
		jmp	loc_97B3

loc_94E7:	jmp	short loc_946D

loc_94E9:	@CALL	loc_9097
loc_94F3:	test	byte ptr [ebp-85h], 1
		jz	short loc_9514
		fldpi	
		btr	dword ptr h_fsw[ebp], 9	; C1
		bts	dword ptr h_fsw[ebp], 5	; PE
		jmp	short loc_9563

loc_950A:	@CALL	loc_9097
loc_9514:	fldz	
		jmp	short loc_9563

loc_9518:	@CALL	loc_9097
loc_9522:	jmp	short loc_9577

loc_9524:	@CALL	loc_9097
loc_952E:	fld	tbyte ptr PiHalf[ecx]
		btr	dword ptr h_fsw[ebp], 9	; C1
		bts	dword ptr h_fsw[ebp], 5	; PE
		jmp	short loc_9563

loc_9540:	btr	dword ptr h_fsw[ebp], 9	; C1
		bts	dword ptr h_fsw[ebp], 5	; PE
		test	byte ptr [ebp-85h], 1
		jz	short loc_955B
		fld	tbyte ptr PiThreeQuarter[ecx]
		jmp	short loc_9563

loc_955B:	fld	tbyte ptr PiQuarter[ecx]
		jmp	short loc_9563		; unnecessary

loc_9563:	test	byte ptr [ebp-85h], 2
		jz	loc_97B3
		fchs	
		jmp	loc_97B3

loc_9577:	fninit	
		fld	tbyte ptr h_fr1[ebp]
		fabs	
		fld	tbyte ptr h_fr0[ebp]
		fabs	
		fld	st(1)
		fsub	st, st(1)
		fstp	tbyte ptr [ebp-9Bh]
		test	byte ptr [ebp-92h], 80h
		jnz	short loc_959F
		or	byte ptr [ebp-85h], 4
		fxch	st(1)
loc_959F:	mov	byte ptr [ebp-91h], 1
		fld	st(1)
		fld	st(1)
		fsubrp	st(1), st
		fcomp	st(2)
		fstsw	word ptr [esp-4]
		mov	ax, [esp-4]
		sahf	
		jbe	short loc_95C2
		mov	byte ptr [ebp-91h], 0
loc_95C2:	cmp	byte ptr [ebp-91h], 1
		jz	loc_967E
		fld	st(1)
		test	byte ptr [ebp-85h], 4
		jnz	loc_9670
		test	byte ptr [ebp-85h], 1
		jnz	loc_9670
		bt	dword ptr h_fcw[ebp], 4	; UM
		jc	short loc_95FD
		mov	ax, 36Fh
		push	ax
		fldcw	word ptr [esp]
		pop	ax
loc_95FD:	fnclex	
		fdiv	st, st(1)
		fstsw	word ptr [esp-4]
		mov	ax, [esp-4]
		test	al, 10h
		jz	loc_969D
		bts	dword ptr h_fsw[ebp], 4	; UE
		bt	dword ptr h_fcw[ebp], 4	; UM
		jc	loc_979E
		fnclex	
		mov	eax, h_fcfg[ebp]
		and	eax, 0FFFFFFF7h
		mov	h_fcfg[ebp], eax
		or	eax, 200h
		mov	[ebp-0A0h], eax
		DELAYNOP 2
		FWRCFG	[ebp-0A0h]
		and	eax, 0FFFFFDFFh
		mov	[ebp-0A0h], eax
		FWRCFG	[ebp-0A0h]
		mov	ax, 37Fh
		push	ax
		fldcw	word ptr [esp]
		pop	ax
		jmp	loc_979E

loc_9670:	fdiv	st, st(1)
		jmp	short loc_969D

loc_9674:	fstp	st
		fstp	st
		fldpi	
		fdiv	st(1), st
		fdivp	st(2), st
loc_967E:	fld	st(1)
		fsub	st, st(1)
		fld	st(1)
		fclex	
		fadd	st, st(3)
		fstsw	word ptr [esp-4]
		mov	ax, [esp-4]
		test	al, 8
		jnz	short loc_9674
		fdivp	st(1), st
		fstp	st(1)
		fstp	st(1)
loc_969D:	fld	st
		fstp	tbyte ptr [ebp-90h]
		and	word ptr [ebp-88h], 7FFFh
		cmp	word ptr [ebp-88h], 3FDFh
		jge	short loc_96BF
		fldz	
		fld1	
		jmp	short loc_9735

loc_96BF:	fld	st
		fmul	st, st(1)
		fld	tbyte ptr loc_92D0[ecx]
		fmul	st, st(1)
		fld	tbyte ptr loc_92C0[ecx]
		faddp	st(1), st
		fmul	st, st(1)
		fld	tbyte ptr loc_92B0[ecx]
		faddp	st(1), st
		fmul	st, st(1)
		fld	tbyte ptr loc_92A0[ecx]
		faddp	st(1), st
		fmul	st, st(1)
		fld	tbyte ptr MinusOneThird[ecx]
		faddp	st(1), st
		fmul	st, st(1)
		fmul	st, st(2)
		fxch	st(2)
		fxch	st(1)
		fld	tbyte ptr loc_9320[ecx]
		fmul	st, st(1)
		fld	tbyte ptr loc_9310[ecx]
		faddp	st(1), st
		fmul	st, st(1)
		fld	tbyte ptr loc_9300[ecx]
		faddp	st(1), st
		fmul	st, st(1)
		fld	tbyte ptr loc_92F0[ecx]
		faddp	st(1), st
		fmul	st, st(1)
		fld	tbyte ptr loc_92E0[ecx]
		faddp	st(1), st
		fmul	st, st(1)
		fld1	
		faddp	st(1), st
		fstp	st(1)
		fxch	st(2)
		fxch	st(1)
		fxch	st(2)
loc_9735:	fdivp	st(1), st
		faddp	st(1), st
		test	byte ptr [ebp-91h], 1
		jz	short loc_974A
		fld	tbyte ptr PiQuarter[ecx]
		faddp	st(1), st
loc_974A:	test	byte ptr [ebp-85h], 4
		jnz	short loc_9755
		jmp	short loc_9760

loc_9755:	test	byte ptr [ebp-85h], 1
		jnz	short loc_9771
		jmp	short loc_977B

loc_9760:	test	byte ptr [ebp-85h], 1
		jnz	short loc_976B
		jmp	short loc_9783

loc_976B:	fldpi	
		fsubrp	st(1), st
		jmp	short loc_9783

loc_9771:	fld	tbyte ptr PiHalf[ecx]
		faddp	st(1), st
		jmp	short loc_9783

loc_977B:	fld	tbyte ptr PiHalf[ecx]
		fsubrp	st(1), st
loc_9783:	fxam	
		fstsw	word ptr [esp-4]
		mov	ax, [esp-4]
		sahf	
		jnz	short loc_979E
		jc	short loc_979E
		@CALL	loc_90C1
loc_979E:	btr	dword ptr h_fsw[ebp], 9	; C1
		bts	dword ptr h_fsw[ebp], 5	; PE
		test	byte ptr [ebp-85h], 2
		jz	short loc_97B3
		fchs	
loc_97B3:	fstp	tbyte ptr h_fr1[ebp]
		@CALL	loc_8F23
		fnrstor	byte ptr h_fenviron[ebp]
		fstp	st
		jmp	loc_8F53

loc_97CA:	@CALL	loc_8F23
		jmp	loc_8F53

		ALIGN0	16

hypseg		ends
		end

;-------------------------------------------------------------- end FPATAN.ASM