;-----------------------------------------------------------------------------
; NexGen Nx586 BIOS Hypercode
;-----------------------------------------------------------------------------
; File: FSCALE.ASM - 
; Date: 2020-09-26
;
; Disassembled by Dipl.-Inf. Herbert Oppmann (herby@memotech.franken.de)
;-----------------------------------------------------------------------------

		include COMMON.INC

	extrn	loc_8E80:near
	extrn	loc_8E99:near
	extrn	loc_8F23:near
	extrn	loc_8F44:near
	extrn	loc_8F53:near
	extrn	loc_8FB3:near
	extrn	loc_8FF4:near
	extrn	loc_9097:near

	public	DecFSCALE


		db '@(#)fscale.asm',TAB,'3.3',0
		ALIGN0	32

loc_8A10	dt 7FFF8000000000000000h	; +INF

loc_8A1A	dt 7FFEFFFFFFFFFFFFFFFFh	; biggest +Normal

loc_8A24	dw 0C3Fh			; FPU Control Word
		;  X=0 Infinity Control
		;  RC=3 Rounding Control - Round toward zero (truncate)
		;  PC=0 Precision Control - Single precision (24 bits)
		;  Exception Masks=1

DecFSCALE:	@CALL	loc_8E80	; CODE XREF: 7B56
		fnsave	byte ptr h_fenviron[ebp]
		sub	esp, 98h
		mov	byte ptr [ebp-86h], 0
		mov	byte ptr [ebp-85h], 0
		FNLDSW	h_fsw[ebp]
		FNLDTW	h_ftw[ebp]
		ffree	st(6)
		ffree	st(7)
		fxam
		fstsw	word ptr [esp-4]
		mov	ax, [esp-4]
		test	ah, 2
		jz	short loc_8A69
		mov	byte ptr [ebp-85h], 1

loc_8A69:				; CODE XREF: 8A60
		sahf
		jbe	short loc_8A77
		jnp	short loc_8A96
		mov	byte ptr [ebp-86h], 1
		jmp	short loc_8AA6

loc_8A77:				; CODE XREF: 8A6A
		jc	short loc_8A84
		jp	short loc_8A9F
		mov	byte ptr [ebp-86h], 3
		jmp	short loc_8AA6

loc_8A84:				; CODE XREF: 8A77
		jp	short loc_8AA6
		jz	short loc_8A91
		mov	byte ptr [ebp-86h], 4
		jmp	short loc_8AA6

loc_8A91:				; CODE XREF: 8A86
		jmp	loc_8B3B

loc_8A96:				; CODE XREF: 8A6C
		mov	byte ptr [ebp-86h], 5
		jmp	short loc_8AA6

loc_8A9F:				; CODE XREF: 8A79
		mov	byte ptr [ebp-86h], 2

loc_8AA6:				; CODE XREF: 8A75	8A82
					; 00008A84 00008A8F	8A9D
		fabs
		fstp	tbyte ptr h_ftemp[ebp]
		fxam
		fstsw	word ptr [esp-4]
		mov	ax, [esp-4]
		xor	edx, edx
		test	ah, 2
		jz	short loc_8AC5
		or	byte ptr [ebp-85h], 2

loc_8AC5:				; CODE XREF: 8ABC
		sahf
		jbe	short loc_8AF3
		jnp	loc_8BC6
		movzx	esi, byte ptr [ebp-86h]
		mov	eax, h_base[ebp]
		lea	eax, loc_8AE7[eax+esi*2]
		movzx	eax, word ptr [eax]
		@JMP	eax

loc_8AE7	dw small offset loc_8C1F
		dw small offset loc_8C81
		dw small offset loc_8C6D
		dw small offset loc_8C1F
		dw small offset loc_8BD5
		dw small offset loc_8BDA

loc_8AF3:				; CODE XREF: 8AC6
		jc	short loc_8B20
		jp	loc_8BA1
		movzx	esi, byte ptr [ebp-86h]
		mov	eax, h_base[ebp]
		lea	eax, loc_8B14[eax+esi*2]
		movzx	eax, word ptr [eax]
		@JMP	eax

loc_8B14	dw small offset loc_8C1F
		dw small offset loc_8C1F
		dw small offset loc_8C29
		dw small offset loc_8C1F
		dw small offset loc_8BD5
		dw small offset loc_8BDA

loc_8B20:				; CODE XREF: 8AF3
		jp	short loc_8B7C
		jz	short loc_8B3B

loc_8B24:				; CODE XREF: 8BD5
		fld	tbyte ptr h_fr0[ebp]
		@CALL	loc_8FF4
		btr	dword ptr h_fsw[ebp], 9
		jmp	loc_8DDF

loc_8B3B:				; CODE XREF: 8A91	8B22
		bt	dword ptr h_fcw[ebp], 0
		jc	short loc_8B56
		btr	dword ptr h_fsw[ebp], 9
		bts	dword ptr h_fsw[ebp], 6
		bts	dword ptr h_fsw[ebp], 0
		jmp	loc_8F44

loc_8B56:				; CODE XREF: 8B40
		mov	ebx, h_fcw[ebp]
		or	byte ptr h_fcw[ebp], 3Fh
		fnclex
		fnrstor	byte ptr h_fenviron[ebp]
		fadd	st, st(1)
		fnstenv	byte ptr h_fenviron[ebp]
		mov	h_fcw[ebp], ebx
		@CALL	loc_8F23
		fnldenv	byte ptr h_fenviron[ebp]
		jmp	loc_8F53

loc_8B7C:				; CODE XREF: 8B20
		movzx	esi, byte ptr [ebp-86h]
		mov	eax, h_base[ebp]
		lea	eax, loc_8B95[eax+esi*2]
		movzx	eax, word ptr [eax]
		@JMP	eax

loc_8B95	dw small offset loc_8BDC
		dw small offset loc_8BF1
		dw small offset loc_8BE7
		dw small offset loc_8C08
		dw small offset loc_8BD5
		dw small offset loc_8BDA

loc_8BA1:				; CODE XREF: 8AF5
		movzx	esi, byte ptr [ebp-86h]
		mov	eax, h_base[ebp]
		lea	eax, loc_8BBA[eax+esi*2]
		movzx	eax, word ptr [eax]
		@JMP	eax

loc_8BBA	dw small offset loc_8C13
		dw small offset loc_8C13
		dw small offset loc_8C29
		dw small offset loc_8C13
		dw small offset loc_8BD5
		dw small offset loc_8BDA

loc_8BC6:	@CALL	loc_8FB3	; CODE XREF: 8AC8	8BDA
					; 00008BE5 00008C11
		jmp	loc_8DDF

loc_8BD5:				; DATA XREF: 8AE7	8B14
					; 00008B95 00008BBA
		jmp	loc_8B24

loc_8BDA:				; DATA XREF: 8AE7	8B14
					; 00008B95 00008BBA
		jmp	short loc_8BC6

loc_8BDC:				; DATA XREF: 8B95
		test	byte ptr [ebp-85h], 2
		jz	short loc_8C1F
		jmp	short loc_8BC6

loc_8BE7:	@CALL	loc_9097	; DATA XREF: 8B95
loc_8BF1:	fabs
		test	byte ptr [ebp-85h], 2
		jz	short loc_8C03
		fldz
		btr	dword ptr h_fsw[ebp], 9

loc_8C03:				; CODE XREF: 8BFA
		jmp	loc_8DD4

loc_8C08:				; DATA XREF: 8B95
		test	byte ptr [ebp-85h], 2
		jnz	short loc_8C1F
		jmp	short loc_8BC6

loc_8C13:	@CALL	loc_9097	; DATA XREF: 8BBA
		jmp	short loc_8C1F

loc_8C1F:				; CODE XREF: 8BE3	8C0F
					; DATA XREF: 8AE7	8B14
		btr	dword ptr h_fsw[ebp], 9
		jmp	loc_8F44

loc_8C29:	@CALL	loc_9097	; DATA XREF: 8B14	8BBA
		btr	dword ptr h_fsw[ebp], 9
		fld	tbyte ptr h_fr0[ebp]
		fldz
		faddp	st(1), st
		fabs
		fstp	tbyte ptr h_ftemp[ebp]
		lea	edi, h_ftemp[ebp]
		movzx	ebx, word ptr [edi+8]
		and	ebx, 7FFFh
		jnz	loc_8CF7
		@CALL	loc_8DE7
loc_8C61:	mov	eax, 0FFFFC002h
		sub	eax, edx
		jmp	loc_8CFF

loc_8C6D:	@CALL	loc_9097	; DATA XREF: 8AE7
		@CALL	loc_8DE7
loc_8C81:	mov	ecx, h_base[ebp]
		lea	edi, h_ftemp[ebp]
		btr	dword ptr h_fsw[ebp], 9
		fldcw	ds:loc_8A24[ecx]
		fistp	dword ptr [ebp+18h]
		fnstsw	word ptr [ebp-90h]
		test	word ptr [ebp-90h], 1
		jnz	short loc_8CB2
		fninit
		mov	eax, [ebp+18h]
		cmp	eax, 0
		jz	short loc_8CC7
		jmp	short loc_8CCE

loc_8CB2:				; CODE XREF: 8CA4
		mov	eax, 0FFFF0000h
		test	byte ptr [ebp-85h], 2
		jnz	short loc_8CFF
		neg	eax
		jmp	loc_8D76

loc_8CC7:				; CODE XREF: 8CAE
		cmp	edx, 0
		jz	short loc_8CF7
		jmp	short loc_8C61

loc_8CCE:				; CODE XREF: 8CB0
		movzx	ebx, word ptr [edi+8]
		sub	ebx, 3FFFh
		sub	ebx, edx
		add	eax, ebx
		cmp	eax, 3FFFh
		jg	loc_8D76
		cmp	eax, 0FFFFC002h
		jl	short loc_8CFF

loc_8CEE:				; CODE XREF: 8D28	8DBC
		add	eax, 3FFFh
		mov	[edi+8], ax

loc_8CF7:				; CODE XREF: 8C51	8CCA
		fld	tbyte ptr h_ftemp[ebp]
		jmp	loc_8DD4

loc_8CFF:				; CODE XREF: 8C68	8CBE
					; 00008CEC
		bt	dword ptr h_fcw[ebp], 4
		jnc	short loc_8D19
		neg	eax
		add	eax, 0FFFFC002h
		cmp	eax, 42h
		jl	short loc_8D17
		mov	eax, 42h

loc_8D17:				; CODE XREF: 8D10
		jmp	short loc_8D36

loc_8D19:				; CODE XREF: 8D04
		bts	dword ptr h_fsw[ebp], 4
		add	eax, 6000h
		cmp	eax, 0FFFFC002h
		jge	short loc_8CEE
		fldz
		bts	dword ptr h_fsw[ebp], 5
		jmp	loc_8DD4

loc_8D36:				; CODE XREF: 8D17
		lea	esi, [ebp-90h]
		fld1
		fstp	tbyte ptr [esi]
		sub	[esi+8], ax
		mov	word ptr [edi+8], 0
		fld	tbyte ptr [esi]
		fld	tbyte ptr [edi]
		test	byte ptr [ebp-85h], 1
		jz	short loc_8D59
		fchs

loc_8D59:	@CALL	loc_8E0B	; CODE XREF: 8D55
		fmulp	st(1), st
		mov	ebx, 230h
		@CALL	loc_8E22
		jmp	short loc_8DDF

loc_8D76:				; CODE XREF: 8CC2	8CE1
		bts	dword ptr h_fsw[ebp], 3
		bt	dword ptr h_fcw[ebp], 3
		jnc	short loc_8DB2
		@CALL	loc_8E0B
		fld	tbyte ptr ds:loc_8A1A[ecx]	; biggest +Normal
		fld	st
		test	byte ptr [ebp-85h], 1
		jz	short loc_8D9F
		fchs

loc_8D9F:				; CODE XREF: 8D9B
		fmulp	st(1), st
		mov	ebx, 220h
		@CALL	loc_8E22
		jmp	short loc_8DDF

loc_8DB2:				; CODE XREF: 8D80
		sub	eax, 6000h
		cmp	eax, 3FFFh
		jle	loc_8CEE
		fld	tbyte ptr ds:loc_8A10[ecx]	; +INF
		bts	dword ptr h_fsw[ebp], 9
		bts	dword ptr h_fsw[ebp], 5
		jmp	short loc_8DD4

loc_8DD4:				; CODE XREF: 8C03	8CFA
					; 00008D31
		test	byte ptr [ebp-85h], 1
		jz	short loc_8DDF
		fchs

loc_8DDF:				; CODE XREF: 8B36	8BD0
					; 00008D74 00008DB0	8DDB
		fstp	tbyte ptr h_fr0[ebp]
		jmp	loc_8F44

loc_8DE7:				; CODE XREF: 8C5C	8C7C
		fld	tbyte ptr h_ftemp[ebp]
		xor	edx, edx
		@CALL	loc_8E99
		mov	[ebp-90h], edx
		fldz
		faddp	st(1), st
		fabs
		fstp	tbyte ptr h_ftemp[ebp]
		@RET

loc_8E0B:				; CODE XREF: 8D5E	8D87
		mov	ax, h_fcw[ebp]
		and	ax, 0C00h
		or	ax, 33Fh
		push	eax
		fldcw	word ptr [esp]
		pop	eax
		@RET

loc_8E22:				; CODE XREF: 8D6F	8DAB
		fstsw	word ptr [esp-4]
		mov	ax, [esp-4]
		and	eax, ebx
		not	ebx
		and	h_fsw[ebp], bx
		or	h_fsw[ebp], ax
		@RET

		ALIGN0	16

hypseg		ends
		end

;-------------------------------------------------------------- end FSCALE.ASM