;-----------------------------------------------------------------------------
; NexGen Nx586 BIOS Hypercode
;-----------------------------------------------------------------------------
; File: FSINCOS.ASM - 
; Date: 2020-09-26
;
; Disassembled by Dipl.-Inf. Herbert Oppmann (herby@memotech.franken.de)
;-----------------------------------------------------------------------------
; Only used for VL

		include COMMON.INC

	extrn	loc_8E80:near
	extrn	loc_8F23:near
	extrn	loc_8F44:near
	extrn	loc_8F53:near
	extrn	loc_8FB3:near
	extrn	loc_8FD3:near
	extrn	loc_902B:near
	extrn	loc_9097:near
	extrn	loc_90C1:near
	extrn	loc_90ED:near

	public	DecFSINCOS
	public	DecFCOS
	public	DecFSIN

		db '@(#)fsincos.asm',TAB,'3.2',0
		ALIGN0	32

		; Factors for the Taylor series for sinus
MFaculty15:	dt 0BFD6D552CB8148B8A016h	; -7.57877e-013 ~ -1/(15!)
		ALIGN 16

PFaculty13:	dt 3FDEB09049AF2D7CCA61h	; 1.60584e-010 ~ 1/(13!)
		ALIGN 16

MFaculty11:	dt 0BFE5D732294CAF07340Ch	; -2.50521e-008 ~ -1/(11!)
		ALIGN 16

PFaculty9:	dt 3FECB8EF1D299D2C0F72h	; 2.75573e-006 ~ 1/(9!)
		ALIGN 16

MFaculty7:	dt 0BFF2D00D00D00C577E49h	; -0.000198413 ~ -1/(7!)
		ALIGN 16

PFaculty5:	dt 3FF8888888888888582Fh	; 0.00833333 ~ 1/(5!)
		ALIGN 16

MFaculty3:	dt 0BFFCAAAAAAAAAAAAAA98h	; -0.166667 ~ -1/(3!)
		ALIGN 16

		; Factors for the Taylor series for cosinus
PFaculty16:	dt 3FD2D5619ACB5506BB55h	; 4.73802e-014 ~ 1/(16!)
		ALIGN 16

MFaculty14:	dt 0BFDAC9C99969F7E18F28h	; -1.14703e-011 ~ -1/(14!)
		ALIGN 16

PFaculty12:	dt 3FE28F76C64F758C54DEh	; 2.08768e-009 ~ 1/(12!)
		ALIGN 16

MFaculty10:	dt 0BFE993F27DBAFCA48B06h	; -2.75573e-007 ~ -1/(10!)
		ALIGN 16

PFaculty8:	dt 3FEFD00D00D00C6D5FB7h	; 2.48016e-005 ~ 1/(8!)
		ALIGN 16

MFaculty6:	dt 0BFF5B60B60B60B607EF4h	; -0.00138889 ~ -1/(6!)
		ALIGN 16

PFaculty4:	dt 3FFAAAAAAAAAAAAAAA9Bh	; 0.0416667 ~ 1/(4!)


DecFSINCOS:	mov	byte ptr [ebp-86h], 4
		jmp	short loc_8F03

DecFCOS:	mov	byte ptr [ebp-86h], 1
		jmp	short loc_8F03

DecFSIN:	mov	byte ptr [ebp-86h], 0
loc_8F03:	@CALL	loc_8E80
		fnsave	byte ptr h_fenviron[ebp]
		sub	esp, 90h
		FNLDTW	h_ftw[ebp]
		FNLDSW	h_fsw[ebp]
		btr	dword ptr h_fsw[ebp], 10
		ffree	st(6)
		ffree	st(7)
		fxam	
		fstsw	word ptr [esp-4]
		mov	ax, [esp-4]
		sahf	
		jnz	short loc_8F45
		jnc	short loc_8F45

loc_8F36:	@CALL	loc_902B
		jmp	loc_921F

loc_8F45:	push	eax
		cmp	byte ptr [ebp-86h], 4
		jz	loc_9255
loc_8F53x:	pop	eax
		sahf	
		jbe	short loc_8FAC
		jnp	short loc_8F9D
loc_8F59:	mov	word ptr [ebp-92h], 0
		test	ah, 2
		jz	short loc_8F7B
		fabs	
		cmp	byte ptr [ebp-86h], 1
		jz	short loc_8F7B
		mov	word ptr [ebp-92h], 8000h
loc_8F7B:	fld	st
		fstp	tbyte ptr h_ftemp[ebp]
		cmp	word ptr h_ftemp[ebp+8], 403Eh
		jl	loc_900A
		bts	dword ptr h_fsw[ebp], 10
		mov	byte ptr [ebp-86h], 0
		jmp	loc_91FA

loc_8F9D:	@CALL	loc_8FB3
		jmp	loc_921F

loc_8FAC:	jc	short loc_8FD3x
		jp	short loc_8FF9
		fld1	
		cmp	byte ptr [ebp-86h], 0
		jz	loc_8F44
		cmp	byte ptr [ebp-86h], 1
		jz	short loc_8FCB
		fstp	tbyte ptr h_ftemp[ebp]
loc_8FCB:	fstp	tbyte ptr h_fr0[ebp]
		jmp	loc_91FA

loc_8FD3x:	jp	short loc_8FEA
		jz	loc_8F36
		@CALL	loc_8FD3
		jmp	loc_921F

loc_8FEA:	@CALL	loc_8FB3
		jmp	loc_921F

loc_8FF9:	push	eax
		@CALL	loc_9097
		pop	eax
		jmp	loc_8F59

loc_900A:	lea	esi, h_ftemp[ebp]
		mov	ecx, h_base[ebp]
		fninit	
		fld	tbyte ptr [esi]
		FNUNKNOWN1
		fstsw	word ptr [esp-4]
		mov	ax, [esp-4]
		fst	st(1)
		fstp	tbyte ptr [esi]
		and	word ptr [esi+8], 7FFFh
		mov	bx, ax
		and	bx, 4000h
		shr	bx, 4
		and	ax, 200h
		or	ax, bx
		shr	ax, 9
		add	al, [ebp-86h]
		and	ax, 3
		cmp	byte ptr [ebp-86h], 4
		jz	short loc_905F
		bt	ax, 0
		jc	loc_90FD
loc_905F:	btr	dword ptr h_fsw[ebp], 9
		bts	dword ptr h_fsw[ebp], 5
		cmp	word ptr [esi+8], 3FDFh
		jl	short loc_90EC
		fld	st
		fld	st
		fmul	st, st(1)
		fld	tbyte ptr ds:MFaculty15[ecx]
		fmul	st, st(1)
		fld	tbyte ptr ds:PFaculty13[ecx]
		faddp	st(1), st
		fmul	st, st(1)
		fld	tbyte ptr ds:MFaculty11[ecx]
		faddp	st(1), st
		fmul	st, st(1)
		fld	tbyte ptr ds:PFaculty9[ecx]
		faddp	st(1), st
		fmul	st, st(1)
		fld	tbyte ptr ds:MFaculty7[ecx]
		faddp	st(1), st
		fmul	st, st(1)
		fld	tbyte ptr ds:PFaculty5[ecx]
		faddp	st(1), st
		fmul	st, st(1)
		fld	tbyte ptr ds:MFaculty3[ecx]
		faddp	st(1), st
		fmul	st, st(1)
		fmul	st, st(2)
		fstp	st(1)
		fstp	st(1)
		fadd	st, st(1)
		fxch	st(1)
loc_90C5:	cmp	byte ptr [ebp-86h], 4
		jz	short loc_90FD
		shl	ax, 14
		and	ax, 8000h
		xor	ax, [ebp-92h]
		fstp	st
		fstp	tbyte ptr h_fr0[ebp]
		wait	
		xor	h_fr0[ebp+8], ax
		jmp	loc_91FA

loc_90EC:	fld	st
		wait	
		push	eax
		@CALL	loc_9232
		pop	eax
		jmp	short loc_90C5

loc_90FD:	btr	dword ptr h_fsw[ebp], 9
		bts	dword ptr h_fsw[ebp], 5
		cmp	word ptr [esi+8], 3FDFh
		jl	loc_9191
		fld	st
		fmul	st, st(1)
		fstp	st(1)
		fld	tbyte ptr ds:PFaculty16[ecx]
		fmul	st, st(1)
		fld	tbyte ptr ds:MFaculty14[ecx]
		faddp	st(1), st
		fmul	st, st(1)
		fld	tbyte ptr ds:PFaculty12[ecx]
		faddp	st(1), st
		fmul	st, st(1)
		fld	tbyte ptr ds:MFaculty10[ecx]
		faddp	st(1), st
		fmul	st, st(1)
		fld	tbyte ptr ds:PFaculty8[ecx]
		faddp	st(1), st
		fmul	st, st(1)
		fld	tbyte ptr ds:MFaculty6[ecx]
		faddp	st(1), st
		fmul	st, st(1)
		fld	tbyte ptr ds:PFaculty4[ecx]
		faddp	st(1), st
		fmul	st, st(1)
		fmul	st, st(1)
		fxch	st(1)
		fstp	tbyte ptr [esi]
		dec	word ptr [esi+8]	; = 1/(2!)
		fld	tbyte ptr [esi]
		fsubrp	st(1), st
		fld1	
		fsubrp	st(1), st
loc_916F:	cmp	byte ptr [ebp-86h], 4
		jz	short loc_9197
		shl	ax, 14
		and	ax, 8000h
		xor	ax, [ebp-92h]
		fstp	tbyte ptr h_fr0[ebp]
		wait	
		xor	h_fr0[ebp+8], ax
		jmp	short loc_91FA

loc_9191:	fstp	st
		fld1	
		jmp	short loc_916F

loc_9197:	bt	ax, 0
		jc	short loc_91CC
		mov	bx, ax
		shl	ax, 14
		and	ax, 8000h
		inc	bx
		shl	bx, 14
		and	bx, 8000h
		fstp	tbyte ptr h_ftemp[ebp]
		fstp	tbyte ptr h_fr0[ebp]
		wait
		xor	ax, [ebp-92h]
		xor	h_fr0[ebp+8], ax
		xor	h_ftemp[ebp+8], bx
		jmp	short loc_91FA

loc_91CC:	mov	bx, ax
		shl	ax, 14
		and	ax, 8000h
		xor	ax, [ebp-92h]
		inc	bx
		shl	bx, 14
		and	bx, 8000h
		fstp	tbyte ptr h_fr0[ebp]
		fstp	tbyte ptr h_ftemp[ebp]
		wait	
		xor	h_fr0[ebp+8], ax
		xor	h_ftemp[ebp+8], bx
		jmp	short loc_91FA		; unnecessary

loc_91FA:	cmp	byte ptr [ebp-86h], 4
		jz	short loc_9208
		jmp	loc_8F44

loc_9208:	@CALL	loc_8F23
		fnrstor	byte ptr h_fenviron[ebp]
		ffree	st(7)
		fld	tbyte ptr h_ftemp[ebp]
		jmp	loc_8F53

loc_921F:	fld	st
		fstp	tbyte ptr h_fr0[ebp]
		cmp	byte ptr [ebp-86h], 4
		jnz	short loc_9230
		fstp	tbyte ptr h_ftemp[ebp]
loc_9230:	jmp	short loc_91FA

loc_9232:	fxch	st(1)
		fxam	
		fstsw	word ptr [esp-4]
		mov	ax, [esp-4]
		sahf	
		jnz	short loc_924D
		@CALL	loc_90C1
loc_924D:	fxch	st(1)
		@RET

loc_9255:	@CALL	loc_90ED
		cmp	cl, 1
		jz	short loc_921F
		jmp	loc_8F53x

		ALIGN0	16

hypseg		ends
		end

;------------------------------------------------------------- end FSINCOS.ASM