;-----------------------------------------------------------------------------
; NexGen Nx586 BIOS Hypercode
;-----------------------------------------------------------------------------
; File: FST.ASM - 
; Date: 2020-09-27
;
; Disassembled by Dipl.-Inf. Herbert Oppmann (herby@memotech.franken.de)
;-----------------------------------------------------------------------------

		include COMMON.INC

	extrn	loc_5320:near
	extrn	loc_79E4:near
	extrn	loc_8ED1:near

	public	loc_80B0

 IF V033S OR V033V
		db '@(#)fst.asm',TAB,'3.5',0
 ELSE
		db '@(#)fst.asm',TAB,'3.6',0
 ENDIF
		ALIGN0	32

loc_80B0:				; CODE XREF: 76FC
		mov	eax, cr0
		mov	[ebp-4], eax
		or	eax, 1
		mov	cr0, eax
		pushf
		btr	dword ptr [esp], 17
		popf
		fnsave	byte ptr h_fenviron[ebp]
		fnclex
		mov	eax, h_fsw[ebp]
		shr	eax, 11		; TOP = Top of Stack Pointer
		and	eax, 7
		shl	eax, 1
		mov	cl, al
		mov	ebx, h_ftw[ebp]
		shr	ebx, cl
		and	ebx, 3		; now TAG of TOP in EBX
		cmp	ebx, 3		; empty?
		jz	short loc_8134
		cmp	ebx, 0		; valid?
		jz	loc_8168
		cmp	ebx, 1		; zero?
		jz	short loc_815A
		; Tag = invalid (NaN, unsupported), infinity, or denormal
		mov	ecx, h_fr0[ebp+8]	; read biased exponent
		; this actually also reads the first two bytes of h_fr1, but they are masked out
		and	ecx, 7FFFh	; remove sign
		mov	[ebp-74h], ecx
		cmp	ecx, 7FFFh	; infinity or NaN?
		jz	short loc_810B
		cmp	ecx, 0		; denormal
		jz	short loc_817D
		; zero or normal - do we really come here?
		jmp	short loc_8147

loc_810B:	; infinity or NaN
		mov	edx, h_fr0[ebp+4]	; high DWORD of significand
		cmp	edx, 80000000h		; maybe infinity?
		jz	short loc_8118
		jmp	short loc_8122

loc_8118:	; maybe infinity
		mov	edx, h_fr0[ebp]		; low DWORD of significand
		cmp	edx, 0			; really infinity?
		jz	short loc_815A
		jmp	short loc_8147

loc_8122:	; NaN (SNaN or QNaN)
		test	edx, 80000000h		; integer-bit
		jz	short loc_8147	
		test	edx, 40000000h		; most significant bit of fraction
		jnz	short loc_815A		; QNaN
		jmp	short loc_8147		; SNaN

loc_8134:	; Tag = empty
		or	dword ptr h_fsw[ebp], 0C1h
		and	dword ptr h_fsw[ebp], 0FFFFFDFFh
		jmp	loc_8582

loc_8147:	; SNaN
		and	dword ptr h_fsw[ebp], 0FFFFFDFFh

loc_814E:	or	dword ptr h_fsw[ebp], 81h
		jmp	loc_8582

loc_815A:	; Tag = zero
		; QNaN and infinity
		cmp	byte ptr [ebp-94h], 4
		jge	short loc_8147
		jmp	loc_8582

loc_8168:	; Tag = valid
		cmp	byte ptr [ebp-94h], 4
		jge	short loc_814E
		mov	ecx, h_fr0[ebp+8]	; read biased exponent
		and	ecx, 7FFFh		; remove sign
		mov	[ebp-74h], ecx

loc_817D:	; denormal
		mov	eax, h_fcw[ebp]
		and	eax, 10h		; UM
		mov	[ebp-8Ch], eax
		test	byte ptr [ebp-94h], 1
		jnz	short loc_8197
		jmp	loc_8249

loc_8197:	; 
		sub	dword ptr [ebp-74h], 3F80h
 IF V033S OR V033V
		cmp	dword ptr [ebp-74h], 0FFh
 ELSE
		mov	eax, [ebp-74h]
		cmp	dword ptr [ebp-74h], 0FEh
 ENDIF
		jge	short loc_81D3
 IF V033S OR V033V
		cmp	dword ptr [ebp-74h], 1FFE9h
 ELSE
		cmp	dword ptr [ebp-74h], 0FFFFFFE9h
 ENDIF
		jle	short loc_81C1
		cmp	dword ptr [ebp-74h], 0
		jz	short loc_81E3
 IF V033S OR V033V
		cmp	dword ptr [ebp-74h], 1FFEAh
 ELSE
		cmp	dword ptr [ebp-74h], 0FFFFFFE8h
 ENDIF
		jge	short loc_8225
		jmp	loc_8582

loc_81C1:	cmp	dword ptr [ebp-8Ch], 10h	; = UM bit from h_fcw
		jnz	loc_82BE
		jmp	loc_8582

loc_81D3:	mov	eax, h_fcw[ebp]
		test	al, 8		; ZM
		jz	loc_8373
		jmp	loc_8582

loc_81E3:	@CALL	loc_84D7
		@CALL	loc_8383
		cmp	edx, 20h
		jnz	loc_82B3
		cmp	ecx, 200h
		jnz	loc_82F9
		mov	eax, h_fr0[ebp+4]	; high DWORD of significand
		and	eax, [ebp-84h]
		cmp	eax, 7FFFFF00h
		jz	loc_82D7
		jmp	loc_82F9

loc_8225:	@CALL	loc_8383
		cmp	edx, 20h
		jnz	loc_8351
		cmp	ecx, 200h
		jz	loc_8338
		jmp	loc_8312

loc_8249:
		sub	dword ptr [ebp-74h], 3C00h
 IF V033S OR V033V
		cmp	dword ptr [ebp-74h], 7FFh
 ELSE
		cmp	dword ptr [ebp-74h], 7FEh
 ENDIF
		jge	loc_81D3
 IF V033S OR V033V
		cmp	dword ptr [ebp-74h], 01FFCCh
 ELSE
		cmp	dword ptr [ebp-74h], 0FFFFFFCCh
 ENDIF
		jle	loc_81C1
		cmp	dword ptr [ebp-74h], 0
		jz	short loc_8278
 IF V033S OR V033V
		cmp	dword ptr [ebp-74h], 01FFCDh
 ELSE
		cmp	dword ptr [ebp-74h], 0FFFFFFCBh
 ENDIF
		jge	short loc_8225
		jmp	loc_8582

loc_8278:	@CALL	loc_84D7
		@CALL	loc_8383
		cmp	edx, 20h
		jnz	short loc_82B3
		cmp	ecx, 200h
		jnz	short loc_82F9
		mov	eax, h_fr0[ebp+4]
		cmp	eax, 0FFFFFFFFh
		jnz	short loc_82F9
		mov	eax, h_fr0[ebp]
		and	eax, [ebp-84h]
		cmp	eax, 0FFFFF000h
		jz	short loc_82D7
		jmp	short loc_82F9

loc_82B3:	cmp	dword ptr [ebp-8Ch], 10h
		jz	short loc_82CE
		DELAYJMP

loc_82BE:	or	dword ptr h_fsw[ebp], 10h
		and	dword ptr h_fsw[ebp], 0FFFFFDDFh
		jmp	loc_8582

loc_82CE:	or	dword ptr h_fsw[ebp], 10h
		jmp	loc_8582

loc_82D7:	or	dword ptr h_fsw[ebp], 220h
		cmp	dword ptr [ebp-8Ch], 10h
		jnz	short loc_82F0
		or	dword ptr h_fsw[ebp], 10h
		jmp	loc_8582

loc_82F0:	and	dword ptr h_fsw[ebp], 0FFFFFFEFh
		jmp	loc_8582

loc_82F9:	or	dword ptr h_fsw[ebp], 10h
		cmp	dword ptr [ebp-8Ch], 10h
		jz	short loc_830D
		and	dword ptr h_fsw[ebp], 0FFFFFDFFh

loc_830D:	jmp	loc_8582

loc_8312:	or	dword ptr h_fsw[ebp], 10h
		and	dword ptr h_fsw[ebp], 0FFFFFDFFh
		cmp	dword ptr [ebp-8Ch], 10h
		jnz	short loc_832F
		or	dword ptr h_fsw[ebp], 20h
		jmp	loc_8582

loc_832F:	and	dword ptr h_fsw[ebp], 0FFFFFFDFh
		jmp	loc_8582

loc_8338:	cmp	dword ptr [ebp-8Ch], 10h
		jnz	loc_82BE
		or	dword ptr h_fsw[ebp], 230h
		jmp	loc_8582

loc_8351:	and	dword ptr h_fsw[ebp], 0FFFFFDFFh
		cmp	dword ptr [ebp-8Ch], 10h
		jz	short loc_836A
		or	dword ptr h_fsw[ebp], 10h
		jmp	loc_8582

loc_836A:	and	dword ptr h_fsw[ebp], 0FFFFFFEFh
		jmp	loc_8582

loc_8373:	or	dword ptr h_fsw[ebp], 8
		and	dword ptr h_fsw[ebp], 0FFFFFDFFh
		jmp	loc_8582

loc_8383:	mov	edx, [ebp-78h]
		xor	edx, edx
		mov	[ebp-78h], edx
		test	byte ptr [ebp-94h], 1
		jnz	short loc_83B5
		mov	eax, h_fr0[ebp]
		and	eax, [ebp-7Ch]
		cmp	eax, 0
		jnz	short loc_83B0
		or	dword ptr [ebp-78h], 1
		mov	eax, h_fcw[ebp]
		test	al, 20h
		jz	short loc_83B0
		or	dword ptr h_fsw[ebp], 20h
		jmp	short loc_83B0

loc_83B0:	mov	ebx, h_fr0[ebp]
		jmp	short loc_83DE

loc_83B5:	mov	eax, h_fr0[ebp]
		cmp	eax, 0
		jz	short loc_83CE

loc_83BD:	or	dword ptr [ebp-78h], 1
		mov	eax, h_fcw[ebp]
		test	al, 20h
		jz	short loc_83DB
		or	dword ptr h_fsw[ebp], 20h
		jmp	short loc_83DB

loc_83CE:	mov	ebx, h_fr0[ebp+4]
		and	ebx, [ebp-7Ch]
		cmp	ebx, 0
		jnz	short loc_83BD
		DELAYJMP

loc_83DB:	mov	ebx, h_fr0[ebp+4]

loc_83DE:	and	ebx, [ebp-80h]
		mov	cl, [ebp-88h]
		shr	ebx, cl
		cmp	ebx, 1
		jz	short loc_840E
		cmp	ebx, 2
		jz	short loc_8414
		cmp	ebx, 3
		jz	short loc_841A
		cmp	ebx, 4
		jz	short loc_8420
		cmp	ebx, 5
		jz	short loc_8426
		cmp	ebx, 6
		jz	short loc_842C
		cmp	ebx, 7
		jz	short loc_8432
		jmp	short loc_8438

loc_840E:	or	dword ptr [ebp-78h], 2
		jmp	short loc_844A

loc_8414:	or	dword ptr [ebp-78h], 4
		jmp	short loc_844A

loc_841A:	or	dword ptr [ebp-78h], 6
		jmp	short loc_844A

loc_8420:	or	dword ptr [ebp-78h], 8
		jmp	short loc_845A

loc_8426:	or	dword ptr [ebp-78h], 0Ah
		jmp	short loc_844A

loc_842C:	or	dword ptr [ebp-78h], 0Ch
		jmp	short loc_844A

loc_8432:	or	dword ptr [ebp-78h], 0Eh
		jmp	short loc_844A

loc_8438:	and	dword ptr h_fsw[ebp], 0FFFFFDDFh
		mov	edx, 0
 IF V033S OR V033V
		ret		; this is a bug!
 ELSE
		@RET
 ENDIF

loc_844A:	mov	eax, h_fcw[ebp]
		test	al, 20h
		jz	short loc_845A
		or	dword ptr h_fsw[ebp], 20h
		mov	edx, 20h

loc_845A:	mov	eax, h_fcw[ebp]
		and	eax, 0C00h
		cmp	eax, 0
		jz	short loc_8477
		cmp	eax, 400h
		jz	short loc_8485
		cmp	eax, 800h
		jz	short loc_849C
		jmp	short loc_84C5

loc_8477:	mov	eax, [ebp-78h]
		test	al, 4
		jz	short loc_84C5
		cmp	eax, 4
		jg	short loc_84B3
		jmp	short loc_84C5

loc_8485:	mov	eax, [ebp-78h]
		and	eax, 7
		cmp	eax, 0
		jz	short loc_84C5
		mov	eax, h_fr0[ebp+8]
		test	eax, 10000h
		jz	short loc_84B3
		jmp	short loc_84C5

loc_849C:	mov	eax, [ebp-78h]
		and	eax, 7
		cmp	eax, 0
		jz	short loc_84C5
		mov	eax, h_fr0[ebp+8]
		test	eax, 10000h
		jz	short loc_84B3
		jmp	short loc_84C5

loc_84B3:	or	dword ptr h_fsw[ebp], 200h
		mov	ecx, 200h
 IF V033S OR V033V
		ret		; this is a bug!
 ELSE
		@RET
 ENDIF

loc_84C5:	and	dword ptr h_fsw[ebp], 0FFFFFDFFh
		mov	ecx, 0
		@RET

loc_84D7:	test	byte ptr [ebp-94h], 1
		jz	short loc_84F4
		mov	eax, 1
		add	eax, 29h
		mov	ebx, 28h
		mov	ecx, 7Fh
		jmp	short loc_8506

loc_84F4:	mov	eax, 1
		add	eax, 0Ch
		mov	ebx, 0Bh
		mov	ecx, 3FFh

loc_8506:	sub	eax, [ebp-74h]
		sub	eax, ebx
		mov	edx, eax

loc_850D:	shl	ecx, 1
		dec	eax
		jnz	short loc_850D
		mov	ebx, 1
		mov	eax, edx

loc_8519:	shl	ebx, 1
		dec	eax
		jnz	short loc_8519
		dec	ebx
		add	ecx, ebx
		mov	[ebp-7Ch], ecx
		test	byte ptr [ebp-94h], 1
		jz	short loc_8534
		mov	eax, 380h
		jmp	short loc_8539

loc_8534:	mov	eax, 1C00h

loc_8539:	shl	eax, 1
		dec	edx
		jnz	short loc_8539
		mov	[ebp-80h], eax
		test	byte ptr [ebp-94h], 1
		jz	short loc_8551
		mov	eax, 7
		jmp	short loc_8556

loc_8551:	mov	eax, 0Ah

loc_8556:	add	eax, edx
		mov	[ebp-88h], eax
		test	byte ptr [ebp-94h], 1
		jz	short loc_856E
		mov	eax, 0FFFFFE00h
		jmp	short loc_8573

loc_856E:	mov	eax, 0FFFFF000h

loc_8573:	dec	edx
		sub	eax, edx
		mov	[ebp-84h], eax
		@RET

loc_8582:	@CALL	loc_5320
		@CALL	loc_8ED1
		fnrstor	byte ptr h_fenviron[ebp]
		mov	eax, [ebp-4]
		mov	cr0, eax
		jmp	loc_79E4

		ALIGN0	16

hypseg		ends
		end

;----------------------------------------------------------------- end FST.ASM