;-----------------------------------------------------------------------------
; NexGen Nx586 BIOS Hypercode
;-----------------------------------------------------------------------------
; File: HDEB.ASM - hypercode debugger
; Date: 2020-09-27
;
; Disassembled by Dipl.-Inf. Herbert Oppmann (herby@memotech.franken.de)
;-----------------------------------------------------------------------------
; Only used for VL

		include COMMON.INC

	extrn	loc_5B93:near
	extrn	loc_2A20:near

	public	loc_6A20
	public	loc_6AA8
	public	InitUart
 IF V033S OR V033V
	public	loc_708A
	public	loc_6B9A
 ENDIF
 IF V033S
	extrn	NxWriteOPCL:near
 ENDIF


 IF V033S
		db '@(#)hdeb.asm',9,'2.11',0
 ELSE
		db '@(#)hdeb    ',0
 ENDIF
		ALIGN0	32

loc_6A20:	mov	[ebp+21Ch], esp
		mov	eax, h_eip2[ebp]
		mov	h_eip3[ebp], eax
		mov	eax, h_efl[ebp]
		bts	eax, 10h	; RF = Resume Flag
		mov	h_efl[ebp], eax
		pushf	
		pop	eax
		btr	eax, 17	; VM = Virtual 8086 Mode
		bts	eax, 12	; IOPL = I/O Privilege Level
		bts	eax, 13
		push	eax
		popf	
		@CALL	loc_6AA8
		jmp	loc_5B93

		mov	eax, [esp+4]
		shr	eax, 16
		and	al, 0Fh
		cmp	al, 6
		jz	short loc_6A7A
		cmp	al, 1
		jz	short loc_6A7A
		add	esp, 4
		jmp	loc_2A20	; exception handler

loc_6A7A:	mov	[ebp+21Ch], esp
		@CALL	RestoreDBState
		@CALL	loc_6ADB
		@CALL	loc_701B
		add	esp, 8
		pop	eax
		popf	
		add	esp, 4
		jmp	eax

; Subroutine
loc_6AA8:	mov	[ebp+21Ch], esp
		mov	eax, cr0
		mov	[ebp+220h], eax
		or	al, 1
		and	al, 0FBh
		and	al, 0F7h
		btr	eax, 1Fh
		mov	cr0, eax
		@CALL	SaveDBState
		xor	eax, eax
		WRB	gs, eax
		mov	eax, 928FFFFFh
		WRAR	gs, eax

; Subroutine
loc_6ADB:	@CALL	loc_70C3
loc_6AE5:	@CALL	ReceiveByte	; Receive one byte command
		@CALL	loc_6B0E
		cmp	bl, 1		; stop execution?
		jnz	short loc_6AE5	; no -> get next command
		@CALL	loc_6EC4
		@RET

; Do one command
loc_6B0E:	cmp	bl, 0F0h	; Receive Debug State
		jz	short loc_6B47
		cmp	bl, 0F2h	; Transmit Bytes from segment GS
		jz	short loc_6B5E
		cmp	bl, 0F3h	; Receive Bytes to segment GS
		jz	short loc_6B96
		cmp	bl, 0F4h	; IN
		jz	loc_6C3C
		cmp	bl, 0F5h	; OUT
		jz	loc_6C92
		cmp	bl, 0F6h	; Transmit Bytes
		jz	loc_6BCE
		cmp	bl, 0F7h	; Receive Bytes
		jz	loc_6C05
		@RET

loc_6B47:	@CALL	ReceiveDBState
 IF V033V OR V033W
		btr	h_dbflag[ebp], 17
 ENDIF
		mov	bl, 1		; stop
		@RET

; Transmit Bytes from segment GS
loc_6B5E:	@CALL	loc_7119	; Receive ebp+210h: Count
		@CALL	loc_70FE	; Receive ebp+214h: Address
		mov	ecx, [ebp+210h]
		mov	ebx, [ebp+214h]
loc_6B7E:	mov	al, gs:[ebx]
		@CALL	TransmitByte
		inc	ebx
		loop	loc_6B7E
		mov	bl, 0		; continue
		@RET

; Receive Bytes to segment GS
loc_6B96:	@CALL	loc_7119	; Receive ebp+210h: Count
		@CALL	loc_70FE	; Receive ebp+214h: Address
		mov	ecx, [ebp+210h]
		mov	edx, [ebp+214h]
loc_6BB6:	@CALL	ReceiveByte
		mov	gs:[edx], bl
		inc	edx
		loop	loc_6BB6
		mov	bl, 0
		@RET

; Transmit Bytes
loc_6BCE:	@CALL	loc_7119	; Receive ebp+210h: Count
		@CALL	loc_70FE	; Receive ebp+214h: Address
		mov	ecx, [ebp+210h]
		mov	ebx, [ebp+214h]
loc_6BEE:	mov	al, [ebx]
		@CALL	TransmitByte
		inc	ebx
		loop	loc_6BEE
		mov	bl, 0
		@RET

; Receive Bytes
loc_6C05:	@CALL	loc_7119	; Receive ebp+210h: Count
		@CALL	loc_70FE	; Receive ebp+214h: Address
		mov	ecx, [ebp+210h]
		mov	edx, [ebp+214h]
loc_6C25:	@CALL	ReceiveByte
		mov	[edx], bl
		inc	edx
		loop	loc_6C25
		mov	bl, 0
		@RET

; IN
loc_6C3C:	@CALL	loc_7119	; Receive ebp+210h: Size 1=byte, 2=word, other=dword
		@CALL	loc_70FE	; Receive ebp+214h: Address
		mov	edx, [ebp+214h]
		mov	ebx, [ebp+210h]
		xor	eax, eax
		cmp	bl, 1
		jz	short loc_6C6F
		cmp	bl, 2
		jz	short loc_6C6B
		in	eax, dx
		jmp	short loc_6C70

loc_6C6B:	in	ax, dx
		jmp	short loc_6C70

loc_6C6F:	in	al, dx
loc_6C70:	mov	[ebp+218h], eax
		mov	dword ptr [ebp+210h], 4
		@CALL	loc_71E4
		mov	bl, 0
		@RET

; OUT
loc_6C92:	@CALL	loc_7119	; Receive ebp+210h:  Size 1=byte, 2=word, other=dword
		@CALL	loc_70FE	; Receive ebp+214h: Address
		mov	ebx, [ebp+210h]
 IF V033V OR V033W
		push	ebx
 ENDIF
		mov	dword ptr [ebp+210h], 4
		@CALL	loc_7134
		mov	edx, [ebp+214h]
		mov	eax, [ebp+218h]
 IF V033V OR V033W
		pop	ebx
 ENDIF
		cmp	bl, 1
		jz	short loc_6CDF
		cmp	bl, 2
		jz	short loc_6CDB
		out	dx, eax
		jmp	short loc_6CE0

loc_6CDB:	out	dx, ax
 IF V033V OR V033W
		jmp	short loc_6CE0
 ENDIF
loc_6CDF:	out	dx, al
loc_6CE0:	mov	bl, 0
		@RET

SaveDBState:	cld	
		lea	edi, h_dbstate[ebp]
		mov	eax, [ebp+220h]
		stosd
		mov	eax, h_efl[ebp]
		btr	eax, 1Fh
		stosd
		mov	eax, h_eip3[ebp]
		stosd
		mov	eax, h_edi[ebp]
		stosd
		mov	eax, h_esi[ebp]
		stosd
		mov	eax, h_ebp[ebp]
		stosd
		mov	eax, h_esp[ebp]
		stosd
		mov	eax, h_ebx[ebp]
		stosd
		mov	eax, h_edx[ebp]
		stosd
		mov	eax, h_ecx[ebp]
		stosd
		mov	eax, h_eax[ebp]
		stosd
		mov	eax, dr6
loc_6D43:	stosd
		mov	eax, dr7
		stosd
		str	ax
		stosd
		sldt	ax
		stosd
		mov	eax, gs
		stosd
		mov	eax, fs
		stosd
		mov	eax, ds
		stosd
		mov	eax, ss
		stosd
		mov	eax, cs
		stosd
		mov	eax, es
		stosd
		RDAR	eax, tr
		and	eax, 0FFF00000h
		stosd
		RDB	eax, tr
		stosd
		RDAR	eax, tr
		and	eax, 0FFFFFh
		stosd
		RDAR	eax, idtr
		and	eax, 0FFF00000h
		stosd
		RDB	eax, idtr
		stosd
		RDAR	eax, idtr
		and	eax, 0FFFFFh
		stosd
		RDAR	eax, gdtr
		and	eax, 0FFF00000h
		stosd
		RDB	eax, gdtr
		stosd
		RDAR	eax, gdtr
		and	eax, 0FFFFFh
		stosd
		RDAR	eax, ldtr
		and	eax, 0FFF00000h
		stosd
		RDB	eax, ldtr
		stosd
		RDAR	eax, ldtr
		and	eax, 0FFFFFh
		stosd
		RDAR	eax, gs
		and	eax, 0FFF00000h
		stosd
		RDB	eax, gs
		stosd
		RDAR	eax, gs
		and	eax, 0FFFFFh
		stosd
		RDAR	eax, fs
		and	eax, 0FFF00000h
		stosd
		RDB	eax, fs
		stosd
		RDAR	eax, fs
		and	eax, 0FFFFFh
		stosd
		RDAR	eax, ds
		and	eax, 0FFF00000h
		stosd
		RDB	eax, ds
		stosd
		RDAR	eax, ds
		and	eax, 0FFFFFh
		stosd
		RDAR	eax, ss
		and	eax, 0FFF00000h
		stosd
		RDB	eax, ss
		stosd
		RDAR	eax, ss
		and	eax, 0FFFFFh
		stosd
		RDAR	eax, cs
		and	eax, 0FFF00000h
		stosd
		RDB	eax, cs
		stosd
		RDAR	eax, cs
		and	eax, 0FFFFFh
		stosd
		RDAR	eax, es
		and	eax, 0FFF00000h
		stosd
		RDB	eax, es
		stosd
		RDAR	eax, es
		and	eax, 0FFFFFh
		stosd
		mov	eax, cr2
		stosd
		mov	eax, cr3
		stosd
		mov	eax, tr6
		stosd
		mov	eax, tr7
		stosd
		mov	eax, dr0
		stosd
		mov	eax, dr1
		stosd
		mov	eax, dr2
		stosd
		mov	eax, dr3
		stosd
		mov	eax, h_cfg0[ebp]
		stosd
		mov	eax, h_cfg1[ebp]
		stosd
		mov	eax, h_fcfg[ebp]
		stosd
		mov	eax, h_opcmsk0[ebp]
		stosd
		mov	eax, h_opcmsk1[ebp]
		stosd
		add	edi, 4
		fnstcw	word ptr [edi]
		add	edi, 2
		fnstsw	word ptr [edi]
		add	edi, 2
		@RET

; Subroutine
RestoreDBState:	push	edi
		cld	
		lea	edi, h_dbstate[ebp]
		mov	eax, cr0
		stosd
		mov	eax, [esp+14h]
		bts	eax, 1Eh
		btr	eax, 1Fh
		stosd
		mov	eax, [esp+10h]
		stosd
		mov	eax, [esp]
		stosd
		mov	eax, esi
		stosd
		mov	eax, ebp
		stosd
		mov	eax, esp
		stosd
		mov	eax, ebx
		stosd
		mov	eax, edx
		stosd
		mov	eax, ecx
		stosd
		mov	eax, [esp+8]
		stosd
		pop	eax
		jmp	loc_6D43

loc_6EC4:	cld	
		lea	esi, h_dbstate[ebp]
		lodsd
		push	eax
		lodsd
		mov	h_efl[ebp], eax
		lodsd
		mov	h_eip3[ebp], eax
		lodsd
		mov	h_edi[ebp], eax
		lodsd
		mov	h_esi[ebp], eax
		lodsd
		mov	h_ebp[ebp], eax
		lodsd
		mov	h_esp[ebp], eax
		lodsd
		mov	h_ebx[ebp], eax
		lodsd
		mov	h_edx[ebp], eax
		lodsd
		mov	h_ecx[ebp], eax
		lodsd
		mov	h_eax[ebp], eax
loc_6F13:	lodsd
		mov	dr6, eax
		lodsd
		mov	dr7, eax
		lodsd
		WRSEL	tr, eax
		lodsd
		WRSEL	ldtr, eax
		lodsd
		WRSEL	gs, eax
		lodsd
		WRSEL	fs, eax
		lodsd
		WRSEL	ds, eax
		lodsd
		WRSEL	ss, eax
		lodsd
		WRSEL	cs, eax
		lodsd
		WRSEL	es, eax
		lodsd
		mov	ebx, eax
		lodsd
		WRB	tr, eax
		lodsd
		or	eax, ebx
		WRAR	tr, eax
		lodsd
		mov	ebx, eax
		lodsd
		WRB	idtr, eax
		lodsd
		or	eax, ebx
		WRAR	idtr, eax
		lodsd
		mov	ebx, eax
		lodsd
		WRB	gdtr, eax
		lodsd
		or	eax, ebx
		WRAR	gdtr, eax
		lodsd
		mov	ebx, eax
		lodsd
		WRB	ldtr, eax
		lodsd
		or	eax, ebx
		WRAR	ldtr, eax
		lodsd
		mov	ebx, eax
		lodsd
		WRB	gs, eax
		lodsd
		or	eax, ebx
		WRAR	gs, eax
		lodsd
		mov	ebx, eax
		lodsd
		WRB	fs, eax
		lodsd
		or	eax, ebx
		WRAR	fs, eax
		lodsd
		mov	ebx, eax
		lodsd
		WRB	ds, eax
		lodsd
		or	eax, ebx
		WRAR	ds, eax
		lodsd
		mov	ebx, eax
		lodsd
		WRB	ss, eax
		lodsd
		or	eax, ebx
		WRAR	ss, eax
		lodsd
		mov	ebx, eax
		lodsd
		WRB	cs, eax
		lodsd
		or	eax, ebx
		WRAR	cs, eax
		lodsd
		mov	ebx, eax
		lodsd
		WRB	es, eax
		lodsd
		or	eax, ebx
		WRAR	es, eax
		lodsd
		mov	cr2, eax
		lodsd
		mov	ebx, cr3
		cmp	eax, ebx
		jz	short loc_6FCC
		mov	cr3, eax
loc_6FCC:	lodsd
		mov	tr6, eax
		lodsd
		mov	tr7, eax
		lodsd
		mov	dr0, eax
		lodsd
		mov	dr1, eax
		lodsd
		mov	dr2, eax
		lodsd
		mov	dr3, eax
		lodsd
		WRCFG0	eax
		mov	h_cfg0[ebp], eax
		lodsd
		WRCFG1	eax
		mov	h_cfg1[ebp], eax
		FWRCFG	[esi]
		lodsd
		mov	h_fcfg[ebp], eax
		lodsd
		mov	h_opcmsk0[ebp], eax
		push	eax
		lodsd
		mov	h_opcmsk1[ebp], eax
		push	eax
		pop	ebx
		pop	eax
 IF V033S
		@CALL	NxWriteOPCL
 ENDIF
		add	esi, 4
		fldcw	word ptr [esi]
		add	esi, 2
		FNLDSW	[esi]
		add	esi, 2
		pop	eax
		mov	cr0, eax
		@RET

; Subroutine
loc_701B:	push	esi
		cld	
		lea	esi, h_dbstate[ebp]
		lodsd
		mov	cr0, eax
		lodsd
		btr	eax, 1Eh
		bts	eax, 1Fh
		mov	[esp+14h], eax
		lodsd
		mov	[esp+10h], eax
		lodsd
		mov	eax, [esp]
		lodsd
		lodsd
		mov	ebp, eax
		lodsd
		lodsd
		mov	ebx, eax
		lodsd
		mov	edx, eax
		lodsd
		mov	ecx, eax
		lodsd
		mov	[esp+8], eax
		pop	eax
		jmp	loc_6F13

; Subroutine
; Initialize UART to 9600 bps, 8E1 and drain receiver
InitUart:	push	edx
		mov	edx, h_uart[ebp]
		mov	dl, 0FBh	; Line Control Register
		mov	al, 80h		; set Divisor Latch Access Bit
		out	dx, al
		mov	dl, 0F8h	; Divisor Latch Low Byte
		mov	al, 0Ch		; 115200 Hz / 12 = 9600 bit per second
		out	dx, al
		inc	edx		; Divisor Latch High Byte
		mov	al, 0
		out	dx, al
		mov	dl, 0FBh	; Line Control Register
		mov	al, 00001011b
		;	          ^^--	word length = 8 bits
		;	         ^----	stop bits = 1 bit
		;	      ^^^-----	parity = odd
		;	     ^--------	break enable = no
		;	    ^---------	divisor latch access = off
		out	dx, al
		mov	dl, 0F9h	; Interrupt Enable Register
		mov	al, 0
		out	dx, al		; all off
		mov	dl, 0FCh	; Modem Control Register
		mov	al, 0
		out	dx, al		; all off
loc_7077:	; drain receiver
		mov	dl, 0FDh	; Line Status Register
		in	al, dx
		test	al, 1		; Data Ready?
		jz	short loc_7083
		mov	dl, 0F8h	; Receiver Buffer
		in	al, dx
		jmp	short loc_7077

loc_7083:	pop	edx
		@RET

; Subroutine
loc_708A:	push	edx
		mov	edx, h_uart[ebp]
		@CALL	InitUart
		mov	dl, 0FCh
		in	al, dx
		or	al, 1
		out	dx, al
loc_709E:	mov	dl, 0FEh
		in	al, dx
		test	al, 20h
		jz	short loc_709E
		mov	dl, 0FCh
		in	al, dx
		and	al, 0FEh
		out	dx, al
loc_70AB:	mov	dl, 0FDh
		in	al, dx
		test	al, 10h
		jnz	short loc_70AB
		@CALL	TransmitDBState
		pop	edx
		@RET

loc_70C3:	mov	al, 0E0h
		@CALL	TransmitByte
		@CALL	TransmitDBState
		@RET

; Subroutine
; Receive debug state
; R:-
ReceiveDBState:	push	ecx
		push	edx
		lea	edx, h_dbstate[ebp]
		mov	ecx, 158h
		@CALL	ReceiveBlock
		pop	edx
		pop	ecx
		@RET

; Subroutine
; Receive 4 byte into ebp+210h
loc_70FE:	lea	edx, [ebp+210h]
		mov	ecx, 4
		@CALL	ReceiveBlock
		@RET

; Subroutine
; Receive 4 byte into ebp+214h
loc_7119:	lea	edx, [ebp+214h]
		mov	ecx, 4
		@CALL	ReceiveBlock
		@RET

; Subroutine
; Reveice buffer
; R:-
loc_7134:	push	ecx
		push	edx
		mov	ecx, [ebp+210h]
		lea	edx, [ebp+218h]
		@CALL	ReceiveBlock
		pop	edx
		pop	ecx
		@RET

; Subroutine
; Receive a block of data
; E: EBX = number of byte to receive, EDX = address of data to receive
; R:-
ReceiveBlock:	push	eax
		push	ecx
		push	edx
loc_7157:	@CALL	ReceiveByte
		mov	[edx], bl
		inc	edx
		loop	loc_7157
		pop	edx
		pop	ecx
		pop	eax
		@RET

; Subroutine
; Receive one byte
; Set RTS, wait for receive data, read, wait for CTS,
; wait for transmit data, write echo, clear RTS
; E:-
; R: BL = character read
ReceiveByte:	push	edx
		mov	edx, h_uart[ebp]
		mov	dl, 0FCh	; Modem Control Register
		in	al, dx
		or	al, 2		; set RTS (Request To Send)
		out	dx, al
loc_7179:	@CALL	loc_7275
		mov	dl, 0FDh	; Line Status Register
		in	al, dx
		test	al, 1		; Data Ready
		jz	short loc_7179
		mov	edx, h_uart[ebp] ; Receiver Buffer
		in	al, dx		; read data
		push	eax
loc_718F:	@CALL	loc_7275
		mov	dl, 0FEh	; Modem Status Register
		in	al, dx
		test	al, 10h		; CTS (Clear To Send)?
		jz	short loc_718F
loc_71A0:	@CALL	loc_7275
		mov	dl, 0FDh	; Line Status Register
		in	al, dx
		test	al, 20h		; Empty Transmitter Holding Register?
		jz	short loc_71A0
		mov	edx, h_uart[ebp] ; Transmitter Holding Buffer
		pop	eax
		out	dx, al		; Transmit character to UART
		push	eax
		mov	dl, 0FCh	; Modem Control Register
		in	al, dx
		and	al, 0FDh	; clear RTS (Request To Send)
		out	dx, al
		pop	ebx
		pop	edx
		@RET

; Subroutine
; Transmit debug state
; R:-
TransmitDBState: push	ecx
		push	edx
		lea	edx, h_dbstate[ebp]
		mov	ecx, 158h
		@CALL	TransmitBlock
		pop	edx
		pop	ecx
		@RET

; Subroutine
; Transmit buffer
; R:-
loc_71E4:	push	ecx
		push	edx
		mov	ecx, [ebp+210h]
		lea	edx, [ebp+218h]
		@CALL	TransmitBlock
		pop	edx
		pop	ecx
		@RET

; Subroutine
; Transmit a block of data
; E: EBX = number of byte to transmit, EDX = address of data to transmit
; R:-
TransmitBlock:	push	eax
		push	ecx
		push	edx
loc_7207:	mov	al, [edx]
		@CALL	TransmitByte
		inc	edx
		loop	loc_7207
		pop	edx
		pop	ecx
		pop	eax
		@RET

; Subroutine
; Transmit one byte and receive its echo
; Set RTS, wait for CTS, wait for transmit data, write,
; wait for receive data, read, clear RTS
; E: AL = character to be transmitted
; R:-
TransmitByte:	push	edx
		push	eax
		mov	edx, h_uart[ebp]
		mov	dl, 0FCh	; Modem Control Register
		in	al, dx
		or	al, 2		; set RTS (Request To Send)
		out	dx, al
loc_722A:	@CALL	loc_7275
		mov	dl, 0FEh	; Modem Status Register
		in	al, dx
		test	al, 10h		; CTS (Clear To Send)?
		jz	short loc_722A	; no, wait
loc_723B:	@CALL	loc_7275
		mov	dl, 0FDh	; Line Status Register
		in	al, dx
		test	al, 20h		; Empty Transmitter Holding Register?
		jz	short loc_723B	; no, wait
		mov	edx, h_uart[ebp] ; Transmitter Holding Buffer
		pop	eax
		out	dx, al		; transmit character to UART
loc_7251:	@CALL	loc_7275
		mov	dl, 0FDh	; Line Status Register
		in	al, dx
		test	al, 1		; Data Ready
		jz	short loc_7251
		mov	edx, h_uart[ebp] ; Receiver Buffer
		in	al, dx		; read data
		push	eax
		mov	dl, 0FCh	; Modem Control Register
		in	al, dx
		and	al, 0FDh	; clear RTS (Request To Send)
		out	dx, al
		pop	eax
		pop	edx
		@RET

; Subroutine
loc_7275:	push	edx
		mov	dl, 0FDh	; Line Status Register
		in	al, dx
		test	al, 10h		; Break Interrupt
		jnz	short loc_7284
		pop	edx
		@RET

loc_7284:	@CALL	loc_708A
		mov	esp, [ebp+21Ch]
		jmp	loc_6AE5

 IF V033S OR V033V
; Subroutine
; Check for break interrupt
; R: BL=0 for no, 1 for yes
loc_6B9A:
 ENDIF
		push	edx
		mov	edx, h_uart[ebp]
		mov	bl, 0
		mov	dl, 0FDh
		in	al, dx
		test	al, 10h
		jz	short loc_72A8
		mov	bl, 1
loc_72A8:	pop	edx
		@RET

		ALIGN	256

hypseg		ends
		end

;---------------------------------------------------------------- end HDEB.ASM