;-----------------------------------------------------------------------------
; NexGen Nx586 BIOS Hypercode
;-----------------------------------------------------------------------------
; File: INT.ASM - 
; Date: 2020-09-24
;
; Disassembled by Dipl.-Inf. Herbert Oppmann (herby@memotech.franken.de)
;-----------------------------------------------------------------------------

		include COMMON.INC

	extrn	FORCEBIG:abs

	extrn	loc_1AB7:near
	extrn	loc_2AA7:near
	extrn	loc_2AC8:near
	extrn	loc_2BB6:near
	extrn	loc_2BC5:near
	extrn	loc_2D9A:near
 IF VVL
	extrn	loc_3DE3:near
 ENDIF
	extrn	Exception:near
	extrn	ExcpDebugExcp:near

	public	loc_1F20
	public	loc_1F7F
	public	loc_2046
	public	loc_20AC
	public	loc_2420
	public	loc_244D
	public	loc_246D


 IF V033S
		db '@(#)int.asm',TAB,'3.4',0
 ELSEIF V033W
		db '@(#)int.asm',TAB,'3.5',0
 ELSE	; PCI+V033V
		db '@(#)int     ',0
 ENDIF
		ALIGN0	32

; Hypermode entry via offset 0B00h
loc_1F20:	mov	ebp, esp
		sub	ebp, 3E4h
		push	eax
		push	ebx
		push	ecx
		push	edx
		push	esi
		push	edi
		mov	esp, ebp
		mov	h_excph[ebp], offset loc_2420
		and	dword ptr h_gatflag[ebp], 8FFFFFFFh
		xor	edx, edx
		mov	word ptr h_dbflag[ebp], dx
		bt	h_efl[ebp], 17	; VM
		jc	loc_207B
 IF V033V OR V033W
		mov	dword ptr [ebp+330h], 0
 ENDIF
		RDAR	eax, cs
		OP_0FE4
		WRAR	?6, eax
		RDB	eax, cs
		WRB	?6, eax
		mov	eax, cs
		WRSEL	?6, eax
		RDAR	eax, ?7
		OP_0FE4
		WRAR	cs, eax
		RDB	eax, ?7
		WRB	cs, eax
		MOVSEL	eax, ?7
		WRSEL	cs, eax
		bts	edx, 31

loc_1F7F:				; CODE XREF: 210F	00003D25
					; 00003D38
		mov	eax, cs
		and	eax, 0FFFCh
		RDAR	ebx, cs
		shr	ebx, 29
		and	ebx, 3
		or	eax, ebx
		OP_0FE4
		WRSEL	cs, eax
		bt	edx, 29
		jnc	short loc_2000
		RDAR	eax, ?6
		OP_0FE4
		WRAR	?7, eax
		RDB	eax, ?6
		WRB	?7, eax
		MOVSEL	eax, ?6
		WRSEL	?7, eax
		mov	esi, h_esp[ebp]
		RDAR	ebx, ss
		bt	ebx, 22
		jc	loc_2066
		mov	ebx, esi
		and	esi, 0FFFFh
		jmp	loc_2066
		ALIGN	256

loc_2000:				; CODE XREF: 1F9A
		xor	eax, eax
		WRCPL	eax
		mov	eax, cs
		and	eax, 3
		mov	bl, 1
		WRSBNK	ebx
		bts	edx, 29
		RDAR	ebx, tr
		bt	ebx, 27
		jnc	short loc_202F
		mov	bx, fs:8[eax*8]
		mov	esi, fs:4[eax*8]
		jmp	short near ptr loc_2041

loc_202F:	mov	bx, fs:4[eax*4]
		movzx	esi, word ptr fs:2[eax*4]

loc_2041:	OP_0FE4
		WRCPL	eax
loc_2046:	mov	ss, bx
		bts	edx, 30
		btr	edx, 29
		xor	ebx, ebx
		WRSBNK	ebx
		RDAR	ebx, ss
		bt	ebx, 22
		jc	short loc_2066
		mov	ebx, esi
		and	esi, 0FFFFh

loc_2066:				; CODE XREF: 1FBC	00001FCA
					; 0000205C
		mov	eax, h_gatflag[ebp]
		bt	eax, 31
		jc	loc_2211
		jmp	loc_2114

loc_207B:				; CODE XREF: 1F4F
		pushf
		btr	dword ptr [esp], 17
		popf
 IF V033V OR V033W
		mov	eax, h_gatflag[ebp]
		ror	eax, 10h
		cmp	al, 1
		jnz	short loc_20A3
		cmp	dword ptr [ebp+330h], 6
		jnz	short loc_20A3
		mov	al, 6
		rol	eax, 10h
		mov	h_gatflag[ebp], eax
loc_20A3:	mov	dword ptr [ebp+330h], 0
 ENDIF

		mov	edi, h_gatflag[ebp]
		and	edi, 0FF0000h
		shr	edi, 10h
		shl	edi, 3
		mov	eax, edi
		@CALL	loc_244D
		mov	eax, edi
		@CALL	loc_246D
loc_20AC:	mov	dword ptr h_tsst[ebp], 10000000h
		bt	dword ptr h_gatflag[ebp], 28
		jc	loc_2D9A
 IF VVL
		@CALL	loc_3DE3
 ENDIF
		RDB	eax, ?7
		mov	ebx, eax
		and	ebx, 0FF000000h
		RDAR	ecx, ?7
		and	ecx, 0FFFFFFh
		or	ecx, ebx
		mov	h_gate[ebp], ecx
		and	eax, 0FFFFh
		OP_0FE4
		MOVSEL	cs, eax
		RDAR	ecx, cs
		WRAR	cs, ecx
		bts	edx, 31
		RDAR	eax, cs
		mov	ecx, eax
		shr	ecx, 29
		and	ecx, 3
		cmp	cx, 0
		jnz	loc_243B
		bt	eax, 26
		jc	loc_243B
		jmp	loc_1F7F

loc_2114:				; CODE XREF: 2076
		bt	h_efl[ebp], 17
		jnc	short loc_217F
		xor	eax, eax
		mov	ax, gs
		mov	ss:[esi-2], ax
		mov	ax, fs
		mov	ss:[esi-4], ax
		mov	ax, ds
		mov	ss:[esi-6], ax
		mov	ax, es
		mov	ss:[esi-8], ax
		sub	esi, 8
		RDAR	eax, gs
		btr	eax, 31
		WRAR	gs, eax
		xor	eax, eax
		WRSEL	gs, eax
		RDAR	eax, fs
		btr	eax, 31
		WRAR	fs, eax
		xor	eax, eax
		WRSEL	fs, eax
		RDAR	eax, ds
		btr	eax, 31
		WRAR	ds, eax
		xor	eax, eax
		WRSEL	ds, eax
		RDAR	eax, es
		btr	eax, 31
		WRAR	es, eax
		xor	eax, eax
		WRSEL	es, eax

loc_217F:				; CODE XREF: 211C
		bt	edx, 29
		jc	short loc_219A
		MOVSEL	eax, ?6
		mov	ss:[esi-2], ax
		mov	eax, h_esp[ebp]
		mov	ss:[esi-4], ax
		sub	esi, 4

loc_219A:				; CODE XREF: 2183
		mov	eax, h_efl[ebp]
		mov	ss:[esi-2], ax
		MOVSEL	eax, ?7
		mov	ss:[esi-4], ax
		bt	dword ptr h_gatflag[ebp], 26
		jc	short loc_21BE
		mov	eax, h_eip2[ebp]
		jmp	short loc_21C4

loc_21BE:				; CODE XREF: 21B4
		mov	eax, h_eip3[ebp]

loc_21C4:				; CODE XREF: 21BC
		mov	ss:[esi-6], ax
		sub	esi, 6
		mov	eax, h_gatflag[ebp]
		bt	eax, 24
		jnc	short loc_2205
		mov	ebx, eax
		and	ebx, 0F0000h
		cmp	ebx, 80000h
		jl	short loc_2205
		cmp	ebx, 0E0000h
		jg	short loc_2205
		cmp	ebx, 90000h
		jz	short loc_2205
		and	eax, 0FFFFh
		mov	ss:[esi-2], ax
		sub	esi, 2

loc_2205:				; CODE XREF: 21D6	000021E6
					; 000021EE 000021F6
		movzx	ebx, word ptr h_gate[ebp]
		jmp	near ptr loc_2303

loc_2211:				; CODE XREF: 2070
		bt	h_efl[ebp], 17
		jnc	short loc_2278
		xor	eax, eax
		mov	ax, gs
		mov	ss:[esi-4], eax
		mov	ax, fs
		mov	ss:[esi-8], eax
		mov	ax, ds
		mov	ss:[esi-0Ch], eax
		mov	ax, es
		mov	ss:[esi-10h], eax
		sub	esi, 10h
		RDAR	eax, gs
		btr	eax, 31
		WRAR	gs, eax
		xor	eax, eax
		WRSEL	gs, eax
		RDAR	eax, fs
		btr	eax, 31
		WRAR	fs, eax
		xor	eax, eax
		WRSEL	fs, eax
		RDAR	eax, ds
		btr	eax, 31
		WRAR	ds, eax
		xor	eax, eax
		WRSEL	ds, eax
		RDAR	eax, es
		btr	eax, 31
		WRAR	es, eax
		xor	eax, eax
		WRSEL	es, eax

loc_2278:				; CODE XREF: 2219
		bt	edx, 29
		jc	short loc_2291
		MOVSEL	eax, ?6
		mov	ss:[esi-4], eax
		mov	eax, h_esp[ebp]
		mov	ss:[esi-8], eax
		sub	esi, 8

loc_2291:				; CODE XREF: 227C
		mov	eax, h_efl[ebp]
		btr	eax, 31
		mov	ss:[esi-4], eax
		MOVSEL	eax, ?7
		mov	ss:[esi-8], eax
		bt	dword ptr h_gatflag[ebp], 26
		jc	short loc_22B7
		mov	eax, h_eip2[ebp]
		jmp	short loc_22BD

loc_22B7:				; CODE XREF: 22AD
		mov	eax, h_eip3[ebp]

loc_22BD:				; CODE XREF: 22B5
		mov	ss:[esi-0Ch], eax
		sub	esi, 0Ch
		mov	eax, h_gatflag[ebp]
		bt	eax, 24
		jnc	short loc_22FD
		mov	ebx, eax
		and	ebx, 0F0000h
		cmp	ebx, 80000h
		jl	short loc_22FD
		cmp	ebx, 0E0000h
		jg	short loc_22FD
		cmp	ebx, 90000h
		jz	short loc_22FD
		and	eax, 0FFFFh
		mov	ss:[esi-4], ax
		sub	esi, 4

loc_22FD:				; CODE XREF: 22CE	000022DE
					; 000022E6 000022EE
		mov	ebx, h_gate[ebp]
loc_2303:
 IF V033S
		mov	eax, h_gatflag[ebp]
		bt	eax, 24
		jnc	short near ptr loc_232B
		and	eax, 0F0000h
		cmp	eax, 0E0000h
		jnz	short near ptr loc_232B
		mov	eax, cr3
		mov	cr3, eax
loc_232B:
 ENDIF
		RDAR	eax, cs		; CODE XREF: 220C
		bt	eax, 23		; granularity
		jc	short loc_2313
		and	eax, 0FFFFFh	; gr. 1 byte -> max. 1 MB
		jmp	short loc_231B

loc_2313:	; granularity 4 KB -> max. 4 GB
		shl	eax, 12
		or	eax, 0FFFh
loc_231B:	; now limit in EAX
		cmp	ebx, eax
		ja	loc_2BB6
		mov	eax, h_efl[ebp]
		and	eax, 0FFFDBEFFh
		bt	dword ptr h_gatflag[ebp], 27
		jc	short loc_233C
		btr	eax, 9

loc_233C:				; CODE XREF: 2336
		mov	h_efl[ebp], eax
		RDAR	eax, ss
		bt	eax, 22
		jc	short loc_2354
		mov	word ptr h_esp[ebp], si
		jmp	short loc_235A

loc_2354:				; CODE XREF: 2349
		mov	h_esp[ebp], esi

loc_235A:				; CODE XREF: 2352
		mov	h_eip3[ebp], ebx
		mov	eax, dr7
 IF NOT V033S
		bts	word ptr h_dbflag[ebp], 2
		mov	h_dr7[ebp], eax
 ENDIF
		push	eax
		xor	eax, eax
		mov	dr7, eax
		mov	h_excph[ebp], offset Exception
		mov	h_eip2[ebp], ebx
		RDAR	ecx, cs
		mov	eax, ecx
		bts	ecx, 25
		jnc	short near ptr loc_2393
		test	byte ptr cs:[ebx], 0
		jmp	short loc_23A1

loc_2393:	OP_0FE4			; CODE XREF: 238B
		WRAR	cs, ecx
		test	byte ptr cs:[ebx], 0
		OP_0FE4
		WRAR	cs, eax

loc_23A1:				; CODE XREF: 2391
		pop	eax
		mov	dr7, eax
 IF NOT V033S
		btr	word ptr h_dbflag[ebp], 2
 ENDIF
		bt	h_dbflag[ebp], 17
		jc	ExcpDebugExcp
 IF VPCI
		mov	eax, h_gatflag[ebp]
		bt	eax, 24
		jnc	short loc_240C
		and	eax, 0F0000h
		cmp	eax, 20000h
		jnz	short loc_240C
		btr	h_efl[ebp], 31
		bts	h_dbflag[ebp], 24
		@CALL	loc_24FE
		mov	eax, h_esp[ebp]
		mov	[ebp+338h], eax
		lea	esp, h_edi[ebp]
		pop	edi
		pop	esi
		pop	edx
		pop	ecx
		pop	ebx
		pop	eax
		pop	ebp
		add	esp, 4
		DELAYNOP
		INTH	EXCP_NMI

loc_240C:				; CODE XREF: 23C0	000023CC
 ENDIF
		lea	esp, h_edi[ebp]
		pop	edi
		pop	esi
		pop	edx
		pop	ecx
		pop	ebx
		pop	eax
		pop	ebp
		add	esp, 8
		OP_0FE4
		RETH

; special exception handler for INT and INTO
loc_2420:	mov	esi, esp
		@CALL	loc_2AC8
		@CALL	loc_2BC5
		jmp	loc_1AB7

loc_243B:				; CODE XREF: 20FF	00002109
		mov	eax, cs
		push	EXCP_GENPROT+FORCEBIG
		and	eax, 0FFFCh
		push	eax
		jmp	loc_2AA7

; ensure that descriptor pointed to by EAX is inside IDT
; generate general protection exception if not
loc_244D:	push	ebx
		push	ecx
		RDAR	ebx, idtr
		and	ebx, 0FFFFh	; base
		mov	ecx, eax
		add	ecx, 7		; end of selector
		cmp	ecx, ebx
		jg	GenGenProt
		pop	ecx
		pop	ebx
		@RET

; subroutine: check segment register ?7
; - general protection exception if not an int gate, trap gate or task gate
; - general protection exception if privilege level too low
; - segment not present exception if segment not present
loc_246D:	push	ebx
		push	ecx
		push	edx
		RDAR	ebx, ?7
		btr	dword ptr h_gatflag[ebp], 28
		mov	ecx, ebx
		and	ecx, 1F000000h	; descriptor type S, segment type TYPE
		shr	ecx, 24
		cmp	ecx, 6		; 16-bit int gate
		jz	short loc_24B7
		cmp	ecx, 0Eh	; 32-bit int gate
		jz	short loc_24B7
		cmp	ecx, 7		; 16-bit trap gate
		jz	short loc_24B7
		cmp	ecx, 0Fh	; 32-bit trap gate
		jz	short loc_24B7
		cmp	ecx, 5		; task gate
		jnz	short GenGenProt
		; task gate
		mov	ecx, h_gatflag[ebp]
		and	ecx, 8FFFFFFFh
		or	ecx, 10000000h
		mov	h_gatflag[ebp], ecx
loc_24B7:	bt	dword ptr h_gatflag[ebp], 26
		jnc	short loc_24D3
		mov	ecx, ebx
		shr	ecx, 29		; descriptor privilege level DPL
		and	ecx, 3
		RDCPL	edx
		and	edx, 3
		cmp	ecx, edx
		jl	short GenGenProt
loc_24D3:	bt	ebx, 31		; segment present P
		jnc	short GenSegNotPres
		pop	edx
		pop	ecx
		pop	ebx
		@RET

; generate general protection exception
GenGenProt:	push	EXCP_GENPROT+FORCEBIG
		add	eax, 2
		push	eax
		jmp	loc_2AA7

; generate segment not present exception
GenSegNotPres:	push	EXCP_SEGNOTPRES+FORCEBIG
		add	eax, 2
		push	eax
		jmp	loc_2AA7

 IF VPCI
; set opcode mask to emulate all instructions
loc_24FE:	DELAYNOP 2
		LOPCMSK	 0, 0FFh
		LOPCMSK	 1, 0FFh
		LOPCMSK	 2, 0FFh
		LOPCMSK	 3, 0FFh
		LOPCMSK	 4, 0FFh
		LOPCMSK	 5, 0FFh
		LOPCMSK	 6, 0FFh
		LOPCMSK	 7, 0FFh
		@RET
 ENDIF

		ALIGN	256

hypseg		ends
		end

;----------------------------------------------------------------- end INT.ASM