;-----------------------------------------------------------------------------
; NexGen Nx586 BIOS Hypercode
;-----------------------------------------------------------------------------
; File: INTO.ASM - 
; Date: 2020-09-24
;
; Disassembled by Dipl.-Inf. Herbert Oppmann (herby@memotech.franken.de)
;-----------------------------------------------------------------------------

		include COMMON.INC

	extrn	FORCEBIG:abs

	extrn	Exception:near
	extrn	ExcpDebugExcp:near
	extrn	loc_1F7F:near
	extrn	loc_20AC:near
	extrn	loc_2420:near
	extrn	loc_244D:near
	extrn	loc_246D:near
	extrn	loc_2AA7:near
	extrn	loc_2B92:near
	extrn	loc_2BA4:near
	extrn	loc_2BC5:near
	extrn	loc_2D9A:near
	extrn	loc_5320:near
 IF V033S
	extrn	loc_6A20:near
 ENDIF
 IF V033V OR V033W
	extrn	loc_3F20v:near
 ENDIF

	public	loc_3B20
 IF V033V OR V033W
	public	loc_3B35
 ENDIF
 IF VVL
	public	loc_3DE3
 ENDIF

 IF V033S
		db '@(#)into.asm',TAB,'3.4',0
 ELSEIF V033V
		db '@(#)into    ',0
 ELSE	; PCI+V033W
		db '@(#)into.asm',TAB,'3.5',0
 ENDIF
		ALIGN0	32

; Hypermode entry via offset 0D80h
loc_3B20:	mov	ebp, esp
		sub	ebp, 3E4h
		push	eax
		push	ebx
		push	ecx
		push	edx
		push	esi
		push	edi
		mov	esp, ebp
 IF V033V OR V033W
		jmp	loc_3F20v
loc_3B35:
 ELSE	; PCI+V033S
		and	h_gatflag[ebp], 70000FFh
		mov	eax, h_gatflag[ebp]
 ENDIF

 IF V033S
		and	al, 0Fh
		cmp	al, 1
		jz	loc_6A20
		bt	h_dbflag[ebp], 22
		jnc	short loc_3A56
		jmp	loc_3AED

loc_3A56:	and	al, 0Fh
		cmp	al, 0Eh
		jnz	short loc_3A67
		OP_0FE4
		mov	eax, cr2
		mov	h_cr2[ebp], eax
loc_3A67:	mov	eax, 0FFFFFFFFh
		mov	cr2, eax
                bts     h_dbflag[ebp], 22
; set opcode mask to emulate all instructions
		DELAYNOP 2
		LOPCMSK	0, 0FFh
		LOPCMSK	1, 0FFh
		LOPCMSK	2, 0FFh
		LOPCMSK	3, 0FFh
		LOPCMSK	4, 0FFh
		LOPCMSK	5, 0FFh
		LOPCMSK	6, 0FFh
		LOPCMSK	7, 0FFh
		mov	eax, h_cfg1[ebp]
		btr	eax, 18
		mov	h_cfg1[ebp], eax
		OP_0FE4
		WRCFG1	eax
		mov	eax, h_eip2[ebp]
		mov	h_eip3[ebp], eax
		mov	eax, h_cfg0[ebp]
		bts	eax, 31		; suppress DECEXP p-op,
		DELAYNOP 2		; i.e. force execution
		WRCFG0	eax
		lea	esp, h_edi[ebp]
		pop	edi
		pop	esi
		pop	edx
		pop	ecx
		pop	ebx
		pop	eax
		pop	ebp
		add	esp, 8
		OP_0FE4
		RETH

loc_3AED:
 ENDIF
		@CALL	loc_5320
		mov	eax, h_gatflag[ebp]
		and	eax, 0FFh
		or	eax, 4000000h
		mov	h_gatflag[ebp], eax
		mov	edi, h_gatflag[ebp]
		and	edi, 0FFh
		mov	ebx, cr0
		bt	ebx, 0
		jc	loc_3C11
		mov	h_excph[ebp], offset loc_3C02
		xor	edx, edx
		mov	word ptr h_dbflag[ebp], dx
		mov	esi, h_esp[ebp]
		and	esi, 0FFFFh
		mov	ebx, h_efl[ebp]
		mov	ss:[esi-2], bx
		mov	ss:[esi-4], cs
		bt	dword ptr h_gatflag[ebp], 26
		jc	short loc_3BB3
		mov	ebx, h_eip2[ebp]
		jmp	short loc_3BB9

loc_3BB3:				; CODE XREF: 3BA9
		mov	ebx, h_eip3[ebp]

loc_3BB9:				; CODE XREF: 3BB1
		mov	ss:[esi-6], bx
		sub	esi, 6
		shl	edi, 2
		@CALL	loc_3D85
		OP_0FE4
		WRSEL	cs, ecx
		shl	ecx, 4
		WRB	cs, ecx
		mov	ecx, 9B00FFFFh
		WRAR	cs, ecx
		btr	h_efl[ebp], 9
		btr	h_efl[ebp], 8
		mov	h_esp[ebp], esi
		mov	h_eip3[ebp], ebx
		jmp	loc_3D57

; special exception handler for INTO
loc_3C02:	@CALL	loc_2BC5
		jmp	Exception

loc_3C11:				; CODE XREF: 3B73
		mov	h_excph[ebp], offset loc_3CC0
		xor	edx, edx
		mov	word ptr h_dbflag[ebp], dx
		bt	h_efl[ebp], 17
		jnc	short loc_3C2F
		pushf
		btr	dword ptr [esp], 17
		popf

loc_3C2F:				; CODE XREF: 3C26
		shl	edi, 3
		mov	eax, edi
		@CALL	loc_244D
		@CALL	loc_3DE3
		mov	eax, edi
		@CALL	loc_246D
		RDAR	ebx, ?7		; DATA XREF: 3C4A
		mov	ecx, h_gatflag[ebp]
		bt	ebx, 27
		jc	short loc_3C69
		btr	ecx, 31
		jmp	short loc_3C6D

loc_3C69:				; CODE XREF: 3C61
		bts	ecx, 31

loc_3C6D:				; CODE XREF: 3C67
		mov	eax, ebx
		and	eax, 7000000h
		cmp	eax, 7000000h
		jz	short loc_3C81
		btr	ecx, 27
		jmp	short loc_3C85

loc_3C81:				; CODE XREF: 3C79
		bts	ecx, 27

loc_3C85:				; CODE XREF: 3C7F
		mov	eax, ecx
		and	eax, 0FFh
		shl	eax, 16
		and	ecx, 0FF00FFFFh
		or	ecx, eax
		mov	h_gatflag[ebp], ecx
		bt	h_efl[ebp], 17
		jc	loc_3D3D
		mov	eax, ebx
		and	eax, 1F000000h
		shr	eax, 24
		cmp	eax, 5
		jz	loc_3D4B
		jmp	short loc_3CC5

loc_3CC0:				; DATA XREF: 3C11
		jmp	Exception

loc_3CC5:				; CODE XREF: 3CBE
		mov	h_excph[ebp], offset loc_2420
		xor	edx, edx
		RDB	eax, ?7
		mov	ecx, eax
		and	ecx, 0FF000000h
		and	ebx, 0FFFFFFh
		or	ebx, ecx
		mov	h_gate[ebp], ebx
		and	eax, 0FFFFh
		OP_0FE4
		MOVSEL	cs, eax
		RDAR	eax, cs
		WRAR	cs, eax
		bts	edx, 31
		RDAR	eax, cs
		mov	ecx, eax
		bt	eax, 26
		jc	short loc_3D2A
		and	eax, 60000000h
		shr	eax, 29
		RDCPL	ebx
		cmp	eax, ebx
		jl	short loc_3D1B
		jz	short loc_3D2A
		jmp	loc_2B92

loc_3D1B:				; CODE XREF: 3D12
		bt	ecx, 31
		jnc	loc_3E71
		jmp	loc_1F7F

loc_3D2A:				; CODE XREF: 3D03	3D14
		bt	ecx, 31
		jnc	loc_3E71
		bts	edx, 29
		jmp	loc_1F7F

loc_3D3D:				; CODE XREF: 3CA5
		mov	h_excph[ebp], offset loc_2420
		xor	edx, edx
		jmp	loc_20AC

loc_3D4B:				; CODE XREF: 3CB8
 IF NOT V033S
		mov	dword ptr h_tsst[ebp], 10000000h
 ENDIF
		jmp	loc_2D9A

loc_3D57:				; CODE XREF: 3BFD
		bt	h_dbflag[ebp], 17
		jc	ExcpDebugExcp
		lea	esp, h_edi[ebp]
		pop	edi
		pop	esi
		pop	edx
		pop	ecx
		pop	ebx
		pop	eax
		pop	ebp
		add	esp, 8
		OP_0FE4
		RETH

loc_3D76:				; CODE XREF: 3E6C
		push	EXCP_GENPROT+FORCEBIG
		push	0+FORCEBIG
		jmp	loc_2AA7

loc_3D85:	RDAR	ebx, idtr	; CODE XREF: 3BC9
		mov	ecx, edi
		add	ecx, 3
 IF NOT V033S
		and	ebx, 0FFFFFh
 ENDIF
		cmp	ecx, ebx
		jg	loc_3E6C
		RDAR	eax, idtr
		and	eax, 0FFFFFh
		or	eax, 92000000h
		OP_0FE4
		WRAR	?7, eax
		RDB	eax, idtr
		WRB	?7, eax
		mov	eax, 0
		WRSEL	?7, eax
		mov	eax, 1
		OP_0FE4
		WRSBNK	eax
		segds
		mov	ebx, [edi]
		mov	eax, 0
		OP_0FE4
		WRSBNK	eax
		mov	ecx, ebx
		and	ebx, 0FFFFh
		shr	ecx, 16
		@RET

loc_3DE3:	push	eax
		push	ebx
		push	ecx
		push	edx
		RDAR	eax, idtr
		and	eax, 0FFFFFh
		or	eax, 92000000h
		OP_0FE4
		WRAR	?7, eax
		RDB	eax, idtr
		WRB	?7, eax
		mov	eax, 0
		WRSEL	?7, eax
		mov	eax, 0
		OP_0FE4
		WRCPL	eax
		mov	eax, 1
		WRSBNK	eax
		segds
		mov	ebx, [edi]
		mov	ecx, ebx
		segds
		mov	ebx, [edi+4]
		mov	eax, cs
		and	eax, 3
		OP_0FE4
		WRCPL	eax
		mov	eax, 0
		WRSBNK	eax
		mov	al, bl
		mov	dh, bh
		shr	ebx, 16
		mov	dl, bl
		mov	ah, bh
		shl	edx, 16
		shl	eax, 16
		mov	ebx, ecx
		shr	ebx, 16
		and	ecx, 0FFFFh
		or	ecx, edx
		or	ebx, eax
		movzx	eax, bx
		OP_0FE4
		WRSEL	?7, eax
		WRB	?7, ebx
		WRAR	?7, ecx
		pop	edx
		pop	ecx
		pop	ebx
		pop	eax
		@RET

loc_3E6C:				; CODE XREF: 3D95
		jmp	loc_3D76

loc_3E71:				; CODE XREF: 3D1F	3D2E
		jmp	loc_2BA4
		ALIGN	256

hypseg		ends
		end

;---------------------------------------------------------------- end INTO.ASM