;-----------------------------------------------------------------------------
; NexGen Nx586 BIOS Hypercode
;-----------------------------------------------------------------------------
; File: INVOP.ASM - Invalid opcode, NexGen NXOP
; Date: 2020-09-27
;
; Disassembled by Dipl.-Inf. Herbert Oppmann (herby@memotech.franken.de)
;-----------------------------------------------------------------------------

		include COMMON.INC

	extrn	FORCEBIG:abs

	extrn	Exception:near
	extrn	HypCodeVers:near
	extrn	loc_16D0:near
	extrn	loc_2AA7:near
	extrn	loc_2BB6:near
	extrn	loc_4C20:near
	extrn	loc_4C44:near
	extrn	loc_532E:near
	extrn	InstrUnsupp:near
	extrn	CheckCPL0:near
 IF VVL
	extrn	loc_4133:near
	extrn	InitUart:near
 ENDIF

	public	loc_3F20
	public	loc_3F9F
	public	DecNXOP
	public	InstrUnsupp2
 IF V033S
	public	NxWriteOPCL
 ENDIF


 IF V033S
		db '@(#)invop.asm',9,'3.29',0
 ELSE	; PCI+V033V+V033W
		db '@(#)invop   ',0
 ENDIF
		ALIGN0	32

; Hypermode entry via offset 0900h
loc_3F20:	mov	ebp, esp
		sub	ebp, 3E4h
		push	eax
		push	ebx
		push	ecx
		push	edx
		push	esi
		push	edi
		mov	esp, ebp
		mov	h_excph[ebp], offset loc_3FB1
		xor	edx, edx
		mov	word ptr h_dbflag[ebp], dx
		and	dword ptr h_gatflag[ebp], 0FFh
		mov	eax, h_gatflag[ebp]
		bt	eax, 7
 IF VVL
		jc	loc_3F9F
 ELSE
		jc	short loc_3F9F
 ENDIF
		bt	eax, 6
 IF VVL
		jc	loc_3FAC
 ELSE
		jc	short loc_3FAC
 ENDIF

 IF V033S
		btr	h_dbflag[ebp], 22
		jnc	short loc_3F9A
		DELAYNOP 2
		LOPCMSK	0, 0
		LOPCMSK	1, 0
		LOPCMSK	2, 0
		LOPCMSK	3, 0
		LOPCMSK	4, 0
		LOPCMSK	5, 0
		LOPCMSK	6, 10h
		LOPCMSK	7, 0
 ELSEIF V033V OR V033W
		cmp	al, 3Fh
		jz	loc_3F9A
		xor	al, al
		btr	h_dbflag[ebp], 22
		adc	al, 0
		btr	h_dbflag[ebp], 23
		adc	al, al
		jz	short loc_3F9A
		or	byte ptr [ebp+2FBh], 10h	; in code, see HYPRES.ASM
		@CALL	loc_16D0
 ELSE
		cmp	al, 3Fh
		jz	short loc_3F9A
		btr	h_dbflag[ebp], 24
		jnc	short loc_3F9A
		@CALL	loc_16D0
 ENDIF

 IF VVL
		mov	eax, h_cfg1[ebp]
		bts	eax, 18
		mov	h_cfg1[ebp], eax
		OP_0FE4
		WRCFG1	eax
		mov	eax, h_eip2[ebp]
		mov	h_eip3[ebp], eax
		mov	eax, cr2
		cmp	eax, 0FFFFFFFFh
		jz	short loc_42B5
		mov	h_cr2[ebp], eax
loc_42B5:
  IF V033V OR V033W
		mov	eax, [ebp+334h]
		cmp	eax, 0FFFFFFFFh
		jz	short loc_42DF
		@CALL	loc_4133
		bts	dword ptr gs:[eax], 5
		mov	cr0, edi
		xor	eax, eax
		OP_0FE4
		WRSBNK	eax
		mov	[ebp+334h], eax
loc_42DF:
  ENDIF
 ELSE
		mov	eax, [ebp+338h]
		mov	h_esp[ebp], eax
		mov	eax, h_eip2[ebp]
		mov	h_eip3[ebp], eax
 ENDIF
		lea	esp, h_edi[ebp]
		pop	edi
		pop	esi
		pop	edx
		pop	ecx
		pop	ebx
		pop	eax
		pop	ebp
		add	esp, 8
		OP_0FE4
		RETH

loc_3F9A:	jmp	loc_532E

loc_3F9F:	xor	eax, eax
		push	EXCP_INVALIDOP+FORCEBIG
		push	eax
		jmp	loc_2AA7

loc_3FAC:	jmp	loc_2BB6

loc_3FB1:	jmp	Exception


; NXOP 0Fh,55h
; API into hypercode
; E: SI=B0xx (00 <= xx <= 0E) call function xx
;    or ESI=FFFF0000 call special function 00
;    else raise exception "invalid opcode"
; R: NCarry and AH=0 if ok, else Carry and AH=error code
; other registers are function-dependant
; Current privilege level must be 0 or function must be special 00
; or 0E else exception "general protection" is raised.

DecNXOP:	mov	esi, h_esi[ebp]
		mov	eax, esi
		cmp	ah, 0B0h	; SI=B0xx?
		jnz	short NxESpecial
		; SI=B0xx
		and	esi, 0FFh
 IF V033S OR V033V
		cmp	esi, 0Dh+1	; max. function?
 ELSE
		cmp	esi, 0Eh+1	; max. function?
 ENDIF
		jnc	short loc_3F9F	; exception invalid opcode
 		add	esi, 0		; ??
 
 IF VPCI GT 'i'
		cmp	esi, 0Eh
		jz	short NxNoCPL0Chk ; no level check for function 0E
 ENDIF
 IF NOT V033W
		@CALL	CheckCPL0	; exception general protection if not CPL=0
NxNoCPL0Chk:
 ENDIF
		mov	byte ptr h_eax+1[ebp], 0 ; no error yet
		jmp	short NxDispatch

; SI<>B000. Check for ESI=FFFF0000
NxESpecial:	ror	esi, 16
		cmp	si, -1+FORCEBIG
		jnz	short loc_3F9F	; exception invalid opcode
		shr	esi, 16
		cmp	esi, 0
		jg	short loc_3F9F	; exception invalid opcode
		; ESI=0

; dispatch hypercode API function
; ESI=function number (00-0E)
NxDispatch:	mov	eax, h_base[ebp]
		lea	eax, NxopTable[eax+esi*2]
		movzx	eax, word ptr [eax]
		@JMP	eax

; DecNXOPxx
; E: ESI=function number (00-0E)
;    EAX=DecNXOPxx address
; V: EAX-EDX, EDI and ESI may be used. h_esi mustn't be changed.
; R: h_eax contains error code

NxopTable:	dw small offset DecNXOP0
		dw small offset DecNXOP1
		dw small offset DecNXOP2
		dw small offset DecNXOP3
		dw small offset DecNXOP4
		dw small offset DecNXOP5
		dw small offset DecNXOP6
		dw small offset DecNXOP7
		dw small offset DecNXOP8
		dw small offset DecNXOP9
		dw small offset DecNXOP10
		dw small offset DecNXOP11
		dw small offset DecNXOP12
		dw small offset DecNXOP13
 IF NOT (V033S OR V033V)
		dw small offset DecNXOP14
 ENDIF

;    EDI and ESI will be taken from h_edi and h_esi.
;    Other registers depend on function (function code taken from h_esi):
;    Special: EAX-EDX are taken from EAX-EDX, flags are unchanged
;    00     : ECX is taken from EAX, EAX is taken from h_eax
;             EBX and EDX are taken from EBX and EDX
;             carry flag set according to h_eax-highbyte
;    01-0E  : EAX-EDX are taken from h_eax-h_edx
;             carry flag set according to h_eax-highbyte
NxopRet:	mov	esi, h_eip2[ebp]
		add	esi, 2		; advance EIP
		mov	h_eip3[ebp], esi
		lea	esp, h_edi[ebp]
		pop	edi		; h_edi into EDI
		pop	esi		; h_esi into ESI
		push	eax		; save EAX
		mov	eax, esi
		cmp	ah, 0B0h
		jnz	short NxRSpecial ; for special function
		or	al, al
		jnz	short NxRNonZero ; all other
		; function 00
		pop	ecx		; restore EAX into ECX
		add	esp, 12		; ignore h_edx, h_ecx, h_ebx
NxRNormal:	and	dword ptr h_efl[ebp], 0FFFFFFFEh ; clear carry (assume no error)
		pop	eax		; get h_eax
		or	ah, ah		; error?
		jz	short NxopRet3	; no, return
		or	dword ptr h_efl[ebp], 1		; set carry
		jmp	short NxopRet3

NxRNonZero:	; function 01-0E
		pop	eax		; drop saved EAX
		pop	edx		; get h_edx, h_ecx, h_ebx
		pop	ecx
		pop	ebx
		jmp	short NxRNormal

NxRSpecial:	; special function
		pop	eax		; restore EAX
		add	esp, 16		; ignore h_edx, h_ecx, h_ebx, h_eax
NxopRet3:	pop	ebp		; restore EBP
		add	esp, 8		; skip h_gate, h_gatflag
		OP_0FE4
		RETH

 IF VVL
; read UART address
		mov	eax, h_uart[ebp]
		jmp	short NxopRet

; read DWORD from hyperspace
		mov	ebx, h_ebx[ebp]
		xor	edx, edx
		mov	edx, [ebx]
		jmp	short NxopRet

; write DWORD into hyperspace
		mov	ebx, h_ebx[ebp]
		mov	edx, h_edx[ebp]
		mov	[ebx], edx
		jmp	short NxopRet

; cause pagefault
		push	EXCP_PAGEFAULT+FORCEBIG
		push	0+FORCEBIG
		jmp	loc_2AA7

; get NPX-config
		DELAYNOP 2
		FRDCFG	h_eax[ebp]
		jmp	NxopRet

; set NPX-config
		mov	ebx, h_eax[ebp]
		mov	h_fcfg[ebp], ebx
		DELAYNOP 2
		FWRCFG	h_eax[ebp]
		jmp	NxopRet

; move hyper page to new address
; (copy content and then change hyper base register)
; E: new position in h_eax
		mov	esi, [ebp+8]	; current hyper base register
		mov	edi, h_eax[ebp]	; destination
		push	edi
		mov	ecx, 400h	; 4096 byte = one page
loc_4441:	lodsd
		stosd
		loop	loc_4441
		pop	eax
		mov	ebp, eax
		add	ebp, 0C00h	; that's HypStruc-HypEntries
		mov	[ebp+8], eax	; save new position
		WRB	hbr, eax	; set hyper base register
		jmp	NxopRet

; get CFG0, CFG1, NPX-config and cache config
		mov	eax, h_cfg0[ebp]
		mov	ebx, h_cfg1[ebp]
		mov	ecx, h_fcfg[ebp]
		mov	edx, h_ccfg[ebp]
		jmp	NxopRet

; set CFG0 and CFG1
		push	ecx
		mov	eax, h_eax[ebp]
		mov	ebx, h_ebx[ebp]
		mov	h_cfg0[ebp], eax
		mov	h_cfg1[ebp], ebx
		DELAYNOP 2
		WRCFG0	eax
		WRCFG1	ebx
		OP_0FE4
		pop	ecx
		jmp	NxopRet
 ENDIF

DecNXOP0:	; Function 00 and special function 00
		; Identification (get processor and microcode version)
 IF VVL
		mov	eax, h_base[ebp]
		lea	eax, offset HypCodeVers[eax] ; string '033w'
 ELSE
		mov	eax, offset HypCodeVers	; string '034q'
		add	eax, h_base[ebp]
 ENDIF
		mov	edx, [eax]
		RDMOST	ecx		; model + stepping
 IF V033S
		RDCPL	ebx
		and	ebx, 0FF80h
		or	ebx, ebx
		jz	short loc_41A5
		mov	ecx, 05000000h
loc_41A5:
 ELSEIF VPCI
		not	ecx
 ENDIF
		mov	eax, ecx
		shr	eax, 24
		cmp	al, 0		; old model?
		jnz	short Nxop0_2	; no, use NOT RDMOST-result
		; old model, use constants
		mov	ecx, 03000000h
		mov	al, 03h
Nxop0_2:	mov	ah, 15h
		xor	ebx, ebx
		mov	bl, 4		; assume 256K
		bt	h_dbflag[ebp], 19 ; cache size 0=256K, 1=1M
		jnc	short Nxop0_4
		mov	bl, 10h		; 1M
Nxop0_4:
 IF VVL
		jmp	NxopRet
 ELSE
		jmp	short NxopRet
 ENDIF
; values of my Nx586s in brackets
;	EAX=version 15xxh (1503h/1504h)
;	EBX=cache size in multiples of 64K (4)
;	ECX=NOT result of RDMOST instruction (00000000h/0400F039h)
;	EDX=hypercodeversion (4 chars, e.g. '033w'/'034q')


; Get base into EBX and AR into EDX of segment register in h_eax
; E: h_eax = segment register code (0-7 normal, 8-15 other)
; R: EAX= h_eax, EBX=base address, ECX= h_ecx, EDX=access rights
		mov	ecx, 900FF2C3h	; = NOP / RDB ebx,es
		mov	edx, 900FF6C2h	; = NOP / RDAR edx,es
		mov	ax, word ptr h_eax[ebp]
		btr	ax, 3		; register bank
		jnc	short GetBaseAR2
		bts	ecx, 8		; RDB normal segment -> RDB other segment
		bts	edx, 8		; RDAR normal segment -> RDAR other segment
GetBaseAR2:	and	al, 7
		shl	al, 3
		add	cl, al
		add	dl, al
		@CALL	RunCode
		mov	eax, h_eax[ebp]
		mov	ecx, h_ecx[ebp]
		jmp	NxopRet

; Set/Reset bit 20 of configuration register 1 and set h_uart from h_eax
; E: ECX= UART port for hyperdebugger
; R: EAX= h_eax, ECX= h_ecx, EDX= h_edx
		mov	ecx, h_eax[ebp]
		mov	eax, h_cfg1[ebp]
 IF VVL
		jecxz	short loc_4522
		bts	eax, 20
		jmp	short loc_4526
loc_4522:	btr	eax, 20
loc_4526:
 ELSE
		btr	eax, 20
 ENDIF
		mov	h_cfg1[ebp], eax
		WRCFG1	eax
		OP_0FE4
		mov	h_uart[ebp], ecx
		jecxz	short loc_410x
 IF VVL
		pushf
		pop	eax
		btr	eax, 17		; clear VM
		bts	eax, 12		; IOPL to 3
		bts	eax, 13
		push	eax
		popf
		@CALL	InitUart
 ENDIF
loc_410x:	mov	eax, h_eax[ebp]
		mov	ecx, h_ecx[ebp]
		mov	edx, h_edx[ebp]
		jmp	NxopRet

; Get OPCMSK (low 64 bits)
; E:-
; R: EAX= OPCMSK (lo)
;    EBX= OPCMSK (hi)
		mov	eax, h_opcmsk0[ebp]
		mov	ebx, h_opcmsk1[ebp]
		jmp	NxopRet

; Set OPCMSK (low 64 bits)
; E: h_eax= OPCMSK (lo)
;    h_ebx= OPCMSK (hi)
; V: EAX, EBX
		mov	eax, h_eax[ebp]
		mov	ebx, h_ebx[ebp]
loc_4135:	mov	h_opcmsk0[ebp], eax	; write into shadow
		mov	h_opcmsk1[ebp], ebx
		@CALL	NxWriteOPCL
 IF VVL
		@CALL	loc_4EB6
 ENDIF
		jmp	NxopRet

; write OPCMSK (low 64 bits)
; E: EBX, EAX = 64 bit OPCMSK
; V: EAX, EBX
; R:-
NxWriteOPCL:	push	ecx
		push	edx
		push	esi
		mov	ecx, 0FFAC000h	; = LOPCMSK 0, 0
NxWriteOPC:	mov	edx, 90909090h	; = NOP / NOP / NOP / NOP
		xor	esi, esi
		mov	cl, al
loc_415B:	push	eax
		push	ebx
		push	ecx
		push	edx
		@CALL	RunCode
		pop	edx
		pop	ecx
		pop	ebx
		pop	eax
		shrd	eax, ebx, 8
		shr	ebx, 8
		mov	cl, al
		inc	ch		; increment register
		inc	esi
		cmp	esi, 7
		jle	short loc_415B
		pop	esi
		pop	edx
		pop	ecx
		@RET

; let a small variable code sequence run (temporarily on the stack)
; E: ECX and EDX hold up to 8 byte opcode(s). If less is needed, it has
;    to be padded with 90h (NOP). The content of ECX and EDX is swapped
;    before writing to the stack.
; R: AH = CL = flags after code sequence
RunCode:	mov	eax, offset RunCode2	; continuation address
		add	eax, h_base[ebp]
		; swap bytes
		ror	cx, 8
		ror	ecx, 16
		ror	cx, 8
		ror	dx, 8
		ror	edx, 16
		ror	dx, 8
		push	9090E0FFh	; = JMP EAX / NOP / NOP
		push	edx
		push	ecx
		DELAYJMP 3
		jmp	esp		; after routine done, continues at RunCode2

RunCode2:	lahf			; flags into AH
		mov	cl, ah
		add	esp, 3*4
		@RET

;
		bt	dword ptr h_eax[ebp], 31
		jnc	short loc_41F2
		mov	ebx, h_ebx[ebp]
		mov	ecx, h_ecx[ebp]
loc_41D6:	mov	[ebp+294h], ebx
		mov	[ebp+290h], ecx
		mov	eax, 18000000h
		mov	[eax], ebx
		mov	eax, 1A000000h
		mov	[eax], ecx
		jmp	short loc_422C

loc_41F2:	mov	edx, h_eax[ebp]
		mov	ebx, h_ebx[ebp]
		mov	ecx, h_ecx[ebp]
; EDX=lower 2 bits select register set (cache bank?)
; ECX=mask 0FFFFF000h - 0FF800000h
; EBX=some value inside mask
; EDX=0: write EBX to 1C000000h and ebp+224h,
;        write ECX to 1E000000h and ebp+228h
; EDX=1: write EBX to 1C400000h and ebp+22Ch,
;        write ECX to 1E400000h and ebp+230h
; EDX=2: write EBX to 1C800000h and ebp+234h,
;        write ECX to 1E800000h and ebp+238h
; EDX=3: write EBX to 1CC00000h and ebp+23Ch,
;        write ECX to 1EC00000h and ebp+240h
loc_4204:
 IF VVL
		mov	eax, 1C000000h
 ELSE	; PCI
		mov	eax, 1E000000h
 ENDIF
		and	edx, 3
		push	edx
		shl	edx, 22
		or	eax, edx	; 1E000000h, 1E400000h, 1E800000h, 1EC00000h
 IF VVL
		mov	[eax], ebx
		mov	eax, 1E000000h
 ELSE	; PCI
		mov	[eax], ecx
		mov	eax, 1C000000h
 ENDIF
		or	eax, edx	; 1C000000h, 1C400000h, 1C800000h, 1CC00000h
 IF VVL
		mov	[eax], ecx
 ELSE	; PCI
		mov	[eax], ebx
 ENDIF
		pop	edx
		mov	[ebp+edx*8+224h], ebx
		mov	[ebp+edx*8+228h], ecx
loc_422C:	DELAYIO	3
		jmp	NxopRet

; to NXOP2, AL=0 or 1
loc_4237:	bt	dword ptr h_eax[ebp], 0
		jc	short loc_4250	; if AL=1
		@CALL	loc_4C20
		jmp	NxopRet

loc_4250:	@CALL	loc_4C44
		jmp	NxopRet

;
		mov	ecx, 555h
		mov	eax, gs:[ecx]
		mov	ebx, [ecx]
		jmp	NxopRet

; get NPX-status from NPX
		DELAYNOP 2
		FNLDSW	h_eax[ebp]
		jmp	NxopRet


		mov	edx, h_eax[ebp]
; set all of cache configuration register except second level cache size and return
; EDX= new value for CCFG
NxSetCCFG:	mov	eax, h_ccfg[ebp]	; read current value from memory copy
		and	eax, BIT 28		; keep bit 28 (cache size: 0=256K, 1=1M)
		and	edx, not BIT 28		; remove bit 28 from new value
		or	edx, eax		; combine
		mov	h_ccfg[ebp], edx	; update memory copy
		mov	ebx, 10000000h
		mov	[ebx], edx		; write CCFG
		DELAYIO	3
		jmp	NxopRet

		mov	eax, h_eax[ebp]
; set cache on/off and return
NxCacheOnOff:	; EAX=00 off, =81h on
		; bit 7 of EAX controls bits 25 and 14-13 of CCFG
		; bit 0 of EAX controls bit 26 of CCFG
		push	eax
		mov	edx, h_ccfg[ebp]
		bt	edx, 18		; level 2 cache on?
		jnc	short loc_42D6	; no, then level 1 cache is also off
					; so no need for flush
		bt	edx, 26		; ??
		jc	short loc_42D6	; also no need for flush
		; It is currently on and we need to flush (??)
		; the 2nd level cache before switching it off
		@CALL	loc_4C44
		jmp	short loc_42E0

loc_42D6:	; initialise the cache
		; It is currently off and we prepare to switch it on
		@CALL	loc_4C20
loc_42E0:	pop	eax
		cmp	eax, 0		; on or off?
		jz	short NxCacheOff
		cmp	eax, 3		; unused value
		jz	short loc_4338

		; set cache on
		push	eax
		@CALL	SetCfg0_24
		mov	edx, h_ccfgmaster[ebp]
		pop	eax
		and	dh, 9Fh		; reset bits 14-13
		test	al, 80h
		jz	short loc_430B
		or	dh, 60h		; set bits 14-13
		sub	al, 80h
		jmp	short loc_430F

loc_430B:	btr	edx, 25
loc_430F:	and	edx, not BIT 26
		cmp	al, 1
		jz	short loc_431F
		or	edx, BIT 26
loc_431F:	jmp	NxSetCCFG

NxCacheOff:	; set cache off
		@CALL	ResetCfg0_24
		; revert to initial value for CCFG
 IF VVL
		mov	edx, 84901000h
 ELSE	; PCI
		mov	edx, 8CD01300h
 ENDIF
		jmp	NxSetCCFG

loc_4338:	; unused function 3: set h_ccfgmaster from h_ebx
		mov	ebx, h_ebx[ebp]
		mov	h_ccfgmaster[ebp], ebx
		jmp	NxopRet


; Set bit 24 of configuration register 0
SetCfg0_24:	mov	eax, h_cfg0[ebp]
		bts	eax, 24
		jmp	short Cfg0_24

; Reset bit 24 of configuration register 0
ResetCfg0_24:	mov	eax, h_cfg0[ebp]
		btr	eax, 24
Cfg0_24:	mov	h_cfg0[ebp], eax
		DELAYNOP 2
		WRCFG0	eax
		@RET


; Get OPCMSK (high 64 bits) and return
		mov	eax, h_opcmsk2[ebp]
		mov	ebx, h_opcmsk3[ebp]
		jmp	NxopRet

; Set OPCMSK (high 64 bits) and return
		mov	eax, h_eax[ebp]
		mov	ebx, h_ebx[ebp]
		mov	h_opcmsk2[ebp], eax
		mov	h_opcmsk3[ebp], ebx
		@CALL	NxWriteOPCH
 IF VVL
		@CALL	loc_4EB6
 ENDIF
		jmp	NxopRet

; write OPCMSK (high 64 bits)
; E: EBX, EAX = 64 bit OPCMSK
; V: EAX, EBX
; R:-
NxWriteOPCH:	push	ecx
		push	edx
		push	esi
		mov	ecx, 0FFAC800h	; LOPCMSK 8,0
		jmp	NxWriteOPC

		mov	ebx, h_ebx[ebp]
; write EBX to register at 1D000000h and to its memory copy and return
loc_43C0:	mov	eax, 1D000000h
		mov	[eax], ebx
		mov	[ebp+28Ch], ebx
		jmp	loc_422C

; cache on/off/state
DecNXOP1:	mov	eax, h_eax[ebp]
		and	eax, 0FFh
 IF NOT (V033S OR V033V)
		cmp	al, 0FFh	; get cache state
		jz	short NxCacheState
 ENDIF
		cmp	al, 1		; must be 0 or 1
		jg	short NxopError ; error if not
		or	al, al		; 0=off
		jz	NxCacheOnOff
		or	al, 80h		; 1=on
		jmp	NxCacheOnOff

 IF NOT (V033S OR V033V)
; get cache state
NxCacheState:	mov	ecx, h_ccfg[ebp]
		and	ecx, BIT 18
		mov	eax, h_eax[ebp]
		mov	al, 0
		or	ecx, ecx
		jz	short loc_440B
		mov	al, 1
; AL=return value, highword of EAX should be 0
loc_440B:	mov	ah, 0		; no error
		jmp	short loc_4417
 ENDIF

; return with error code 81h in AH
NxopError:	mov	eax, h_eax[ebp]
		mov	ah, 81h		; error
loc_4417:	mov	h_eax[ebp], eax
		jmp	NxopRet

 IF NOT (V033S OR V033V)
; return with AH=0 (ok)
NxopOk:		mov	eax, h_eax[ebp]
		jmp	short loc_440B
 ENDIF

DecNXOP2:	mov	eax, h_eax[ebp]
		cmp	al, 1
		jg	short NxopError
		jmp	loc_4237

DecNXOP3:	mov	edx, 1
loc_443E:	mov	eax, h_eax[ebp]
		mov	ebx, h_ebx[ebp]
 IF VPCI
		cmp	al, 0FFh
		jz	short loc_4465
 ENDIF
		cmp	al, 0Ch
		jg	short NxopError
		or	al, al
		jnz	short loc_44AF

loc_4456:	; AL=0
		mov	ebx, 40000000h
		mov	ecx, 0FFFFF000h
		jmp	loc_4204

 IF VPCI
loc_4465:	; AL=0FFh
		mov	ebx, [ebp+edx*8+224h]
		mov	ecx, [ebp+edx*8+228h]
		cmp	ebx, 40000000h
		jnz	short loc_4487
		cmp	ecx, 0FFFFF000h
		jnz	short loc_4487
		mov	al, 0
		jmp	short loc_440B

loc_4487:	mov	h_ebx[ebp], ebx
		mov	al, 1

loc_448F:	shr	ecx, 1
		or	ecx, 80000000h
		cmp	ecx, 0FFFFF800h
		jz	loc_440B
		inc	al
		cmp	al, 0Dh
		jz	loc_440B
		jmp	short loc_448F
 ENDIF

loc_44AF:	; AL=01..0Ch
		mov	cl, al
		mov	eax, 0FFFFF800h
		shl	eax, cl
		mov	ecx, eax
		mov	eax, ebx
		and	eax, ecx
		jz	NxopError
		mov	eax, 0FFFFFFFFh
		xor	eax, ecx
		and	eax, ebx
		jnz	NxopError
		cmp	ebx, 40000000h
		jnc	loc_4456
		jmp	loc_4204

DecNXOP4:	mov	edx, 2
		jmp	loc_443E

DecNXOP5:	mov	edx, 0
		jmp	NxopError	; seems to be inserted afterwards
		jmp	loc_443E	; this is original jump

DecNXOP6:
 IF VPCI
		mov	eax, h_eax[ebp]
		cmp	al, 0FFh
		jz	short loc_4549
 ENDIF
		mov	ebx, h_ebx[ebp]
		and	ebx, 0FFE00000h
 IF VVL
		jmp	loc_43C0
 ELSE	; VPCI
		bt	ebx, 21
		jnc	loc_43C0
		mov	ecx, ebx
		and	ebx, 0FFC00000h
		add	ebx, 400000h
		mov	eax, 1D000000h
		mov	[eax], ebx
		mov	[ebp+28Ch], ebx
		mov	edx, 0
		mov	ebx, ecx
		mov	ecx, 0FFE00000h
		jmp	loc_4204

loc_4549:	; AL=0FFh
		mov	ebx, [ebp+28Ch]
		mov	h_ebx[ebp], ebx
		jmp	loc_440B
 ENDIF

DecNXOP7:	mov	edx, 3
		mov	eax, h_eax[ebp]
 IF VPCI
		cmp	al, 0FFh
		jz	short loc_4587
 ENDIF
		cmp	al, 1
		jg	NxopError
		mov	ebx, 8C00h
		or	al, al
		jz	short loc_457D
		and	bh, 0F0h
loc_457D:	mov	ecx, 0FFFFE000h
		jmp	loc_4204

 IF VPCI
loc_4587:	mov	al, 0
		mov	ebx, [ebp+edx*8+224h]
		cmp	bh, 8Ch
		jz	loc_440B
		mov	al, 1
		jmp	loc_440B
 ENDIF

DecNXOP8:
 IF VPCI
		mov	eax, h_eax[ebp]
		cmp	al, 0FFh
		jz	short loc_45D3
 ENDIF
		mov	ebx, h_ebx[ebp]
		mov	ecx, h_ecx[ebp]
		test	bh, 10h
		jz	short loc_45BE
		or	bh, 0F0h	; 1xxx -> Fxxx
loc_45BE:	test	ch, 10h
		jz	short loc_45C6
		or	ch, 0F0h	; 1xxx -> Fxxx
loc_45C6:	or	ecx, ebx
		shl	ecx, 16
		shl	ebx, 16
		jmp	loc_41D6

 IF VPCI
loc_45D3:	mov	ebx, [ebp+294h]
		mov	ecx, [ebp+290h]
		shr	ecx, 16
		shr	ebx, 16
		and	ecx, 1FFFh
		and	ebx, 1FFFh
		mov	h_ebx[ebp], ebx
		mov	h_ecx[ebp], ecx
		jmp	loc_440B
 ENDIF

; check hypercode checksum
DecNXOP9:	mov	esi, h_base[ebp]
		cmp	word ptr [esi+12h], -1+FORCEBIG
		jz	NxopRet		; no error if no checksum available
		mov	ecx, 400h	; check area 0000h-07FFh
		xor	edx, edx
loc_4618:	lodsw
		add	dx, ax		; arithmetic sum of words
		loop	loc_4618
		add	esi, 1000h	; check area 1800h-end
		mov	ecx, h_endhyp[ebp]
		sub	ecx, 1800h
		shr	ecx, 1
loc_4633:	lodsw
		add	dx, ax
		loop	loc_4633
		or	dx, dx		; the sum should be 0
		jz	NxopRet
loc_4643:	mov	eax, h_eax[ebp]
		mov	ah, 83h		; error
		mov	h_eax[ebp], eax
		jmp	NxopRet

; test 2nd level cache memory
loc_4656:	bt	h_dbflag[ebp], 19	; cache size
		mov	ebx, 10000h		; 1 M
		jc	short loc_4667
		mov	ebx, 4000h		; 256 K
loc_4667:	clc
		cld
		xor	ecx, ecx
		mov	esi, 0
		mov	edx, 1
		@CALL	loc_46C0
		mov	esi, 55555555h
		mov	dl, 0
		@CALL	loc_46C0
		not	esi
		@CALL	loc_46C0
		mov	esi, 0FFFFFFFFh
		@CALL	loc_46C0
		not	esi
		@CALL	loc_46C0
		or	ecx, ecx
		jnz	short loc_4643
		jmp	NxopRet

; subroutine level 2 cache test
; EBX=count, ECX=error flag, EDX=pattern increment, ESI=test pattern
; special treatment for bank 3: contains hypercode plus tags
; on stack size 256K almost all of bank 3 is in use, on 1M the upper 64K is used
; First, fill with test pattern
loc_46C0:	or	ecx, ecx		; error?
		jnz	loc_4757		; then skip this test
		mov	edi, 60000000h		; level 2 cache base
		mov	eax, esi		; test pattern
loc_46CF:	mov	ecx, ebx		; count
loc_46D1:	stosd
		add	eax, edx		; pattern increment
		loop	loc_46D1
		add	edi, 400000h		; next bank
		and	edi, 0FFC00000h
		cmp	edi, 60C00000h		; bank 3 reached?
		jnz	short loc_46CF		; no, continue
		cmp	ebx, 4000h		; is cache size 256K?
		jz	short loc_46FF		; yes, don't test bank 3
		mov	ecx, ebx		; test bank 3, but leave out
		sub	ecx, 4000h		; uppermost 64K
loc_46FA:	stosd
		add	eax, edx
		loop	loc_46FA
; Then, check if pattern reads ok
loc_46FF:	mov	edi, 60000000h		; level 2 cache base
		mov	eax, esi		; test pattern
loc_4706:	mov	ecx, ebx		; count
loc_4708:	scasd
		jnz	short loc_4740
		add	eax, edx		; pattern increment
		loop	loc_4708
		add	edi, 400000h		; next bank
		and	edi, 0FFC00000h
		cmp	edi, 60C00000h		; bank 3 reached?
		jnz	short loc_4706		; no, continue
		cmp	ebx, 4000h		; is cache size 256K?
		jz	short loc_473A		; yes, don't test bank 3
		mov	ecx, ebx		; test bank 3, but leave out
		sub	ecx, 4000h		; uppermost 64K
loc_4733:	scasd
		jnz	short loc_4740
		add	eax, edx
		loop	loc_4733
loc_473A:	@RET

; level 2 cache test failed, tell user error location
loc_4740:	sub	edi, 4			; roll back address
		mov	h_ebx[ebp], eax		; pattern
		mov	h_edi[ebp], edi		; tested address
		mov	eax, [edi]		; faulty cache content
		mov	h_ecx[ebp], eax
loc_4757:	@RET

; Set lowword h_mode (e.g. for alternate instruction set on/off bit 7)
DecNXOP11:	mov	ax, word ptr h_ecx[ebp]
		mov	word ptr h_mode[ebp], ax
		jmp	NxopRet

; Get h_mode
DecNXOP12:	mov	eax, h_mode[ebp]
		mov	h_ecx[ebp], eax
		jmp	NxopRet

; Read CMOS value
DecNXOP13:	mov	ecx, h_ecx[ebp]
		mov	al, cl
		out	P_CMOSADR, al	; CMOS Memory
		DELAYJMP 2
		in	al, P_CMOSVAL	; CMOS Memory
		or	ch, al
		mov	h_ecx[ebp], ecx
		jmp	NxopRet

; test 1st and 2nd level caches
DecNXOP10:	cld
		mov	eax, h_mode[ebp]
		and	eax, 0FFFFh	; clear error flag
		mov	h_mode[ebp], eax
		clc
		mov	esi, offset dloc_49D5-10h	; table of test areas
		add	esi, h_base[ebp]
loc_47B9:	; walk table of test areas
		add	esi, 10h
		cmp	dword ptr [esi], 0FFFFFFFFh	; end of table reached?
		jz	short loc_47D6		; yes, done
		jmp	short loc_47F4

loc_47C3:	; test of one area done, carry contains success
		jnc	short loc_47B9		; no error, do next area
		mov	eax, h_mode[ebp]	; set error flag
		or	eax, 0FFFF0000h
		mov	h_mode[ebp], eax
loc_47D6:	; table done
		mov	ax, word ptr h_mode+2[ebp]
		mov	word ptr h_edx[ebp], ax	; DX = counter/error flag
		mov	ah, al
		cmp	ah, 64h		; did 1st level cache test succeed?
		jbe	loc_4656	; yes, goto 2nd level cache test
		jmp	loc_4992	; fatal

loc_47F4:	; test one area
		clc
		mov	edi, offset dloc_4A19-4	; table of test patterns
		add	edi, h_base[ebp]
loc_47FD:	; walk table of test patterns
		add	edi, 4
		cmp	dword ptr [edi], 0FFFFFFFFh	; end of table reached?
		jz	short loc_4815		; yes, done
		@CALL	loc_4899
		jc	short loc_4813		; jmp if error
		jmp	short loc_47FD		; do next test pattern

loc_4813:	; test failed
		jmp	short loc_47C3

loc_4815:	mov	edx, [esi]
		mov	ebx, [edi-4]
		mov	eax, [esi+8]
loc_481D:	mov	ecx, [esi+4]
loc_4820:	cmp	[edx], ebx
		jz	short loc_4831
		@CALL	loc_4949
		mov	eax, [esi+8]
loc_4831:	not	ebx
		mov	[edx], ebx
		not	ebx
		add	edx, eax
		loop	loc_4820
		add	edx, 400000h
		and	edx, 0FFC00000h
		bt	edx, 24
		jnc	short loc_481D
		clc
		not	ebx
		mov	edx, [esi]
loc_4852:	mov	ecx, [esi+4]
loc_4855:	cmp	[edx], ebx
		jz	short loc_4866
		@CALL	loc_4949
		mov	eax, [esi+8]
loc_4866:	add	edx, eax
		loop	loc_4855
		add	edx, 400000h
		and	edx, 0FFC00000h
		bt	edx, 24
		jnc	short loc_4852
		clc
		bt	edx, 25
		jnc	loc_47C3
		clc
		xor	ebx, ebx
		@CALL	loc_49AC
		jmp	loc_47C3

; Compare test pattern
; ESI points to an entry in table dloc_49D5
; EDI points to an entry in table dloc_4A19
loc_4899:	@CALL	loc_49AA
		mov	eax, [esi+8]	; increment
loc_48A6:	mov	edx, [esi]	; start address
loc_48A8:	mov	ecx, [esi+4]	; count
loc_48AB:	cmp	[edx], ebx	; test pattern
		jz	short loc_48BC
		@CALL	loc_4949
		mov	eax, [esi+8]
loc_48BC:	not	ebx
		mov	[edx], ebx
		cmp	[edx], ebx
		jz	short loc_48D1
		@CALL	loc_4949
		mov	eax, [esi+8]
loc_48D1:	not	ebx
		add	edx, eax
		loop	loc_48AB
		add	edx, 400000h
		and	edx, 0FFC00000h
		bt	edx, 24
		jnc	short loc_48A8
		clc
		cmp	ebx, [edi]
		jnz	short loc_48F2
		not	ebx
		jmp	short loc_48A6

loc_48F2:	not	ebx
loc_48F4:	mov	edx, [esi]
loc_48F6:	add	edx, [esi+0Ch]
		mov	ecx, [esi+4]
loc_48FC:	sub	edx, eax
		cmp	[edx], ebx
		jz	short loc_490F
		@CALL	loc_4949
		mov	eax, [esi+8]
loc_490F:	not	ebx
		mov	[edx], ebx
		cmp	[edx], ebx
		jz	short loc_4924
		@CALL	loc_4949
		mov	eax, [esi+8]
loc_4924:	not	ebx
		loop	loc_48FC
		add	edx, 400000h
		and	edx, 0FFC00000h
		bt	edx, 24
		jnc	short loc_48F6
		clc
		cmp	ebx, [edi]
		jnz	short loc_4943
		not	ebx
		jmp	short loc_48F4

loc_4943:	@RET

loc_4949:	push	edx
		and	edx, 0FFFFFFE0h
		bt	edx, 25
		jc	short loc_498E
 IF VPCI
		jmp	short loc_498E
 ENDIF
		or	edx, 2000000h
		bt	dword ptr [edx], 30
		jc	short loc_4986
		or	dword ptr [edx], 0FFFFFFFFh
		xor	edx, 0C00000h
		bt	dword ptr [edx], 30
		jc	short loc_498E
		xor	edx, 0C00000h
		bt	dword ptr [edx], 30
		jnc	short loc_498E
		add	h_mode[ebp], 10000h
loc_4986:	pop	edx
		clc
		@RET

loc_498E:	pop	eax
		pop	eax
		mov	ah, 0FFh
loc_4992:	; Fatal error: let error message
		; (in AH) flash on diagnostic port
		mov	ecx, 800000h
		loop	$
		DIAG	ah
		mov	ecx, 800000h
		loop	$
		DIAG	0CAh		; CAche error
		jmp	short loc_4992	; forever


; Write test pattern
; ESI points to an entry in table dloc_49D5
; EDI points to an entry in table dloc_4A19
loc_49AA:	mov	ebx, [edi]	; test pattern
loc_49AC:	mov	edx, [esi]	; start address
		mov	eax, [esi+8]	; increment
loc_49B1:	mov	ecx, [esi+4]	; counter
loc_49B4:	DELAYJMP
		mov	[edx], ebx	; write test pattern
		add	edx, eax	; increment address
		loop	loc_49B4
		add	edx, 400000h	; repeat for each cache bank
loc_49C2:	and	edx, 0FFC00000h
		bt	edx, 24		; until 4 banks done
		jnc	short loc_49B1
		clc
		@RET


; test areas: first level cache (16K code + 16K data)
; base address, counter, increment, total (counter x increment)
dloc_49D5	dd 42000000h,  80h, 20h, 1000h	; tags
		dd 52000000h,  80h, 20h, 1000h	; tags
		dd 40000000h, 400h,  4h, 1000h	; array
		dd 50000000h, 400h,  4h, 1000h	; array
		dd 0FFFFFFFFh		; terminator

; test patterns
dloc_4A19	dd 00000000h, 55555555h
		dd 33333333h, 0F0F0F0Fh
		dd 00FF00FFh, 0000FFFFh
		dd 0FFFFFFFFh		; terminator


; #UD invalid instruction
InstrUnsupp2:	jmp	InstrUnsupp

 IF VPCI
; user's AL =0: reset bit 4 of OPCMSK
; user's AL<>0: set bit 4 of OPCMSK
		mov	ecx, h_eax[ebp]
		xor	ch, ch
		mov	h_eax[ebp], ecx
		or	cl, cl
		jz	short loc_4A4E
		mov	ch, 8
loc_4A4E:	mov	eax, h_opcmsk0[ebp]
		and	al, 0F7h
		or	al, ch
		mov	ebx, h_opcmsk1[ebp]
		jmp	loc_4135
 ENDIF

 IF NOT (V033S OR V033V)
; miscellaneous small functions
DecNXOP14:	mov	eax, h_eax[ebp]
		cmp	al, 0
		jnz	short NXOP14_1

		; 14/0 - get CFG0, CFG1, ?, CCFG
		mov	eax, h_cfg0[ebp]
		mov	h_ebx[ebp], eax
		mov	eax, h_cfg1[ebp]
		mov	h_ecx[ebp], eax
		mov	eax, h_fcfg[ebp]
		mov	h_edx[ebp], eax
		mov	eax, h_ccfg[ebp]
		mov	h_edi[ebp], eax
		jmp	NxopOk

NXOP14_1:	cmp	al, 1
		jnz	short NXOP14_2

		; 14/1 - get OPCMSK
		mov	eax, h_opcmsk0[ebp]
		mov	h_ebx[ebp], eax
		mov	eax, h_opcmsk1[ebp]
		mov	h_ecx[ebp], eax
		mov	eax, h_opcmsk2[ebp]
		mov	h_edx[ebp], eax
		mov	eax, h_opcmsk3[ebp]
		mov	h_edi[ebp], eax
		jmp	NxopOk

NXOP14_2:	cmp	al, 2
   IF NOT V034I
		jnz	short NXOP14_3
   ELSE
		jnz	short NXOP14_x
   ENDIF

		; 14/2 - get [EBP+250h] ff
		mov	ebx, 0FFFF1650h
		mov	edx, [ebx]
		mov	h_ebx[ebp], edx
		mov	ebx, 0FFFF1654h
		mov	edx, [ebx]
		mov	h_ecx[ebp], edx
		mov	ebx, 0FFFF1658h
		mov	edx, [ebx]
		mov	h_edx[ebp], edx
		mov	ebx, 0FFFF165Ch
		mov	edx, [ebx]
		mov	h_edi[ebp], edx
		jmp	NxopOk

  IF NOT V034I
NXOP14_3:	cmp	al, 3
		jnz	short NXOP14_4

		; 14/3 - ID and 486 mode on
		or	byte ptr h_mode[ebp], BIT 7 ; 486 instructions enable
		lea	edi, [ebp+2D0h]
		mov	byte ptr [edi+1Bh], 6	; write into code loc_16D0
		mov	ecx, BIT 17 or BIT 18
NXOP14_34:	mov	eax, h_opcmsk0[ebp]
		and	eax, not (BIT 17 or BIT 18)
		; bits 17 controls POPF, bit 18 controls PUSHF emulation
		or	eax, ecx		; add new bits 17, 18
		mov	h_opcmsk0[ebp], eax
		@CALL	loc_16D0
		jmp	NxopOk

NXOP14_4:	cmp	al, 4
   IF VVL
		jnz	short NXOP14_5
   ELSE
		jnz	short NXOP14_x
   ENDIF

		; 14/4 - ID and 486 mode off
		and	byte ptr h_mode[ebp], not BIT 7 ; 486 instructions disable
		lea	edi, [ebp+2D0h]
		mov	byte ptr [edi+1Bh], 0	; write into code loc_16D0
		xor	ecx, ecx		; clear bits 17, 18
		jmp	short NXOP14_34

   IF VVL
NXOP14_5:	cmp	al, 5
		jnz	short NXOP14_x
		; 14/5 - "game assistant" (minor conflict with implementing DOS extenders)
		mov	ecx, h_ecx[ebp]
		mov	eax, h_eax[ebp]
		xor	ah, ah			; no error yet
		mov	h_eax[ebp], eax
		xor	ch, ch
		or	cl, cl			; 1=on, 0=off
		jz	short loc_4EA2
		mov	ch, BIT 3
loc_4EA2:	mov	eax, h_opcmsk0[ebp]
		and	al, not BIT 3
		; bit 3 controls MOV reg/mem to/from segreg emulation
		or	al, ch
		mov	ebx, h_opcmsk1[ebp]
		jmp	loc_4135
   ENDIF
  ENDIF

NXOP14_x:	jmp	NxopError
 ENDIF

 IF VVL
; insert opcode mask into code at 16D0h
loc_4EB6:	cld	
		lea	esi, h_opcmsk0[ebp]
		lea	edi, [ebp+2D0h+13h]	;<-- see HYPRES.ASM
		@CALL	loc_4EFD
		lea	esi, h_opcmsk1[ebp]
		@CALL	loc_4EFD
		lea	esi, h_opcmsk2[ebp]
		@CALL	loc_4EFD
		lea	esi, h_opcmsk3[ebp]
		@CALL	loc_4EFD
		@RET

; insert dword as 4 bytes into code at 16D0h
loc_4EFD:	mov	ecx, 4
loc_4F02:	lodsb
		mov	[edi], al
		add	edi, 4
		loop	loc_4F02
		@RET
 ENDIF

		ALIGN	256

hypseg		ends
		end

;--------------------------------------------------------------- end INVOP.ASM