;-----------------------------------------------------------------------------
; NexGen Nx586 BIOS Hypercode
;-----------------------------------------------------------------------------
; File: IOBM.ASM - 
; Date: 2020-09-24
;
; Disassembled by Dipl.-Inf. Herbert Oppmann (herby@memotech.franken.de)
;-----------------------------------------------------------------------------

		include COMMON.INC

	extrn	Exception:near
	extrn	loc_5B93:near

	public	loc_3720


		db '@(#)iobm.asm',TAB,'2.2',0
		ALIGN0	32

; Hypermode entry via offset 0C80h
loc_3720:	mov	ebp, esp
		sub	ebp, 3E4h
		push	eax
		push	ebx
		push	ecx
		push	edx
		push	esi
		push	edi
		mov	esp, ebp
		movzx	edx, dx		; clear upper 16 bits
		; set special exception handler
		mov	h_excph[ebp], offset loc_39C5
		mov	word ptr h_dbflag[ebp], 0
		mov	eax, h_eip2[ebp]

		; read instruction which caused hyper escape
		mov	ecx, 4		; loop counter
loc_374B:	; get 4 bytes into ECX
		mov	ebx, cs:[eax]
loc_374E:	; process 1 byte
		cmp	bl, 0F3h	; REP/REPE prefix
		jz	short loc_375F
		cmp	bl, 66h		; OPSIZE prefix
		jz	short loc_3765
		cmp	bl, 67h		; ADRSIZE prefix
		jz	short loc_376B
		jmp	short near ptr loc_3779 ; no prefix

loc_375F:	; REP/REPE prefix
		bts	edx, 31		; remember
		jmp	short loc_376F

loc_3765:	; OPSIZE prefix
		bts	edx, 30		; remember
		jmp	short loc_376F

loc_376B:	; ADRSIZE prefix
		bts	edx, 29		; remember

loc_376F:	; get next byte of opcode
		shr	ebx, 8
		loop	loc_374E
		add	eax, 4		; increment opcode address
		jmp	short loc_374B	; this jump destination is probably wrong:
					; it doesn't set ECX to 4 again!

loc_3779:	; no (more) prefix
		RDAR	eax, cs
		bt	edx, 30		; OPSIZE prefix seen?
		jnc	short loc_378E
		; OPSIZE prefix
		bt	eax, 22
		jnc	short loc_3798
		btr	edx, 30
		jmp	short loc_3798

loc_378E:	; no OPSIZE prefix
		bt	eax, 22
		jnc	short loc_3798
		bts	edx, 30

loc_3798:	; now EDX.30 ist operand size
		cmp	bl, 0ECh	; IN AL, DX
		jz	loc_3847
		cmp	bl, 0EEh	; OUT DX, AL
		jz	loc_3928
		cmp	bl, 0E4h	; IN AL, Ib
		jz	short loc_37FC
		cmp	bl, 0E6h	; OUT Ib, AL
		jz	loc_38DD
		cmp	bl, 0E5h	; IN eAX, Ib
		jz	short loc_3813
		cmp	bl, 6Eh		; OUTSB DX, Xb
		jz	loc_396A
		cmp	bl, 0EDh	; IN eAX, DX
		jz	loc_385E
		cmp	bl, 6Ch		; INSB Yb, DX
		jz	loc_3892
		cmp	bl, 6Dh		; INSW/D Yv, DX
		jz	loc_38A9
		cmp	bl, 0E7h	; OUT Ib, eAX
		jz	loc_38F4
		cmp	bl, 0EFh	; OUT DX, eAX
		jz	loc_393C
		cmp	bl, 6Fh		; OUTSW/D DX, Xv
		jz	loc_397E
		; we shouldn't come here!

loc_37FC:	; IN AL, Ib
		movzx	edx, bh		; get port address
		mov	ecx, 1		; size of access
		@CALL	loc_39D3
		jmp	loc_39AC

loc_3813:	; IN eAX, Ib
		bt	edx, 30		; 32 bit operand size?
		jc	short loc_3830
		; IN AX, Ib
		movzx	edx, bh		; get port address
		mov	ecx, 2		; size of access
		@CALL	loc_39D3
		jmp	loc_39AC

loc_3830:	; IN EAX, Ib
		movzx	edx, bh		; get port address
		mov	ecx, 4		; size of access
		@CALL	loc_39D3
		jmp	loc_39AC

loc_3847:	; IN AL, DX
		movzx	edx, dx		; get port address
		mov	ecx, 1		; size of access
		@CALL	loc_39D3
		jmp	loc_39AC

loc_385E:	; IN eAX, DX
		bt	edx, 30		; 32 bit operand size?
		jc	short loc_387B
		; IN AX, DX
		movzx	edx, dx		; get port address
		mov	ecx, 2		; size of access
		@CALL	loc_39D3
		jmp	loc_39AC

loc_387B:	; IN EAX, DX
		movzx	edx, dx		; get port address
		mov	ecx, 4		; size of access
		@CALL	loc_39D3
		jmp	loc_39AC

loc_3892:	; INSB Yb, DX
		movzx	edx, dx		; get port address
		mov	ecx, 1		; size of access
		@CALL	loc_39D3
		jmp	loc_39AC

loc_38A9:	; INSW/D Yv, DX
		bt	edx, 30		; 32 bit operand size?
		jc	short loc_38C6
		; INSW Yv, DX
		movzx	edx, dx		; get port address
		mov	ecx, 2		; size of access
		@CALL	loc_39D3
		jmp	loc_39AC

loc_38C6:	; INSD Yv, DX
		movzx	edx, dx		; get port address
		mov	ecx, 4		; size of access
		@CALL	loc_39D3
		jmp	loc_39AC

loc_38DD:	; OUT Ib, AL
		movzx	edx, bh		; get port address
		mov	ecx, 1		; size of access
		@CALL	loc_39D3
		jmp	loc_39AC

loc_38F4:	; OUT Ib, eAX
		bt	edx, 30		; 32 bit operand size?
		jc	short loc_3911
		; OUT Ib, AX
		movzx	edx, bh		; get port address
		mov	ecx, 2		; size of access
		@CALL	loc_39D3
		jmp	loc_39AC

loc_3911:	; OUT Ib, EAX
		movzx	edx, bh		; get port address
		mov	ecx, 4		; size of access
		@CALL	loc_39D3
		jmp	loc_39AC

loc_3928:	; OUT DX, AL
		movzx	edx, dx		; get port address
		mov	ecx, 1		; size of access
		@CALL	loc_39D3
		jmp	short loc_39AC

loc_393C:	; OUT DX, eAX
		bt	edx, 30		; 32 bit operand size?
		jc	short loc_3956
		; OUT DX, AX
		movzx	edx, dx		; get port address
		mov	ecx, 2		; size of access
		@CALL	loc_39D3
		jmp	short loc_39AC

loc_3956:	; OUT DX, EAX
		movzx	edx, dx		; get port address
		mov	ecx, 4		; size of access
		@CALL	loc_39D3
		jmp	short loc_39AC

loc_396A:	; OUTSB DX, Xb
		movzx	edx, dx		; get port address
		mov	ecx, 1		; size of access
		@CALL	loc_39D3
		jmp	short loc_39AC

loc_397E:	; OUTSW/D DX, Xv
		bt	edx, 30		; 32 bit operand size?
		jc	short loc_3998
		; OUTSW DX, Xv
		movzx	edx, dx		; get port address
		mov	ecx, 2		; size of access
		@CALL	loc_39D3
		jmp	short loc_39AC

loc_3998:	; OUTSD DX, Xv
		movzx	edx, dx		; get port address
		mov	ecx, 4		; size of access
		@CALL	loc_39D3
		jmp	short loc_39AC	; not necessary


loc_39AC:	; permission is granted, do the IO access
		bts	dword ptr h_efl[ebp], 30	; set EFL.30 wow!!
		; does this suppress checking IO BM for the next instruction?
		mov	eax, h_eip2[ebp]
		mov	h_eip3[ebp], eax
		jmp	loc_5B93	; return to mortal mode


; special exception handler for IO bit mask
loc_39C5:	mov	eax, [esp+10h]	; same as ebp+10h??
		OP_0FE4
		WRCPL	eax
		jmp	Exception


; Subroutine check IO access against IO bit map
; E: EDX = port address
;    ECX = size of access
; R: no return if check failed (exception)
loc_39D3:	RDCPL	eax
		and	eax, 3
		push	eax
		RDAR	eax, tr
		bt	eax, 27
		jnc	short loc_3A21
		; set CPL to 0 temporarily
		mov	eax, 0
		OP_0FE4
		WRCPL	eax
		; bank 1
		mov	eax, 1
		WRSBNK	eax
		movzx	edi, word ptr fs:66h	; Task-State Segment, I/O Map Base Address
		; Contains a 16-bit offset from the base of the TSS to the
		; I/O permission bit map and interrupt redirection bitmap.
		mov	eax, edx
		shr	eax, 3			; calculate byte offset
		mov	ebx, edx
		and	ebx, 7			; bit offset
		movzx	esi, word ptr fs:[edi+eax] ; get two permission bytes
		; must be ok because Intel mandates one additional byte with
		; all bits set after last mapped I/O permission
loc_3A0B:	OP_0FE4
		bt	esi, ebx		; I/O access allowed?
		jc	short loc_3A21		; no -> exception
		inc	ebx			; next bit
		loop	near ptr loc_3A0B	; until all port addresses done
		; restore CPL
		pop	eax
		OP_0FE4
		WRCPL	eax
		@RET

loc_3A21:	; check failed, cause Exception General Protection
		; restore CPL
		pop	eax
		OP_0FE4
		WRCPL	eax
		; ??
		mov	dword ptr h_gatflag[ebp], 0D0000h
		mov	eax, h_eip2[ebp]
		mov	h_eip3[ebp], eax
		or	byte ptr h_efl+2[ebp], 1 ; RF (resume flag)
		btr	h_dbflag[ebp], 17	; do not generate #DB on exit
		lea	esp, h_edi[ebp]
		pop	edi
		pop	esi
		pop	edx
		pop	ecx
		pop	ebx
		pop	eax
		pop	ebp
		add	esp, 4
		INTH	EXCP_GENPROT

		ALIGN	256

hypseg		ends
		end

;---------------------------------------------------------------- end IOBM.ASM