;-----------------------------------------------------------------------------
; NexGen Nx586 BIOS Hypercode
;-----------------------------------------------------------------------------
; File: IO_EM.ASM - 
; Date: 2020-09-21
;
; Disassembled by Dipl.-Inf. Herbert Oppmann (herby@memotech.franken.de)
;-----------------------------------------------------------------------------

		include COMMON.INC

	extrn	Exception:near
	extrn	ForceExec:near
	extrn	loc_7A0F:near

	public	DecOUTib
	public	DecOUTdb
	public	DecOUTiw
	public	DecOUTdw


 IF VVL OR V034I
		db '@(#)io_em.asm',TAB,'2.5',0
 ELSE
		db '@(#)io_em.asm',TAB,'3.8',0
 ENDIF
		ALIGN0	32

DecOUTib:	inc	byte ptr h_opflag[ebp]	; length of opcode
		movzx	edx, byte ptr cs:[esi]	; get out address
 IF V033V OR V034I OR V034N
loc_n6627:	cmp	dl, 40h
  IF V033V
		jnz	ForceExec
  ELSE
		jnz	short loc_662F
  ENDIF
		mov	al, 71h
		out	70h, al
		jmp	short loc_n6632

loc_n6632:	in	al, 71h
		mov	ah, al
		mov	al, 70h
		out	70h, al
		jmp	short loc_n663C

loc_n663C:	in	al, 71h
		out	40h, al
		mov	al, ah
		out	40h, al
		jmp	loc_7A0F
 ENDIF
		jmp	short loc_662F

DecOUTdb:	mov	edx, h_edx[ebp]
 IF V033V OR V034I OR V034N
		jmp	short loc_n6627
 ENDIF
loc_662F:	cmp	dl, 0F1h
		jz	short loc_6660
		cmp	dl, 0F0h
 IF VVL OR V034I
		jz	short loc_66CF
 ELSE
		jz	loc_66CF
 ENDIF
		jmp	ForceExec

DecOUTiw:	inc	byte ptr h_opflag[ebp]	; length of opcode
		movzx	edx, byte ptr cs:[esi]	; get out address
		jmp	short loc_6651

DecOUTdw:	mov	edx, h_edx[ebp]
loc_6651:	cmp	dl, 0F1h
		jz	short loc_6660
		cmp	dl, 0F0h
		jz	short loc_66CF
		jmp	ForceExec

 IF VVL
loc_6660:	jmp	short loc_7360

loc_66CF:	jmp	short loc_7376

loc_7360:	fninit
		mov	dword ptr [ebp-20h], 37Eh
		fldcw	word ptr [ebp-20h]
		mov	dword ptr [ebp-1Ch], 8081h
		FNLDSW	[ebp-1Ch]
loc_7376:	mov	eax, h_fcfg[ebp]
		and	eax, 0FFFFFFF7h
		mov	h_fcfg[ebp], eax
		or	eax, 200h
		mov	[ebp-4], eax
		DELAYNOP 2
		FWRCFG	[ebp-4]
		and	eax, 0FFFFFDFFh
		mov	[ebp-4], eax
		FWRCFG	[ebp-4]
		jmp	loc_7A0F
 ELSE
; out byte or word to 0F1h
loc_6660:
  IF NOT V034I
		mov	eax, cr0
		mov	[ebp+344h], eax
		and	eax, 0FFFFFFF3h		; clear TS, EM
		or	eax, 2			; set monitor coprocessor MP
		mov	cr0, eax
  ENDIF
		bt	h_fcfg[ebp], 15
		jnc	short loc_66BD
		btr	h_fcfg[ebp], 16
		DELAYNOP 2
		FWRCFG	h_fcfg[ebp]
		fninit
		bts	h_fcfg[ebp], 0
		bts	h_fcfg[ebp], 17
		DELAYNOP 2
		FWRCFG	h_fcfg[ebp]
		btr	h_fcfg[ebp], 0
		btr	h_fcfg[ebp], 17
		FWRCFG	h_fcfg[ebp]
loc_66BD:
  IF V034I
 		push	eax
  ENDIF
		xor	al, al
		out	0F1h, al
  IF V034I
 		pop	eax
  ELSE
		mov	eax, [ebp+344h]
		mov	cr0, eax
  ENDIF
		jmp	loc_7A0F

; out byte or word to 0F0h
loc_66CF:
  IF NOT V034I
		mov	eax, cr0
		mov	[ebp+344h], eax
		and	eax, 0FFFFFFF3h
		or	eax, 2
		mov	cr0, eax
  ENDIF
		bt	h_fcfg[ebp], 15
		jnc	short loc_6715
		btr	h_fcfg[ebp], 16
		fstsw	word ptr [esp-4]
		mov	ax, [esp-4]
		bt	eax, 7
		jnc	short loc_6702
		bts	h_fcfg[ebp], 18
loc_6702:	DELAYNOP 2
		FWRCFG	h_fcfg[ebp]
loc_6715:
  IF V034I
 		push	eax
  ENDIF
		xor	al, al
		out	0F0h, al
  IF V034I
 		pop	eax
  ELSE
		mov	eax, [ebp+344h]
		mov	cr0, eax
  ENDIF
		jmp	loc_7A0F
 ENDIF

		jmp	Exception

		ALIGN	256

hypseg		ends
		end

;--------------------------------------------------------------- end IO_EM.ASM