;-----------------------------------------------------------------------------
; NexGen Nx586 BIOS Hypercode
;-----------------------------------------------------------------------------
; File: IRET.ASM - 
; Date: 2004-09-11
;
; Disassembled by Dipl.-Inf. Herbert Oppmann (herby@memotech.franken.de)
;-----------------------------------------------------------------------------

		include COMMON.INC

	extrn	loc_1840:near
	extrn	Exception:near
	extrn	ExcpDebugExcp:near

	public	loc_1D20


 IF V033S
		db '@(#)iret.asm',TAB,'3.2',0
 ELSEIF V033V OR V033W
		db '@(#)iret    ',0
 ELSE	; PCI
		db '@(#)iret.asm',TAB,'3.3',0
 ENDIF
		ALIGN0	32

; Hypermode entry via offset 0B80h
loc_1D20:				; DATA XREF: 0B81
		mov	ebp, esp
		sub	ebp, 3E4h
		push	eax
		push	ebx
		push	ecx
		push	edx
		push	esi
		push	edi
		mov	esp, ebp
 IF V033W
		push	edi
 ENDIF
		mov	eax, offset loc_1EBA
		mov	h_excph[ebp], eax
		xor	edx, edx
		mov	word ptr h_dbflag[ebp], dx
		and	dword ptr h_gatflag[ebp], 80000000h
		mov	edi, h_gatflag[ebp]
		bt	edi, 31
		jnc	short loc_1D7D
		mov	esi, h_esp[ebp]
		RDAR	eax, ss
		bt	eax, 22
		jc	short loc_1D69
		and	esi, 0FFFFh

loc_1D69:				; CODE XREF: 1D61
		mov	eax, ss:[esi+8]
		bt	eax, 17
		jnc	short loc_1D84
		RDCPL	edi
		and	edi, 3
		jz	short loc_1D94
		jmp	short loc_1D84

loc_1D7D:				; CODE XREF: 1D52
		mov	edi, 40000002h
		jmp	short loc_1D89

loc_1D84:				; CODE XREF: 1D71, 1D7B
		mov	edi, 0C0000004h

loc_1D89:				; CODE XREF: 1D82
		mov	h_gatflag[ebp], edi
		jmp	loc_1840

loc_1D94:				; CODE XREF: 1D79
		mov	esi, h_esp[ebp]
		RDAR	eax, ss
		bt	eax, 22
		jc	short loc_1DA9
		and	esi, 0FFFFh

loc_1DA9:				; CODE XREF: 1DA1
		movzx	ebx, word ptr ss:[esi]
		mov	edi, ss:[esi+4]
		mov	eax, ss:[esi+8]
		mov	ecx, ss:[esi+0Ch]
		mov	edi, ss:[esi+10h]
		mov	edi, ss:[esi+14h]
		mov	edi, ss:[esi+18h]
		mov	edi, ss:[esi+1Ch]
		mov	edi, ss:[esi+20h]
		bts	eax, 31
		mov	h_efl[ebp], eax
		mov	h_eip3[ebp], ebx
		mov	h_esp[ebp], ecx
		movzx	eax, word ptr ss:[esi+4]
		WRSEL	cs, eax
		shl	eax, 4
		WRB	cs, eax
		mov	eax, 0FB00FFFFh
		WRAR	cs, eax
		movzx	eax, word ptr ss:[esi+18h]
		WRSEL	ds, eax
		shl	eax, 4
		WRB	ds, eax
		mov	eax, 0F300FFFFh
		WRAR	ds, eax
		movzx	eax, word ptr ss:[esi+14h]
		WRSEL	es, eax
		shl	eax, 4
		WRB	es, eax
		mov	eax, 0F300FFFFh
		WRAR	es, eax
		movzx	eax, word ptr ss:[esi+1Ch]
		WRSEL	fs, eax
		shl	eax, 4
		WRB	fs, eax
		mov	eax, 0F300FFFFh
		WRAR	fs, eax
		movzx	eax, word ptr ss:[esi+20h]
		WRSEL	gs, eax
		shl	eax, 4
		WRB	gs, eax
		mov	eax, 0F300FFFFh
		WRAR	gs, eax
		movzx	eax, word ptr ss:[esi+10h]
		WRSEL	ss, eax
		shl	eax, 4
		WRB	ss, eax
		mov	eax, 0F300FFFFh
		WRAR	ss, eax
		mov	eax, 3
		WRCPL	eax
		mov	ebx, h_eip3[ebp]
		mov	h_eip2[ebp], ebx
		mov	ecx, dr7
 IF NOT V033S
		bts	word ptr h_dbflag[ebp], 2
		mov	h_dr7[ebp], ecx
 ENDIF
		xor	eax, eax
		mov	dr7, eax
		mov	eax, cs:[ebx]
		mov	dr7, ecx
 IF NOT V033S
		btr	word ptr h_dbflag[ebp], 2
 ENDIF
		bt	h_dbflag[ebp], 17
		jc	ExcpDebugExcp
		lea	esp, h_edi[ebp]
		pop	edi
		pop	esi
		pop	edx
		pop	ecx
		pop	ebx
		pop	eax
		pop	ebp
		add	esp, 8
		OP_0FE4
		RETH

loc_1EBA:				; DATA XREF: 1D30
		jmp	Exception

		ALIGN	256

hypseg		ends
		end

;---------------------------------------------------------------- end IRET.ASM