;-----------------------------------------------------------------------------
; NexGen Nx586 BIOS Hypercode
;-----------------------------------------------------------------------------
; File: MOVCR.ASM - 
; Date: 2020-09-24
;
; Disassembled by Dipl.-Inf. Herbert Oppmann (herby@memotech.franken.de)
;-----------------------------------------------------------------------------

		include COMMON.INC

	extrn	FORCEBIG:abs

	extrn	Exception:near
	extrn	loc_2AA7:near
 IF NOT V033S
	extrn	loc_3F9F:near
 ENDIF
	extrn	loc_5B59:near
	extrn	ForceExec:near
 IF V033V OR V033W
	extrn	loc_5CE4:near
 ELSE	; PCI
	extrn	GetOperand:near
 ENDIF
	extrn	WriteReg:near

 IF VVL
	public	DecMOVfromCR
	public	DecMOVtoCR
 ENDIF

 IF V033S
		db '@(#)movcr.asm',TAB,'3.1',0
 ELSEIF V033V OR V033W
		db '@(#)movcr   ',0
 ELSE
		db '@(#)movcr.asm',TAB,'3.2',0
 ENDIF
		ALIGN0	32

; Intel manual says: "The operand size for these instructions is always
; 32 bits, regardless of the operand-size attribute."

; CR2 = Page Fault Linear Address
 IF VVL
DecMOVtoCR:
 ENDIF
 IF NOT V033S
		mov	eax, h_gatflag[ebp]
		cmp	al, 3Fh
		jz	loc_3F9F
 ENDIF
		and	ecx, 38h	; take the Reg/Opcode field from the ModR/M byte
		shr	ecx, 3
		cmp	cl, 2		; only handle MOV to CR2
		jnz	ForceExec
		RDCPL	eax
		and	al, 3		; only in CPL0
		jnz	short loc_74A6
		or	byte ptr h_opflag+3[ebp], 40h ; force 32-bit operand size
 IF V033V OR V033W
		movzx	eax, byte ptr cs:[esi]
		or	eax, 0C0h
		@CALL	loc_5CE4
 ELSE	; PCI+V033S
		@CALL	GetOperand
 ENDIF
		mov	ebx, h_content[ebp]
		mov	h_cr2[ebp], ebx	; save value
 IF V033S
		jmp	loc_5B59
 ELSE
		jmp	short loc_749A
 ENDIF

 IF VVL
DecMOVfromCR:
 ENDIF
 IF NOT V033S
		mov	eax, h_gatflag[ebp]
		cmp	al, 3Fh
		jz	loc_3F9F
 ENDIF
		mov	ebx, ecx
		and	ebx, 7		; take the R/M field from the ModR/M byte
		and	ecx, 38h	; take the Reg/Opcode field from the ModR/M byte
		shr	ecx, 3
		cmp	cl, 2		; only handle MOV from CR2
		jnz	ForceExec
		RDCPL	eax
		and	al, 3		; only in CPL0
		jnz	short loc_74A6
		or	byte ptr h_opflag+3[ebp], 40h ; force 32-bit operand size
		mov	ecx, h_cr2[ebp]
		@CALL	WriteReg
 IF V033S
		inc	h_opflag[ebp]
 ELSE
loc_749A:	mov	h_opflag[ebp], 3	; set length of opcode
 ENDIF
		jmp	loc_5B59

loc_74A6:	push	EXCP_GENPROT+FORCEBIG
		push	0+FORCEBIG
		jmp	loc_2AA7

		jmp	Exception

		ALIGN0	16

hypseg		ends
		end

;--------------------------------------------------------------- end MOVCR.ASM