;-----------------------------------------------------------------------------
; NexGen Nx586 BIOS Hypercode
;-----------------------------------------------------------------------------
; File: NPHCODE.ASM - Numeric processor hypercode
; Date: 2020-09-25
;
; Disassembled by Dipl.-Inf. Herbert Oppmann (herby@memotech.franken.de)
;-----------------------------------------------------------------------------

		include COMMON.INC

	extrn	loc_2AA7:near
	extrn	loc_5320:near
	extrn	loc_532E:near
	extrn	loc_7BE0:near
	extrn	loc_80B0:near
	extrn	DecFSCALE:near
 IF VVL
	extrn	DecFSINCOS:near
	extrn	DecFCOS:near
	extrn	DecFSIN:near
	extrn	DecFPATAN:near
	extrn	DecF2XM1:near
	extrn	DecFYL2XP1:near
	extrn	DecFYL2X:near
	extrn	DecFPTAN:near
	extrn	DecFXTRACT:near
	extrn	DecFSQRT:near
 ENDIF

	public	loc_74E0
	public	loc_79D5
	public	loc_79E4
	public	loc_7A0F

 IF V033S
		db '@(#)nphcode.asm',TAB,'3.10',0
 ELSEIF V033V OR V034I
		db '@(#)nphcode ',0
 ELSEIF V033W
		db '@(#)nphcode.asm',TAB,'3.11',0
 ELSE
		db '@(#)nphcode.asm',TAB,'3.16',0
 ENDIF
		ALIGN0	32

; Hypermode entry via offset 0F00h
loc_74E0:	mov	ebp, esp
		sub	ebp, 3E4h
		push	eax
		push	ebx
		push	ecx
		push	edx
		push	esi
		push	edi
		mov	esp, ebp
		sub	esp, 98h
		mov	eax, h_gatflag[ebp]
		bt	eax, 10
 IF VVL
		jc	loc_81BD
		bt	eax, 12
		jc	loc_8238
loc_8120:
 ELSE
		jnc	short loc_7507
		jmp	loc_7BE0

loc_7507:
  IF NOT V034I
		mov	eax, cr0
		mov	[ebp+344h], eax
		and	eax, 0FFFFFFF3h	; clear TS (task switched)
					; and EM (emulation)
		or	eax, 2		; set MP (math present)
		mov	cr0, eax
  ENDIF
		fstsw	word ptr [esp-4]
		mov	ax, [esp-4]
		bt	eax, 7		; ES (error summary status)
		jc	short loc_7535
		bt	h_fcfg[ebp], 18
		jnc	short loc_7535
		btr	h_fcfg[ebp], 18

loc_7535:	bt	h_fcfg[ebp], 15
		jnc	short loc_756E
		FNUNKNOWN2 [esp-4]
		mov	ax, [esp-4]
		bt	ax, 14
		jnc	short loc_756E
		bts	h_fcfg[ebp], 16
		bts	h_fcfg[ebp], 17
		DELAYNOP 2
		FWRCFG	h_fcfg[ebp]
		btr	h_fcfg[ebp], 17

loc_756E:	DELAYNOP 2		; CODE XREF: 753A	754A
		FWRCFG	h_fcfg[ebp]
  IF NOT V034I
		mov	eax, [ebp+344h]	; saved CR0
		mov	cr0, eax
  ENDIF
		mov	eax, h_gatflag[ebp]
		bt	eax, 12
		jc	loc_79FE
		mov	esi, h_eip2[ebp]
		RDAR	eax, cs
		bts	eax, 25
		OP_0FE4
		WRAR	cs, eax
		bt	h_fcfg[ebp], 15
		jnc	short loc_7601
		bt	h_fcfg[ebp], 16
		jnc	loc_7675
		movzx	eax, byte ptr cs:[esi]
		cmp	al, 0DBh
		jnz	loc_76D7
		inc	esi
		movzx	eax, byte ptr cs:[esi]
		cmp	al, 0E2h	; FCLEX
		jz	short loc_75E0
		cmp	al, 0E3h	; FINIT
		jz	short loc_75EB
		cmp	al, 0E4h	; FSETPM
		jz	short near ptr loc_75F6
		jmp	loc_76D7

loc_75E0:	; FCLEX
		fnclex
		mov	byte ptr h_opflag[ebp], 2	; length of opcode
		jmp	loc_7A09

loc_75EB:	; FINIT
		fninit
		mov	byte ptr h_opflag[ebp], 2	; length of opcode
		jmp	loc_7A09

loc_75F6:	; FSETPM
		FNSETPM
		mov	byte ptr h_opflag[ebp], 2	; length of opcode
		jmp	loc_7A09

loc_7601:	; 
		fstsw	word ptr [esp-4]
		mov	ax, [esp-4]
		bt	eax, 7			; ES=Error Summary Status
		jnc	short loc_7675
		movzx	eax, byte ptr cs:[esi]
		inc	esi
		cmp	al, 0D9h
		jz	short loc_7628
		cmp	al, 0DBh
		jz	short loc_7638
		cmp	al, 0DDh
		jz	short loc_7652
		cmp	al, 0DFh
		jz	short loc_7662
		jnz	short loc_7675

loc_7628:	; D9
		movzx	eax, byte ptr cs:[esi]
		and	al, 38h
		cmp	al, 30h
		jz	short loc_766C
		cmp	al, 38h
		jz	short loc_766C
		jnz	short loc_7675

loc_7638:	; DB
		movzx	eax, byte ptr cs:[esi]
		cmp	al, 0E0h	; FENI
		jz	short loc_766C
		cmp	al, 0E1h	; FDISI
		jz	short loc_766C
		cmp	al, 0E2h	; FCLEX
		jz	short loc_766C
		cmp	al, 0E3h	; FINIT
		jz	short loc_766C
		cmp	al, 0E4h	; FSETPM
		jz	short loc_766C
		jnz	short loc_7675

loc_7652:	; DD
		movzx	eax, byte ptr cs:[esi]
		and	al, 38h
		cmp	al, 30h		; FSTENV
		jz	short loc_766C
		cmp	al, 38h		; FSTCW
		jz	short loc_766C
		jnz	short loc_7675

loc_7662:	; DF
		movzx	eax, byte ptr cs:[esi]
		cmp	al, 0E0h	; FSTSW AX
		jz	short loc_766C
		jnz	short loc_7675

loc_766C:	; Exception #NM Device Not Available (No Math Coprocessor)
		push	EXCP_NOMATH
		push	0
		jmp	loc_2AA7

loc_7675:
 ENDIF
		mov	eax, h_gatflag[ebp]
 IF VVL
		bt	eax, 31
		jc	loc_820A
loc_8130:
 ENDIF
		bt	eax, 8
		jc	loc_7701
 IF VPCI
		bt	eax, 9
		jc	short loc_7701
 ENDIF
		bt	eax, 7
		jc	loc_7A79
		mov	dword ptr [ebp-94h], 0
		bt	eax, 11
		jc	short loc_76A7
 IF VVL
loc_8154:	mov	byte ptr h_opflag[ebp], 0
		jmp	loc_7A09
 ELSE
		jmp	short loc_76D7
 ENDIF

loc_76A7:				; CODE XREF: 76A3
 IF VVL
		bt	eax, 23
		jnc	short loc_8154
 ENDIF
		cmp	al, 12h
		jz	short loc_76EC
		cmp	al, 13h
		jz	short loc_76F0
		cmp	al, 14h
		jz	short loc_76E0
		cmp	al, 15h
		jz	short loc_76E4
		cmp	al, 16h
		jz	short loc_76E8
		cmp	al, 18h
		jz	short loc_76EC
		cmp	al, 19h
		jz	short loc_76F0
		cmp	al, 1Ah
		jz	short loc_76F4
		cmp	al, 1Bh
		jz	short loc_76E0
		cmp	al, 1Ch
		jz	short loc_76E4
		cmp	al, 1Dh
		jz	short loc_76E8
		cmp	al, 1Eh
		jz	short loc_76E8
 IF VPCI
loc_76D7:
 ENDIF
		mov	byte ptr h_opflag[ebp], 0
		jmp	loc_7A09

loc_76E0:	mov	al, 1
		jmp	short loc_76F6

loc_76E4:	mov	al, 2
		jmp	short loc_76F6

loc_76E8:	mov	al, 3
		jmp	short loc_76F6

loc_76EC:	mov	al, 4
		jmp	short loc_76F6

loc_76F0:	mov	al, 5
		jmp	short loc_76F6

loc_76F4:	mov	al, 6

loc_76F6:	mov	[ebp-94h], al
		jmp	loc_80B0

 IF VVL
loc_81BD:	jmp	loc_7BE0
 ENDIF

loc_7701:
 IF V034Q
		movzx	eax, byte ptr cs:[esi]
		inc	esi
		cmp	al, 0D9h
		jz	short loc_7774
		cmp	al, 0DCh
		jz	loc_77B3
		cmp	al, 0DDh
		jz	loc_77C3
		cmp	al, 0DEh
		jz	loc_77D7
		cmp	al, 0DFh
		jz	loc_77EB
 ELSE
		@CALL	loc_5320
 ENDIF

 IF VVL
		mov	ebx, h_eip3[ebp]
		jmp	loc_7A1F
 ELSE
loc_772A:	mov	eax, cr0
		mov	[ebp-4], eax
		or	eax, 1		; set PE (segment-level protection)
		mov	cr0, eax
		pushf
		btr	dword ptr [esp], 11h
		popf
		fnsave	byte ptr h_fenviron[ebp]
		FNLDSW	h_fsw[ebp]
		FNLDTW	h_ftw[ebp]
		mov	ebx, h_eip2[ebp]
		mov	h_fipoffs[ebp], ebx
  IF V034Q
		mov	bx, cs
		mov	h_fopcodecs[ebp], bx
  ENDIF
		fnrstor	byte ptr h_fenviron[ebp]
		mov	eax, [ebp-4]
		mov	cr0, eax
  IF V034Q
		@CALL	loc_5320
  ENDIF
		mov	ebx, h_eip3[ebp]
  IF V034Q
		jmp	loc_7A1F
  ELSE
		jmp	short loc_7A1F
  ENDIF

  IF V034Q
loc_7774:	; D9
		movzx	eax, byte ptr cs:[esi]
		and	al, 0F8h	; D8-DF, 287 behaves as FSTP ST(i) here
		cmp	al, 0D8h
		jnz	short loc_772A
		fstsw	word ptr [esp-4]
		mov	ax, [esp-4]
		and	ax, 3800h	; TOP (top of stack pointer)
		ror	ax, 10
		mov	cl, al		; = TOP*2
		FNSTTW	[ebp+344h]	; FPU Tag Word
		mov	ax, [ebp+344h]
		ror	ax, cl		; get tag
		and	ax, 3
		cmp	ax, 3		; empty?
		jnz	short loc_7825
		fincstp
		jmp	loc_772A

loc_77B3:	; DC
		movzx	eax, byte ptr cs:[esi]
		and	al, 0F0h	; D0-DF, 287 behaves as FCOM ST(i) and FCOMP ST(i) here
		cmp	al, 0D0h
		jz	short loc_77FF
		jnz	loc_772A

loc_77C3:	; DD
		movzx	eax, byte ptr cs:[esi]
		and	al, 0F8h	; C8-CF, 287 behaves as FXCH ST(i) here
		cmp	al, 0C8h
		jz	loc_7875
		jnz	loc_772A

loc_77D7:	; DE
		movzx	eax, byte ptr cs:[esi]
		and	al, 0F8h	; D0-D7, 287 behaves as FCOMP ST(i) here
		cmp	al, 0D0h
		jz	loc_78C5
		jnz	loc_772A

loc_77EB:	; DF
		movzx	eax, byte ptr cs:[esi]
		and	al, 0F0h	; C0-CF, 287 behaves as FFREE ST(i) and pop stack and FXCH ST(i) here
		cmp	al, 0C0h
		jz	short loc_7814
		cmp	al, 0D0h	; D0-DF, 287 behaves as FSTP ST(i) here
		jz	short loc_7825
		jnz	loc_772A

loc_77FF:	movzx	eax, byte ptr cs:[esi]
		bt	ax, 3
		jnc	loc_7915
		jc	loc_78C5

loc_7814:	movzx	eax, byte ptr cs:[esi]
		bt	ax, 3
		jnc	loc_7965
		jc	short loc_7875

loc_7825:	; do FSTP ST(i)
		movzx	ebx, byte ptr cs:[esi]	; modR/M byte
		and	ebx, 7		; R/M
		mov	eax, 7		; size of FSTP ST(i) + JMP
		mul	bl
		add	eax, offset loc_783D
		@JMP	eax

loc_783D:	fstp	st
		jmp	loc_772A

		fstp	st(1)
		jmp	loc_772A

		fstp	st(2)
		jmp	loc_772A

		fstp	st(3)
		jmp	loc_772A

		fstp	st(4)
		jmp	loc_772A

		fstp	st(5)
		jmp	loc_772A

		fstp	st(6)
		jmp	loc_772A

		fstp	st(7)
		jmp	loc_772A

loc_7875:	; do FXCHG ST(i)
		movzx	ebx, byte ptr cs:[esi]	; modR/M byte
		and	ebx, 7		; R/M
		mov	eax, 7		; size of FXCHG ST(i) + JMP
		mul	bl
		add	eax, offset loc_788D
		@JMP	eax

loc_788D:	fxch	st
		jmp	loc_772A

		fxch	st(1)
		jmp	loc_772A

		fxch	st(2)
		jmp	loc_772A

		fxch	st(3)
		jmp	loc_772A

		fxch	st(4)
		jmp	loc_772A

		fxch	st(5)
		jmp	loc_772A

		fxch	st(6)
		jmp	loc_772A

		fxch	st(7)
		jmp	loc_772A

loc_78C5:	; do FCOMP ST(i)
		movzx	ebx, byte ptr cs:[esi]	; modR/M byte
		and	ebx, 7		; R/M
		mov	eax, 7		; size of FCOMP ST(i) + JMP
		mul	bl
		add	eax, offset loc_78DD
		@JMP	eax

loc_78DD:	fcomp	st
		jmp	loc_772A

		fcomp	st(1)
		jmp	loc_772A

		fcomp	st(2)
		jmp	loc_772A

		fcomp	st(3)
		jmp	loc_772A

		fcomp	st(4)
		jmp	loc_772A

		fcomp	st(5)
		jmp	loc_772A

		fcomp	st(6)
		jmp	loc_772A

		fcomp	st(7)
		jmp	loc_772A

loc_7915:	; do FCOM ST(i)
		movzx	ebx, byte ptr cs:[esi]	; modR/M byte
		and	ebx, 7		; R/M
		mov	eax, 7		; size of FCOM ST(i) + JMP
		mul	bl
		add	eax, offset loc_792D
		@JMP	eax

loc_792D:	fcom	st
		jmp	loc_772A

		fcom	st(1)
		jmp	loc_772A

		fcom	st(2)
		jmp	loc_772A

		fcom	st(3)
		jmp	loc_772A

		fcom	st(4)
		jmp	loc_772A

		fcom	st(5)
		jmp	loc_772A

		fcom	st(6)
		jmp	loc_772A

		fcom	st(7)
		jmp	loc_772A

loc_7965:	; do FFREE ST(i) + FFREE ST
		movzx	ebx, byte ptr cs:[esi]	; modR/M byte
		and	ebx, 7		; R/M
		mov	eax, 11		; size of FFREE ST(i) + FFREE ST + FINCSTP + JMP
		mul	bl
		add	eax, offset loc_797D
		@JMP	eax

loc_797D:	ffree	st
		ffree	st
		fincstp
		jmp	loc_772A

		ffree	st(1)
		ffree	st
		fincstp
		jmp	loc_772A

		ffree	st(2)
		ffree	st
		fincstp
		jmp	loc_772A

		ffree	st(3)
		ffree	st
		fincstp
		jmp	loc_772A

		ffree	st(4)
		ffree	st
		fincstp
		jmp	loc_772A

		ffree	st(5)
		ffree	st
		fincstp
		jmp	loc_772A

		ffree	st(6)
		ffree	st
		fincstp
		jmp	loc_772A

		ffree	st(7)
		ffree	st
		fincstp
		jmp	loc_772A
  ENDIF

 ENDIF
loc_79D5:	mov	eax, [ebp-4]
		mov	cr0, eax
 IF VVL
		jmp	short loc_7A09

loc_81DF:	bts	h_fcfg[ebp], 9
		DELAYNOP 2
		FWRCFG	h_fcfg[ebp]
		btr	h_fcfg[ebp], 9
		FWRCFG	h_fcfg[ebp]
		mov	eax, h_gatflag[ebp]
		jmp	loc_8130

loc_820A:	fstsw	word ptr [esp-4]
		mov	ax, [esp-4]
		bt	eax, 7
		jnc	short loc_81DF
		mov	byte ptr h_opflag[ebp], 0
loc_79E4:	bts	h_fcfg[ebp], 3
		DELAYNOP 2
		FWRCFG	h_fcfg[ebp]
		jmp	short loc_7A09

loc_8238:	bt	eax, 31
		jnc	short loc_79FE
		mov	eax, h_fcfg[ebp]
		test	al, 8
		jnz	short loc_79FE
		jmp	loc_8120
 ELSE
		jmp	loc_7507

		mov	byte ptr h_opflag[ebp], 0

loc_79E4:				; CODE XREF: 859F
		bts	h_fcfg[ebp], 3
		DELAYNOP 2
		FWRCFG	h_fcfg[ebp]
		jmp	short loc_7A09
 ENDIF

loc_79FE:	add	esp, 98h
		jmp	loc_532E

loc_7A09:	add	esp, 98h
loc_7A0F:	movzx	ebx, byte ptr h_opflag[ebp]
		add	ebx, h_eip2[ebp]
		mov	h_eip3[ebp], ebx
loc_7A1F:	push	ecx
		mov	ecx, dr7
 IF NOT V033S
		bts	word ptr h_dbflag[ebp], 2
		mov	h_dr7[ebp], ecx
 ENDIF
		push	ecx
		xor	ecx, ecx
		mov	dr7, ecx
		RDAR	ecx, cs
		bt	ecx, 25
		jc	short loc_7A56
		bts	ecx, 25
		OP_0FE4
		WRAR	cs, ecx
		test	byte ptr cs:[ebx], 0
		btr	ecx, 25
		OP_0FE4
		WRAR	cs, ecx
		jmp	short loc_7A5A

loc_7A56:	test	byte ptr cs:[ebx], 0
loc_7A5A:	pop	ecx
		mov	dr7, ecx
 IF NOT V033S
		btr	word ptr h_dbflag[ebp], 2
 ENDIF
		pop	ecx
loc_7A65:	lea	esp, h_edi[ebp]
		pop	edi
		pop	esi
		pop	edx
		pop	ecx
		pop	ebx
		pop	eax
		pop	ebp
		add	esp, 8
		OP_0FE4
		RETH

loc_7A79:	add	esp, 98h
		and	eax, 7Fh
		mov	ecx, eax
		sub	ecx, 50h
		jl	short loc_7ABC
		mov	esi, h_eip2[ebp]
		mov	h_excph[ebp], offset loc_7AB9
		mov	al, cs:[esi]
		cmp	al, 0D9h
		jnz	short loc_7ABC
		mov	byte ptr h_opcode[ebp], 0D9h
		mov	byte ptr h_opflag[ebp], 2
		mov	ebx, offset loc_7B00
		add	ebx, h_base[ebp]
		shl	ecx, 1
		movzx	eax, word ptr [ebx+ecx]
		add	eax, h_base[ebp]
		push	eax
		jmp	eax

loc_7AB9:	add	esp, 10h
 IF VVL OR V034I
loc_7AC2:
 ENDIF
loc_7ABC:	push	eax
		jmp	loc_532E

 IF VPCI GT 'i'
loc_835C:
loc_836B:
loc_837A:
loc_8389:
loc_8398:
loc_83A7:
loc_83B6:
loc_83C5:
loc_83E3:
loc_83F2:
loc_7AC2:	mov	ebx, h_eip2[ebp]
		mov	h_eip3[ebp], ebx
		mov	eax, h_fcfg[ebp]
		or	eax, 4000h
		mov	[bp+344h], eax
		DELAYNOP 2
		FWRCFG	[ebp+344h]
		jmp	loc_7A65
 ENDIF
		ALIGN	16

loc_7B00:	dw small offset loc_7ABC
		dw small offset loc_7ABC
		dw small offset loc_7ABC
		dw small offset loc_7ABC
		dw small offset loc_7ABC
 IF V034I
		dw 0
		dw 0
		dw 0
		dw 0
 ELSE
		dw small offset loc_835C
		dw small offset loc_836B
		dw small offset loc_83C5
		dw small offset loc_8398
 ENDIF
		dw small offset loc_7ABC
 IF V034I
		dw 0
		dw 0
		dw 0
		dw 0
 ELSE
		dw small offset loc_83A7
		dw small offset loc_837A
		dw small offset loc_8389
		dw small offset loc_83B6
 ENDIF
		dw small offset loc_7AC2
		dw small offset loc_7ABC
		dw small offset loc_7ABC
		dw small offset loc_7ABC
		dw small offset loc_7ABC
		dw small offset loc_7ABC
		dw small offset loc_7ABC
		dw small offset loc_7ABC
		dw small offset loc_7ABC
		dw small offset loc_7ABC
		dw small offset loc_7ABC
		dw small offset loc_7ABC
		dw small offset loc_7ABC
		dw small offset loc_7ABC
		dw small offset loc_7ABC
		dw small offset loc_7ABC
		dw small offset loc_7AC2
		dw small offset loc_7AC2
		dw small offset loc_7AC2
		dw small offset loc_7AC2
 IF V034I
		dw 0
 ELSE
		dw small offset loc_83F2
 ENDIF
		dw small offset loc_83D4
 IF VVL
		dw small offset loc_7ABC
 ELSE
		dw small offset loc_7AC2
 ENDIF
 IF V034I
		dw 0
 ELSE
		dw small offset loc_83E3
 ENDIF

 IF VVL
loc_835C:	mov	byte ptr h_modrm[ebp], 0FEh
		inc	dword ptr h_fsinc[ebp]		; Statistics: Count number of FSIN instructions
		jmp	DecFSIN

loc_836B:	mov	byte ptr h_modrm[ebp], 0FFh
		inc	dword ptr h_fcosc[ebp]		; Statistics: Count number of FCOS instructions
		jmp	DecFCOS

loc_837A:	mov	byte ptr h_modrm[ebp], 0F0h
		inc	dword ptr h_f2xm1c[ebp]		; Statistics: Count number of F2XM1 instructions
		jmp	DecF2XM1

loc_8389:	mov	byte ptr h_modrm[ebp], 0F1h
		inc	dword ptr h_fyl2x[ebp]		; Statistics: Count number of FYL2X instructions
		jmp	DecFYL2X

loc_8398:	mov	byte ptr h_modrm[ebp], 0F2h
		inc	dword ptr h_fptanc[ebp]		; Statistics: Count number of FPTAN instructions
		jmp	DecFPTAN

loc_83A7:	mov	byte ptr h_modrm[ebp], 0F3h
		inc	dword ptr h_fpatanc[ebp]	; Statistics: Count number of FPATAN instructions
		jmp	DecFPATAN

loc_83B6:	mov	byte ptr h_modrm[ebp], 0F9h
		inc	dword ptr h_fyl2xp1[ebp]	; Statistics: Count number of FYL2XP1 instructions
		jmp	DecFYL2XP1

loc_83C5:	mov	byte ptr h_modrm[ebp], 0FBh
		inc	dword ptr h_fsincosc[ebp]	; Statistics: Count number of FSINCOS instructions
		jmp	DecFSINCOS
 ENDIF

loc_83D4:	mov	byte ptr h_modrm[ebp], 0FDh
		inc	dword ptr h_fscalec[ebp]	; Statistics: Count number of FSCALE instructions
		jmp	DecFSCALE

 IF VVL
loc_83E3:	mov	byte ptr h_modrm[ebp], 0F4h
		inc	dword ptr h_fxtractc[ebp]	; Statistics: Count number of FXTRACT instructions
		jmp	DecFXTRACT

loc_83F2:	mov	byte ptr h_modrm[ebp], 0FAh
		inc	dword ptr h_fsqrtc[ebp]		; Statistics: Count number of FSQRT instructions
		jmp	DecFSQRT
 ENDIF

		ALIGN	256

hypseg		ends
		end

;------------------------------------------------------------- end NPHCODE.ASM