;-----------------------------------------------------------------------------
; NexGen Nx586 BIOS Hypercode
;-----------------------------------------------------------------------------
; File: NP_SUB.ASM - 
; Date: 2020-09-27
;
; Disassembled by Dipl.-Inf. Herbert Oppmann (herby@memotech.franken.de)
;-----------------------------------------------------------------------------

		include COMMON.INC

	extrn	loc_5B59:near

	public	loc_8E60
	public	loc_8E80
	public	loc_8E99
	public	loc_8ED1
	public	loc_8F23
	public	loc_8F44
	public	loc_8F53


		db '@(#)np_sub.asm',TAB,'3.3',0
		ALIGN0	32

; subroutine
; Set Tag of TOP
; E: AL = new Tag value
loc_8E60:	mov	ecx, h_fsw[ebp]
		shr	ecx, 11
		and	ecx, 7		; ECX = TOP = Top of Stack Pointer
		shl	cl, 1
		mov	ebx, h_ftw[ebp]
		ror	ebx, cl
		and	ebx, 0FFFFFFFCh	; EBX = clear Tag of TOP
		or	bl, al		; insert new Tag
		rol	ebx, cl
		mov	h_ftw[ebp], ebx
		@RET

; subroutine
; enable protection, disable virtual 8086 mode
loc_8E80:	mov	eax, cr0
		mov	[ebp-4], eax		; save old CR0
		or	eax, 1			; CR0.PE
		mov	cr0, eax
		pushf
		btr	dword ptr [esp], 17	; EFL.VM
		popf
		@RET

; subroutine
; some kind of normalisation
loc_8E99:	mov	dx, 0
		fstp	tbyte ptr [ebp-90h]
loc_8EA3:	test	byte ptr [ebp-89h], 80h
		jnz	short loc_8EC5
		shl	dword ptr [ebp-8Ch], 1
		inc	dx
		shl	dword ptr [ebp-90h], 1
		jnc	short loc_8EA3
		or	byte ptr [ebp-8Ch], 1
		jmp	short loc_8EA3

loc_8EC5:	fld	tbyte ptr [ebp-90h]
		@RET

; subroutine
loc_8ED1:	mov	eax, h_disp[ebp]
		mov	h_fdataoffs[ebp], eax
		; get segment override
		mov	ebx, h_opflag[ebp]
		shr	ebx, 24
		and	ebx, 7
		cmp	ebx, 0
		jz	short loc_8F12	; no override defaults to DS
		cmp	ebx, 1		; ES
		jz	short loc_8F03
		cmp	ebx, 2		; CS
		jz	short loc_8F08
		cmp	ebx, 3		; SS
		jz	short loc_8F0D
		cmp	ebx, 4		; DS
		jz	short loc_8F12
		cmp	ebx, 5		; FS
		jz	short loc_8F17
		cmp	ebx, 6		; GS
		jz	short loc_8F1C
		; we should not come here

loc_8F03:	; ES override
		mov	ax, es
		jmp	short loc_8F1F

loc_8F08:	; CS override
		mov	ax, cs
		jmp	short loc_8F1F

loc_8F0D:	; SS override
		mov	ax, ss
		jmp	short loc_8F1F

loc_8F12:	; no override or DS override
		mov	ax, ds
		jmp	short loc_8F1F

loc_8F17:	; FS override
		mov	ax, fs
		jmp	short loc_8F1F

loc_8F1C:	; GS override
		mov	ax, gs

loc_8F1F:	mov	h_fopsec[ebp], ax	; operand selector
;<fall through>

; subroutine
loc_8F23:	mov	eax, h_eip2[ebp]
		mov	h_fipoffs[ebp], eax
		mov	al, byte ptr h_modrm[ebp]
		mov	ah, byte ptr h_opcode[ebp]
		and	ah, 7
		shl	eax, 16
		mov	ax, cs
		mov	h_fopcodecs[ebp], eax
		@RET


loc_8F44:	@CALL	loc_8F23
		fnclex
		fnrstor	byte ptr h_fenviron[ebp]
;<fall through>

; restore old CR0 and return to mortal mode
loc_8F53:	mov	eax, [ebp-4]	; restore old CR0
		mov	cr0, eax
		jmp	loc_5B59

		ALIGN0	16

hypseg		ends
		end

;-------------------------------------------------------------- end NP_SUB.ASM