;-----------------------------------------------------------------------------
; NexGen Nx586 BIOS Hypercode
;-----------------------------------------------------------------------------
; File: NP_XCP.ASM - 
; Date: 2020-09-25
;
; Disassembled by Dipl.-Inf. Herbert Oppmann (herby@memotech.franken.de)
;-----------------------------------------------------------------------------

		include COMMON.INC

	extrn	loc_8E60:near
	extrn	loc_8ED1:near
	extrn	loc_8F44:near
	extrn	loc_8F53:near

	public	loc_8FB3
	public	loc_8FD3
	public	loc_8FF4
	public	loc_902B
 IF VVL
	public	loc_9068
 ENDIF
	public	loc_9097
 IF VVL
	public	loc_90C1
 ENDIF
	public	loc_90ED

		db '@(#)np_xcp.asm',TAB,'3.'
 IF V033W OR (VPCI GE 'p')
		db '4',0
 ELSE
		db '3',0
 ENDIF
		ALIGN0	32

loc_8F80:				; CODE XREF: 8FC2	8FEC
					; 00009018 0000903F	907E
		mov	eax, h_gatflag[ebp]
		and	al, 7Fh
		cmp	al, 4
		jz	short loc_8F95
		cmp	al, 17h
		jz	short loc_8F95
		jmp	loc_8F44

loc_8F95:	@CALL	loc_8ED1	; CODE XREF: 8F8A	8F8E
		fnclex
		fnrstor	byte ptr h_fenviron[ebp]
		jmp	loc_8F53

dloc_8FA9	dt 0FFFFC000000000000000h	; -QNaN

loc_8FB3:				; CODE XREF: 87D7	8817
					; 00008873 00008BCB
		btr	dword ptr h_fsw[ebp], 9
		bts	dword ptr h_fsw[ebp], 0
		bt	dword ptr h_fcw[ebp], 0
		jnc	short loc_8F80
		mov	eax, h_base[ebp]
		fld	tbyte ptr ds:dloc_8FA9[eax]
		@RET

loc_8FD3:				; CODE XREF: 87F9
		test	byte ptr h_fr0[ebp+7], 40h
		jz	short loc_8FDD
 IF V033W OR (VPCI GE 'p')
		fldz
		faddp	st(1), st
 ELSE
		@RET
 ENDIF

loc_8FDD:				; CODE XREF: 8FD7
		btr	dword ptr h_fsw[ebp], 9
		bts	dword ptr h_fsw[ebp], 0
		bt	dword ptr h_fcw[ebp], 0
		jnc	short loc_8F80
 IF NOT (V033W OR (VPCI GE 'p'))
		fldz
		faddp	st(1), st
 ENDIF
		@RET

loc_8FF4:				; CODE XREF: 8B2C
		fclex
		fxch	st(1)
		faddp	st(1), st
		fstsw	word ptr [esp-4]
		mov	ax, [esp-4]
		test	al, 1
		jz	short loc_901E
		btr	dword ptr h_fsw[ebp], 9
		bts	dword ptr h_fsw[ebp], 0
		bt	dword ptr h_fcw[ebp], 0
		jnc	loc_8F80

loc_901E:	@RET			; CODE XREF: 9007

; Subroutine
loc_9024:	bts	dword ptr h_fsw[ebp], 9	; C1
		jmp	short loc_9030

; Subroutine
loc_902B:	btr	dword ptr h_fsw[ebp], 9	; C1

loc_9030:	bts	dword ptr h_fsw[ebp], 6	; SF
		bts	dword ptr h_fsw[ebp], 0	; IE
		bt	dword ptr h_fcw[ebp], 0	; IM
		jnc	loc_8F80
		ffree	st(7)
		mov	eax, h_base[ebp]
		fld	tbyte ptr ds:dloc_8FA9[eax]
		test	byte ptr h_fsw[ebp+1], 2	; C1
		jnz	short loc_9062
		mov	al, 1
		@CALL	loc_8E60
loc_9062:	@RET

 IF VVL
loc_9068:
 ENDIF
		bt	dword ptr h_fcw[ebp], 0
		jc	short loc_9083
		btr	dword ptr h_fsw[ebp], 9
		bts	dword ptr h_fsw[ebp], 6
		bts	dword ptr h_fsw[ebp], 0
		jmp	loc_8F80

loc_9083:				; CODE XREF: 906D
		mov	ebx, h_fcw[ebp]
		or	byte ptr h_fcw[ebp], 3Fh
		fnclex
		fnrstor	byte ptr h_fenviron[ebp]
		faddp	st(1), st
		@RET

loc_9097:				; CODE XREF: 8BEC	8C18
					; 00008C2E 00008C72
		bts	dword ptr h_fsw[ebp], 1
		bt	dword ptr h_fcw[ebp], 1
		jnc	loc_8F80
		@RET

dloc_90AD:	dt 60008000000000000000h

dloc_90B7:	dt 7FFE8000000000000000h

 IF VVL
loc_90C1:
 ENDIF
		bts	dword ptr h_fsw[ebp], 4
		bt	dword ptr h_fcw[ebp], 4
		jnc	short loc_90D4
		bts	dword ptr h_fsw[ebp], 5
		jmp	short loc_90E7

loc_90D4:				; CODE XREF: 90CB
		mov	eax, h_base[ebp]
		fld	tbyte ptr ds:dloc_90AD[eax]
		fmulp	st(1), st
		fld	tbyte ptr ds:dloc_90B7[eax]
		fmulp	st(1), st
loc_90E7:	@RET			; CODE XREF: 90D2

; Subroutine
; E: FPU Status Word in f_fsw[ebp] and FPU Tag Word in h_ftw[ebp]
; V:
; R: ECX=0 if TAG of TOP is empty
loc_90ED:	; 
		mov	al, h_fsw[ebp+1]
		shr	al, 2
		sub	al, 2
		and	al, 0Eh		; = now 2 x TOP (Top of Stack Pointer)
		mov	cl, al
		mov	ax, h_ftw[ebp]
		shr	ax, cl
		and	al, 3		; = now TAG of TOP
		cmp	al, 3		; empty?
		jnz	short loc_910E
		xor	ecx, ecx	; 0
		@RET

loc_910E:	@CALL	loc_9024
		mov	cl, 1
		@RET

hypseg		ends
		end

;-------------------------------------------------------------- end NP_XCP.ASM