;-----------------------------------------------------------------------------
; NexGen Nx586 BIOS Hypercode
;-----------------------------------------------------------------------------
; File: RETF.ASM - 
; Date: 2020-09-24
;
; Disassembled by Dipl.-Inf. Herbert Oppmann (herby@memotech.franken.de)
;-----------------------------------------------------------------------------

		include COMMON.INC

	extrn	loc_2B92:near
	extrn	loc_2BA4:near
	extrn	loc_2BB6:near
	extrn	ExcpDebugExcp:near
 IF VVL
	extrn	loc_3F20v:near
 ENDIF
	public	loc_1820
	public	loc_1840
	public	loc_1AB7
	public	Exception


 IF V033S
		db '@(#)retf.asm',9,'3.4',0
 ELSEIF V033W
		db '@(#)retf.asm',9,'3.5',0
 ELSE	; PCI+V033V
		db '@(#)retf    ',0
 ENDIF
		ALIGN0	32

; Hypermode entry via offset 0A80h
loc_1820:	mov	ebp, esp
		sub	ebp, 3E4h
		push	eax
		push	ebx
		push	ecx
		push	edx
		push	esi
		push	edi
		mov	esp, ebp
		and	dword ptr h_gatflag[ebp], 8000FFFFh
		mov	edi, h_gatflag[ebp]

loc_1840:	; set special exception handler
		mov	h_excph[ebp], offset loc_1AB7
		; EDX is a progress indicator for the exception handler
		xor	edx, edx
		mov	word ptr h_dbflag[ebp], dx
		bt	dword ptr h_efl[ebp], 8	; EFL.8 = trap flag (single stepping)
		jc	RetTFSet	; this continues with loc_185B

RetTFBack:	RDAR	eax, ss
		bt	eax, 22		; address size (1=32 bit)
		mov	esi, h_esp[ebp]
		jc	short loc_1870
		and	esi, 0FFFFh	; ensure 16 bit
loc_1870:	bt	edi, 31		; set to 1 if 32-bit call gate
		movzx	edi, di		; clear bit 31
		jc	short loc_1899
		; 16-bit gate
		mov	bx, ss:[esi+2]		; CS
		mov	h_ucs[ebp], ebx
		movzx	ebx, word ptr ss:[esi]	; IP
		movzx	ecx, word ptr ss:[esi+4]	; ??
		push	ecx
		movzx	ecx, word ptr ss:[esi+edi+6]	; SS
		movzx	eax, word ptr ss:[esi+edi+4]	; SP
		jmp	short loc_18B2

loc_1899:	; 32-bit gate
		mov	ebx, ss:[esi+4]		; CS
		mov	h_ucs[ebp], ebx
		mov	ebx, ss:[esi]		; EIP
		mov	ecx, ss:[esi+8]		; ??
		push	ecx
		mov	ecx, ss:[esi+edi+12]	; SS
		mov	eax, ss:[esi+edi+8]	; ESP
loc_18B2:	; 
		mov	esi, h_ucs[ebp]		; caller's CS
		OP_0FE4
		WRCPL	esi			; restore his privilege level
		MOVSEL	cs, esi			; restore CS
		RDAR	esi, cs
		WRAR	cs, esi			; why??
		bts	edx, 31			; progress for exception handler

		; check access rights: DPL and Present
		push	ebx
		push	ecx
		push	esi
		RDAR	ecx, cs
		mov	esi, ecx
		shr	ecx, 29			; AR.29-30 = decriptor privilege level
		and	ecx, 3			; ECX holds the dpl
		mov	ebx, cs
		and	ebx, 3			; the CPL
		bt	esi, 26			; AR.26 = conforming
		jc	short loc_18E9
		; nonconforming
		; code segment DPL must equal CPL else #GP(selector)
		sub	ecx, ebx
		jnz	loc_1997
		jmp	short loc_18F1

loc_18E9:	; conforming
		; code segment DPL must be <= CPL else #GP(selector)
		sub	ecx, ebx
		jg	loc_1997
loc_18F1:	; code segment must be present else #NP(selector)
		bt	esi, 31			; AR.31 = present
		jnc	loc_199C
		pop	esi
		pop	ecx
		pop	ebx

		; check access rights: limit
		push	eax
		RDAR	eax, cs
		bt	eax, 23			; AR.23 = granularity
		jc	short loc_190F
		; granularity byte
		and	eax, 0FFFFFh		; AR.0-19 = limit
		jmp	short loc_1917

loc_190F:	; granularity 4 KB
		shl	eax, 12			; * 4096
		or	eax, 0FFFh
loc_1917:	; now limit in EAX, (E)IP in EBX
		; (E)IP must be in code segment limit else #GP(0)
		cmp	ebx, eax
		ja	loc_2BB6
		pop	eax

		mov	ss, cx
		bts	edx, 30			; progress for exception handler
		mov	h_eip3[ebp], ebx
		bt	dword ptr h_gatflag[ebp], 30
		jc	short loc_1952

loc_1936:	add	eax, edi
		RDAR	edi, ss
		bt	edi, 22			; AR.22 = big
		jc	short loc_194A
		mov	word ptr h_esp[ebp], ax
		jmp	short loc_19A1

loc_194A:	mov	h_esp[ebp], eax
		jmp	short loc_19A1

loc_1952:	pop	ebx			; 3rd word on stack
		bts	ebx, 31
		MOVSEL	esi, ?6
		and	esi, 3
		jz	short loc_198D
		mov	ecx, h_efl[ebp]
		and	ecx, 3000h		; EFL.12-13 = IOPL
		and	ebx, 0FFFFCFFFh
		or	ebx, ecx
		shr	ecx, 12
		sub	esi, ecx
		jle	short loc_198D
		;
		mov	ecx, h_efl[ebp]
		and	ecx, 200h		; EFL.9 = IF
		and	ebx, 0FFFFFDFFh
		or	ebx, ecx
loc_198D:	mov	h_efl[ebp], ebx
		xor	edi, edi
		jmp	short loc_1936

loc_1997:	jmp	loc_2B92	; General Protection Exception

loc_199C:	jmp	loc_2BA4	; Segment Not Present

loc_19A1:	; interlevel transfer
		; If the DS, ES, FS and GS segment registers refer to segments
		; that cannot be used by the new privilege level, they are
		; cleared to prevent unauthorized access from the new privilege
		; level.
		xor	ebx, ebx	; for clearing
		mov	cx, cs
		and	ecx, 3
		; check DS
		RDAR	eax, ds
		and	eax, 0F000000h
		shr	eax, 24
		sub	eax, 0Ch
		jge	short near ptr loc_19CE
		RDAR	eax, ds
		shr	eax, 29
		and	eax, 3
		sub	eax, ecx
		jge	short near ptr loc_19CE
		OP_0FE4
		WRAR	ds, ebx
		WRSEL	ds, ebx
loc_19CE:	; check ES
		RDAR	eax, es
		and	eax, 0F000000h
		shr	eax, 24
		sub	eax, 0Ch
		jge	short near ptr loc_19F3
		RDAR	eax, es
		shr	eax, 29
		and	eax, 3
		sub	eax, ecx
		jge	short near ptr loc_19F3
		OP_0FE4
		WRAR	es, ebx
		WRSEL	es, ebx
loc_19F3:	; check FS
		RDAR	eax, fs
		and	eax, 0F000000h
		shr	eax, 24
		sub	eax, 0Ch
		jge	short near ptr loc_1A18
		RDAR	eax, fs
		shr	eax, 29
		and	eax, 3
		sub	eax, ecx
		jge	short near ptr loc_1A18
		OP_0FE4
		WRAR	fs, ebx
		WRSEL	fs, ebx
loc_1A18:	; check GS
		RDAR	eax, gs
		and	eax, 0F000000h
		shr	eax, 24
		sub	eax, 0Ch
		jge	short loc_1A3D
		RDAR	eax, gs
		shr	eax, 29
		and	eax, 3
		sub	eax, ecx
		jge	short loc_1A3D
		OP_0FE4
		WRAR	gs, ebx
		WRSEL	gs, ebx

loc_1A3D:	; check new CS:EIP is accessible
		; save DR7 (and set flag that it was saved)
		mov	edx, dr7
 IF NOT V033S
		bts	word ptr h_dbflag[ebp], 2
		mov	h_dr7[ebp], edx
 ENDIF
		xor	ecx, ecx
		mov	dr7, ecx
		; restore exception handler
		mov	h_excph[ebp], offset Exception
		mov	ebx, h_eip3[ebp]
		mov	h_eip2[ebp], ebx
		RDAR	ecx, cs
		mov	eax, ecx
		bts	ecx, 25			; AR.25 = readable
		jc	short loc_1A7F
		; not readable - temporarily enable R bit
		OP_0FE4
		WRAR	cs, ecx
		test	byte ptr cs:[ebx], 0
		OP_0FE4
		WRAR	cs, eax
		jmp	short loc_1A83

loc_1A7F:	test	byte ptr cs:[ebx], 0

loc_1A83:	; restore DR7 (and clear flag that it was saved)
		mov	dr7, edx
 IF NOT V033S
		btr	word ptr h_dbflag[ebp], 2
 ENDIF
		; do we need to issue #DB on exit?
		bt	h_dbflag[ebp], 17
		jc	ExcpDebugExcp		; debug exception
		; normal exit
		lea	esp, h_edi[ebp]
		pop	edi
		pop	esi
		pop	edx
		pop	ecx
		pop	ebx
		pop	eax
		pop	ebp
		add	esp, 8
		OP_0FE4
		RETH


RetTFSet:	; balcony for single-stepping
		or	h_dbflag[ebp], 20001h
		;		       ^------ generate #DB when exiting
		;			   ^-- set DR6.BS=1
		jmp	near ptr RetTFBack	; continue


; special exception handler for INT, CALL and RETF
loc_1AB7:	bt	edx, 30		; progress: SS checked
		jnc	short loc_1AE5

		RDAR	eax, ?6
		OP_0FE4
		WRAR	ss, eax
		RDB	eax, ?6
		WRB	ss, eax
		MOVSEL	eax, ?6
		WRSEL	ss, eax
		RDAR	eax, ?7
		OP_0FE4
		WRAR	cs, eax
		RDB	eax, ?7
		WRB	cs, eax
		MOVSEL	eax, ?7
		WRSEL	cs, eax
		jmp	short loc_1AFE

loc_1AE5:	bt	edx, 31		; progress: CS checked
		jnc	short loc_1AFE
		RDAR	eax, ?6
		OP_0FE4
		WRAR	cs, eax
		RDB	eax, ?6
		WRB	cs, eax
		MOVSEL	eax, ?6
		WRSEL	cs, eax

loc_1AFE:	; re-set CPL
 IF V033V OR V033W
		bt	h_efl[ebp], 17	; EFL.17 = virtual 8086 mode
		jc	short loc_1B0D
		mov	ax, cs
		jmp	short near ptr loc_1B11

loc_1B0D:	mov	ax, 3
loc_1B11:
 ELSE	; PCI+V033S
		mov	ax, cs
 ENDIF
		OP_0FE4
		WRCPL	eax


; normal exception handler
Exception:	pop	eax
		movzx	ebx, ax
		mov	h_gatflag[ebp], ebx
		shr	eax, 16
		and	eax, 0Fh
		mov	ebx, h_eip2[ebp]
		mov	h_eip3[ebp], ebx
 IF V033S
		bt	h_cfg1[ebp], 18
		jnc	short loc_1B72
		cmp	al, 0Eh
		jnz	short loc_1B26
		OP_0FE4
		mov	ebx, cr2
		mov	h_cr2[ebp], ebx
loc_1B26:	mov	ebx, 0FFFFFFFFh
		mov	cr2, ebx
		bts	h_dbflag[ebp], 22
		DELAYNOP 2
		LOPCMSK	0, 0FFh
		LOPCMSK	1, 0FFh
		LOPCMSK	2, 0FFh
		LOPCMSK	3, 0FFh
		LOPCMSK	4, 0FFh
		LOPCMSK	5, 0FFh
		LOPCMSK	6, 0FFh
		LOPCMSK	7, 0FFh
		mov	ebx, h_cfg1[ebp]
		btr	ebx, 18
		mov	h_cfg1[ebp], ebx
		OP_0FE4
		WRCFG1	ebx
loc_1B72:
 ELSEIF V033V OR V033W
		cmp	al, 6
		jz	short near ptr loc_1B48
		bt	h_cfg1[ebp], 18
		jnc	short near ptr loc_1B48
		mov	h_gatflag[ebp], eax
		jmp	loc_3F20v

loc_1B48:	mov	dword ptr [ebp+330h], 0
 ENDIF
		bt	h_dbflag[ebp], 1
		jc	short loc_1B31
		bts	dword ptr h_efl[ebp], 16
loc_1B31:	btr	h_dbflag[ebp], 17
		cmp	al, EXCP_INVALIDOP
		jz	short ExcpInvalidOp
		cmp	al, EXCP_NOMATH
		jz	short ExcpDevNotAv
		cmp	al, EXCP_DOUBLEFAULT
		jz	short ExcpDoubleFault
		cmp	al, EXCP_INVALIDTSS
 IF V033V OR V033W
		jz	ExcpInvalidTss
 ELSE	; PCI+V033S
		jz	short ExcpInvalidTss
 ENDIF
		cmp	al, EXCP_SEGNOTPRES
		jz	ExcpSegNotPres
		cmp	al, EXCP_STACKFAULT
		jz	ExcpStackFault
		cmp	al, EXCP_GENPROT
		jz	ExcpGenProt
		cmp	al, EXCP_PAGEFAULT
		jz	ExcpPageFault
		jmp	short ExcpDoubleFault


ExcpInvalidOp:
 IF V033V OR V033W
		mov	dword ptr [ebp+330h], 6
 ENDIF
		lea	esp, h_edi[ebp]
		pop	edi
		pop	esi
		pop	edx
		pop	ecx
		pop	ebx
		pop	eax
		pop	ebp
		add	esp, 4
		DELAYNOP
		INTH	EXCP_INVALIDOP

ExcpDevNotAv:	lea	esp, h_edi[ebp]
		pop	edi
		pop	esi
		pop	edx
		pop	ecx
		pop	ebx
		pop	eax
		pop	ebp
		add	esp, 4
		DELAYNOP
		INTH	EXCP_NOMATH

ExcpDoubleFault: lea	esp, h_edi[ebp]
		pop	edi
		pop	esi
		pop	edx
		pop	ecx
		pop	ebx
		pop	eax
		pop	ebp
		add	esp, 4
		DELAYNOP
		INTH	EXCP_DOUBLEFAULT

ExcpInvalidTss:	lea	esp, h_edi[ebp]
		pop	edi
		pop	esi
		pop	edx
		pop	ecx
		pop	ebx
		pop	eax
		pop	ebp
		add	esp, 4
		DELAYNOP
		INTH	EXCP_INVALIDTSS

ExcpSegNotPres:	lea	esp, h_edi[ebp]
		pop	edi
		pop	esi
		pop	edx
		pop	ecx
		pop	ebx
		pop	eax
		pop	ebp
		add	esp, 4
		DELAYNOP
		INTH	EXCP_SEGNOTPRES

ExcpStackFault:	lea	esp, h_edi[ebp]
		pop	edi
		pop	esi
		pop	edx
		pop	ecx
		pop	ebx
		pop	eax
		pop	ebp
		add	esp, 4
		DELAYNOP
		INTH	EXCP_STACKFAULT

ExcpGenProt:	lea	esp, h_edi[ebp]
		pop	edi
		pop	esi
		pop	edx
		pop	ecx
		pop	ebx
		pop	eax
		pop	ebp
		add	esp, 4
		DELAYNOP
		INTH	EXCP_GENPROT

ExcpPageFault:	lea	esp, h_edi[ebp]
		pop	edi
		pop	esi
		pop	edx
		pop	ecx
		pop	ebx
		pop	eax
		pop	ebp
		add	esp, 4
		DELAYNOP
		INTH	EXCP_PAGEFAULT

		ALIGN	256

hypseg		ends
		end

;---------------------------------------------------------------- end RETF.ASM