;-----------------------------------------------------------------------------
; NexGen Nx586 BIOS Hypercode
;-----------------------------------------------------------------------------
; File: UNDOC.ASM - undocumented 386/486 instructions
; Date: 2020-09-27
;
; Disassembled by Dipl.-Inf. Herbert Oppmann (herby@memotech.franken.de)
;-----------------------------------------------------------------------------

		include COMMON.INC

	extrn	ExcpDebugExcp:near
	extrn	loc_5B59:near
	extrn	loc_5B93:near
	extrn	GetOperand:near
	extrn	GetOperandAndReg:near
	extrn	WriteRM:near
	extrn	WriteReg:near
 IF VVL
	extrn	loc_6AA8:near
 ENDIF

	public	DecICEBP
	public	DecSALC
	public	DecUMOVb1
	public	DecUMOVb0
	public	DecUMOVw0
	public	DecUMOVw1


		db '@(#)undoc.asm',TAB,'2.3',0
		ALIGN0	32

; ICEBP - in-circuit-emulator breakpoint

DecICEBP:	cmp	word ptr h_uart[ebp], 0
		jz	short loc_6852
		mov	esi, h_eip2[ebp]
		mov	h_eip3[ebp], esi
		pushf
		pop	eax
		btr	eax, 17	; VM virtual x86 mode
		bts	eax, 12	; IOPL I/O privilege level
		bts	eax, 13	;  "
		push	eax
		popf
 IF VVL
		@CALL	loc_6AA8
 ELSE	; PCI
		@CALL	loc_684D
 ENDIF
loc_684D:	jmp	loc_5B93

loc_6852:	; here if UART port ==0
		jmp	ExcpDebugExcp


; SALC - set AL on carry

DecSALC:	bt	h_efl[ebp], 0	; carry?
		jnc	short SALCno
		mov	byte ptr h_eax[ebp], 0FFh ;yes
		jmp	short SALCret

SALCno:		mov	byte ptr h_eax[ebp], 0	; no
SALCret:	jmp	loc_5B59


; UMOV - user MOV

; UMOV r8,r/m8
DecUMOVb1:	or	byte ptr h_opflag+2[ebp], 20h
; UMOV r16,r/m16 or UMOV r32,r/m32
DecUMOVw1:	@CALL	GetOperand
		mov	ecx, h_content[ebp]
		movzx	ebx, byte ptr h_modrm[ebp]
		and	ebx, 38h
		shr	ebx, 3
		@CALL	WriteReg
		jmp	loc_5B59

; UMOV r/m8,r8
DecUMOVb0:	or	byte ptr h_opflag+2[ebp], 20h
; UMOV r/m16,r16 or UMOV r/m32,r32
DecUMOVw0:	@CALL	GetOperandAndReg
		@CALL	WriteRM
		jmp	loc_5B59

		ALIGN	256

hypseg		ends
		end

;--------------------------------------------------------------- end UNDOC.ASM